c SIMS: public
c Smooth Invariant Molecular Surface
c Yury N Vorobjev , February 21, 1997
c All copyright reserved
c to obtain copy of SIMS contact
c (919)966-8625; Fax: (919)966-2852
c vorobjev@femto.med.unc.edu
c---------------------------------------------------
c parameters for assign_qr  subroutine
c---------------------------------------------------
        integer nclist,nrlist,nrmax,ncmax,ncrgmx

	parameter (nclist = 1000)
	parameter (nrlist = 1000)
	parameter (nrmax = 1000)
	parameter (ncmax = 1000)
	parameter (ncrgmx = 10000)
c---------------------------------------------------
c
c     atom names for radii table
c
      
      dimension atnam(nrmax)		
c
c     residue names for radii table
c
      dimension rnam(nrmax)		
c
c     radius table 
c
      real*8 radt(nrmax)		
c
c     links for radius hash table
c
      integer irlink(nrlist)	
c
c	radii id numbers in hash table
c
      integer irnumb(nrlist)	
c
c	atom names   for charge table
c
      dimension catnam(ncmax)		
c
c	chain names for charge table
c
      dimension cchn(ncmax)		
c
c	residue names for charge table
c
      dimension crnam(ncmax)		
c
c	residue number for charge table
c
      dimension crnum(ncmax)		
c
c	charge table 
c
      real*8 chrgvt(ncmax)		
c
c	links for charge hash table
c
      integer iclink(nclist)	
c
c	charge entry id numbers in hash table
c
      integer icnumb(nclist)	
c
c	atom charges for boundary condition
c
c	dimension atcrd(3,maxat),atrad(maxat),atcrg(maxat)	
	real*8 atcrd(3,maxat),atrad(maxat),atcrg(maxat)	
	dimension atmcrg(4,ncrgmx)
        real*4 atmcrg

c---------------------------------------------------
        character*1 chn,schn,cchn
        character*3 crnam,rnam,sres,res
        character*4 rnum,snum,crnum
        character*6 atnam,catnam
       character*6 atm !bilo    
c---------------------------------------------------
        integer irtot,ictot
	common
     &	/linkk/  irlink,irnumb,iclink,icnumb,irtot,ictot
     &	/name/  atnam,rnam,catnam,cchn,crnam,crnum
     &	/value/ radt,chrgvt
c---------------------------------------------------
