      subroutine ACCEPTING(IMOV,CNGEO)
      
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.EDMC'
      INCLUDE 'COMMON.XBOUNDX'
      INCLUDE 'COMMON.TRACK'
      INCLUDE 'COMMON.CALC'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.FILES'
      INCLUDE 'COMMON.NNDRUK'
      INCLUDE 'COMMON.MOVE'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.MYCONF'
      INCLUDE 'COMMON.TOR2'
      INCLUDE 'COMMON.SETUP'
      INCLUDE 'COMMON.CNTRL'
      INCLUDE 'COMMON.PROB'

      DATA IZERO /0/
      LOGICAL cngeo

      iacc(imov)=iacc(imov)+1
      do i=1,3
        itotc(i)=itotc(i)+icounter(i)
        icounter(i)=0
      enddo
      lther=.false.
      if (adptwei) then
        call modifwei
      endif
      call place
!     call update
!     if (elowst.gt.etot) then
      edifer=elowst-etot
      write(*,'(3(a10,e12.5) )') 'ELOWST= ',elowst, 
     &               'ETOT=',etot,' EDIFER=',edifer        
      if (edifer.gt.0.1D-03) then
        elowst= etot
        ilowst= ndone
        write(*,9050)ilowst,elowst
        write(jout,9050)ilowst,elowst
9050    format('ITER N',I4,3X,'LOWEST ENERGY UPDATED =',E12.5)
! reset counter of residue trial when search finds a new GM
         do i=1,inumrs
            itrials(i)=0
         enddo
      end if
      nuk=0
      if (nprint_elec.gt.0) then
        nprm=nprint_elec*int(ndone/nprint_elec)
        if (nprm.eq.ndone) nuk=1
      endif
      if (movang.eq.3) call nonstgeo(cngeo)
      if (arbt.lt.1.0) call theta
      nuk=0
      if (nprnt_cnst.gt.0) then
        nprm=nprnt_cnst*int(ndone/nprnt_cnst)
        if (nprm.eq.ndone) then
           nukco=1
           if (withcnst ) call disprt
           if (dihecnst) call const_dieh(numvar,x)
           nukco=0  
        endif
      endif
      call probres
      call probdi(IZERO)
!     write (*,*) ' Calling iter_out', ndone
      call iter_out
      if (efinal.ge.elowst) then
        not_done =.false.
!       write (*,*) '*****NOT_DONE #4*****'
        write(jout,'(a)')
     &       'Search ends because the REQUESTED ENERGY was reached'
      endif
      if (refcod) then
        do i=2, inumrs-1
          if(zimmk(I).ne. zimmre(i) ) goto 4990
        enddo
        not_done=.false.
!       write (*,*) '*****NOT_DONE #5*****'
        write(jout,'(a)')
     &       'Search ends because REFERENCE CODE was achieved'
      endif
4990  continue
      if (not_done .and. (ndone.LT.LICZM) ) then
        call close_app(jout,outfile)
        if (ONSCREEN) write (*,110) ndone+1
          write (jout,110) ndone+1
 110  FORMAT('***********************************************'/
     &       '        Beginning iteration #',I4/
     &       '***********************************************')
!     else
!       nukco=1
!       if (withcnst) then 
!         write(jout,'(/a)') 
!    &         'LIST OF UNSATISFIED DISTANCE CONSTRAINTS'
!         call disprt
!       endif
!       if (dihecnst) call const_dieh(numvar,x)
!       nukco=0
      endif

      RETURN
      END

! =======================================================================
! =======================================================================


      SUBROUTINE SORT_OUT(IOLDNUM,INUMCO,ELIMINATE)

#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      include 'PARAMET.MP'
      include 'COMMON.MP'
      include 'COMMON.MYCONF'
      include 'COMMON.TRACK'
      include 'COMMON.IOUNIT'
      include 'COMMON.CALC'
      include 'COMMON.GEN100'
      include 'COMMON.BONDSX'
      include 'COMMON.EDMC'
      INCLUDE 'COMMON.CNTRL'
      include 'COMMON.VIBRAT'
      logical ELIMINATE

! This is for randomly generated conformations
      IF(IOLDNUM.EQ.-1) THEN
           MYCON = NextOut
           IOLDNUM=NextOut
!       write(*,*)'RANDOM:IOLDNUM  NextOut ',IOLDNUM , NextOut
           if( NextOut.ge.liczm) not_done =.false.
           if( NextOut.gt.liczm) return
      ENDIF

! Next is for input conformations
! MYCON (in COMMON) indicates the latest conformation to be considered
! This is the sequential number used by the master processor.
! IOLDNUM is the number of the conformation in the input(outo.*) file.

!       write(*,*)'MYCON - NextOut Highest ',MYCON, NextOut
!    &    , Highest, 'IOLDNUM', IOLDNUM
      IF (MYCON.EQ.NextOut) THEN
        NextOut = NextOut + 1
        IF(.NOT.ELIMINATE) THEN
!       write(*,*)'PRINT1 ',MYCON,' NextOut ',  NextOut
!    &      ,'IOLDNUM ', IOLDNUM
        CALL DRUANG(JANG,IOLDNUM)
#ifdef AIX
           CALL FLUSH_(JANG)
#endif
#ifdef WINNT
           CALL FLUSH(JANG)
#endif
        INUMCO = INUMCO + 1
!          write(*,*)'INUMCO( or NDONE)= ',INUMCO
        JCONFIN(INUMCO)= IOLDNUM
           IF (LFREE_ENE) THEN
               ETOTT(INUMCO)= ETOT-EVIB
               ENEFREE(INUMCO)= ETOT
            ENDIF
           IF(Highest.GT.2*numtasks) THEN
              WRITE(*,*) 
     &      'SORT_OUT:TOO MANY conformations in storage list'
           ENDIF
        ELSE
!          write(*,*)'ELIMINATE ',MYCON,' NextOut ',NextOut
        ENDIF
        NIN = 0
!       IF (IAMMIN(1).EQ. MYCON) NIN = 1
        IF (Highest .GT. 1) NIN = 1
        DO I = 1, Highest
          IF (IAMMIN(I).EQ.NEXTOUT) THEN
            NextOut = NextOut + 1
            IF (OKMIN(I)) THEN
            MYCON   = IAMMIN(I)
            IOLDNUM = IOLDMIN(I)
            ETOT    = ETOTMIN(I)
            EES     = EESMIN(I)
            ENB     = ENBMIN(I)
            EHYDA   = EHYDAMIN(I)
            EVIB   = EVIBMIN(I)
            DO K=1,INUMRS
              LIST(K) = LISTMIN(K,I)
              DO J=1,MAXNUM_DIHE
                ANGULO(J,K) = ANGMIN(J,K,I) 
              ENDDO
            ENDDO                    
!       write(*,*)'PRINT2 ',MYCON,' NextOut ',  NextOut
!    &      ,'IOLDNUM ', IOLDNUM
            CALL DRUANG(JANG,IOLDNUM)
#ifdef AIX
               CALL FLUSH_(JANG)
#endif
#ifdef WINNT
               CALL FLUSH(JANG)
#endif
            IAMMIN(I) = 0
            INUMCO = INUMCO + 1
!              write(*,*)'INUMCO( or NDONE)= ',INUMCO
            JCONFIN(INUMCO)= IOLDNUM
               IF (LFREE_ENE) THEN
                  ETOTT(INUMCO)= ETOT-EVIB
                  ENEFREE(INUMCO)= ETOT
               ENDIF
            ELSE
!              write(*,*)'ELIMINATE ',MYCON,' NextOut ',NextOut
            ENDIF
            NIN = NIN + 1
          ELSE
            IAMMIN(I-NIN) = IAMMIN(I)
            IF (IAMMIN(I).NE.0) THEN
              IAMMIN(I) = 0
              OKMIN(I-NIN)   = OKMIN(I)
              IF (OKMIN(I-NIN)) THEN
              IOLDMIN(I-NIN) = IOLDMIN(I)
              ETOTMIN(I-NIN) = ETOTMIN(I)
              EESMIN(I-NIN) = EESMIN(I)
              ENBMIN(I-NIN) = ENBMIN(I)
              EHYDAMIN(I-NIN) = EHYDAMIN(I)
              EVIBMIN(I-NIN) = EVIBMIN(I)
              DO K=1,INUMRS
                LISTMIN(K,I-NIN) = LISTMIN(K,I)
                DO J=1,MAXNUM_DIHE
                  ANGMIN(J,K,I-NIN) = ANGMIN(J,K,I) 
                ENDDO
              ENDDO                    
            ENDIF
          ENDIF
          ENDIF
        ENDDO
        Highest = Highest - NIN
        if (Highest .lt. 0) then
           Highest=0
!          write(*,*)'Highest was zero. MYCON=', MYCON,
!    &       ' NextOut ',  NextOut
        endif
      ELSE
        Index = MYCON - NextOut
           IF (Index .gt. Highest) then
              Highest = Index
!          write(*,*)'RESETTING   Highest ' 
!          write(*,*)'MYCON   NextOut  Index  Highest ',
!    &                MYCON,  NextOut, Index, Highest 
           endif
        IF (Index.gt.0) then
        IAMMIN(Index)   = MYCON
           IF(ELIMINATE) THEN
              OKMIN(Index)   = .FALSE.
           ELSE
              OKMIN(Index)   = .TRUE.
        IOLDMIN(Index)  = IOLDNUM
        ETOTMIN(Index) = ETOT
        EESMIN(Index) = EES
        ENBMIN(Index) = ENB
        EHYDAMIN(Index) = EHYDA
        EVIBMIN(Index) = EVIB
        DO I=1,INUMRS
          LISTMIN(I,Index) = LIST(I)
          DO J=1,MAXNUM_DIHE
            ANGMIN(J,I,Index) = ANGULO(J,I) 
          ENDDO
        ENDDO                    
      ENDIF
        ELSE
           write(*,*)'ERROR: MYCON LT NextOut ',
     &      MYCON, NextOut  
        ENDIF
      ENDIF
      RETURN
      END
