#ifdef PKSR
C FOLLOWING LINE IS AN INSTRUCTION FOR THE KSR COMPILER. DO NOT DELETE 
c*ksr* globalnoautotile
#endif
c
C The NT precompiler needs this comment here

      SUBROUTINE CALCFPO (N,X,NF,F,IUP,RUP,FUNC)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      PARAMETER (MXAT3=3*maxnum_atoms)
      PARAMETER (mxgrd =3*maxnum_atoms)
      EXTERNAL FUNC
      DIMENSION IUP(1),RUP(1)
      DIMENSION X(N)
      INCLUDE 'COMMON.CALC'
      INCLUDE 'COMMON.MYCONF'
      INCLUDE 'COMMON.DERIV'
      INCLUDE 'COMMON.ATOMSS'
      INCLUDE 'COMMON.BONDSX'
      INCLUDE 'COMMON.TOR'
      INCLUDE 'COMMON.TORQUEX'
      INCLUDE 'COMMON.BRIDGES'  
      INCLUDE 'COMMON.IOUNIT'  
      INCLUDE 'COMMON.ENG000'
      INCLUDE 'COMMON.CNTRL'  
      INCLUDE 'COMMON.DEBUG'
      INCLUDE 'COMMON.SOLVAT'
      INCLUDE 'COMMON.SOLVAT2'
      INCLUDE 'COMMON.PARALE'
      INCLUDE 'COMMON.BLOKA'
      INCLUDE 'COMMON.KASOS'
C     INCLUDE 'COMMON.EDMC'
      INCLUDE 'COMMON.VTFEX'
      INCLUDE 'COMMON.XBOUNDX'
      INCLUDE 'COMMON.MOVE'
      INCLUDE 'COMMON.TIME1'
      INCLUDE 'COMMON.RMSCNST'
C
#ifdef PKSR
      PARAMETER (num_proc = maxthreads)
      INCLUDE 'COMMON.PARRAY'
CD      INCLUDE '/usr/include/ksr/pmon.fh'
CD      integer ibuff(IPMSIZE,maxthreads)
CDC*KSR* Subpage ibuff
CD       integer istatus
#else
      PARAMETER (num_proc = 1)
#endif
      DOUBLE PRECISION CX,CY,CZ,DADX,DADY,DADZ
      DOUBLE PRECISION EQS(3,num_proc),EXS2,EXB2,EXH2
      DOUBLE PRECISION CPX(mxgrd,num_proc)
      DOUBLE PRECISION GEES, SR, ESR, VDF, GVDF, DIEINV
      INTEGER IOVER_FLAG(maxnum_atoms)
      REAL TOOBIG
      DATA TOOBIG /1.0E18/
      DATA ZERO  /0.0/
       
C     LPRNT=.TRUE.         !   for debugging
      LPRNT=.FALSE.

      OVER_FLAG=.FALSE.
C     IOVER_FLAG=0
      NATM3=3*NATM
      ETOR=ETORS
      ICG=MOD(NF,2)+1
      NFL=NF

      DO I=1,NATM3
         CGX(I,ICG)=0.0
      ENDDO
      IF (ICOMP(1).EQ.0) THEN
C    ONLY SOLVATION ENERGY IS REQUESTED
        GOTO 710
      END IF
C
*****************************************************************
*          NEXT FOR FORCE FIELDS "ECEPP" and "SOFT_SPHERE"      *
*****************************************************************
      DO L=1,NPROCS
         DO I=1,NATM3
              CPX(I,L)=0.0
         ENDDO
      ENDDO

C COUNT NUMBER OF CALLS TO CALCFPA
      NCOUN= NCOUN+1
      NFL=NF
C  GENERATE CONFORMATION
      DO L=1,N
       IF ( (ABS( X(L)).GT.1.0E+6)  ) THEN
          WRITE (*,*)'ERROR CALCFPO START WITH X(',L,') ',X(L)
C         Let's try a random value to see if it helps
          X(L)= rnunf(1)*DWAPI
          ISTOP=1
          ERR_X=.true.
       END IF

       ANGLES( INDXV(L) ) = PINORM(X(L))
      ENDDO

      CALL GENER

      IF (SIMPLE_POT) THEN
C USING A SIMPLIFIED POTENTIAL
C
*******************************************************
C  LOOP OVER INTERACTIONS DISTRIBUTED ON EACH PROCESSOR
*********1*********2*********3*********4*********5*********6*********7**
#ifdef PKSR
C NEXT LINES  ARE INSTRUCTIONS FOR THE KSR COMPILER. DO NOT DELETE !!!!
c*ksr* PARALLEL REGION(TEAMID=idteam(idleader+1) ,
c*ksr*&  private=(IPRC,L,II,KM,CX,CY,CZ,KOFF,KST,K5ST,KEY,EXS2,EXB2,
c*ksr*&  KFINL,JADD,QJ1,JJ1,IHBJJ1,XJ,YJ,ZJ,JM1,JMLST,JMOFF,KMOFF,FF,
c*ksr*&  JKR,JKE,X1,X2,X3,R0,R2,R4,R6,CHJK,DCH,EPP,TVDW,DVDW,DTRM,DADX,
c*ksr*&  DADY,DADZ,R2JK,RMAG,IHBCHK,KK,
c*ksr*& /threadid/))
CD          call pmon_delta(ibuff(1,ithread),IPMSIZE,istatus)
C+++++++++++++++++++++++++++++++++++
C  next line is for parallel version
         IPRC= ITHREAD + 1
#endif
#ifndef PKSR
C  next line is for serial version
         DO IPRC=1, NPROCS
#endif
C+++++++++++++++++++++++++++++++++++
            EXS2=0.D0
            EXB2=0.D0
            EQS(1,IPRC)=0.D0
            EQS(2,IPRC)=0.D0
            JM1=JM_PROC(IPRC)
            JMLST=JML_PROC(IPRC)
            JMOFF=JMOF_PROC(IPRC)
C            JJ1=NBTYPE(JM1)
            JJ1=NAPTYP(JM1)
            JADD=2*idiff_types*(JJ1-1)
            XJ=COORD(1,JM1)
            YJ=COORD(2,JM1)
            ZJ=COORD(3,JM1)
C           if(LPRNT) write(JOUT,445) IPRC,JM_PROC(IPRC),
C    &            JML_PROC(IPRC),LEN_INI(IPRC),LEN_FIN(IPRC)
C445   FORMAT('IN CALF IPRC =',i3,' JM_PROC= ',i5,' JML_PROC= ',i5,
C    &        ' LEN_INI=',i3,' LEN_FIN= ',i3)
            DO 200 L=LEN_INI(IPRC),LEN_FIN(IPRC)
               KOFF=INTER(1,L)
               IF (KOFF) 200,110,120
110            JM1=JM1+1
               GO TO 200
120            KST=JM1+KOFF
               K5ST=KST+INTER(2,L)
               KEY=INTER(3,L)
               KFINL=K5ST+KEY-1
               IF (KEY.LT.0) KFINL=NATM
               IF (JM1.EQ.JMLST) GO TO 130
               JMOFF=3*(JM1-1)
C                JJ1=NBTYPE(JM1)
               JJ1=NAPTYP(JM1)
               JADD=2*idiff_types*(JJ1-1)
               JMLST=JM1
               XJ=COORD(1,JM1)
               YJ=COORD(2,JM1)
               ZJ=COORD(3,JM1)
130            CX=0.D0
               CY=0.D0
               CZ=0.D0
               DO KM=KST,KFINL
                  KMOFF=3*(KM-1)
                  JKE=JADD+2*NAPTYP(KM)-1
                  IF (KM.LT.K5ST) JKE=JKE+1
C There is a discrimination on the parameters for 1-4 and 1-5 interactions.
                  X1=COORD(1,KM)-XJ
                  X2=COORD(2,KM)-YJ
                  X3=COORD(3,KM)-ZJ
                  R2JK = X1*X1 + X2*X2 + X3*X3
C*************************************************************
C SIMPLE ENERGY FUNCTION 
                  RCON=APSIMP(JKE)
                  TVDW= (RCON-R2JK)**2
                  IF (RCON.LE.R2JK) TVDW = ZERO
                  IOVER_FLAG(KM)=0
                  IF (TVDW.GT.OVER_CUTOFF) IOVER_FLAG(KM)=1
                  EXB2=EXB2+TVDW
C***************************************************************
C  STORE COMPONENTS OF CARTESIAN GRADIENT
                  DTRM  = 4.0*( RCON-R2JK)
                  IF ( RCON.LE.R2JK) DTRM = ZERO
C                 DTRM=DVDW+DCH
                  DADX=DTRM*X1
                  CX=CX+DADX
                  CPX(KMOFF+1,IPRC)=CPX(KMOFF+1,IPRC)-DADX
                  DADY=DTRM*X2
                  CY=CY+DADY
                  CPX(KMOFF+2,IPRC)=CPX(KMOFF+2,IPRC)-DADY
                  DADZ=DTRM*X3
                  CZ=CZ+DADZ
                  CPX(KMOFF+3,IPRC)=CPX(KMOFF+3,IPRC)-DADZ
               ENDDO                                          !KM
               DO KM=KST,KFINL
                   IF(IOVER_FLAG(KM).EQ.1) OVER_FLAG=.TRUE.
               ENDDO
               CPX(JMOFF+1,IPRC)=CX +CPX(JMOFF+1,IPRC)
               CPX(JMOFF+2,IPRC)=CY +CPX(JMOFF+2,IPRC)
               CPX(JMOFF+3,IPRC)=CZ +CPX(JMOFF+3,IPRC)
               IF (KEY.GE.0) GO TO 200
               JM1=JM1+1
  200       CONTINUE
            EQS(1,IPRC)= EXS2
            EQS(2,IPRC)= EXB2


C END LOOP OVER PROCESSORS
#ifdef PKSR
C+++++++++++++++++++++++++++++++++++
C NEXT LINE IS AN INSTRUCTION FOR THE KSR COMPILER. DO NOT DELETE !!!!
C+++++++++++++++++++++++++++++++++++
c*ksr* END PARALLEL REGION
#endif

#ifndef PKSR
C+++++++++++++++++++++++++++++++++++
C  next line is for serial version
         ENDDO                                                ! IPRC
C+++++++++++++++++++++++++++++++++++
#endif

      ELSE
C   FULL ECEPP CALCULATION
#ifdef PKSR
*******************************************************
C  LOOP OVER INTERACTIONS DISTRIBUTED ON EACH PROCESSOR
*********1*********2*********3*********4*********5*********6*********7**
C NEXT LINES  ARE INSTRUCTIONS FOR THE KSR COMPILER. DO NOT DELETE !!!!
c*ksr* PARALLEL REGION(TEAMID=idteam(idleader+1) ,
c*ksr*&  private=(IPRC,L,II,KM,CX,CY,CZ,KOFF,KST,K5ST,KEY,EXS2,EXB2,
c*ksr*&  KFINL,JADD,QJ1,JJ1,IHBJJ1,XJ,YJ,ZJ,JM1,JMLST,JMOFF,KMOFF,FF,
c*ksr*&  JKR,JKE,X1,X2,X3,R0,R2,R4,R6,CHJK,DCH,EPP,TVDW,DVDW,DTRM,DADX,
c*ksr*&  DADY,DADZ,R2JK,RMAG,IHBCHK,KK,
c*ksr*&  GEES, SR,ESR,VDF, GVDF, DIEINV,
c*ksr*& /threadid/))
CD          call pmon_delta(ibuff(1,ithread),IPMSIZE,istatus)
C+++++++++++++++++++++++++++++++++++
C  next line is for parallel version
         IPRC= ITHREAD + 1
#endif
#ifndef PKSR
C  next line is for serial version
         DO IPRC=1, NPROCS
#endif
C+++++++++++++++++++++++++++++++++++
            EXS2=0.D0
            EXB2=0.D0
            EQS(1,IPRC)=0.D0
            EQS(2,IPRC)=0.D0
            if(icomp(4) .eq. 5) then
               EXH2 = 0.0D0
               EQS(3,IPRC) = 0.0D0
            endif
            JM1=JM_PROC(IPRC)
            JMLST=JML_PROC(IPRC)
            JMOFF=JMOF_PROC(IPRC)
            QJ1=CHARGE(JM1)
C            JJ1=NBTYPE(JM1)
            JJ1=NAPTYP(JM1)
            JADD=2*idiff_types*(JJ1-1)
            XJ=COORD(1,JM1)
            YJ=COORD(2,JM1)
            ZJ=COORD(3,JM1)
C           if(LPRNT) write(JOUT,445) IPRC,JM_PROC(IPRC),
C    &           JML_PROC(IPRC), LEN_INI(IPRC),LEN_FIN(IPRC)
C445   FORMAT('IN CALF IPRC =',i3,' JM_PROC= ',i5,' JML_PROC= ',i5,
C    &      ' LEN_INI=',i3,' LEN_FIN= ',i3)
            DO 100 L=LEN_INI(IPRC),LEN_FIN(IPRC)
               KOFF=INTER(1,L)
               IF (KOFF) 100,10,20
10             JM1=JM1+1
               GO TO 100
20             KST=JM1+KOFF
               K5ST=KST+INTER(2,L)
               KEY=INTER(3,L)
               KFINL=K5ST+KEY-1
               IF (KEY.LT.0) KFINL=NATM
               IF (JM1.EQ.JMLST) GO TO 30
               JMOFF=3*(JM1-1)
               QJ1=CHARGE(JM1)
C               JJ1=NBTYPE(JM1)
               JJ1=NAPTYP(JM1)
               JADD=2*idiff_types*(JJ1-1)
               JMLST=JM1
               XJ=COORD(1,JM1)
               YJ=COORD(2,JM1)
               ZJ=COORD(3,JM1)
30             CX=0.D0
               CY=0.D0
               CZ=0.D0
C2       call pmon_delta(ibuff,IPMSIZE,istatus)
               DO KM=KST,KFINL
                  KMOFF=3*(KM-1)
                  FF=1.0
                  IF (KM.LT.K5ST) FF=0.5
                  JKR=JADD+2*NAPTYP(KM)
                  JKE=JKR-1
                  X1=COORD(1,KM)-XJ
                  X2=COORD(2,KM)-YJ
                  X3=COORD(3,KM)-ZJ
C*************************************************************
C According to David Zirl(KSR), This should be much faster.
CCKSR             R2=1./(X1**2+X2**2+X3**2)
                  R2JK = X1*X1 + X2*X2 + X3*X3
                  RMAG=1./SQRT(R2JK)
                  R2= RMAG*RMAG
                  R0=R2*APS(JKR)
                  R4=R0*R0
                  R6=R0*R4

C Feng Ni, variable dielectric function
C new variables GEES, SR ESR VDF, GVDF, DIEINV
                  IF (VARDIEL) THEN
                     SR=0.3/RMAG
	             ESR=EXP(-SR)
	             VDF=78.0-37.0*ESR*(SR*SR+2.0*SR+2.0)
C                     GVDF=-0.3*(VDF-78.0)-37.0*ESR*(2.0*SR+2.0)*0.3
                     GVDF=-0.3*((VDF-78.0)+74.0*ESR*(SR+1.0))
C This factor of 4.0 is to remove the asummed dielectric function
C from ECEPP force field.                                                    
                     DIEINV=4.0/VDF
                     CHJK=QJ1*CHARGE(KM)*RMAG*DIEINV
c    correction term to gradient with VDF
                     GEES=CHJK*GVDF*RMAG/VDF
                  ELSE
CCKSR                   CHJK=QJ1*CHARGE(KM)*SQRT(R2)
                     CHJK=QJ1*CHARGE(KM)*RMAG
                     GEES=0.0
                  ENDIF
cj
cj   volume hydration    6/13/96  jda
cj
cj       write(6,*) ' IN CALCFPO, ICOMP(4) =', icomp(4)
                  if(icomp(4) .eq. 5) then
                    ii = ictsol(jm1)
                    jj = ictsol(km)
                    if(ii .ne. 0 .and. jj .ne. 0) then
                      locat = ioltec(ii) + 8*(jj - ii - 1)
                      A1=sconst(locat+1)*exp(sconst(locat+2)*r2jk)
                      A2=sconst(locat+3)*exp(sconst(locat+4)*r2jk)
                      A3=sconst(locat+5)*exp(sconst(locat+6)*r2jk)
                      A4=sconst(locat+7)*exp(sconst(locat+8)*r2jk)
                      EXH2 = EXH2 + A1 + A2 + A3 + A4
cj                  write(6,'(2i4,5f12.4)') jm1,km,a1,a2,a3,a4,exh2

                      if (surder) then
                        HDER = -2.0*(sconst(locat+2)*A1 
     &                   + sconst(locat+4)*A2 + sconst(locat+6)*A3
     &                   + sconst(locat+8)*A4) * WGHSUR
cj
cj   the minus sign is inserted above so that what is being computed
cj   is d / dxj (x1 = xk - xj); this is consistent with nonbonded terms.
cj
                        HX = X1 * HDER
                        CX = CX + HX
                        HY = X2 * HDER
                        CY = CY + HY
                        HZ = X3 * HDER
                        CZ = CZ + HZ
                        CPX(KMOFF+1,IPRC)=CPX(KMOFF+1,IPRC)-HX
                        CPX(KMOFF+2,IPRC)=CPX(KMOFF+2,IPRC)-HY
                        CPX(KMOFF+3,IPRC)=CPX(KMOFF+3,IPRC)-HZ
                      endif
                    endif
                  endif
cjj   ********************************************************


C*************************************************************
                  DCH=CHJK*R2
                  EPP=APS(JKE)
C  DISTINGUISH BETWEEN NON-BONDED AND HYDROGEN BOND
                  TVDW=R6*EPP
                  DVDW=TVDW*R2
                  IF (EPP.GE.0.0) THEN
                     TVDW=TVDW*(FF*R6-2.0)
                     DVDW=DVDW*(12.0*FF*R6-12.0)
                  ELSE
                     TVDW=TVDW*(2.0*R4-R6)
                     DVDW=DVDW*(20.0*R4-12.0*R6)
                  ENDIF
C  ADD ENERGY CONTRIBUTIONS (from KM) TO PARTIAL ENERGY
                  EXS2=EXS2+CHJK
                  EXB2=EXB2+TVDW
C  STORE COMPONENTS OF CARTESIAN GRADIENT
                  DTRM=DVDW+DCH+GEES
                  DADX=DTRM*X1
                  CX=CX+DADX
                  CPX(KMOFF+1,IPRC)=CPX(KMOFF+1,IPRC)-DADX
                  DADY=DTRM*X2
                  CY=CY+DADY
                  CPX(KMOFF+2,IPRC)=CPX(KMOFF+2,IPRC)-DADY
                  DADZ=DTRM*X3
                  CZ=CZ+DADZ
                  CPX(KMOFF+3,IPRC)=CPX(KMOFF+3,IPRC)-DADZ
               ENDDO
#ifdef PKSR
C2     call pmon_delta(ibuff,IPMSIZE,istatus)
C2     call pmon_print(ibuff,IPMSIZE)
C3     call pmon_delta(ibuff,IPMSIZE,istatus)
#endif
               CPX(JMOFF+1,IPRC)=CX +CPX(JMOFF+1,IPRC)
               CPX(JMOFF+2,IPRC)=CY +CPX(JMOFF+2,IPRC)
               CPX(JMOFF+3,IPRC)=CZ +CPX(JMOFF+3,IPRC)
               IF (KEY.GE.0) GO TO 100
               JM1=JM1+1
  100       CONTINUE
            EQS(1,IPRC)= EXS2
            EQS(2,IPRC)= EXB2
            if(icomp(4).eq. 5) EQS(3,IPRC) = EXH2 


#ifdef PKSR
CD            call pmon_delta(ibuff(1,ithread),IPMSIZE,istatus)
C END LOOP OVER PROCESSORS; 
C+++++++++++++++++++++++++++++++++++
C NEXT LINE IS AN INSTRUCTION FOR THE KSR COMPILER. DO NOT DELETE !!!!
C+++++++++++++++++++++++++++++++++++
c*ksr* END PARALLEL REGION

CD            call nt_end(idteam)
CD            do itred=0,nprocs-1
CD               print *
CD               print *,' pmon data for thread',itred
CD               call pmon_print(ibuff(1,itred),IPMSIZE)
CD            enddo
C
#endif
#ifndef PKSR
C+++++++++++++++++++++++++++++++++++
C  next line is for serial version
         ENDDO
C+++++++++++++++++++++++++++++++++++
#endif
C
      ENDIF
C  ADD ENERGY CONTRIBUTIONS TO ENERGY
      EES=0.D0
      ENB=0.D0
      if(icomp(4).eq.5) EHYDA=FIX_HYD
      DO L=1, NPROCS
         EES=EES+EQS(1,L)
         ENB=ENB+EQS(2,L)
         if(icomp(4).eq.5) EHYDA = EHYDA + EQS(3,L)
         DO M=1,NATM3
            CGX(M,ICG)= CGX(M,ICG)+ CPX(M,L)
         ENDDO
      ENDDO
      if(icomp(4) .eq. 5) EHYDA = EHYDA * WGHSUR
C       if(LPRNT) WRITE (JOUT,761) EES,ENB
C 761 FORMAT (/,' IN PARALLEL: ENERGIES:',/,
C    @ ' ELECTROSTATIC  ',1P,E12.4,/,' NON-BONDED     ',E12.4)
cd    IF (LPTOR)  WRITE (JOUT,'(a,i2)') 'NUMVAR= ',N
      DO L=1,N
C        write(*,*) l, deg*x(l) 
C        if(LPTOR) 
C    &    write(jout,*) l, iftor(l), a(l),ns(l),nb(l),deg*x(l) 
         IF (IFTOR(L).EQ.1.AND.IFLOV.EQ.0) THEN
            UK=A(L)*(1.+FLOAT(NS(L))*COS(FLOAT(NB(L))*X(L)))
C           write(jout,'(2i3,f7.3,2i5,1x,2e12.5)') l,iftor(l),a(l),
C    &          ns(l),nb(l),deg*x(l),uk
            ETOR=ETOR+UK
         ENDIF
      ENDDO
C       WRITE (JOUT,*)  'DIHECNST is ',DIHECNST
      EDIHC=0.0
c     IF (DIHECNST) write(*,*) 'NOW CALCFPO CALLING CONST_DIEH'
      IF (DIHECNST) CALL CONST_DIEH(N,X)
C
      IF (NLOOP.GT.0.AND.IFLOV.EQ.0) CALL ENEBRIDGE
C
C DISTANCE-CONSTRAINT ENERGY COMES HERE.
      EDIS=0.0
c     IF (WITHCNST) write(*,*) 'NOW CALCFPO CALLING DISFF'
      IF (WITHCNST)   CALL DISFF
      ERMSD=0.0
      IF (IRUNTYP.EQ.8)   CALL RMSCONST(.FALSE.)
      IF (ICOMP(4).EQ.5) THEN
         F=EES+ENB+ETOR+ETORBR+ELOOP+EDIS+EDIHC+EHYDA+ERMSD
      ELSE
         F=EES+ENB+ETOR+ETORBR+ELOOP+EDIS+EDIHC+ERMSD
      ENDIF
C       WRITE (JOUT,*)  'F or ETOT ',F,' EDIS ', EDIS
C    &                  ,'EDIHC ', EDIHC
      IF (NF.LT.0) THEN
#ifdef PKSR
        call pthread_mutex_lock (imutex, jstat)
#endif
        WRITE (JOUT,768) EES,ENB,ETOR,ELOOP,F
#ifdef PKSR
        call pthread_mutex_unlock (imutex, jstat)
#endif
      ENDIF
710   CONTINUE
      DELPHI=0.0D0
cj      EHYDA=0.0D0
      IF (ICOMP(2).EQ.1 .AND. SURDER) THEN
        CALL HYDRAT
        if (iamcon.eq.-1) nf=0
        F=F+EHYDA
      ENDIF

 
cd     WRITE(jout,*)'FINAL CGX' 
cd     DO M=1,NATM3
cd          JMX= M/3
cd          IF (3*JMX.LT.M) JMX=JMX+1
cd          print *,m,jmx,icg
cd           WRITE(jout,*)'JMX,CGX ',JMX, CGX(M,ICG)
cd     ENDDO
      IF (ABS(F).GT.TOOBIG) NF=0
      RETURN
  768 FORMAT (/,' ENERGIES:',/,
     @ ' ELECTROSTATIC  ',1P,E12.4,/,' NON-BONDED     ',E12.4,
     @ /,' TORSIONAL      ',E12.4,/,' S-S BRIDGE     ',E12.4,
     @ /,' TOTAL  ',8X,E12.4)
      END
