c.. connection of low  density dots with all heavy atoms    
c.  results of this procedure needs for fast sorting lg_se-->sm_se
c.nov.94 
c Double precision 

	subroutine connect_la(nsoord,soord,rad_ps)          

#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
	include'param.ibems'
	include'comm.ibems'
        include 'COMMON.MYCONF'
        real*8 soord(3,maxat),rad_ps(maxat),atmq_ps(maxat)
        integer nsoord,natomt


c.. 
	real*8 xyz(3),vnor(3)
	real*8 od,big,blow,ssb,dmin,dist1,dtemp,sd,sc
        character*1 atname
        integer llarg,ib,is,lsmalg,isn,j,ntot,il,nlgatm,i,nh,nlzero
        integer llargel,nbsenew,ipos,jl,k,ia,ie
        integer iiprint0,iiprint1,iiprint2
        integer ip,lsk,l,ia1,nnll,kk
        real*8 d1,d0

c        real*8 darray(1000,100)

        iiprint0=0
        iiprint1=1
        iiprint2=2
c..
        od = 0.d0

	big=9.9d10
	blow=0.0d0
c 

        natomt=nsoord
        nlgatm=nlgse_pmx
c. nlgatm, nlgse_pmx -number of large se per atom
        
        if(outdetl.ge.iiprint1)then
c          write(kanalp,*)'connect_la:',
c    &     'natomt',natomt
c          write(*,'(A4)')(atnamel(jl),jl=1,natomt)
           
           write(*,*)'connect_la:',
     &     'nlargse_t',nlargse_t,'nsurfp_t=',nsurfp_t
        end if

	do 100 i=1,MAXAT    
	   do 110 j=1,nlgatm     
110        ilarg_atm(j,i)=0
100	nlargt_atm(i)=0

c..assembling  of large se with heavy atoms> H
	ntot=0
	do 200 il=1,nlargse_t
           sstot_l=sstot_l+arealargse_t(il) 
	   ssb=od
	   dmin=big
	   ipos=0

	   do 210 jl=1,natomt  
c test
c             darray(il,jl)=big
c end test

              atname=atnamel(jl)(1:1)
              if(atname.eq.'H')goto 210

cMY11 consider atoms which has assigned sm se
              if(nsmalt_atm(jl).eq.0)goto 210

	      dist1=od  
	      sc=od
        
	      do 220 k=1,3
	         dtemp= soord(k,jl)-cxyzlargse_t(k,il)
                 dist1=dist1 + dtemp*dtemp
220	      continue

c               if (il.eq.300) write (*,'(i4,2f10.5)') 
c     &                                   jl,dist1,rad_ps(jl)
        
              dist1=dist1/rad_ps(jl)-rad_ps(jl)

c.... for diagnostics
c               darray(il,jl)=dist1
c.... end diagnostics

	      if(dist1.le.dmin)then
                 ipos=jl
	         dmin=dist1
              end if
210	   continue
	   if(ipos.ne.0)then
	      ntot=ntot+1
	      nlargt_atm(ipos)=nlargt_atm(ipos)+1
	      nh=nlargt_atm(ipos)  
c nlargt_atm(ia) = number of lg se which belongs to atom ia

	      if(nh.ge.nlgse_pmx)then
                 write(*,*)'connect_la:ERROR nlgse_pmx SMALL',
     &               nlgse_pmx
                 kprotfail=-110
                 return
              end if ! nh control 
	      ilarg_atm(nh,ipos)=il  
c  ilarg_atm(il,ia)=il - list of lg se which are belongs to atom ia

           end if
200	continue
c.......................................................................
c.
        if(outdetl.ge.iiprint2)then
           do ia=1,nnmlat
c             write(*,*)ia,atnamel(ia),'lg se',nlargt_atm(ia),
c    &        'sm se',nsmalt_atm(ia)
           end do ! ia
        end if
c.
c..creation of surface pieces=surface expoused atoms

	nlzero=0
	nbsenew=0       ! numb of surf pieces
        nnll=0

	do 400 ib=1,natomt  
	   if(nsmalt_atm(ib).eq.0)then
c..No surface of atom ib
              if(outdetl.gt.iiprint2)then
                 write(*,*)
     &            'connect_la: atom ib=',ib,' has zero sm se'
              end if
              latom_ip(ib)=0
	      nlzero=nlzero+1

c..yu m28 start
              if(nlargt_atm(ib).ne.0)then
         
c..put into list atoms with large_se (but without small se)
                 do ie=1,nlargt_atm(ib)
                    nnll=nnll+1     
                    llargel=ilarg_atm(ie,ib)
                    if(outdetl.ge.iiprint1)then
                       write(*,*)'connect_la:!!atom',ib,
     &                'has lq se,but no sm se'
                       write(*,*)
     &                'connect_la: canceled lg se',llargel
                       write(*,*)
     &                'connect_la:area of lg se',llargel,'set to 0.0'
                       write(*,*)
     &                'area(elimint)=',arealargse_t(llargel)
                    end if

                    arealargse_t(llargel)=0.d0
                 enddo

cMY11             nlargt_atm(ib)=0

              end if !nlargt_atm(ib) n.e. 0 
c...yu m28 end

	      goto 400
   	   end if ! zero numb of sm se

	   if(nsmalt_atm(ib).ne.0)then
c Surface for atom ib EXISTS

              nbsenew=nbsenew+1

c              write(*,*)'connect_la: atom ib=',ib,' has nonzero sm se',
c     &                                             nsmalt_atm(ib)

              if(nlargt_atm(ib).eq.0)then
c ....................................................................... 
                 if(outdetl.ge.iiprint1)then
                    write(*,*)'connect_la: insert new large se!'
                 end if
c
c.. insert additional large se and assign it to atom ib
c
                 nlargse_t=nlargse_t+1
                 if(nlargse_t.gt.nlargsemx_t)then
                    write(*,*)
     &               'connect_la: nlargesemx_t SMALL',nlargsemx_t
                    kprotfail=-111
                    return
                 end if !control
c 
c                  write(*,*)'connect_la:atom ib, nsurfp=',ib,nbsenew
c

                 if(nbsenew.gt.npc_mx)then
                    write(*,*)
     &               'connect_la:ERROR prm: npc_mx(n surf p) SMALL'
                    kprotfail=-112
                    return
                 end if ! nbsenew control
         
c                if(outdetl.ge.iiprint1)then
c                   write(*,*)
c    &             'connect_la:insert new lg se atom ib, nbsenew=',
c    &                ib,nbsenew, 'nlargse_t=',nlargse_t
c                   write(*,*)'new lg se consist on ',
c    &                nsmalt_atm(ib),'sm se'
c                   write(*,'(10i5)')
c    &                (ismal_atm(isn,ib),isn=1,nsmalt_atm(ib))
c                end if
c.
                 nlargt_atm(ib)=1
                 nsurfp_lg(nbsenew)=nlargt_atm(ib)
                 ilarg_atm(1,ib)=nlargse_t

                 llarg=ilarg_atm(1,ib)
                 lsurfp_ilg(1,nbsenew)=ilarg_atm(1,ib)
c.
                 do k=1,3
                    cxyzlargse_t(k,nlargse_t)=0.d0
                    vnlargse_t(k,nlargse_t)=0.d0
                 end do !k

                 nsmalse_ilg(nlargse_t)=nsmalt_atm(ib)
                 arealargse_t(nlargse_t)=0.d0
c.
                 if(nsmalt_atm(ib).eq.0)then
                    write(*,*)
     &                'Warning!! connect_la: nsmalt_atm(ib)=0,ib=',ib
                 end if

                 do isn=1,nsmalt_atm(ib)     
                    lsmalg=ismal_atm(isn,ib)  
                    if(isn.gt.nsmalse_lgmx)then
c                      write(*,*)
c    &        'ERROR connect_la: param nsmalse_lgmx too small!!=',isn
                       write(*,*)
     &        'ERROR connect_la: param nsmalse_lgmx too small!!=',isn
                       kprotfail=-113
                       return
                    end if

                    lsmalse_ilg(isn,nlargse_t)=ismal_atm(isn,ib)
                    arealargse_t(nlargse_t)=arealargse_t(nlargse_t)+
     &                          areasmalse_t(lsmalg)            
                    do k=1,3
                       cxyzlargse_t(k,nlargse_t)=
     &                  cxyzlargse_t(k,nlargse_t)+
     &                  cxyzsmalse_t(k,lsmalg)*areasmalse_t(lsmalg)
        
                       vnlargse_t(k,nlargse_t)=
     &                  vnlargse_t(k,nlargse_t)+
     &                  vnsmalse_t(k,lsmalg)*areasmalse_t(lsmalg)
                    end do  ! k
                 end do !isn

                 do k=1,3
                    cxyzlargse_t(k,nlargse_t)=
     &               cxyzlargse_t(k,nlargse_t)/arealargse_t(nlargse_t)        

                    vnlargse_t(k,nlargse_t)=vnlargse_t(k,nlargse_t)/
     &               arealargse_t(nlargse_t)        
                 end do !k

              end if ! nlargt_atm. Inserting of new largse
c...................................................................

              if(nbsenew.gt.npc_mx)then
                 write(*,*)
     &              'connect_la:ERROR prm: npc_mx(n surf p) SMALL'
                 kprotfail=-113
                 return
              end if ! nbsenew control
c.

              if(nlargt_atm(ib).gt.0)then
                 nsurfp_lg(nbsenew)=nlargt_atm(ib)

                 if(latom_ip(ib).ne.nbsenew)then 
                    write(*,*)'ERROR 1 in connect_la'
                    kprotfail=-114
                    return
                 end if ! control

                 do 402 is=1,nlargt_atm(ib)
                    nnll=nnll+1
                    llarg=ilarg_atm(is,ib)
                    lsurfp_ilg(is,nbsenew)=ilarg_atm(is,ib)
402              continue
      
              end if !nlargt_atm(ib).gt.0

           end if !nsmalt_atm(ib).ne.0

400	continue
c Control
        if(outdetl.ge.iiprint1)then
           write(*,*)'connect_la: nlargese_t=',nlargse_t
           write(*,*)'connect_la: control(1):nlargse_t=',nnll
        end if
 
c Control
        nnll=0
        do ip=1,nbsenew
           do il=1,nsurfp_lg(ip)
              nnll=nnll+1
           end do
        end do

        if(nsurfp_t.ne.nbsenew)then
           write(*,*)'ERROR 2 connect_la '
           write(*,*)'nbsenew=',nbsenew,'nsurfp_t=',nsurfp_t
           kprotfail=-115
           return
        end if !control

c	write(*,*)' connect_la: atoms with zero area=',nlzero 	
        sstot_l=0.d0
        do il=1,nlargse_t
           sstot_l=sstot_l+arealargse_t(il) 
        end do !il

        if(outdetl.ge.iiprint1)then
           write(*,*)'connect_la: nlargese_t=',nlargse_t
           write(*,*)
     &     'connect_la: control(2)over atoms with sm senlargse_t=',
     &      nnll
           write(*,*)'connect_la: sstot_l',sstot_l
        end if
c
        if(outdetl.ge.iiprint2)then
c             write (*,'(6(i5,f10.5))') (k,darray(300,k),k=1,natomt)
           do ip=1,nsurfp_t
              ia=lsurfp_ia(ip)
              write (*,'(a,i4,a,i4)') 'Surface atom',ip,
     &         ' global number',ia

c              do k=1,nsurfp_lg(ip)
c                ia1=0
c                lsk=lsurfp_ilg(k,ip)
c                d0=darray(lsk,ia)
c                d1=10000000.0D0
c                do l=1,natomt
c                   if (l.ne.ia .and. darray(lsk,l).lt.d1) then
c                       ia1=l
c                       d1=darray(lsk,l)
c                   endif
c                 enddo !l atom
c                 write (*,'(a,2i4,f20.15,i4,f20.15)') 
c     &          'Surface element',lsurfp_ilg(k,ip),ia,d0,ia1,d1
c               enddo !k
c              write (*,'(a)')

              write(*,*)'n lg se=',nsurfp_lg(ip),'lg se list:'
              write(*,'(14i5)')
     &              (lsurfp_ilg(is,ip),is=1,nsurfp_lg(ip))
           end do !ip
        end if
c          write(*,*)'END connect_la'

c
c .PDB file of surface and molecule
c
c        write (22,'(/a)') 'REMARK molecule'
c        do i=1,natomt
c
c        write (22,'(A6,I5,1X,A4,1X,A4,1X,I4,4X,3F8.3)')
c     & 'ATOM  ',i,atnamel(i),resnamel(i),resnumbl(i),(soord(j,i),j=1,3)
c
c        enddo
c        write (22,'(/a)') 'REMARK surface'
c        do i=1,nlargse_t
c        write (22,'(A6,I5,1X,A4,1X,A4,1X,I4,4X,3F8.3)')
c     & 'ATOM  ',i,'X   ','ALA',i,(cxyzlargse_t(j,i),j=1,3)
c        enddo

1099	return
	end
