c.. connection of low  density dots with high density dots    
c.nov.94 
c Double precision 

	subroutine connect_lh          

#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
	include'param.ibems'
	include'comm.ibems'
        include 'COMMON.MYCONF'
c extedned region for lg se
        integer nlargmx_ex
        parameter(nlargmx_ex=6*nlgse_pmx)
        integer lsurfpex_ilg(nlargmx_ex,maxat), nsurfpex_lg(maxat)
c pointers
        integer nnew_pse(maxat),point_pse(maxat)
        integer nnew_lse(nlargsemx_t),point_lse(nlargsemx_t)
        integer ngaplse,ngappse,ipn
c.. 
	real*8 xyz(3)
	real*8 big,blow,sd2,dmin,ss,sum
        character*1 atname
        integer ilg,k,lg,nsm,isg,nlgtot,nsmtot,il,ipos,is,ip,np
        integer iiprint0,iiprint1,iiprint2
        integer nnss,npi_new,nlg_new,nnls,nnll
        real*8 range,dd,toler
c..

	big=9.9d10
	blow=0.0d0
        toler=1.0d-9
        iiprint0=0
        iiprint1=1
        iiprint2=2

        do il=1,nlargsemx_t
           nsmalse_ilg(il)=0
        end do !il

c        write(kanalp,*)'start connect_lh:'
c        write(*,*)'start connect_lh:'
c. 
        nsmtot=0
        nlgtot=0

c apr 17 new version of connect_lh - consider l-->h connection in the exdended
c subset of sm se and lg se which belongs to given sp ip and all nearest sp jp
c defenition of nearest neighbours
        if (nsurfp_t.gt.maxat) then
          write(*,*) 'ERROR: CONNECT_LH; nsurfp_t.gt.maxat '
c         write(kanalp,*) 'ERROR: CONNECT_LH; nsurfp_t.gt.maxat '
          kprotfail=-120
          return
        endif
c       write(*,*) 'CONNECT_LH; nsurfp_t; nlargse_t',nsurfp_t,nlargse_t
        do ip=1,nsurfp_t

           nsurfpex_lg(ip)=0
           range=(atradl(lsurfp_ia(ip))+1.5d0*rp_rpr)**2

           do il=1,nlargse_t
              dd=0.d0
              do k=1,3
	         dd=dd+(surfp_xyz(k,ip)-cxyzlargse_t(k,il))**2
              end do !k
              if(dd.lt.range)then
                 np=nsurfpex_lg(ip)+1
                 nsurfpex_lg(ip)=np

                 if(np.gt.nlargmx_ex)then
                    write(*,*)'CONNECT_LH: ERROR increase nlargmx_ex'
c                   write(kanalp,*)
c    &                 'CONNECT_LH: ERROR increase nlargmx_ex'
                    kprotfail=-121
                    return
                 end if

                 lsurfpex_ilg(np,ip)=il
              end if

           end do !il

           if(outdetl.ge.iiprint2)then
              write(*,*)'extended asignment lg se to spiece ip='
     &         ,ip,'n=',nsurfpex_lg(ip)
              write(*,'(14i5)')
     &          (lsurfpex_ilg(k,ip),k=1,nsurfpex_lg(ip))
           end if

        end do !ip
c end of EXTENDED subset definition

c      sm se ---> lg se connection for each atom
c. main loop over pieces and sm se in that pieces

        do ip=1,nsurfp_t
           nlgtot=nlgtot+nsurfp_lg(ip)
c  subset of sm se is regular nonoverlaping
           do is=1,nsurfp_sm(ip)        
              dmin=big
              ipos=0
              isg=lsurfp_ism(is,ip)
              do k=1,3
                 xyz(k)=cxyzsmalse_t(k,isg)
              end do !k

c subset of large se is changed on extended subset
c nsurfpex_lg() and lsurfpex_ilg(,) instead regular one lsurfp_ilg(,)

cex
              do il=1,nsurfpex_lg(ip) 
                 sd2=0.d0
cex
                 ilg=lsurfpex_ilg(il,ip)
                 do k=1,3
                    sd2=sd2+(xyz(k)-cxyzlargse_t(k,ilg))**2
                 end do !k
                 if(sd2.lt.dmin)then
                    dmin=sd2
                    ipos=il
                 end if
              end do !il
c. ipos - neares il to small se is
              if(ipos.ne.0)then
cex
                 ilg=lsurfpex_ilg(ipos,ip)
                 nsmtot=nsmtot+1
                 nsm=nsmalse_ilg(ilg)+1
                 nsmalse_ilg(ilg)=nsm
                 if(nsm.gt.nsmalse_lgmx)then
                    write(*,*)'ERROR connect_lh:',
     &                       ' nsmalse_lgmx too small ',nsm 
                    kprotfail=-122
                    return
                 end if !nsm
     
                 lsmalse_ilg(nsm,ilg)=isg
              end if !ipos
c.MY11
              if(ipos.eq.0)then
                 if(outdetl.le.iiprint1)then
                    write(*,*)'WARNING !!'
                    write(*,*)'sm se isg',isg,'of piece ip',ip,
     &                      'is not CONNECTED with any lg se'
                 end if
              end if
          
           end do !is

        end do !ip

c control
        if(nsmtot.ne.nsmalse_t)then
           write(*,*)'ERR2 connect_lh: sm se numbers are',
     &      'inconsistent. nsmtot,nsmalse_t=',nsmtot,nsmalse_t
c          write(kanalp,*)'ERR2 connect_lh: sm se numbers are',
c    &      'inconsistent. nsmtot,nsmalse_t=',nsmtot,nsmalse_t
           kprotfail=-123
           return 
        end if

c 
c refined defenition of small se into surf piece
c Piece-->Large-->Small
c
        nnss=0
        nnll=0
        sstot_s=0.d0
        sstot_l=0.d0
        sstot_p=0.d0
        npi_new=0
        do ip=1,nsurfp_t
           
           do is=1,nsmse_pmx
              lsurfp_ism(is,ip)=0
           end do !is

           nsurfp_sm(ip)=0
           surfp_s(ip)=0.d0

c 
c Loop over all Large se
c

           if(nsurfp_lg(ip).gt.0)then
              do il=1,nsurfp_lg(ip)
                 ilg=lsurfp_ilg(il,ip)
                 nnll=nnll+1
                 if(nsmalse_ilg(ilg).ne.0)then 
                    do is=1,nsmalse_ilg(ilg)
                       isg=lsmalse_ilg(is,ilg)
                       nsurfp_sm(ip)=nsurfp_sm(ip)+1   
                       lsurfp_ism(nsurfp_sm(ip),ip)=isg
                       surfp_s(ip)=surfp_s(ip)+areasmalse_t(isg)
                       nnss=nnss+1
                       sstot_s=sstot_s+areasmalse_t(isg)
                    end do ! is
                 end if

                 sstot_l=sstot_l+arealargse_t(ilg)
              end do ! il
           end if

           sstot_p=sstot_p+surfp_s(ip)

        end do ! ip

cMY11 Control
        if(nnll.ne.nlargse_t)then
            write(*,*)'connect_lh: nnll,nlargse_t',nnll,nlargse_t
c          write(kanalp,*)'connect_lh: nnll,nlargse_t',nnll,nlargse_t
           kprotfail=-124
           return 
c            stop
        end if
c
           if(outdetl.ge.iiprint1)then
           write(*,*)'connect_lh: surf control:sstot_s=',
     &     sstot_s,'sstot_l=',sstot_l,'sstot_p=',sstot_p
        end if
cMY11
c
c redefine surface area of large se 
c                        to be consistent with surface area of small se
        nlg_new=0
        sum=0.d0
        nnls=0
        do lg=1,nlargse_t
           ss=0.d0
           
           nsm=nsmalse_ilg(lg)

           if(nsm.ne.0)then
              do is=1,nsm
                 nnls=nnls+1
                 isg=lsmalse_ilg(is,lg)
                 ss=ss+areasmalse_t(isg)
              end do !is
           end if !nsm
           arealargse_t(lg)=ss

           sum=sum+ss
        end do !lg
        sstot_l=sum
c 

        if(nnss.ne.nsmalse_t.or.nnls.ne.nsmalse_t)then
           write(*,*)'connect_lh ERROR3: nnss=',nnss,
     &     'nnls=',nnls,'nsmalse_t=',nsmalse_t
c          write(kanalp,*)'connect_lh ERROR3: nnss=',nnss,
c    &     'nnls=',nnls,'nsmalse_t=',nsmalse_t
           kprotfail=-125
           return
        end if
        if(dabs(sstot_s-sstot_p).gt.toler.or.
     &     dabs(sstot_l-sstot_p).gt.toler)then
           write(*,*)'connect_lh ERROR4: surf control:sstot_s=',
     &     sstot_s,'sstot_l=',sstot_l,'sstot_p=',sstot_p
c          write(kanalp,*)'connect_lh ERROR4: surf control:sstot_s=',
c    &     sstot_s,'sstot_l=',sstot_l,'sstot_p=',sstot_p
           kprotfail=-126
           return
        end if
           
	sstot_sm=sstot_s  !Apr

c. end of refined def
c
c clean zero lg se and zero p se
c
c pointers and new_numubers for lg se
        ngaplse=0
        do lg=1,nlargse_t
           point_lse(lg)=lg
           if(arealargse_t(lg).eq.0.d0)then
              ngaplse=ngaplse+1
              point_lse(lg)=0
           end if
           nnew_lse(lg)=lg-ngaplse
        end do
c
c pointers and new numbers for p se
        ngappse=0
        do ip=1,nsurfp_t
           point_pse(ip)=ip
           if(surfp_s(ip).eq.0.d0)then
              ngappse=ngappse+1
              point_pse(ip)=0
           end if
           nnew_pse(ip)=ip-ngappse
        end do
c
c renumbering of p se
            if(outdetl.ge.iiprint1)then
           write(*,*)'Canceled zero area P se=',ngappse
        end if

        do ip=1,nsurfp_t
           if(point_pse(ip))10,10,20

20         ipn=nnew_pse(ip)
           surfp_s(ipn)=surfp_s(ip)
           do k=1,3
              surfp_xyz(k,ipn)=surfp_xyz(k,ip)
           end do
c data move 
           do il=1,nsurfp_lg(ip)
              lsurfp_ilg(il,ipn)=lsurfp_ilg(il,ip)
           end do
           nsurfp_lg(ipn)=nsurfp_lg(ip)

           do is=1,nsurfp_sm(ip)   
              lsurfp_ism(is,ipn)=lsurfp_ism(is,ip)
           end do
           nsurfp_sm(ipn)=nsurfp_sm(ip)
 
10         continue       
        end do ! ip

        nsurfp_t=nsurfp_t-ngappse

c  p se of zero area must not be existed
c  end of renumbering



        if(outdetl.ge.iiprint1)then
           write(*,'(a31,f14.7,a9,f14.7,a9,f14.7,a9,f14.7)')
     &    'connect_lh:final surf control:sstot_s=',
     &     sstot_s,'sstot_l=',sstot_l,'sstot_p=',sstot_p
        end if

        if(outdetl.ge.iiprint2)then
           write(*,*)'connect_lh:total redefined surf of lg se='
     &           ,sum   
           do il=1,nlargse_t    
              nsm=nsmalse_ilg(il)
              write(*,'(a14,i5,a5,f8.4,a17,i5)')
     &         'large se il=',il,'area=',arealargse_t(il),
     &         'consist of nsm se=',nsm    
              write(*,'(14i5)')(lsmalse_ilg(is,il),is=1,nsm)
           end do
           write(*,*)'end of connect_lh:'     
        end if
        return
        end
