      subroutine read_supat(jin,jout,errflag)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      include 'PARAMET.ADD'
      include 'COMMON.CLUSTAT'
      logical errflag
      read(jin,*,end=10,err=10) nnat
      read(jin,'(15(A4,1X))',end=10,err=10) (idatt(i),i=1,nnat)
cd    write(*,*) nnat
cd    write(*,'(15(A4,1X))') (idatt(i),i=1,nnat)
      return
   10 errflag=.true.
      return
      end
c------------------------------------------------------------------------------------------------
      subroutine atselect
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      include 'PARAMET.ADD'
      include 'COMMON.CNTRL'
      include 'COMMON.CNTRL1'
      include 'COMMON.IOUNIT'
      include 'COMMON.GEN100'
      include 'COMMON.ATOMSS'
      include 'COMMON.CLUSTAT'
      include 'COMMON.SUPER'
      include 'COMMON.TRACK'

C Just temporary initialization of nrclus1 & nrclus2 (means that this will stay here for ...
C a long time at least).
      nrclus1 = 1
      nrclus2 = inumrs
      natoms=npre(inumrs+1)
      if (idatt(1).eq.'ALL') then
        nnat=0
        nacomp=natoms
        do i=1,inumrs
          nresup(i)=npre(i+1)-npre(i)
          do j=npre(i)+1,npre(i+1)
            iresup(i,j)=i
          enddo
        enddo
        nacomp=0
        do 112 i=1,natoms
          ires=kax(i)+1
          if (ires.lt.nrclus1 .or. ires.gt.nrclus2) goto 112
          nacomp=nacomp+1
          iaclust(nacomp)=i
          do j=1,nnat
            if (alph(i).eq.idatt(j)) goto 112
          enddo
          nnat=nnat+1
          if (nnat.gt.100) then
            write (jout,'(a)') 
     &        'Too many atom types to superimpose. Stop.'
            write (jout,'(5(20a4/))') 'Found so far:',(idatt(l),l=1,100)
            stop
          endif
          idatt(nnat)=alph(i) 
  112   continue
      else if (idatt(1).eq.'HEAV') then
        nnat=0
        nacomp=0
        do i=1,inumrs
          nresup(i)=0
        enddo
        do i=1,natoms
          ka=kax(i)+1
          if (ka.ge.nrclus1 .and. ka.le.nrclus2 .and.
     &        alph(i)(1:1).ne.'H') then
            nacomp=nacomp+1
            iaclust(nacomp)=i
            nresup(ka)=nresup(ka)+1
            iresup(ka,nresup(ka))=i
            do j=1,nnat
              if (alph(i).eq.idatt(j)) goto 111
            enddo
            nnat=nnat+1
          if (nnat.gt.100) then
            write (jout,'(a)') 
     &     'Too many atom types to superimpose. Stop.'
            write (jout,'(5(20a4/))') 
     &    'Found so far:',(idatt(l),l=1,100)
            stop
          endif
            idatt(nnat)=alph(i) 
 111      endif  
        enddo
      else if (idatt(1).eq.'BACK') then
        nnat=0
        nacomp=0
        do i=1,inumrs
           nresup(i)=0
           npre1=npre(i)
           if ( i.eq.1 .or. i.eq.inumrs) then
              nlasta = npre(i+1)-npre1
           else
              nlasta = 7
           endif
           do j=(npre1 + 1),(npre1 + nlasta)
             ka=kax(j)+1
             if (ka.ge.nrclus1 .and. ka.le.nrclus2 .and.
     &           alph(j)(1:1).ne.'H') then
               nacomp=nacomp+1
               iaclust(nacomp)=j
               nresup(ka)=nresup(ka)+1
               iresup(ka,nresup(ka))=j
               do k=1,nnat
                 if (alph(j).eq.idatt(k)) goto 113
               enddo
               nnat=nnat+1
               if (nnat.gt.100) then
                 write (jout,'(a)') 
     &          'Too many atom types to superimpose. Stop.'
                 write (jout,'(5(20a4/))') 
     &         'Found so far:',(idatt(l),l=1,100)
                 stop
               endif
               idatt(nnat)=alph(j) 
 113         endif  
           enddo
        enddo
      else
        nacomp=0
        do i=1,inumrs
          nresup(i)=0
        enddo
cd      write (jout,*) 'nnat=',nnat
cd      write(jout,'(15(A4,1X))') (idatt(i),i=1,nnat)
cd    write (jout,*)'natoms=',natoms,' nrclus1=',nrclus1,
cd   & ' nrclus2=',nrclus2
cd    write (jout,*)'npre:',(npre(i),i=1,inumrs)
        do 10 i=1,natoms
          ka=kax(i)+1
cd        write(jout,*) 'i=',i,' ka=',ka
          if (ka.lt.nrclus1 .or. ka.gt.nrclus2) goto 10 
          do j=1,nnat
cd          write (jout, *)i,j,' ',alph(i),idatt(j)
            if (alph(i).eq.idatt(j)) then
              do k=1,nresup(ka)
                if (alph(i).eq.alph(iresup(ka,k))) goto 10 
              enddo
              nacomp=nacomp+1
              iaclust(nacomp)=i
              nresup(ka)=nresup(ka)+1
              iresup(ka,nresup(ka))=i
              goto 10
            endif
          enddo 
   10   continue
      endif 
      write (jout,'(a)') 'The IDATT array:'
      write (jout,'(16a5)') (idatt(i),i=1,nnat)
      ntresup(1)=0
      do i=2,inumrs+1
        ntresup(i)=ntresup(i-1)+nresup(i-1) 
      enddo
      write (jout,'(a,i5)') 'Number of atoms to be superimposed:',
     1            nacomp
      write (jout,'(a)') 'Numbers and IDs of these atoms:'

      do i=1,nacomp
        write (jout,'(3i5,1x,a4)') i,kax(iaclust(i))+1,iaclust(i),
     & alph(iaclust(i))
      enddo
cd    do i=1,inumrs
cd      write (jout,'(20i4)') i,nresup(i),ntresup(i),
cd   &                     (iresup(i,j),j=1,nresup(i))
cd    enddo
      if (nacomp.gt. maxnum_atoms_clust) then
        write (jout,'(/80(1h*),a,i6,a,i6)') 
     & 'Number of atoms in clustering is',nacomp,
     & ' this is greater than MAXNUM_ATOMS_CLUST=',maxnum_atoms_clust
        write (jout,'(2a/80(1h*))') 
     & 'To proceed, increase MAXNUM_ATOMS_CLUST',
     & ' in PARAMET.ECEPP and re-make the program.'
        stop 'Insufficient memory'
      endif
      return
      end
c------------------------------------------------------------------------------
      subroutine dist_new_conf(rms_min,icnfn)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      include 'PARAMET.ADD'
      include 'COMMON.IOUNIT'
      include 'COMMON.CNTRL'
      include 'COMMON.CNTRL1'
      include 'COMMON.GEN100'
      include 'COMMON.BONDSX'
      include 'COMMON.GEN000'
      include 'COMMON.ATOMSS'
      include 'COMMON.CLUSTAT'
      include 'COMMON.CLUSTER'
      include 'COMMON.SUPER'
      include 'COMMON.TRACK'
      double precision t(3),b(3,3),rms
      logical fail

      call gener
      do i=1,nacomp
        ici=iaclust(i)
        do j=1,3
          allcart(j,i,ncon+1)=coord(j,ici)
          s1(j,i)=coord(j,ici)
        enddo
      enddo
      rms_min=1.0D+06
      icnfn=0
      do i=1,ncon
         do k=1,nacomp
            do l=1,3
               s2(l,k)=allcart(l,k,i)
            enddo
         enddo
c add 7th argument, fail, since sub has it. dis 6-9-99
         call fitsq(s2,s1,nacomp,t,b,rms,fail) 
! check if fitsq has worked properly. DR 10/99
         if (.not.fail) then
            if (rms.lt.rms_min)   then
               rms_min=rms
               icnfn=i
            endif
         else
! if the comparison fails, then assume the conformations are very different
            rms=1.0D+06
         endif
         attalums(icant(i,ncon+1))=rms
      enddo
      return
      end
