C $Date: 1996/11/11 22:10:01 $
C $Revision: 3.9 $
C
C
C
      SUBROUTINE  ATTABLE
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.PEPT'
      INCLUDE 'COMMON.ACAR'
      INCLUDE 'COMMON.IOUNIT'
      LOGICAL LPROLIN
      LOGICAL FIRSTC
C
C This subroutine determines the numbers of CA's (and pseudo CA'a in the
C case of the end groups) in the polypeptide chain.
C
      INTERM=IABS(LIST(1))
      ICTERM=IABS(LIST(INUMRS))
      NST=2
      IF (INTERM.GT.3 .AND. INTERM.NE.6 .AND. INTERM.NE.10) THEN
        NST=1
        IF (INTERM.EQ.4) THEN
          IAT(1,1)=4
          IAT(1,3)=6
        ELSE IF (INTERM.EQ.5) THEN
          IAT(1,1)=1
          IAT(1,3)=3
        ELSE IF (INTERM.EQ.7) THEN
          IAT(1,1)=13
          IAT(1,3)=15
        ELSE IF (INTERM.EQ.8) THEN
          IAT(1,1)=14
          IAT(1,3)=16
        ELSE IF (INTERM.EQ.9) THEN
          IAT(1,1)=12
          IAT(1,3)=14
        ELSE IF (INTERM.EQ.21) THEN
          IAT(1,1)=7
          IAT(1,2)=12
        ELSE IF (INTERM.EQ.22) THEN
          IAT(1,1)=13
          IAT(1,2)=18
        ELSE IF (INTERM.EQ.23) THEN
          IAT(1,1)=20
          IAT(1,2)=25
        ELSE IF (INTERM.NE.10) THEN
          WRITE (JOUT,'(A)') 
     &    'Warning - undefined N-terminal group for lambda motion.'
        ENDIF
      ENDIF
      NEN=INUMRS-1
      IF (ICTERM.GT.13 .AND. ICTERM.NE.20) THEN
        NEN=INUMRS
        IF (ICTERM.EQ.14) THEN
          IAT(INUMRS,1)=3
          IAT(INUMRS,2)=1
        ELSE IF (ICTERM.EQ.15) THEN
          IAT(INUMRS,1)=3
          IAT(INUMRS,2)=1
        ELSE IF (ICTERM.EQ.16) THEN
          IAT(INUMRS,1)=3
          IAT(INUMRS,2)=1
        ELSE IF (ICTERM.EQ.17) THEN
          IAT(INUMRS,1)=2
          IAT(INUMRS,2)=1
        ELSE IF (ICTERM.EQ.18) THEN
          IAT(INUMRS,1)=2
          IAT(INUMRS,2)=1
        ELSE
          WRITE (JOUT,'(A)') 
     &   'Warning - undefined C-terminal group for lambda motion.'
        ENDIF
      ENDIF
      NRES0=NEN-2
      NRES1=NEN-1
      NRES2=NEN
      DO I=2,NEN 
        IAT(I,2)=NPRE(I)+1
        IAT(I,1)=NPRE(I)+3
        IAT(I,3)=NPRE(I)+6
cd      write (jout,'(4i5)') i,iat(i,1),iat(i,2),iat(i,3)
      ENDDO
      DO I=1,INUMRS
        IALPH(I)=IAT(I,1)
      ENDDO
C Determine whether the lambda motion is possible.
      NPROL=0
      DO III=NST+1,NEN-1
        IF (LPROLIN(III+1)) THEN
          NPROL=NPROL+1
        ENDIF
      ENDDO
      NMOVA=NEN-NST-NPROL
      WRITE (JOUT,*) 'NPROL:',NPROL,' NMOVA:',NMOVA
      IF (NMOVA.LE.0) THEN
       WRITE (JOUT,'(2A/A)') 'Error - cannot attempt at moving lambda ',
     1  'angle(s)','without violating proline geometry.'
        STOP
      ENDIF
C Evaluate virtual geometry of the chain and some auxiliary parameters
C that are necessary to define it.
      FIRSTC = .TRUE.
      CALL NONSTGEO(FIRSTC)
      RETURN
      END
      SUBROUTINE BCKTRK(NQCH,OVER)                                           
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.XBOUNDX'
      INCLUDE 'COMMON.PEPT'
      INCLUDE 'COMMON.MOVE'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.BONDSX'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.EDMC'
      INCLUDE 'COMMON.PROB'
      LOGICAL LPROLIN,LDIS
      LOGICAL OVER
      DIMENSION IND(20)                                                 
      CHARACTER*3 ANGNAM(2) /'phi','psi'/
      INTEGER IONE
      DATA IONE /1/
      IF (PRINT_SAMPLED) 
     & WRITE(JOUT,'(/A)') '**** Thermal-type motion **** '
      IF (MOVANG.LT.3) GOTO 9
* Case of lambda angle movement
      KK=1
      NSAMP=0
      DO WHILE (KK.LE.NQCH)
        IF (NSAMP.GT.1000) THEN
          NQCH=KK-1
          IF (NQCH.EQ.0) THEN
            WRITE (JOUT,'(/80(1H*)/2A/80(1H*)/)')
     &      'Cannot change any lambda angle in thermal-type motion... ',
     &      'Something must be very wrong... Terminating.'
            OVER=.TRUE.
            RETURN
          ENDIF
          WRITE (JOUT,'(/A/A,I4,A/)')
     & 'Warning - too many attempts at changing the desired number',
     & 'of lambda angles in thermal-type motion; only',NQCH,' changed.'
        ENDIF
        NSAMP=NSAMP+1  
        III=NST+AINT((NEN-NST)*RNUNF(1))
        IF (III.GT.NEN-1) III=NEN-1
        IF (III.GE.NEN) III=NEN-1
        IF (LPROLIN(III+1)
     1      .AND. III.LT.NEN-1) GOTO 1
        DO I=1,KK-1
          IF (IND(I).EQ.III) GOTO 1
        ENDDO 
        IND(KK)=III
cd      write (jout,*) 'kk=',kk,' ind=',iii,
cd   1      ' lambda before=',180.0*rl(iii)/3.14159
        RL(III)=RL(III)+2.0*PI*RNUNF(1)
        RL(III)=PINORM(RL(III))
        IF (PRINT_SAMPLED)
     &  WRITE (JOUT,'(A,I3,A,F8.3)') 'lambda(',III,')=',DEG*RL(III)
        KK=KK+1
    1 ENDDO   
cd    write (jout,*) 'ind before sorting',(ind(i),i=1,nqch)
      DO I=1,NQCH-1
        IMIN=IND(I)
        JMIN=I
        DO J=I+1,NQCH
          IF (IND(J).LT.IMIN) THEN
            IMIN=IND(J)
            JMIN=J
          ENDIF
        ENDDO
        IF (JMIN.GT.I) THEN
          IND(JMIN)=IND(I)
          IND(I)=IMIN
        ENDIF
      ENDDO
cd    write (jout,*) 'ind after sorting',(ind(i),i=1,nqch)
      DO I=NQCH,1,-1
        IRES=IND(I)
cd      write (jout,*) 'i=',i,' ires=',ires
        CALL PHIPSI(IRES)
      ENDDO
      RETURN 
 9    KK=1                                                              
      DO I=1,maxnum_res
        IFFIX(I)=0
        IPFIX(I)=0
      ENDDO
      IND(1)=0                                                          
C10    CALL RNDANG(NDX)                                                  
10    CALL RNDNDX(INMR10,P,NDX)
      IQ=INT(NDX/maxnum_dihe)     
      ID=IQ+1                                                           
      IANG=NDX-maxnum_dihe*IQ     
      IF (ITYPBK.EQ.1.AND.IANG.GT.2) THEN
         WRITE(JOUT,'(80(1H*)/A/A,I4,A/A/80(1H*))') 
     &   'Error in thermal-motion procedure... Local index of angle ',
     &   'must not be greater than 2, but',IANG,' was generated...',
     &   'Terminating.'
         OVER=.TRUE.
         RETURN
      END IF                                                            
      DO 20 J=1,KK                                                      
      IF(NDX.EQ.IND(J)) GOTO 10                                         
20    CONTINUE                                                          
      RND2=RNUNF(1)
      TAK=RND2*2*PI                                                     
      MVANG=1                                                           
      ANG=ANGLES(NDX)+TAK                                               
      ANGLES(NDX)=PINORM(ANG)                                           
      ANGLS=ANGLES(NDX)*DEG                                             
      IF (PRINT_SAMPLED) WRITE(JOUT,110) ANGNAM(IANG),ID,ANGLS
110   FORMAT(A3,'(',I3,')=',F8.3)
      IF (IANG.EQ.1) IFFIX(ID)=1 
      IF (IANG.EQ.2) IPFIX(ID)=1      
C     LDIS= (ID.GT.IS .AND. ID.LT.IE)
      LDIS= (IS.GT.0 .AND. IE.GT.0 .AND. ID.GT.IS .AND. ID.LT.IE) 
      KK=KK+1                               
      IND(KK)=NDX                          
      IF(KK.LE.NQCH) GOTO 10              
      IF (LDIS) CALL DISTFORCE
      RETURN                                                            
      END                                                               
      SUBROUTINE CHISPRO(LCHG)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.MYCONF'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.LIST0'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.BONDSX'
      INCLUDE 'COMMON.SETUP'
      INCLUDE 'COMMON.PROB'
      INCLUDE 'COMMON.EDMC'
C     COMMON/TOR3/ETOR
C     COMMON/sconfo/ ERING
      LOGICAL LPROLIN, LHISTID, LCHG
      CHARACTER*5 CISTRANS(2) /'CIS','TRANS'/
C

      LCHG=.FALSE.
CD     ERING=0.0
      MSK=ISHFT(1,NPH-1)
      DO 80 J=1,INUMRS
C when using PRO-HIS with changes in ring conformations it is necessary 
C to reset the LIST array.
           LIST(J)=LIST0(J)
           LIT= IABS(LIST0(J))
C
C NOW LET'S SEE IF THIS IS AN "L" OR "D" RESIDUE
           ISIGNO=ISIGN( 1, LIST(J) )
           IF ( LHISTID(J) ) THEN
C A HIS, HIE or HIP RESIDUE.
                IF (INDPH(J).NE.0) THEN
C CAN BE VARIED
C*****************************************************************
C*                IF (JDSEQ(J).EQ.0) THEN
C HISTIDINE RESIDUE IS UNCHARGED.
C*****************************************************************
C  ALLOW H-ATOM OF HISTIDINE TO MOVE BETWEEN DELTA AND EPSILON N-ATOMS
                     IF (IAND(LPRHI,MSK).EQ.0) THEN
C  H-ATOM OF HISTIDINE IS ON DELTA N-ATOM
                          IF (RNUNF(1).LT.0.5) THEN
C  MOVE H-ATOM TO EPSILON N-ATOM
                               LIST(J)=ISIGNO*25
                               LPRHI=IOR(LPRHI,MSK)
                               LCHG=.TRUE.
                               ITRIALS(J)=ITRIALS(J)+1
                          ENDIF
                     ELSE
C  H-ATOM OF HISTIDINE IS ON EPSILON N-ATOM
                          IF (RNUNF(1).LT.0.5) THEN
C  MOVE H-ATOM TO DELTA N-ATOM
                               LPRHI=IAND(LPRHI,NOT(MSK))
                               LCHG=.TRUE.
                               ITRIALS(J)=ITRIALS(J)+1
                          ELSE
                               LIST(J)=ISIGNO*25
                          ENDIF
                     ENDIF
C**************************************
C*                ELSE
C HISTIDINE RESIDUE IS CHARGED.
C*                   LIST(J)=ISIGNO*28
C*                ENDIF
C**************************************
                ENDIF
                MSK=ISHFT(MSK,-1)
           ELSE IF (LPROLIN(J).AND.(LIT.NE.34)) THEN

C  IS A PROLINE WITH VARIABLE DIHEDRAL ANGLES.
                IF (INDPH(J).NE.0) THEN
                   IF (NCHVAR(J-1,3).EQ.1 ) THEN
                     DIFANG=ABS(OMREF(J-1)-ABS(ANGULO(3,J-1)*DEG))
                     IF (DIFANG.GT.60.0) THEN
                        ICISTR=(OMREF(J-1)/179.9999)+1
                        WRITE(JOUT,4) J-1,CISTRANS(ICISTR)
4            FORMAT('OMEGA of residue',I4,' Preceeding PRO is not in a '
     &                             ,a,' conformation')

                        ANGULO(3,J-1)=RAD*OMREF(J-1)+
     &                                PI*(2.0*RNUNF(1)-1.0)/6.0D0 
c            write(*,*) 'PRO(',J,') CHANGING PRECEEDING OMEGA TO',
c    &                   ANGULO(3,J-1)*DEG  
                        LCHG=.TRUE.

                     ELSE IF (RNUNF(1).LT.POMGPPRO) THEN
C  ALLOW OMEGA BEFORE PROLINE TO BECOME THE REFERENCE + 180
C  WITH PROBABILITY POMGPPRO (probability for omega's preceeding PRO)
C GENERATION OF  dihedral angle (reference+180) +/- PI/6  
                        ANGULO(3,J-1)=RAD*OMREF(J-1) + 
     &                              PI*(1+(2.0*RNUNF(1)-1.0)/6.0D0)
                        LCHG=.TRUE.
c            write(*,*) 'PRO(',J,') CHANGING PRECEEDING OMEGA TO',
c    &                   ANGULO(3,J-1)*DEG  
                     ENDIF
                   ENDIF
                  
C  ALLOW PROLINE RING TO CHANGE CONFIGURATIONS
                   IF (IAND(LPRHI,MSK).EQ.0) THEN
C  PROLINE RING IS IN DOWN CONFIGURATION
                      IF (RNUNF(1).LE.0.5) THEN
C  CHANGE PROLINE OR H-PROLINE RING TO UP CONFIGURATION
                         IF (LIST(J).EQ.13) LIST(J)=ISIGNO*33
                         IF (LIST(J).EQ.22) LIST(J)=ISIGNO*35
                         IF (LIST(J).EQ.75) LIST(J)=ISIGNO*76
c            write(*,*) 'PRO(',J,') CHANGING PHI=',ANGULO(1,J)*DEG, 
c    &                                            'to  -54.03'
                         ANGULO(1,J)=-54.03*RAD
                         LPRHI=IOR(LPRHI,MSK)
                         LCHG=.TRUE.
                         ITRIALS(J)=ITRIALS(J)+1
                      ENDIF
                   ELSE
C  PROLINE RING IS IN UP CONFIGURATION
                      IF (RNUNF(1).GT.0.5) THEN
C SINCE LIST(J) WAS RESET TO LIST0(J) AT THE BEGINNING OF THE SUBROUTINE,
C WE NEED TO CORRECT ITS VALUE.
                         IF (LIST(J).EQ.13) LIST(J)=ISIGNO*33
                         IF (LIST(J).EQ.22) LIST(J)=ISIGNO*35
                         IF (LIST(J).EQ.75) LIST(J)=ISIGNO*76
                      ELSE
C  CHANGE PROLINE RING TO DOWN CONFIGURATION
c            write(*,*) 'PRO(',J,') CHANGING PHI=',ANGULO(1,J)*DEG,
c    &                                                 'to  -68.78'
                         ANGULO(1,J)=-68.78*RAD
                         LPRHI=IAND(LPRHI,NOT(MSK))
                         LCHG=.TRUE.
                         ITRIALS(J)=ITRIALS(J)+1
                      ENDIF
                   ENDIF
                ENDIF
                MSK=ISHFT(MSK,-1)
           ENDIF
  80  CONTINUE

      RETURN
      END
      SUBROUTINE CMPARE(KK)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.TOR2'
      INCLUDE 'COMMON.TRACK'
      INCLUDE 'COMMON.BONDSX'
      INCLUDE 'COMMON.CALC'
      INCLUDE 'COMMON.MYCONF'
      INCLUDE 'COMMON.IOUNIT'
      DATA EPS,ETA /15.0,0.5/
C     CEPS  = COS(Delta);  Delta=15. degree
      DATA CEPS /0.966/
      KK=0
      DO 20 K=1,MST
C   Check angles of new minimum against previous minima
         DO 10 J=1,INUMRS
         DO 10 I=1,maxnum_dihe
C           DANG=RAD*(ANGULO(I,J)-ANGMIN(I,J,K))
            DANG=(ANGULO(I,J)-ANGMIN(I,J,K))
            IF (COS(DANG).LT.CEPS) GO TO 20
  10     CONTINUE
C  Check geometries
C  Check the histidine and proline rings of the new conformation are the same
C  as for the old one.
C        IF (LPRHI.NE.LPROHIS(K)) GO TO 20
C   Check energies
         IF (ABS(ETOT-ENEMIN(K)).GT.ETA) GO TO 20
         KK=KK+1
         WRITE (JOUT,201) KK
  20  CONTINUE
      RETURN
 201  FORMAT (" Conformation's energy  is  similar to minimum # ",I3)
      END
      SUBROUTINE CORECT(ID)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      parameter (nsuppl=maxnum_dihe-3)
      INCLUDE 'COMMON.BRAIN'
      INCLUDE 'COMMON.PICK'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.XBOUNDX'
      INCLUDE 'COMMON.BONDSX'
      INCLUDE 'COMMON.PEPT'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.MOVE'
      INCLUDE 'COMMON.BRIDGES'
      INCLUDE 'COMMON.EDMC'
      INCLUDE 'COMMON.PROB'
      CHARACTER*3 ANGCHAR(maxnum_dihe)/'phi','psi','ome',nsuppl*'chi'/
      CALL NWCHG(L1,M2,DELTA,ID)
      NDEF=M2(ID)
cd    write (jout,*) 'NROT array:'
cd    do i=1,l1
cd      write (jout,'(2i5)') nrot(i,1),nrot(i,2)
cd    enddo
C NDEF indicates the number of the defect considered.
      MVANG=NROT(NDEF,1)
C MVANG gives the number of axes to be rotated:
C MVANG=1 indicates that only one backbone angle will be changed at a time;
C MVANG=2 indicates crankshaft-type motion;
C MVANG=3 indicates lambda-type motion.
C
      IF (PRINT_SAMPLED) 
     & write (jout,*) 'CORECT: ID',ID,' NDEF',NDEF,' MOVANG',MOVANG,
     & ' MVANG=', MVANG
C Reset the array IFFIX and IPFIX that indicate which angles must be kept
C fixed during distance fitting by DISTFIT.
      DO I=1,maxnum_res
        IFFIX(I)=0
        IPFIX(I)=0
      ENDDO
C     WRITE(JOUT,1733)NDEF,MOVANG 
C1733 FORMAT('No DEF=',I3,'MOVANG',I3)
C     THE ANGLE(S) IS (ARE) SET ACCORDING TO THE DIAGNOSIS.
      TAK1=RTANG1(NDEF)
      TAK2=RTANG2(NDEF)
      IF (MOVANG .EQ. 2) TAK2=-TAK1 
      IF (MOVANG.EQ.1 .OR. MVANG .EQ. 1)  THEN 
        NDX=NROT(NDEF,2)
        IQ=INT(NDX/maxnum_dihe)
        IDE=IQ+1
        IANG=NDX-maxnum_dihe*IQ
        IF (IANG.EQ.0) THEN
          IANG=maxnum_dihe
          IDE=IDE-1
        ENDIF
        IF (IANG.EQ.2) THEN
          M1=IDE
          MA1=0
        ELSE
          M1=0
          MA1=IDE
        ENDIF
        ITRIALS(IDE)=ITRIALS(IDE)+1
        ANGLS=ANGLES(NDX)*DEG
        IF (PRINT_SAMPLED) THEN
          IF (IANG.LT.4) THEN
            WRITE(JOUT,109)ANGCHAR(IANG),IDE,ANGLS
          ELSE
            WRITE(JOUT,110)ANGCHAR(IANG),IANG-3,IDE,ANGLS
          ENDIF
        ENDIF
109     FORMAT('Initial angle ',A3,'(',I3,')=',F8.3)                         
110     FORMAT('Initial angle ',A3,I2,'(',I3,')=',F8.3) 
        ANGLES(NDX)=ANGLES(NDX)+TAK1
        ANGLES(NDX)=PINORM(ANGLES(NDX))
        ANGLS=ANGLES(NDX)*DEG
        DTAK=TAK1*DEG
        IF (PRINT_SAMPLED) THEN
          IF (IANG.LT.4) THEN
            WRITE(JOUT,111)NDEF,DTAK,ANGCHAR(IANG),IDE,ANGLS
          ELSE
            WRITE(JOUT,112)NDEF,DTAK,ANGCHAR(IANG),IANG-3,IDE,ANGLS
          ENDIF
        ENDIF
111     FORMAT('Defect',I3,' ang add',F8.3,' changed angle ',A3,
     &         '(',I3,')=',F8.3)
112     FORMAT('Defect',I3,' ang add',F8.3,' changed angle ',A3,
     &         I2,'(',I3,')=',F8.3) 
      ELSE IF (MOVANG. EQ. 2) THEN
        IF (PRINT_SAMPLED) WRITE(JOUT,1753) NDEF
 1753   FORMAT('Defect No=',I3)
        NDX=NROT(NDEF,2)
        IQ=INT(NDX/maxnum_dihe)
        IDE=IQ+1
        IANG=NDX-maxnum_dihe*IQ
cd      write (jout,*) 'NDX',NDX,' IQ',IQ,' IANG',IANG
        IF (IANG.NE.2) THEN
          WRITE(JOUT,2002) NDX
2002      FORMAT('Iuhhhho we are becoming crazy!!, NDX=',I4/
     &  'The rule is that backbone axes only can move simultaneously.')
        END IF
        M1=IDE
        MA1=M1+1
        ANGL1=ANGULO(2,M1)*DEG
        ANGL2=ANGULO(1,MA1)*DEG
        IF (PRINT_SAMPLED) WRITE(JOUT,4)M1,ANGL1,MA1,ANGL2
4       FORMAT('Angles before: psi',I4,'=',F8.3,' phi',I4,'=',F8.3)
        ANGULO(2,M1)=ANGULO(2,M1)+TAK1
        ANGULO(1,MA1)=ANGULO(1,MA1)+TAK2
        ANGULO(2,M1)=PINORM(ANGULO(2,M1))
        ANGULO(1,MA1)=PINORM(ANGULO(1,MA1))
        ITRIALS(M1)=ITRIALS(M1)+1
        ITRIALS(MA1)=ITRIALS(MA1)+1
        ANGL1=ANGULO(2,M1)*DEG
        ANGL2=ANGULO(1,MA1)*DEG
        IF (PRINT_SAMPLED) WRITE(JOUT,5) M1,ANGL1,MA1,ANGL2
5       FORMAT('New angles : psi',I4,'=',F8.3,' phi',I4,'=',F8.3)
CD      CALL DRUANG(JOUT,ndone)
      ELSE IF (MOVANG.EQ.3) THEN
        INLAM=NROT(NDEF,2)
        INLAM1=INLAM+1
CD      WRITE (JOUT,*) 'NDEF=',NDEF,' INLAM=',INLAM
CD      WRITE (JOUT,*) 'NST=',NST,' NEN=',NEN
CD      CALL PHIPSI(INLAM)
        IF (PRINT_SAMPLED) THEN
        WRITE(JOUT,1754)NDEF,INLAM,TAK1*DEG 
        WRITE(JOUT,'(A)')'Before change'
        IF (INLAM.EQ.NST) THEN
          WRITE(JOUT,1756) RL(INLAM)*DEG,ANGULO(1,INLAM1)*DEG,
     1    ANGULO(2,INLAM1)*DEG
        ELSE IF (INLAM.LT.NEN-1) THEN
          WRITE(JOUT,1755) RL(INLAM)*DEG,ANGULO(1,INLAM)*DEG,
     1         ANGULO(2,INLAM)*DEG,ANGULO(1,INLAM1)*DEG,
     1         ANGULO(2,INLAM1)*DEG
        ELSE
          WRITE(JOUT,1756) RL(INLAM)*DEG,ANGULO(1,INLAM)*DEG,
     1    ANGULO(2,INLAM)*DEG
        ENDIF
        ENDIF
        RL(INLAM)=RL(INLAM)+TAK1 
        CALL PHIPSI(INLAM)
        IF (PRINT_SAMPLED) THEN
        WRITE(JOUT,'(A)')'After change'
        IF (INLAM.EQ.NST) THEN
          WRITE(JOUT,1756) RL(INLAM)*DEG,ANGULO(1,INLAM1)*DEG,
     1    ANGULO(2,INLAM1)*DEG
        ELSE IF (INLAM.NE.NEN-1) THEN
          WRITE(JOUT,1755) RL(INLAM)*DEG,ANGULO(1,INLAM)*DEG,
     1         ANGULO(2,INLAM)*DEG,ANGULO(1,INLAM1)*DEG,
     1         ANGULO(2,INLAM1)*DEG
        ELSE
          WRITE(JOUT,1756) RL(INLAM)*DEG,ANGULO(1,INLAM)*DEG,
     1    ANGULO(2,INLAM)*DEG
        ENDIF
        ENDIF
        ITRIALS(INLAM)=ITRIALS(INLAM)+1
 1754   FORMAT('************ Defect',I3,' delta(',I3,')=',F10.2,
     1         ' ************')
 1755   FORMAT('Lambda=',F10.2,' phi1=',F8.2,' psi1=',F8.2,
     1         ' phi2=',F8.2,' psi2=',F8.2)
 1756   FORMAT('Lambda=',F8.2,' phi=',F8.2,' psi=',F8.2)
      ELSE
        WRITE (JOUT,1757) MOVANG
        STOP 
 1757 FORMAT (/80(1H*)/'Something strange is happening in CORECT.'/
     & 'MOVANG=',I4,' was passed, while it should be from 1 to 3. ',
     & 'Terminating... '/80(1H*))
      END IF                                                            
      IF (MOVANG.NE.3 .OR. MVANG.EQ.1) THEN
cd       write (jout,*) 'CORECT: M1',M1,' MA1',MA1,' IS',IS,' IE',IE
         IF (IANG.LE.2 .AND. IS.GT.0 .AND.IE.GT.0 .AND. 
     &   (M1.GE.IS .AND. M1.LE.IE .OR. MA1.GE.IS .AND. MA1.LE.IE)) THEN
CD         CALL DRUANG(JOUT,ndone)
           IF (M1.GE.IS .AND. M1.LT.IE) THEN
             IPFIX(M1)=1
           ENDIF
           IF (MA1.GT.IS .AND. MA1.LE.IE) THEN
             IFFIX(MA1)=1
           ENDIF
cd         WRITE (JOUT,*) 'Calling DISTFORCE'
           CALL DISTFORCE
cd         WRITE (JOUT,*) 'Exit DISTFORCE'
CD         CALL DRUANG(JOUT,ndone)
         ELSE IF (NLOOP.GT.0 .AND. IANG.NE.3) THEN
* Change 4/23/93 Bridge constraints.
           DO I=1,NLOOP
             NKAI1I=NKAI1(I)
             DO J=1,NKAI1I
               IF (NDX.EQ.ICHIND1(I,J)) THEN
                 ICHFIX1(I,J)=1
                 GOTO 11
               ELSEIF (NDX.EQ.ICHIND2(I,J)) THEN
                 ICHFIX2(I,J)=1
                 GOTO 11
               ENDIF
             ENDDO
           ENDDO
           GOTO 12
cd 11      write (jout,*) 'CORECT: calling DISTFORCE, IANG.GT.3.'
   11      CALL DISTFORCE
cd         write (jout,*) 'CORECT: exit DISTFORCE.'
CD         CALL DRUANG(JOUT,ndone)
   12      CONTINUE
         ENDIF
      ENDIF
      RETURN                                                            
      END                                                               
      SUBROUTINE DECIS(M2)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      DIMENSION M2(maxnum_var)
      INCLUDE 'COMMON.BRAIN'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.NNDRUK'      
C*VDIR: PREFER SCALAR ON
      DO 80 J=1,NUMDEF
      NUBIC=1
      DO 85 I=1,NUMDEF
      IF (DELTA(J) .LT. DELTA(I)) THEN
         NUBIC=NUBIC+1
      END IF
85    CONTINUE
C M2(L) IS A RECORD OF THE ORIGINAL POSITION OF THE DEFECT IN COMMON
C BRAIN.NUBIC IS THE VARIABLE WHICH ORDER THEM DECREASINGLY.
      M2(NUBIC)=J
80    CONTINUE
      DO 95 I=1,NUMDEF
      NDX=NROT(M2(I),2)
      IF (NUK.NE.0) WRITE(JOUT,300) I,M2(I),DELTA(M2(I)),NDX
 95    CONTINUE
300   FORMAT('M2(',I3,')=',I3,' DELTA=',F7.3,' INDXV=',I4)
      RETURN

      END
      INTEGER FUNCTION METROPOLIS()
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.CNTRL'
      INCLUDE 'COMMON.OMTOR'
      INCLUDE 'COMMON.MINPAR'
      INCLUDE 'COMMON.EDMC'
      INCLUDE 'COMMON.SOLVAT'
      INCLUDE 'COMMON.EXTPH'
      INTEGER LISTP(maxnum_res)
      REAL DELPHJ
      REAL EPSPRO,EPSSOL,ERGSO1,EESDE1,ERGSO2,EESDE2
      INCLUDE 'COMMON.CALC'
      INCLUDE 'COMMON.TOR'
      INCLUDE 'COMMON.BRIDGES'
      INCLUDE 'COMMON.XBOUNDX'
      INCLUDE 'COMMON.GEN002X'
      INCLUDE 'COMMON.TIME1'
      INCLUDE 'COMMON.BONDSX'
      INCLUDE 'COMMON.TORPX'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.BLOKA'
      INCLUDE 'COMMON.GEN000'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.GEN004'
      INCLUDE 'COMMON.TOR2'
      INCLUDE 'COMMON.TORQUEX'
      INCLUDE 'COMMON.MOVE'
      INCLUDE 'COMMON.BRAIN'
      INCLUDE 'COMMON.PICK'
      INCLUDE 'COMMON.TERMAL'
      INCLUDE 'COMMON.TRACK'
      INCLUDE 'COMMON.MYCONF'
      INCLUDE 'COMMON.CLUSTER'
      COMMON/NUMRND/NUMR
      DATA IONE /1/, ZERO /0.00000000/
C ******************** New  rules for the Acceptance Test *****************
C We are including some changes here when the subroutine is used within a
C parallel program.
C Since we are trying to avoid syncronization, we must modify the
C acceptance criterion. 
C When a processor with a minimized conformation reaches this point
C it may occur that the accepted conformation that was used to generate
C the starting(non minimized) conformation had already been changed. 
C Consequently, this fact has to be considered. 
c If the starting minimum was changed,  {i.e. if (IINC.NE.ndone) }, then,
C we will screen the new conformation only if it has a lower energy 
C that the one from which it was generated. 
C ******************** End new Metropolis rules *****************

      IF(TEMP.LT.T_LOCAL) THEN
         write(jout,*) 'T_local reset in metropolis.',
     &      'T_LOCAL was =', T_LOCAL, ' GLOBAL TEMP= ', TEMP
         T_LOCAL=TEMP
      ENDIF
cd    write(jout,*) 'IINC ndone ETOT EINIT ',
cd   &    IINC,ndone,ETOT,EINIT 

#ifdef PHCALC
C When we carry out IBEM solvation energy calculation, some energies can
C become excessively low due to bad surface. So, we have to reject conformations
C that dropped excessively low in energy.
      if ((pHs.gt.0.0) .and.(etot-einit.le.-50.0)) then
        write (jout,'(a,1pe16.6,a,1pe16.6,a/,2a,1pe16.6,a)')
     & 'Current conformation has energy of ',etot,' which is by',
     & einit-etot,' kcal/mol',' lower than the energy of the starting ',
     & 'conformation (',einit,').'
        metropolis=0
        return
      endif
#endif

      IF((IINC.EQ.ndone).OR.(ETOT.LT.EINIT)) THEN
C         IF [we are in the same iteration (i.e. the incoming conformation is a 
C perturbation of the current minimum)], OR [The energy of the new conformation
C is lower than the previously accepted minima ] THEN ..  apply Metropolis test
         EDIFF=(ENEMIN(MST)-ETOT)
c     write(*,*) 'ETOT =',ETOT,' ENEMIN(',MST,')= ', ENEMIN(MST) 
c     write(jout,*) 'ETOT =',ETOT,' ENEMIN(',MST,')= ', ENEMIN(MST) 
c        AETOT= ABS(ETOT)
c        IF ( AETOT.LT. 1.0) THEN
c          IF ( ABS( ENEMIN(MST) ).LT. 1.0) THEN
c             DIENE=0.0
c          ELSE 
c             DIENE=EDIFF/ABS(ENEMIN(MST) )
c          ENDIF 
c        ELSE 
c          DIENE=EDIFF
c        ENDIF
c        write (*,*) 'EDIFF',EDIFF
c        write (jout,*) 'EDIFF',EDIFF
         IF (EDIFF.LT.ecrit1 .AND. EDIFF.GT.-ecrit) THEN
            PROB=-1.0
c           write(*,*) 'PROBABILITY ZERO: ETOT = ENEMIN '
c           write(jout,*) 'PROBABILITY ZERO: ETOT = ENEMIN '
         ELSE IF (ETOT.LT.ENEMIN(MST)) THEN
             PROB=1.0
C     write(jout,*) 'PROBABILITY ONE: ETOT < ENEMIN(MST) ',ETOT,' < ',
C    & ENEMIN(MST) 
         ELSE
C     write(jout,*) 'EDIFF ',EDIFF
             XHH=EDIFF/(RBOLTZ*T_LOCAL)
             IF (ABS(XHH).GT.50.0) THEN
C Just to avoid underflow error
                 PROB=0.0
             ELSE
                 PROB=EXP(XHH)
             ENDIF
         ENDIF
      ELSE
         PROB=0.0
      ENDIF
C ****************************************************
C 
C DR. 5/20/96
C We will avoid the acceptance of conformations with sidechain variations 
C only, if there is a large set of accepted conformations have the same 
C backbone pattern. The conformation will only be saved if  it represents 
C an improvement to the energy, i.e. if it is  the lowest energy conformation
C currently found.
C
C First get the zimmerman code
      CALL PLACE
      KZI=0
C     DO J=1, NDONE
C        DO I=2, INUMRS-1
C           IF(ZIMMK(I).NE. ZIMMIN(I,J) ) GOTO 10
C        ENDDO
      DO J=1, NCON  
         IF (LACCEPT(J)) THEN
         DO I=2, INUMRS-1
              IF(ZIMMK(I).NE. ZIMM(I,J) ) GOTO 10
         ENDDO
         KZI=KZI+1
C  Backbones are different try next.
         ENDIF
10       CONTINUE
      ENDDO
C     IF (KZI.GT.0) THEN
C        write(*, *) 'ZIMM Code is found in previous minimum'
C        write(*, *) 'KZI ', KZI
C     ENDIF
      IF ((KZI.GT.MaxKzimm).AND.(ETOT.GT.ELOWST)) THEN
         PROB=0.0
         write(jout,'(2a,i3,a)')'REJECTED; backbone ',
     &   ' conformation was repeated more than ', MaxKzimm,' times'
      ENDIF
C ****************************************************
      RNDNUM=RNUNF(1)
C test for the random number generator
      IF (RNDNUM.LE.ZERO) THEN
        NUMR=NUMR+1
        IF (NUMR.GT.5) THEN
          write(jout,'(/a/a)')'ERROR random no. generator. Probability'
     &    ,'was consistently set to zero. Check initialization routine'
          stop
        ENDIF
      ELSE
         NUMR=0
      ENDIF
      
      IF (RNDNUM.LE.PROB) THEN
! Not accepted, yet. Conformation has to pass other test.

         NREPM=0
! Check if conformation is very similar to an already accepted minimum.
         CALL DIST_NEW_CONF(RMS_MIN,ICNFN)
         WRITE(*,*)'Closest conf.= ', ICNFN,' with RMS=',RMS_MIN 
         WRITE(JOUT,*)'Closest conf.= ',ICNFN,' with RMS=',RMS_MIN 
         IF (RMS_MIN.LT.0.1) THEN
! Backbone rms of this conformation is similar to accepted minimum 'icnfn'.
            WRITE(*,*)'similar: ENEENEMIN(',ICNFN,')=', ENEMIN(ICNFN)
            WRITE(JOUT,*)'similar: ENEENEMIN(',ICNFN,')=',ENEMIN(ICNFN)
            EDIFF= ENEMIN(ICNFN)- ETOT
!           IF (EDIFF.LT.ecrit1 .AND. EDIFF.GT.-ecrit) THEN
! if the energy is  also similar, then conformations are considered identical
!Check how many times have this conformation been repeated.
               NREPM= NCOUNT(ICNFN)
!              WRITE (JOUT,*)'Conf. similar to: ',ICNFN
!              WRITE (*,*)'Conf. similar to: ',ICNFN
!              WRITE (*,*)
!    &          'enemin(',icnfn,') =',ENEMIN(ICNFN),' ETOT= ',ETOT
!              WRITE (JOUT,*)
!    &          'enemin(',icnfn,') =',ENEMIN(ICNFN),' ETOT= ',ETOT
!
!           ENDIF
         ENDIF
! if this conformations was found NREPMM times or more, use entropy sampling type of acceptance
         IF (NREPM.GE.NREPMM) THEN
! we used the same random number but reduce the probability by NREPM
            PROB= PROB/NREPM 
! **************************************
! for testing purposes
            IF (RNDNUM.GT.PROB) THEN
              WRITE (*,*)'Conf. rejected; repeated ',NREPM,' TIMES'
            ELSE
              WRITE (*,*)'Conf. accepted but repeated ',NREPM,' TIMES'
            ENDIF
! **************************************
         ENDIF
!now, check if the acceptance criterion is satisfy with the new probability
!if the conformation was repeated NREPMM or more.
         IF (RNDNUM.GT.PROB) THEN
           METROPOLIS=0
         ELSE
C       write(jout,*) 'random no. and probability', rndnum, prob
C       write(jout,*) 'CONFORMER passed metropolis, ETOT= ', ETOT,
C    &       'ENEMIN= ', ENEMIN(MST)
           METROPOLIS=1
           IF (T_LOCAL.LT.TEMP) THEN
              TEMP=T_LOCAL
              WRITE (JOUT,'(/80(1h*)/A,I4,2A/A,F8.1,A/80(1h*)/)')
     &        'Processor',idleader,' accepted a conformation while', 
     &        ' using the temperature before heating the system up.',
     &        'The temperature is again lowered to ',TEMP,' K.'
           ENDIF
           IF (TEMP.GT.TLOW) THEN
             TEMP=TEMP/TSTEPC
             IF (TEMP.LT.TLOW) TEMP=TLOW
             WRITE (JOUT,'(/33(1H*)/A,F8.1,A/33(1H*))')
     &             'System cooled down, T=',TEMP,' K.'
           ENDIF
         ENDIF 
      ELSE
         IF (PROB.EQ.-1.0) THEN
           METROPOLIS=-1
         ELSE
         METROPOLIS=0
      ENDIF
      ENDIF
      RETURN
      END
      subroutine modifwei
C                      Written by Daniel Ripoll  APR-94
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      include 'COMMON.CNTRL'
      include 'COMMON.CALC'
      include 'COMMON.EDMC'
      include 'COMMON.IOUNIT'
      include 'COMMON.XBOUNDX'
      data zero /0.0E00/, small /.001/
      aetot= abs(etot)
      if ( aetot.lt. 1.0) then
C Weight should be OK (same magnitud ?).
C        write(jout,'(a,f8.3)') 'Total ENERGY close to ZERO ',aetot
         return
      endif 
      ecos=edis+edihc
      erest= abs(etot-ecos)
C EREST is the sum of all energy term (NONBONDED +TORSIONAL + ELECTROSTATICS 
C  + LOOP CLOSING +...) excluding EDIS.
C
      if ( erest.lt. 1.0) then
C Energy terms are close to zero. Implying no overlaps (?) 
C Weight should be ok. Distance term must be significant.
C Next return should avoid underflow errors.
C        write(jout,'(a,f8.3)') 'ENERGY terms are close to ZERO ',erest
         return
      else 
         ratio_ene=100.0*abs(ecos)/erest 
      endif 
      old_wei=wei_ene
      old_weitorc=weitorc
C     write(jout,'(a,f8.3)') 'Delta Percent ',deltaperc
      if( abs(deltaperc).gt.small) then
C  Weight will increase (or decrease) linerarly with the no. of iterations.
         old_perc_wei= perc_wei
         perc_wei= perc_wei + (deltaperc/liczm)
C        write(jout,'(a,f8.3)') 'Percent Weight ',perc_wei
         if ( perc_wei.lt.zero) then
             perc_wei=zero
C next line avoids overflow error.
             if ( old_perc_wei.le.small) old_perc_wei=1.0
         endif
         wei_ene= old_wei*perc_wei/old_perc_wei
         if(wei_ene.lt.weitmin) wei_ene= weitmin
         if(wei_ene.gt.weitmax) wei_ene= weitmax
C        write(jout,'(a,f8.3)') 'Variable Distance-constraint Energy Weight= ',wei_ene
         if (dihecnst) then
            weitorc= old_weitorc*perc_wei/old_perc_wei
         if(weitorc.lt.weitmin) weitorc= weitmin
         if(weitorc.gt.weitmax) weitorc= weitmax
C        write(jout,'(a,f8.3)') 'Variable Dihedral-constraint Energy Weight= ',weitorc
         endif
      else
         pmin_wei= perc_wei- 0.1*perc_wei
         pmax_wei= perc_wei+ 0.1*perc_wei
         if ( ratio_ene.lt.pmin_wei .or. ratio_ene.gt.pmax_wei) then
C Modify energy weight
            if( abs(ratio_ene).lt.small) then
C This should avoid underflow errors if edis is zero (all distance satisfied).
               return
            else
               wei_ene= old_wei*perc_wei/ratio_ene
               if (dihecnst) weitorc= old_weitorc*perc_wei/ratio_ene
            endif
            if(wei_ene.lt.weitmin) wei_ene= weitmin
            if(wei_ene.gt.weitmax) wei_ene= weitmax
            if (dihecnst) then
            if(weitorc.lt.weitmin) weitorc= weitmin
            if(weitorc.gt.weitmax) weitorc= weitmax
         endif 
      endif
      endif
      if((wei_ene.ne.old_wei).or.(weitorc.ne.old_weitorc)) then
C Avoid printing if value remains unchanged (weitmin or weitmax)
C otherwise
C Modify values of etot and edis and print warning msgs.
         ediff=etot-ecos
         edis= wei_ene*edis/old_wei
         if (dihecnst) edihc= weitorc*edihc/old_weitorc
         etot=ediff+edis+edihc
         write(jout,3018)
     &   'DISTANCE AND(OR) DIHEDRAL CONSTRAINTS Weight modified',
     &   'New DISTANCE-CONST. WEIGHT Value= ', wei_ene,'Old = ', 
     &   old_wei,'New DIHEDRAL-CONST. WEIGHT Value= ', weitorc,
     &   'Old = ',old_weitorc,
     &   'ETOT(',etot,') EDIS(',edis,') and EDIHC(',edihc,
     &   ') were renormalized accordingly'
      endif 
C 3018     format( a,/,a,f8.3,a,f8.3,/,a,f8.3,a,f8.3,/, a)
3018     format( a,2(/,2(a,f8.3)),/,3(a,e12.4),a)
      return
      end
      SUBROUTINE NWCHG(L1,M2,DELTA,K)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.TERMAL'
      INCLUDE 'COMMON.IOUNIT'
      DIMENSION M2(maxnum_var),DELTA(maxnum_var),E(maxnum_var),
     & P(maxnum_var+1)
      DATA IONE /1/
      SE=0.0
cd    write (jout,*) 'NWCHG: L1',L1
      DO 10 I=1,L1
      LI=L1-I+1
      ARGUM = DELTA(M2(I))/(RBOLTZ*TEMP)
cd    write (jout,*) 'NWCHG: I ',I,' M2',M2(I),' DELTA',DELTA(M2(I)),
cd   & ' ARGUM',ARGUM
      IF (ABS(ARGUM).GT.70.) THEN
        WRITE(JOUT,880) I, M2(I), DELTA(M2(I)), L1
880     FORMAT('NWCHG:  "ARGUM" is TOO LARGE !',/, 'M2(',I4,') =', I4,
     & ' DELTA= ', E12.5,' L1 = ', I4 )
C ARGUM TOO BIG  CAUSES THE EXPONENTIAL TO OVERFLOW
         IF (ARGUM.GT.0.0) THEN
              ARGUM = 70.
         ELSE
              ARGUM =-70.
         END IF
      END IF
      E(LI)=EXP(ARGUM)
      SE=E(LI)+SE
C      WRITE(JOUT,80) LI,E(LI)
C80    FORMAT('E(',I4,') =',F8.6)
10    CONTINUE
      P0=0.0
      P(1)=0.0
      DO 20 I=1,L1
      P(I+1)=E(I)/SE + P0
      P0=P(I+1)
C      WRITE(JOUT,90) (I+1),P(I+1)
C90    FORMAT('P(',I4,') =',F8.6)
20    CONTINUE
      IF (P(L1+1).LT.0.9990)THEN
         WRITE(JOUT,100)P(L1+1)
100      FORMAT('P(L1+1) =',F8.6)
      END IF
      P(L1+1)=1.0
C  RANDOM NUMBER
            RND=RNUNF(1)
      N=0
      DO 30 L=1,L1
      IF ((RND .GT.P(L)) .AND. (RND .LT. P(L+1))) THEN
         K=L1-L+1
C        WRITE(JOUT,115)RND,K
C115      FORMAT('RANDOM NUMBER=',F10.8,'K=',I4)

         N=1 + N
      END IF
30    CONTINUE
      IF ((N .EQ. 0) .OR.(N.GT.1))THEN
         WRITE(JOUT,120)N
120      FORMAT('Something strange is happening!! There is no change.'
     &, I3,' out from nwchg')
      END IF
      RETURN
      END
      SUBROUTINE ORDER(LOLD,IOUT,M,LNEW)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      DIMENSION M(maxnum_var)
C THIS SUBROUTINE PUT IN ORDER VECTOR M WHEN
C A COMPONENT OF IT HAS TO BE REJECTED
C LOLD IS THE OLD LENGTH
C IOUT IS THIS POSITION WHICH SHOULD BE REJECTED
      LNEW=LOLD-1
      DO 1 I=IOUT,LNEW
      M(I)=M(I+1)
1     CONTINUE
      RETURN
      END
      SUBROUTINE PROBDI(IOPT)
C DEC/91  higher probability for CHI() of GLP (44) or CHI() of LYP (45)
C if the torsion of the (OE=CD)---(NZ-HZ) bond is in cis conformation.
C                                                        DR^^^&&&
C PROBDI CALCULATES A SPECIAL PROBABILITY DISTRIBUTION FOR THE RANDOM
C MOVEMENTS,IF THE ARGUMENT IS ZERO(0) A SEARCH NEAR THE DEFECTS IS
C FAVORED. ARGUMENT EQUAL 1 IS USED IN THE BACKTRACK MOVEMENT TYPE 2
C AND IN THIS CASE ONLY PHI AND PHI ARE GOING TO BE SELECTED FOR A
C RANDOM MOVEMENT.

      INTEGER IOPT
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.EDMC'
      INCLUDE 'COMMON.BRIDGES'
      INCLUDE 'COMMON.BONDSX'
      INCLUDE 'COMMON.CHECK'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.GEN002X'
      INCLUDE 'COMMON.PRAMX'
      INCLUDE 'COMMON.BRAIN'
      INCLUDE 'COMMON.PROB'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.NOMEGA'
      LOGICAL LPROLIN,NMETHYL
      DIMENSION INDTOR(16)
      DIMENSION M0(maxnum_var)
      DOUBLE PRECISION  DIST(maxnum_dihe*maxnum_res)
      character*5 cistrans(2) /'CIS','TRANS'/
      INMR10=maxnum_dihe*INUMRS
C      WRITE(JOUT,'(A)') 'NOW IN PROBDI'
C RESET ARRAY OF INDEXES CORRESPONDING TO UNSUCCESSFUL ROTATIONS OF
C PEPTIDE BONDS IN cis CONFORMATIONS.
      KOMG= 0
      DO 3 I=1, MMX
         NDXOMG(I)=0
3     CONTINUE
C Used for assigning probabilities to last CHI's of GLUP and LYP.
      ILOOP=0
      DO 5 J=1,16
      INDTOR(J)=0
5     CONTINUE

C      WRITE(JOUT,9998) IOPT, MMX, INMR10
C9998  FORMAT(' iopt ',i4,'mmx',i4,'inmr10',i4 ) 
      NOMEG=0
      DO 10 I=1,INMR10
         DIST(I)=0.0D0
10    CONTINUE
      IF (IOPT.EQ.0) THEN
         KHK=0
         KHBK=0
C 2/21/95 - amide-bridge treatment loop moved outside the main loop.
         do n=1,nloop
	   if (iom_flag(1,n)+iom_flag(2,n).gt.0) then
	     lcpar=n
	     nv1=npair(1,n)
	     nv2=npair(2,n)
	     i=nv1
	     klc=nv2
	     listi=iabs(list(i))
	     listj=iabs(list(nv2))
C********************************************************
C This section is for an special case
C It attempts to detect the dihedral angle value of the bond
C bettwen GLP and LYP side chains, if any.
C if IJ is one of the residues involved in a side-chain loop-closing
C this section finds KLC the residue number of the other loop-closing
C residue
C
C           WRITE(JOUT,'(a,i4)')'PROBDI: NLOOP', NLOOP
C           WRITE(JOUT,'(a,i4)')'RESIDUE No.= ',I
C           WRITE(JOUT,'(3(a,i4))')' N= ', N,
C    &      ' NV1= ',NV1, ' NV2= ',NV2
C                            WRITE(JOUT,1954)LCPAR, NV1,KLC
1954   format('PROBDI:loop (',i3,') closing between ',i3,' and', i3)
C         Look for the cosine of the dihedral angle.
            IF (LCPAR.EQ.0) THEN
               WRITE(JOUT,'(a,i4)')'ERROR PROBDI RESIDUE',I
            ENDIF
            COSENO= CTORS(LCPAR)
C           WRITE(JOUT,'(a,f8.3)')'COSINE= ',COSENO
            IF(COSENO.GT.0.0) THEN
C             WRITE(JOUT,1955)
1955   format('PROBDI -- loop closing bond in cis conformation ')
1956   format('Residue ',i4,' var No',i4,' and residue ',i4,' var No',i4,
     & /,' assigned with a high probability')
	      inchi1=nchi(listi)+3
	      inchi2=nchi(listj)+3
C             WRITE(JOUT,1956) nv1,inchi1,nv2,inchi2
              IF(iom_flag(1,n) .gt.0 .and. NCHVAR(I,inchi1).EQ.1) 
     &        THEN
                INDX=(I-1)*maxnum_dihe+inchi1
                ILOOP =ILOOP+1
                INDTOR(ILOOP)= INDX
C               DIST(INDX)=omprob
                DIST(INDX)=omprob*probrs(i)
c               IF (DIST(INDX).lt.0.0) 
c    &                write(*,*) '1 ', omprob, probrs(i)
               END IF
               IF(iom_flag(2,n).gt.0.and.NCHVAR(KLC,inchi2).EQ.1) 
     &         THEN
                 INDX=(KLC-1)*maxnum_dihe+inchi2
                 ILOOP =ILOOP+1
                 INDTOR(ILOOP)= INDX
C                DIST(INDX)=omprob
                 DIST(INDX)=omprob*probrs(i)
c                IF (DIST(INDX).lt.0.0) 
c    &                write(*,*) '2 ', omprob, probrs(i)
               END IF
            ENDIF
          END IF
         ENDDO
C END SPECIAL SECTION. 
C********************************************************
         DO 20 I=1,INUMRS
C NOW SET WEIGHTING FACTOR FOR VARIABLE DIHEDRAL ANGLES TO ONE.
         IF(NV(I) .GE. 1) THEN
              DO 30 L=1,NV(I)
                INDX=NDXARR(L,I)+maxnum_dihe*(I-1)
                DIST(INDX)=1.0
                KHK=KHK+1
                IF(L.LT.3) KHBK=KHBK+1
30            CONTINUE
              IF ((I.GT.1).OR.(I.LT.INUMRS)) THEN
                   LIST1=LIST(I)
                   LIST1=IABS(LIST1)
                   KIND1=IABS(KNDRES(LIST1))
36                 CONTINUE
C LET'S LOOK AT OMEGAS NOW.
                   IF (NCHVAR(I,3).EQ. 1) THEN
C                    DIFANG=180.000-ABS(ANGULO(3,I)*DEG)
                     DIFANG=abs(omref(i)-ABS(ANGULO(3,I)*DEG))
                        INDX=(I-1)*maxnum_dihe+3
C AN OMEGA DIHEDRAL ANGLE THAT DOES NOT PRECEED A PROLINE RESIDUE,
C WILL BE ASSIGNED A LARGE WEIGHT IF IT IS IN A CIS CONFORMATION.
C
C AL 9/14/95 For prolines and N-methylated residues omega is treated at the
C same level as any other backbone angle.
C
                     IF (promet .or. (.NOT.LPROLIN(I+1) .AND. 
     &                              .NOT.NMETHYL(I+1)) ) THEN
                       IF (DIFANG.GT.60.0) THEN
                         icistr=(omref(i)/179.9999)+1
                         WRITE(JOUT,4) I,cistrans(icistr)
4     FORMAT ('OMEGA of residue',I4,' is not in a ',a,' conformation')
C                            DIST(INDX)=OMPROB
                             DIST(INDX)=omprob*probrs(i)
c                            IF (DIST(INDX).lt.0.0) 
c    &                             write(*,*) '3 ', omprob, probrs(i)
c                      write (jout,*) 'indx=',indx,' dist=',dist(indx)
                             NOMEG=1
                        ELSE
C
C IF OMEGA IS CLOSE TO 180 THE SEARCH WILL AVOID IT.
                             DIST(INDX)=0.0
                        END IF
                     ELSE
c                      DIST(INDX)=4.0
                       IF(POMGPPRO.GT.0.0) DIST(INDX)=4.0*probrs(i)
c                      write (jout,*) 'Changing omega',i
c                      IF (DIST(INDX).lt.0.0) 
c    &                   write(*,*) '4 ', probrs(i)
                     ENDIF
                   END IF

C THE WEIGHT OF A CHI(4) IS INCREASED IF THERE ARE OTHER SIDECHAIN 
C VARIABLES FOR THIS RESIDUE
                   IF((NCHVAR(I,4).EQ.1).AND.(NV(I).GT.4)) THEN
                        INDX=(I-1)*maxnum_dihe+4
C                       DIST(INDX)=4.0
                        DIST(INDX)=4.0*probrs(i)
c                      IF (DIST(INDX).lt.0.0) 
c    &                   write(*,*) '5 ', probrs(i)
                   END IF
              END IF
         END IF
20       CONTINUE
         MXNOCHG=KHK
         MXNOCHGBK=KHBK
C NOW WE TRY TO ADJUST THE PROBABILITIES FOR DIHEDRAL ANGLES
C FOR WHICH AN ELECTROSTATIC PREDICTION EXIST.
         DO 40 J=1,NUMDEF
         JDX=NROT(J,2)
         IQ=INT(JDX/maxnum_dihe)
         ID=IQ+1
         IANG=JDX-maxnum_dihe*IQ
         IF (IANG.EQ.0) THEN
              ID=IQ
              IANG=maxnum_dihe
         END IF
         IF ((IANG.EQ.1).OR.(IANG.EQ.2)) THEN
C WHEN A BACKBONE PREDICTION EXISTS, WE HELP WITH AN INTENSE RANDOM
C SEARCH IN THE NEIGHBORING REGION (2 RESIDUES AT EACH SIDE OF 
C THE PREDICTION).
           DO 50 L=1,5
              I1=ID-3+L
              IF ((I1.GT.0).AND.(I1.LE.INUMRS)) THEN
                   DO 60 LM=1,2
                   IF(NCHVAR(I1,LM).NE. 0) THEN
                        INDX=(I1-1)*maxnum_dihe+LM
C                       DIST(INDX)=6.0
                        DIST(INDX)=6.0*probrs(i)
c                       IF (DIST(INDX).lt.0.0) 
c    &                   write(*,*) '6 ', probrs(i)
                   END IF
60                 CONTINUE
              END IF
50         CONTINUE
         ELSE
C WHEN A SIDE CHAIN PREDICTION EXISTS, A MORE INTENSE RANDOM SEARCH
C TAKES PLACE OVER THE SIDE CHAIN VARIABLES GREATER THAN CHI(4).
              LT=ABS(LIST(ID))
              IF(ID.EQ.1 .OR. ID.EQ.INUMRS) LT = NREG + LT
              NCHHI=NCHI(LT)
              DO 65 LM=5,NCHHI
              IF(NCHVAR(ID,LM).EQ. 1) THEN
                   INDX=(ID-1)*maxnum_dihe+LM
C********************************************************************
C avoid changing weights for GLUP and LYP last dihedral angles if the
C conformation of the side-chains bond is cis.
                   DO 67 LL=1,ILOOP
                        IF(INDTOR(LL).EQ.INDX) THEN
C                            WRITE(JOUT,2050) INDX
2050   format(' Variable ',i4, ' probability was assigned before ')
                             GOTO 68
                        END IF
67                 CONTINUE
C********************************************************************
c                  DIST(INDX)=2.0
                   DIST(INDX)=2.0*probrs(i)
c                  IF (DIST(INDX).lt.0.0) 
c    &                   write(*,*) '7 ', probrs(i)
68                 CONTINUE
              END IF
65       CONTINUE
         END IF
40       CONTINUE
      ELSE
C  ###########################################################
C IOPT=1 CONSTRUCTS A PROBABILITY DISTRIBUTION WHICH ONLY ALLOWS
C PHI'S AND PSI'S TO BE VARIED. ONLY USED WITH THE BACKTRACK
C MOVEMENT TYPE 2
         KHK=0
         DO 220 I=1,INUMRS
         IF(NV(I) .GE. 1) THEN
              DO 230 L=1,NV(I)
              NDX=NDXARR(L,I)
              IF(NDX.LE.2) THEN
                   INDX=NDX+maxnum_dihe*(I-1)
                   DIST(INDX)=1.0
                   KHK=KHK+1
              END IF
230           CONTINUE
         END IF
220      CONTINUE
         MXNOCHG=KHK
C  ###########################################################
      END IF
      DO  I=1,INMR10
          IF(DIST(I).LT.0.0) write(*,*) I, DIST(I)
      enddo
      CALL GENDISTR ( INMR10,DIST,P)
      RETURN
      END
      SUBROUTINE RNDMOV(ID,NSEL)                                        
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      parameter (nsuppl=maxnum_dihe-3)
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.CHECK'
      INCLUDE 'COMMON.TOR2'
      INCLUDE 'COMMON.TORQUEX'
      INCLUDE 'COMMON.BONDSX'
      INCLUDE 'COMMON.NOMEGA'
      INCLUDE 'COMMON.PEPT'
      INCLUDE 'COMMON.MOVE'
      INCLUDE 'COMMON.BIAS'
      INCLUDE 'COMMON.XBOUNDX'
      INCLUDE 'COMMON.BRIDGES'
      INCLUDE 'COMMON.EDMC'
      INCLUDE 'COMMON.PROB'
      INCLUDE 'COMMON.IOUNIT'
      CHARACTER*3 ANGCHAR(maxnum_dihe)/'phi','psi','ome',nsuppl*'chi'/
      LOGICAL LPRO,LPRO1,LPROLIN
      LOGICAL SC_OMEG
      DATA IONE /1/

      DO I=1,maxnum_res
        IFFIX(I)=0
        IPFIX(I)=0
      ENDDO
      DO I=1,NLOOP
        NKAI1I=NKAI1(I)
        DO J=1,NKAI1I
          ICHFIX1(I,J)=0
          ICHFIX2(I,J)=0
        ENDDO
      ENDDO

      NFAIL=0
      NFAILR=0
C25    CALL RNDANG(NDX)                                                  
25    CALL RNDNDX(INMR10,P,NDX)
C Another variable will chosen if NDX points to an omega or Chi from
C GLP or LYP that was selected previously, within the same iteration.
      DO 10 K=1, KOMG
         IF( NDX.EQ.NDXOMG(K) ) THEN
C             WRITE(JOUT,1089) NDX
C1089          FORMAT('Movement rejected; variable already chosen ',I4)
              GOTO 25
         END IF
10    CONTINUE
********************************************
      IQ=INT(NDX/maxnum_dihe)
      ID=IQ+1
      IANG=NDX-maxnum_dihe*IQ
      LIST1=LIST(ID)
      LIST1=IABS(LIST1)
      KIND1=IABS(KNDRES(LIST1))
      IF (IANG.EQ.0) THEN
         ID=IQ
         IANG=maxnum_dihe
      END IF
* Change 6/29/93 Reject angle, if it belongs to a residue not included in
*                the iwind array.
      DO I=1,NWIND
        IF (ID.GE.IWIND(I,1).AND.ID.LE.IWIND(I,2)) GOTO 26
      ENDDO
      NFAILR=NFAILR+1
      IF (NFAILR.GT.5000) THEN
       WRITE (JOUT,'(A)') 'Error - cannot choose angle (out of RNDMOV).'
        STOP
      ENDIF
      GOTO 25
   26 NFAILR=0
* End of change.
      IF (PRINT_SAMPLED) THEN
        IF (IANG.LT.4) THEN
          WRITE(JOUT,101) ANGCHAR(IANG),ID
        ELSE
          WRITE(JOUT,1) ANGCHAR(IANG),IANG-3,ID
        ENDIF
      ENDIF
101   FORMAT('**Random movement** angle ',A3,'(',I3,')')            
1     FORMAT('**Random movement** angle ',A3,I2,'(',I3,')')            
      RND2=RNUNF(1)
      TAK=RND2*2*PI                                                     
C   If the angle is omega or the last chi of GLUP or LYP,
C   then try a rotation of PI degrees.
      IF ( (IANG.EQ.3) .or. SC_OMEG(ID,IANG) ) THEN
C     IF ( (IANG.EQ.3) .or. ( (KIND1.EQ.44).and.(IANG.EQ.6) ) .or.
C    &  ( (KIND1.EQ.45).and.(IANG.EQ.7) ) ) THEN
         KOMG= KOMG+1
         NDXOMG(KOMG)=NDX
         TAK= PI
         IF (PRINT_SAMPLED) WRITE(JOUT,1099)
1099     FORMAT(' ** Pi rotation assigned. ')
      END IF
      IF (NSEL.EQ.1) THEN     
         MVANG=1                                                        
         GO TO 150                                                      
      END IF                                                            
                                                                        
      IF(IANG.GT.2 .OR. ID.EQ.1 .OR. ID.EQ.INUMRS) THEN
         MVANG=1                                                        
      ELSE                                                              
         IF ((IANG.EQ.2).AND.(ID.LT.INUMRS)) THEN                       
              ID2=ID+1                                                  
              IF(NCHVAR(ID2,1).NE.0) THEN                               
                   MVANG=2                                              
                   M1=ID                                                
              ELSE                                                      
                   MVANG=1                                              
              END IF                                                    
         ELSE IF ((IANG.EQ.1).AND.(ID.GT.1))THEN                        
              ID2=ID-1                                                  
              IF(NCHVAR(ID2,2).NE.0) THEN                               
                   MVANG=2                                              
                   M1=ID2                                               
                   TAK=-TAK                                             
              ELSE                                                      
                   MVANG=1                                              
              END IF                                                    
         END IF                                                         
      END IF                                                            
C
C 9/26/96 AL For MVANG.GT.1 the PHI angle of the next residue can happen 
C            not to be included in WINDOWS.
C
      IF (MVANG.GT.1) THEN
        DO I=1,NWIND
          IF (ID+1.GE.IWIND(I,1).AND.ID+1.LE.IWIND(I,2)) GOTO 150
        ENDDO
        GO TO 25
      ENDIF
* Changes on 10/9/91 - lambda angle movement
150   IF (MVANG.GT.1 .AND. MOVANG.EQ.3) THEN
        LPRO=(LPROLIN(ID))
        LPRO1=(LPROLIN(ID).AND. ID.LT.NEN)
cd      write (jout,*) 'ID',ID,' LPRO ',LPRO,' LPRO1 ',LPRO1
        IF (LPRO .AND. LPRO1) THEN
          IF (NFAIL.GT.1000) THEN
            WRITE (JOUT,'(2A/A)')'Error in RNDMOV - cannot change',
     & ' lamda angle(s)','without violating proline standard geometry.'
            STOP 
          ELSE
            NFAIL=NFAIL+1
            GOTO 25
          ENDIF
        ENDIF
        NFAIL=0
        IF (LPRO .OR. ID.EQ.NST) THEN
          IRES=ID
        ELSE IF (LPRO1 .OR. ID.EQ.NEN) THEN
          IRES=ID-1
        ENDIF
cd      WRITE (JOUT,'(A)') 'RNDMOV'
cd      WRITE (JOUT,*) 'IRES=',IRES,' IANG=',IANG
        if (ires.lt.1 .or. ires.gt.maxnum_res) then
           write (jout,*) 'ERROR - IRES=',ires,' in LAMBDA movemet.'
           goto 25
        endif
        IF (PRINT_SAMPLED) WRITE (JOUT,'(A,I3,A,F8.3,A,F8.3)') 
     &  'Before change: lambda(',IRES,') =',RL(IRES)*DEG,
     &  ' delta=',TAK*DEG
        RL(IRES)=PINORM(RL(IRES)+TAK)
        IF (PRINT_SAMPLED) WRITE (JOUT,'(A,I3,A,F8.3)') 
     &  'After change: lambda(',IRES,') =',RL(IRES)*DEG 
        CALL PHIPSI(IRES)
      ELSE IF (MVANG .EQ. 1)  THEN                                           
         M1=ID
         MA1=M1
         ANGLS=ANGLES(NDX)*DEG                                          
         IF (PRINT_SAMPLED) THEN
           IF (IANG.LT.4) THEN
             WRITE(JOUT,109)ANGCHAR(IANG),ID,ANGLS
           ELSE
             WRITE(JOUT,110)ANGCHAR(IANG),IANG-3,ID,ANGLS
           ENDIF
         ENDIF
109      FORMAT('Initial angle ',A3,'(',I3,')=',F8.3)                         
110      FORMAT('Initial angle ',A3,I2,'(',I3,')=',F8.3) 
         ANG=ANGLES(NDX)+TAK                                            
         ANGLES(NDX)=PINORM(ANG)                                        
         ANGLS=ANGLES(NDX)*DEG                                          
         IF (PRINT_SAMPLED) THEN
           IF (IANG.LT.4) THEN
             WRITE(JOUT,13)ANGCHAR(IANG),ID,ANGLS
           ELSE
             WRITE(JOUT,14)ANGCHAR(IANG),IANG-3,ID,ANGLS
           ENDIF
         ENDIF
         IF (( IANG.LE.2 .AND. IS.GT.0 .AND. IE.GT.0 )
     &                      .AND. M1.GE.IS .AND. M1.LE.IE) THEN
cd       write (jout,*) 'RNDMOV: M1',M1,' MA1',MA1,' IS',IS,' IE',IE
CD         CALL DRUANG(JOUT,NDONE)
           IF (IANG .EQ.1) THEN
             IFFIX(M1)=1
           ELSE
             IPFIX(M1)=1
           ENDIF
cd         write (jout,*) 'RNDMOV: calling DISTFORCE, IANG.LE.2.'
           CALL DISTFORCE
cd         write (jout,*) 'RNDMOV: exit DISTFORCE.'
CD         CALL DRUANG(JOUT,NDONE)
         ELSE IF (NLOOP.GT.0 .AND. IANG.NE.3) THEN
* Change 4/23/93 Bridge constraints.
           DO I=1,NLOOP
             NKAI1I=NKAI1(I)
             DO J=1,NKAI1I
               IF (NDX.EQ.ICHIND1(I,J)) THEN
                 ICHFIX1(I,J)=1
                 GOTO 11 
               ELSEIF (NDX.EQ.ICHIND2(I,J)) THEN
                 ICHFIX2(I,J)=1
                 GOTO 11
               ENDIF
             ENDDO
           ENDDO
           GOTO 12
cd 11      write (jout,*) 'RNDMOV: calling DISTFORCE, IANG.GT.3.'
   11      CALL DISTFORCE
cd         write (jout,*) 'RNDMOV: exit DISTFORCE.'
CD         CALL DRUANG(JOUT,NDONE)
   12      CONTINUE
         ELSEIF (( IANG.EQ.3 .AND. IS.GT.0 .AND. IE.GT.0 )
     &                    .AND. M1.GE.IS .AND. M1.LE.IE) THEN
cd         write (jout,*) 'RNDMOV: calling DISTFORCE IANG=3.'
           CALL DISTFORCE
cd         write (jout,*) 'RNDMOV: exit DISTFORCE.'
         ENDIF
13     FORMAT('New angle ',A3,'(',I3,')=',F8.3)                         
14     FORMAT('New angle ',A3,I2,'(',I3,')=',F8.3)                         
      ELSE                                                              
         MA1=M1+1                                                       
         ANGL1=ANGULO(2,M1)*DEG                                         
         ANGL2=ANGULO(1,MA1)*DEG                                        
         IF (PRINT_SAMPLED) WRITE(JOUT,4)M1,ANGL1,MA1,ANGL2      
4     FORMAT('Changed angles : psi(',I3,')=',F8.3,' phi(',I3,')=',F8.3)
         ANGULO(2,M1)=ANGULO(2,M1)+TAK                                  
         ANGULO(1,MA1)=ANGULO(1,MA1)-TAK                                
         ANGULO(2,M1)=PINORM(ANGULO(2,M1))                              
         ANGULO(1,MA1)=PINORM(ANGULO(1,MA1))                            
         ANGL1=ANGULO(2,M1)*DEG                                         
         ANGL2=ANGULO(1,MA1)*DEG                                        
         IF (PRINT_SAMPLED) WRITE(JOUT,5) M1,ANGL1,MA1,ANGL2
5        FORMAT('New angles : psi',I4,'=',F8.3,' phi',I4,'=',F8.3)       
cd       write (jout,*) 'is',is,' ie',ie,' m1',m1,' ma1',ma1
         IF (M1.GE.IS .AND. M1.LE.IE .OR. MA1.GE.IS .AND. MA1.LE.IE
     1   .AND. IS.GT.0 .AND. IE.GT.0 ) THEN
CD         CALL DRUANG(JOUT,NDONE)
           IF (M1.GE.IS .AND. M1.LE.IE) THEN
             IPFIX(M1)=1
           ENDIF
           IF (MA1.GE.IS .AND. MA1.LE.IE) THEN
             IFFIX(MA1)=1
           ENDIF
           CALL DISTFORCE
CD         CALL DRUANG(JOUT,NDONE)
         ENDIF
      END IF                                                            
      RETURN                                                            
      END                                                               
      logical function sc_omeg(id,iang)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      include 'COMMON.GEN100'
      include 'COMMON.GEN002X'
      include 'COMMON.BRIDGES'
      listi=iabs(list(id))
      if (nchi(listi)+3.ne.iang) then
	sc_omeg=.false.
	return
      endif
      do i=1,nbridge
	if (id .eq. npair(1,i)) then 
	  if (iom_flag(1,i).eq.1) then
	    sc_omeg=.true.
	    return
          endif
	else if (id.eq.npair(2,i)) then
	  if (iom_flag(2,i).eq.1) then
	    sc_omeg=.true.
	    return
          endif
        endif
      enddo
      sc_omeg=.false.
      return
      end

      SUBROUTINE PERTURB(IMOV,OVER)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
C ==================================================================
#ifdef MP
      INCLUDE 'PARAMET.MP'
      INCLUDE 'COMMON.MP'
#endif
#ifdef MPI
      include 'mpif.h'
      INTEGER IERR, STATUS(MPI_STATUS_SIZE)
#endif
      INCLUDE 'COMMON.ODONNELL'
      INCLUDE 'COMMON.TRACK'
C ==================================================================
      INCLUDE 'COMMON.EDMC'
      INCLUDE 'COMMON.PICK'
      INCLUDE 'COMMON.TERMAL'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.TOR2'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.GEN004'
      INCLUDE 'COMMON.TORQUEX'
      INCLUDE 'COMMON.BONDSX'
      INCLUDE 'COMMON.MYCONF'
      INCLUDE 'COMMON.PROB'
      INCLUDE 'COMMON.PRTBKTK'
      INCLUDE 'COMMON.SETUP'
      INCLUDE 'COMMON.THRLET'
      INCLUDE 'COMMON.BIAS'
      INCLUDE 'COMMON.CLUSTER'
      INCLUDE 'COMMON.TRIPROB'
      LOGICAL OVER
      LOGICAL LADDC, LCHG, GET_OTHER
      INTEGER ITMPLIST(maxnum_res)
      INTEGER IZERO, IONE
      DATA IZERO /0/, IONE /1/
      REAL REGPHIPSI(4)
      DATA REGPHIPSI /-140.0,-140.0,-60.0,-40.0/

      OVER=.FALSE.
C ==================================================================

C     If YourJob is true, that means you are either the MASTER in an
C  MP run or this is not an MP run.  In either case, you are allowed
C  to perform perturbations normally.  If this is not the case, then
C  you must be an MP worker, in which case you must tell the
C  master that you need him to do a PERTURBATION for you.

      IF (YourJob) THEN
         RNDCLS=RNUNF(1)
c       write(*, *)'ChooseCluster, RNDCLS, ngr ',
c    &                      ChooseCluster,RNDCLS, ngr 
         IF (RNDCLS.LT.ChooseCluster.and. ngr.gt.1) THEN
C We select here a conformation different from the current minima to
C produce the perturbation.
C The call should retrieve a single conformation from a selected clusters
           IF (PRINT_SAMPLED) write(jout,*)'Choose from Cluster'
            CALL SELECT_FROM_CLUSTER
C
C Only random changes will be allowed since electrostatic predictions for this
C conformation are not available, and also will be hard to track if the movement 
Cis allowed. 
            IMOV=0
            IF (ICOUNTER(2).LT.NRANM) IMOV=2
         ELSE
C    Perturb the current conformation in order to generate a new one.
C
C  SET UP ANGL ARRAY AND CODE, USING MOST RECENT MINIMUM
         do 25 i=1,inumrs
            do 26 j=1,MAXNUM_DIHE
               angulo(j,i)=angmin(j,i,mst)
   26       continue
   25    continue
C  KEEP TRACK OF TYPE OF PRO AND HIS RESIDUES.
            LPRHI=LPROHIS(MST)
C  AND STATE OF CHARGE OF MINIMUM_ENERGY CONFORMATION. NOT USED CURRENTLY.
            LCHAR=LCHARG(MST)
C TYPE OF MOTION: INITIALIZE IMOV
            IMOV=0
            IF (ARBT.LT.1.0 .AND. ICOUNTER(1).LT.MAXEL .AND. 
     &              L1.GT.0) THEN
               RNDX=RNUNF(1)
               IF (RNDX.GT.ARBT) IMOV=1
            ENDIF
         ENDIF
           
C  KEEP TRACK OF THE ORIGINAL MINIMUM: ITERATION NUMBER AND ENERGY.
         iinc=ndone
C            WRITE (*,*) 'perturbing iinc = ',iinc
         einit=enemin(mst)
C ==================================================================
C set sequence of the current minimun if there are HIS or PRO residues.
         IF (EXCPRH.LT.1.0 .AND. LOGICPH) CALL DETSEQ


         IF (IMOV.EQ.0 .AND. ICOUNTER(2).LT.NRANM) IMOV=2

         IF (IMOV.EQ.0) THEN
           IF (.NOT. LTHER .OR. ICOUNTER(3).GE.NTERMM) THEN
             IF (TEMP.LT.TUP) THEN
               TEMP=TEMP*TSTEPH
               IF (TEMP.GT.TUP) TEMP=TUP
               WRITE (*,'(a,f8.3)') 'TSTEPH = ', TSTEPH
               WRITE (JOUT,'(/33(1H*)/A,F8.1,A/33(1H*))')
     &             'System heated up, T=',TEMP,' K.'
               ITOTC(3)=ITOTC(3)+ICOUNTER(3)
C              IF (ICOUNTER(3).EQ.0) THEN
 57               IF (ITYPBK.EQ.1) THEN
C     ITYPBK =1    BACKBONE WILL BE CHANGED.
                     CALL PROBDI(IONE)
                  ELSE
C     ITYPBK =2    ALL VARIABLES WILL BE CONSIDERED FOR BACKTRACKing.
                     CALL PROBDI(IZERO)
                  ENDIF
C MXBKTRR is the number of variables for bactracking that the user requested 
C MXBKTRC  is MXBKTRR-2 (see readrtns.F),   
                  MXBKTRR= MXBKTRC+2
                  NBKTRC=  MIN(MXBKTRR, MXNOCHG)
                  IF (ITYPBK.EQ.1) NBKTRC=  MIN(MXBKTRR, MXNOCHGBK)
                  IF (NBKTRC.LT.MXBKTRR .AND. BKTKPR)  THEN
C PRINTING OF THIS MSG MAY COME AT MOST TWICE IN A RUN.
                     BKTKPR=.FALSE.
                     WRITE(JOUT,2070)NBKTRC
 2070 FORMAT('BACKTRACK: MAX. NO. OF CHANGES ALLOWED IS  ',I4)
                  ENDIF
                  IF (ITYPBK.EQ.1.AND.NBKTRC.EQ.IZERO) THEN
                     WRITE(JOUT,2080)
 2080 FORMAT('%BACKTRACK: NO BACKBONE VARIABLES.',/,' ALL THE VARIABLE',
     &  ' DIHEDRAL ANGLES WILL BE CONSIDERED HEREAFTER')
                     ITYPBK=0
                     BKTKPR=.TRUE.
                     GOTO 57
                  ELSE IF(ITYPBK.EQ.2.AND.NBKTRC.EQ.IZERO) THEN
                     WRITE(JOUT,2090)
 2090 FORMAT('%ERR:BACKTRACK. NONE OF THE VARIABLES CAN BE CHANGED')
                     OVER=.TRUE.
                     RETURN
                  ENDIF
C              ENDIF
               ICOUNTER(3)=0
               IMOV=3
             ENDIF
           ELSE
             IMOV=3
           ENDIF
         ENDIF
         IF (IMOV.EQ.3) LTHER=.TRUE.
         IF (PRINT_SAMPLED) write(jout, *)'IMOV ',IMOV
         GO TO (10,20,30,40) IMOV+1
C No more new minima can be found (IMOV=0). Termination flag is set at .TRUE.
   10    OVER=.TRUE.
         RETURN
C Electrostatic-type perturbation. IMOV=1
   20    CALL CORECT(IDEF)
         IEF(IDLEADER+1)=M2(IDEF)
         LOLD=L1
         CALL ORDER(LOLD,IDEF,M2,L1)
         IF (PRINT_SAMPLED)write(jout, *)'Electrostatic Prediction'
         GOTO 50
C Random-type perturbation. IMOV=2
   30    LADDC=.TRUE.
         IF (EXCPRH.LT.1.0 .AND. LOGICPH) THEN
C   We have HIS or PRO and we attempt to change ring conformations.
C   PRO-UP to PRO-DOWN and viceversa, or HID to HIE and viceversa.
           LCHG=.FALSE.
           RNDX=RNUNF(1)
           IF (RNDX.GT.EXCPRH) THEN
              LPHINT= LPRHI
              IF (PRINT_SAMPLED)write(jout, *)'Change of HIS or PRO'
              CALL CHISPRO(LCHG)
C   If there was a change in HIS or PRO then an extra change in a dihedral 
C   angle could be added (for 0.5 < RNDX < 0.75  LADDC is .TRUE.).
C             IF ( LCHG  .AND.  (RNDX.GT.0.75) ) LADDC=.FALSE.
              IF ( LCHG  .AND.  (RNDX.GT.0.5*(1.0+EXCPRH)) )
     &          LADDC=.FALSE.
              IF ( LCHG ) write(jout,'(A/A,i8,A,i8)') 
     &         'HIS-PRO CHANGE: ',' OLD LPRHI= ',LPHINT,' NEW LPRHI= ',
     &          LPRHI
           ENDIF
         ENDIF
         IF (LADDC) THEN
C   If there was no change in HIS or PRO,  or LADDC is still true,
C   then change some dihedral angle(s). 
C
C After  selecting one or more  consecutive changes the options are: 
C 1- To change the dihedral angles absolutely randomly (40% chances)   DR   APR94
C 2- To change the dihedral angles using  Max Vasquez probabilities 
C     for backbone dihedral angles, from ALA (PHI-PSI map). (with 50% chances)
C 3. generate regular structures by changing a few dihedral angle simultaneously
C    into alpha helices or beta sheet conformations.
C 
C In general, changes in the backbone  implies changing two dihedral angles.
C

C Throwing a dice to define the type of random change.
               RNDCHG=RNUNF(1)
C           write(*,*)' RNDCHG = ', RNDCHG

C The maximum number of residues that can be altered is:
               IF (NWIND.EQ.0) THEN
                 MXRESCHG= INUMRS-2
               ELSE
C 9/25/96 AL Diminish # of alterable residues according to WINDOWS.
                 MXRESCHG= 0
                 DO IWI=1,NWIND
                   MXRESCHG=MXRESCHG+(IWIND(IWI,2)-IWIND(IWI,1)+1)
                 ENDDO
                 IF (MXRESCHG.GT.INUMRS-2) MXRESCHG=INUMRS-2
               ENDIF
C If the number of full residues is less than 4 we don't force generation of
C regular structure
            IF( MXRESCHG.LT.4) RNDCHG=MAX(REGSTRUC,RNDCHG)

C The minimum number of residues that can be altered is 1 or MXRESCHG if (INUMRS-2)< 1
            MINRESCHG=  MIN(1, MXRESCHG)
C           NUMRC=ANINT(RNUNF(1) * (MXRESCHG-MINRESCHG) )+MINRESCHG
C NUMRCHG - Number of residues to be altered. THE LHYPERDIST FUNCTION SELECTS 
C THE NUMBER OF RESIDUES USING A BIAS DISTRIBUTION FUNCTION   (1/N**2).
            NUMRCHG=LHYPERDIST(MXRESCHG-MINRESCHG+1)
            IF (NUMRCHG .LT. 0) THEN
              IF (PRINT_SAMPLED)write(jout,*)'Problems with LHYPERDIST'
               OVER=.TRUE.
               RETURN
            ENDIF
            NUMRCHG=NUMRCHG-1+MINRESCHG
C        write(*,*)' NUMRCHG= ', NUMRCHG, ' MINRESCHG= ',MINRESCHG

            IF (RNDCHG.LE.REGSTRUC) THEN
               IF (PRINT_SAMPLED)write(jout,*)'Regular Structure trial'
C Here we'll generate a regular structure (alpha helix - beta-sheet - fully extended )
C for a given number (random) of  consecutive residues. We'll have some problems
C if the dihedral angles on the backbone are fixed (e.g. PRO).
C
               INITRNDRES=ANINT(  RNUNF(1)* MXRESCHG +1.99999999 )
C        write(*,*)' MXRESCHG= ', MXRESCHG, ' MINRESCHG= ',MINRESCHG,
C    &    ' INITRNDRES= ', INITRNDRES
               IF (INITRNDRES.LE.1) THEN
C                 write(*,*) 'Error in perturb, gen. regular struc.-',
C    &                 ' INITRNDRES= ', INITRNDRES
                  INITRNDRES= 1
               ENDIF
               IF (INITRNDRES.GE.INUMRS) THEN
C                 write(*,*) 'Error in perturb, gen. regular struc.-',
C    &                 ' INITRNDRES= ', INITRNDRES
                  INITRNDRES= INUMRS-1
               ENDIF
               LSTRNDRES= INITRNDRES + NUMRCHG-1
               IF (LSTRNDRES.GT.(INUMRS)) THEN
C  initial residue (IRRE in loop) is (INUMRS - 1) - NUMRCHG 
                  INITRNDRES = INUMRS - NUMRCHG -1
               ENDIF 
C decide randomly the type of regular structure.
C IREGION=1 is beta sheet;  IREGION=2 is alpha helix.
C Note that alpha has a larger probability: P_beta/P/alpha = 0.3/0.7

               IREGION=ANINT(  RNUNF(1)+ 1.2 ) 
               write(jout,'(3(A20,1X,I4))') 'REGULAR STRUCT. ',IREGION, 
     &          ' No. of altered res. ', NUMRCHG, 
     &          ' Starts on Res. =', INITRNDRES
   	       DO IR=1, NUMRCHG
                  IRRE=INITRNDRES+IR -1 
                  ITRIALS(IRRE)=ITRIALS(IRRE)+1  
                  IF(NCHVAR(IRRE,1).EQ. 1)
     &              ANGULO(1,IRRE)=RAD*REGPHIPSI(2*IREGION-1)
                  IF(NCHVAR(IRRE,2).EQ. 1) 
     &              ANGULO(2,IRRE)=RAD*REGPHIPSI(2*IREGION) 
                  IF(NCHVAR(IRRE,3).EQ. 1) 
     &              ANGULO(3,IRRE)=PI
               ENDDO
            ELSE IF (RNDCHG.LE.PHIPSIMAP) THEN
               IF (PRINT_SAMPLED)write(jout,*)'Using PHI-PSI map'

C              WRITE(*,'(i4,a)')NUMRCHG, 
C    &          ' randomly selected residues moved using PHI-PSI MAP :'
C max probabilities
C
C  Select a full residue  (formula eliminates movements on end groups)
   	       DO IRR=1, NUMRCHG
                  ITMPLIST(IRR)=0
               ENDDO
               GET_OTHER=.TRUE.
               KDNE=0
   	       DO WHILE (GET_OTHER)
C                 RNDRES=RNUNF(1)
C
C 9/25/96 AL Changed to take into account WINDOWS
C
C                 IRESRND=AINT((INUMRS-2)*RNDRES) + 2
                  CALL RNDNDX(INUMRS,PROBRS,IRESRND)
!                  WRITE(jout,*) 'IRESRND= ', IRESRND,' INUMRS= ',INUMRS 
                  IFND=0
   	          DO IRR=1, NUMRCHG
                    IF (IRESRND.EQ. ITMPLIST(IRR)) IFND=1
                  ENDDO
C 
C Discard if not in WINDOWS AL & CC 9/23/96
C
                  IF (IFND.EQ.1) GOTO 261
                  DO IWI=1,NWIND
                    IF (IRESRND.GE.IWIND(IWI,1)
     &                .AND. IRESRND.LE.IWIND(IWI,2)) GOTO 261
                  ENDDO
                  IFND=1
  261             CONTINUE
C
C End Change.
C
                  IF (IFND.EQ.0) THEN
                     KDNE=KDNE+1
                     ITMPLIST(KDNE)=IRESRND
                     ILIST=IABS(LIST(IRESRND))
                     IF((IRESRND.EQ.1).OR.(IRESRND.EQ.INUMRS)) THEN
                        NBU = NBOND(ILIST)
                        IF(IRESRND.EQ.INUMRS) NBU = NBU-1
                        ILIST=ILIST+num_restypes
                        IF (NBU.EQ.0) THEN
!                           WRITE(JOUT,'(3a,i4,a)')
!     &                      'ATTEMPTED TO CHANGE CONFORMATION OF ', 
!     &                       ARES(ILIST),'(', IRESRND, 
!     &                       ') BUT THERE IS NO VARIABLE DIHEDRAL ANGLE'
                           IF (KDNE.EQ.NUMRCHG) GET_OTHER=.FALSE.
                           GOTO 271
                        ELSE  
                           WRITE(JOUT,'(3a,i4,a)')
     &                      'WILL CHANGE ENDGROUP ', ARES(ILIST),'(', 
     &                       IRESRND, ') '
                        ENDIF  
                     ELSE  
                        WRITE(JOUT,'(3a,i4,a)')
     &                 'PHI-PSI MAP USED FOR CHANGING CONFORMATION OF ',
     &                  ARES(ILIST),'(' , IRESRND, ')'
                     ENDIF  
                     ITRIALS(IRESRND)=ITRIALS(IRESRND)+1  
                     CALL RANGUX(IRESRND)
                     IF (KDNE.EQ.NUMRCHG) GET_OTHER=.FALSE.
                  ENDIF
271               CONTINUE
               ENDDO

c                 write(*,*)' NUMRCHG= ', NUMRCHG
c                 write(*,*)' ELOWCONF= ', ELOWCONF, ' RNDCHG= ',RNDCHG
            ELSE IF (RNDCHG.LE.ELOWCONF) THEN
               IF( LIST_TOT.GT.0) THEN
               IF (PRINT_SAMPLED)write(jout,*)'Using Database for trial'
                  CALL DBASESEL(NUMRCHG)
               ELSE
                    WRITE(*,'(2a)')'WARNING: Attempt to ',
     &            'a produce random change from non-existing  database'
                    WRITE(JOUT,'(2a)')'WARNING: Attempt to ',
     &            'a produce random change from non-existing  database'
               ENDIF

               ELSE
               NUMDCH=AINT(RNUNF(1)*3.5)+1
               NDHCH=  MIN(NUMDCH, MXNOCHG)
C random
               IF (PRINT_SAMPLED)write(jout,*)NDHCH, 
     &                      ' consecutive random changes'
            WRITE(JOUT,'(i4,a)')NDHCH, ' consecutive random changes:'

   	       DO IRR=1, NDHCH
                  RNDN=RNUNF(1)
                  NSEL=AINT(2.0*RNDN+0.5)
                  CALL RNDMOV(IDEF,NSEL)
                  IEF(IDLEADER+1)=IDEF
                  ITRIALS(IDEF)=ITRIALS(IDEF)+1
            ENDDO
         ENDIF
         ENDIF
         GOTO 50
C Thermal-type perturbation.
   40    RNDS=RNUNF(1)
C MODIFIED. Avoids error with runs for one residue only.
C                                            OCT 13-93 by  DR
         NQS=AINT(RNDS*mxbktrc+0.5)+2
         NQCH=  MIN(NQS, MXNOCHG)
         IF (PRINT_SAMPLED)write(jout,*)'Using BACKTRACK'
         CALL BCKTRK(NQCH,OVER)

C ====================================================================

C     This is the MPL worker portion mentioned previously.  A worker
C  must get his perturbed conformation from the MASTER.

#ifdef MPL
      ELSE
        CALL SLAVE_MAIL
        CALL MP_BSEND(TASKID,INTSIZE,MASTER,PTURBMSG,MSGID)
        CALL MP_BRECV(OVER,BOOLSIZE,MASTER,OVERMSG,BRCVD)
        IF (OVER) THEN
          RETURN
        ELSE
          CALL MP_BRECV(LIST,LISTSIZE,MASTER,LISTMSG,BRCVD)
          CALL MP_BRECV(ANGLES,ANGLESIZE,MASTER,ANGLEMSG,BRCVD)
          CALL MP_BRECV(DESERT,DESERTSIZE,MASTER,DESMSG,BRCVD)
          IMOV  = INT(DESERT(1) + 0.5)
          IINC  = INT(DESERT(2) + 0.5)
          lprhi = INT(DESERT(3) + 0.5)
          lchar = INT(DESERT(4) + 0.5)
          einit = DESERT(5)
          TEMP = DESERT(6)
        ENDIF
#endif
#ifdef MPI
      ELSE
        CALL SLAVE_MAIL
        CALL MPI_SEND(TASKID,1,MPI_INTEGER,MASTER,PTURBMSG,
     &                MPI_COMM_WORLD,IERR)
        if (IERR.NE.0) THEN
           Write(*,*) '4-Error in PERTURB'
!          call sleep(5)
        ENDIF
        CALL MPI_RECV(OVER,IONE,MPI_LOGICAL,MASTER,OVERMSG,
     &                MPI_COMM_WORLD,STATUS,IERR)
! MPI on NT returns ierr=14
        if (IERR.NE.0) THEN
           call MPI_Type_size ( MPI_LOGICAL,issize,jerr )
           IF (JERR.NE.0)Write(*,*)'5.5-PERTURB: JERR=',JERR
           write(*,*)'5-PERTURB: IERR=',IERR,' issize=',issize
!          call sleep(5)
        ENDIF
        IF (OVER) THEN
           Write(*,*) 'Over in PERTURB'
!          call sleep(5)
          RETURN
        ELSE
          CALL MPI_RECV(LIST,maxnum_res,MPI_INTEGER,MASTER,
     &                  LISTMSG,MPI_COMM_WORLD,STATUS,IERR)
        if (IERR.NE.0) THEN
           Write(*,*) '6-Error in PERTURB'
!            call sleep(5)
        ENDIF
          CALL MPI_RECV(ANGLES,maxnum_dihe*maxnum_res,MPI_REAL,
     &                  MASTER,ANGLEMSG,MPI_COMM_WORLD,STATUS,IERR)
        if (IERR.NE.0) THEN
           Write(*,*) '7-Error in PERTURB'
!            call sleep(5)
        ENDIF
          CALL MPI_RECV(DESERT,DESERTLENGTH,MPI_DOUBLE_PRECISION,
     &                  MASTER,DESMSG,MPI_COMM_WORLD,STATUS,IERR)
! MPI on NT returns ierr=14
!         IF (IERR.NE.0) THEN
!            Write(*,*)'8-PERTURB: IERR=',IERR,' DESERT(1:4)=',
!    &       DESERT(1), DESERT(3), DESERT(3), DESERT(4)
!            call sleep(5)
!         ENDIF
          IMOV  = INT(DESERT(1) + 0.5)
          IINC  = INT(DESERT(2) + 0.5)
          lprhi = INT(DESERT(3) + 0.5)
          lchar = INT(DESERT(4) + 0.5)
          einit = DESERT(5)
          TEMP = DESERT(6)
        ENDIF
#endif
      ENDIF
C ====================================================================

   50 CONTINUE
      RETURN

      END 
      SUBROUTINE UPDATE(good)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.BONDSX'
      INCLUDE 'COMMON.TRACK'
      INCLUDE 'COMMON.CALC'
      INCLUDE 'COMMON.MYCONF'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.EDMC'
      INCLUDE 'COMMON.CLUSTER'
      logical good
 
c     print *,'Update: ncon=',ncon,' mst=',mst,' maxnum_track=',
c    &        maxnum_track
c     print *,'good=',good
      IF (NCON.GT.maxnum_track) THEN
        write (jout,'(a)') 'Error - storage arrays have been filled!'
        not_done = .false.
        return
      ENDIF 
      ENEMIN(NCON)=ETOT
      LPROHIS(NCON)=LPRHI
      LCHARG(NCON)=LCHAR
      DO I=1,INUMRS
        LISTMIN(I,NCON)=LIST(I)
        IF (I.NE.1.AND.I.NE.INUMRS)  THEN
           ZIMM(I,NCON)=ZIMMK(I)
        END IF
        DO J=1,maxnum_dihe
           ANGMIN(J,I,NCON)=ANGULO(J,I)
        ENDDO
      ENDDO

C
      IF (.NOT.GOOD) RETURN
      MST = NCON
C This code checks how many times has this particular
C backbone conformation (ZIMMERMAN CODE) appeared.
C DR. 5/20/96
C     DO I=2, INUMRS-1
C        ZIMMIN(I,NDONE)=ZIMMK(I)
C     ENDDO
      write(*, *) 'ACCEPTED CODE ', (ZIMM(I,NCON), I=2,INUMRS-1) 
C     KZI= 1
C     DO J=1, NDONE-1
C        DO I=2, INUMRS-1
C           IF(ZIMMK(I).NE. ZIMMIN(I,J) ) GOTO 10
C        ENDDO
C        KZI=KZI+1
C  Backbone are different try next.
C 10       CONTINUE
C       ENDDO
 
      IF (KZI.GE.MaxKzimm) THEN
         WRITE(JOUT, '(A20,I4,A22,i3,A6)' )
     & 'This conformation ( ',NDONE,') has been repeated ', 
     & KZI,' times'
      ENDIF

      RETURN
      END
