c energy ggg001-interaction of charged side groups with neutral protein -
c                                                               ggg01
c   and charged side(initial state)-charged side groups- ggg02
c   and charged side-charged side groups- ggg03
c
        subroutine en_ggg001(xxinit,xxfinal,ggg01,ggg02,ggg03)

#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
        include'param.ibems'
        include'comm.ibems'
        real*8 fren01(nres_mx),fren02(nres_mx),fren03(nres_mx) 
        real*8 frenpmf(nres_mx,nres_mx)
        integer nsoord,irg,ix,jx
        real*8 soord(3,maxat),rad_ps(maxat),atmq_ps(maxat)
        real*8 soordj(3,natinrs_mx),atmq_jj(natinrs_mx)
        integer xxinit(nres_mx),xxfinal(nres_mx),xxdelt(nres_mx)
        real*8 elfren,hpfren,ggg03,ggg01,ggg02
        real*8 en_cl,en_sl,en_frt
        integer nsoordj,k,iap,natm,j,i,l,ia

c.
        do i=1,nres_mx
        fren01(i)=0.d0
        ggg001_is(i)=0.d0
        fren03(i)=0.d0
        fren03(i)=0.d0
        do j=1,nres_mx
        frenpmf(i,j)=0.d0
        gggpmf(i,j)=0.d0
        end do
        end do
c.
c. define xxdelt(i)
        do i=1,npolres_t 
        xxdelt(i)=abs(xxfinal(i))-abs(xxinit(i))
        end do
c. 
c..define PSneutral side groups coord 

       nsoord=nat_backnt
       do ia=1,nsoord
       l=latm_backnt(ia)
       atmq_ps(ia)=atmcha(l)
       do k=1,3
       soord(k,ia)=atmxyz(k,l)
       end do
       end do
c..
       if(outdetl.gt.1)then
       write(*,*)'en_ggg001: PSneutralside gr'
       write(*,*)'nsoord=',nsoord
       write(*,*)'iat=,atmq=,atmrad=,xyz='
        do i=1,nsoord
       write(*,'(i5,4f8.3)') i,atmq_ps(i),
     & (soord(k,i),k=1,3)
        end do
         end if !outdetl

c..
c..loop over xxdelt
c..
       ggg001=0.d0
       ggg01=0.d0
       ggg002=0.0d0
       ggg02=0.d0
       ggg003=0.d0
       ggg03=0.d0
c.
       irg=0
       ix=0
1000   ix=ix+1
       if(ix.gt.npolres_t)goto 1010
       fren01(ix)=0.d0
       fren02(ix)=0.d0
       fren03(ix)=0.d0
       if(xxdelt(ix).eq.0)goto 1000
c.
c..
c.. interaction between neutral P backbone+neutralside groupsch
c.. with REACTION field+COULfield due to charged sid group S+ix
c.
	call ssint_en(ix,nsoord,soord,atmq_ps,en_cl,
     &                                        en_sl,en_frt)       
c..
       fren01(ix)=xxdelt(ix)*en_frt
       ggg001_is(ix)=fren01(ix)
       ggg001=ggg001+en_frt*xxdelt(ix)
c..
        if(outdetl.ge.1)then
         write(*,*)'en_ggg001: PSneutr - Si+residue'
         write(*,*)'Si(ix):xi=',ix,'fren01(ix)=',fren01(ix)
         end if
        
c. interaction between initially charged side groups  
c.. with REACTION field+COULfield due to charged sid group S+ix
c.
c..define coord  Sj(initial) which are .neq.ix 
       nsoordj=0     
       do jx=1,npolres_t
       if(abs(xxinit(jx)).eq.1.and.ix.ne.jx)then
       natm=natm_polrs(jx)
       do ia=1,natm
       iap=ia+nsoordj
       l=latm_polrs(ia,jx)
       atmq_jj(iap)=atmcha(l)
       do k=1,3
       soordj(k,iap)=atmxyz(k,l)
       end do !k
       end do !ia
       nsoordj=nsoordj+natm
       end if
       end do ! jx
c..
       if(outdetl.gt.1)then
       write(*,*)'en_ggg001: S+(ix),ix=',ix
       write(*,*)'nsoordj=',nsoordj
       write(*,*)'iat=,atmq=,atmrad=,xyz='
        do i=1,nsoordj
       write(*,'(i5,4f8.3)') i,atmq_jj(i),
     & (soordj(k,i),k=1,3)
        end do
        end if !outdetl
c.. interaction between neutral P backbone+neutralsidech+charged(xxinitial)
c.. side groups with REACTION field+COULfield due to charged sid group S+ix
c.
	call ssint_en(ix,nsoordj,soordj,atmq_jj,en_cl,
     &                                        en_sl,en_frt)       
c..
       fren02(ix)=xxdelt(ix)*en_frt
       ggg002=ggg002+en_frt*xxdelt(ix)
c..
       if(outdetl.ge.1)then
       write(*,*)'en_ggg001: interaction Sj+(initial)-Si+(ix)=',ix
       write(*,*)' fren02(ix)=',fren02(ix)
       end if
c
c
c. ineraction between charged residues PMF
       do i=1,natinrs_mx
       atmq_jj(i)=0.d0
       end do
c.
c..define coord  Sj(initial) which are .neq.S(ix) 
       if(xxfinal(ix).eq.0)goto 1000
       if(ix+1.le.npolres_t)then
       do jx=ix+1,npolres_t
       if(abs(xxfinal(jx)).eq.1.and.ix.ne.jx)then
       if(xxdelt(jx).ne.0)then

       nsoordj=0     
       natm=natm_polrs(jx)
       do ia=1,natm
       l=latm_polrs(ia,jx)
       atmq_jj(ia)=atmcha(l)
       do k=1,3
       soordj(k,ia)=atmxyz(k,l)
       end do !k
       end do !ia
       nsoordj=natm
c..
c.. interaction between charged(xxinitial)
c.. side groups with REACTION field+COULfield due to charged side group S+ix
c.
	call ssint_en(ix,nsoordj,soordj,atmq_jj,en_cl,
     &                                        en_sl,en_frt)       
c..
       frenpmf(ix,jx)=en_frt
       gggpmf(ix,jx)=en_frt
       ggg003=ggg003+en_frt*xxdelt(ix)*xxdelt(jx)
       
       if(outdetl.ge.1)then
       write(*,*)'en_ggg001: Sj+ - Si+ interaction'
       write(*,*)'ix,jx=',ix,jx,'frenpmf=',frenpmf(ix,jx)
       end if !outdetl
c..
       end if
       end if
       end do ! jx
       end if
c.
       goto 1000
1010   continue
c.
         ggg01=ggg001
         ggg02=ggg002
         ggg03=ggg003
c
       if(outdetl.ge.1)then
       write(*,*)
       write(*,*)'en_ggg001: final energies'
       write(*,*)'en_g01=',ggg01,'en_gg02=',ggg02
       write(*,*)'i=','fren01(i)  fren02(i)'
       do i=1,npolres_t
       write(*,'(i5,2f8.4)') i,fren01(i),fren02(i)
       end do
       write(*,*)
       write(*,*)'total int S+--S+ ', ggg03
       write(*,*)'potential mean force ij='
       do i=1,npolres_t-1
       do j=i+1,npolres_t
       write(*,'(2i5,f8.3)') i,j,frenpmf(i,j)
       end do
       end do
       end if !outdetl
c.
c.
       return
       end
