C $Date: 1997/05/09 17:11:38 $
C $Revision: 3.2 $
C
C
C
      SUBROUTINE MAP(ICOUNTS)
c
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      PARAMETER (max_grid=100)
      INCLUDE 'COMMON.CNTRL'
      INCLUDE 'COMMON.DEBUG'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.GRID'
      INCLUDE 'COMMON.CALC'
      INCLUDE 'COMMON.BONDSX'
      INCLUDE 'COMMON.SETUP'
      INCLUDE 'COMMON.TOR2'
      INCLUDE 'COMMON.TORQUEX'
      INCLUDE 'COMMON.TRACK'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.MYCONF'
      INCLUDE 'COMMON.MINPAR'
      INCLUDE 'COMMON.NNDRUK'
      INCLUDE 'COMMON.KVS'
      LOGICAL FAIL
      DIMENSION GRD(0:max_grid,0:max_grid)
      external ILEN
C
#ifdef PKSR
      INCLUDE 'COMMON.PARRAY'
#endif
C
      DATA IZERO /0/
#ifdef PKSR
      DO M=1, NCELLS
        COUNTS(M)=0
      ENDDO
#else
      ICOUNTS=0
#endif
      NCOUN=0
      DO J=1,INUMRS
        DO K=1,maxnum_dihe
          ANGMIN(K,J,1)=ANGULO(K,J)
        ENDDO
      ENDDO
C MODIFY THE KV CARD FOR SPECV BY SETTING IVARFLAG to 4 (SPEC).
      IVARFLAG=4
C SAVE THE INFORMATION ABOUT VARIABLES ALREADY COLLECTED
C     NUMVR0    = NUMVAR
      NUMVR0    = 0
      DO I=1,INUMRS
         NV0(I)=NV(I)
         KK=0
         DO K=1,NV(I)
            IF (  ((I.EQ. iresng1).AND.(NDXARR(K,I).EQ. iiang1)).OR.
     &   ((I.EQ. iresng2).AND.(NDXARR(K,I).EQ. iiang2))  ) THEN 
               NV0(I)=NV0(I)-1
            ELSE
               KK=KK+1
               NUMVR0 = NUMVR0+1
               NDXARR0(KK,I)= NDXARR(K,I)
            ENDIF
         ENDDO
      ENDDO

      CALL SETUP_X(IZERO)
      IDNUM=0
      DO I=0,N1
        ANGLES(INDANG1)=(FROM1+I*STEP1)*RAD
	ANGL1= ANGLES(INDANG1)

        DO K=0,N2
           IDNUM= IDNUM+1
           ANGLES(INDANG2)=(FROM2+K*STEP2)*RAD

C          write (jout,*) 'i=',i,'indang=',indang1,
C    &     ' ang=',angles(indang1)*deg

C          write (jout,*) 'k=',k,'indang=',indang2,
C    &    '   ang=',angles(indang2)*deg
C    &   ,' step2=',step2 ,' from2=',from2
           DO JL=1,NUMVAR
            NDX=INDXV(JL)
            VAR(JL)=ANGLES(NDX)
           ENDDO

C          CALL ENE_EVAL
C          write(jout,*)' BEFORE MINIMIZATION '
C          CALL DRUANG(JOUT,1)
C          CALL ENEPRINT


           IF (IRUNTYP .EQ. 1) THEN
              CALL ENE_EVAL
C
#ifdef PKSR
              COUNTS(IDLEADER+1)=NCOUN+COUNTS(IDLEADER+1)
#else
              ICOUNTS=NCOUN+ICOUNTS
#endif
              NCOUN=0
c             write(*,*) 'calling DRUANG'
              CALL DRUANG(JANG,IDNUM)
c             IF (PRINT) CALL OUTNW(0,30,1)
           ELSE
	    
              NUK=0
              CALL ENER_MINIM(FAIL)
C
#ifdef PKSR
              COUNTS(IDLEADER+1)=NCOUN+COUNTS(IDLEADER+1)
#else
              ICOUNTS=NCOUN+ICOUNTS
#endif
              NCOUN=0

C             CALL DRUANG(JANG,1)
C             write(jout,*)' AFTER MINIMIZATION '
C             CALL DRUANG(JOUT,1)
C             CALL ENEPRINT

           ENDIF
           GRD(I,K)=ETOT
C           WRITE (JOUT,'(A,e12.5)') 'Energy =', ETOT
           IF (GRD(I,K).GT.9999.99) GRD(I,K)=9999.99
C reset array angles (angulo) to original value.
          DO JI=1,INUMRS
            DO IK=1,maxnum_dihe
               ANGULO(IK,JI)=ANGMIN(IK,JI,1)
            ENDDO
          ENDDO
          ANGLES(INDANG1)=ANGL1

        ENDDO
      ENDDO
 
#ifdef PKSR
      CALL PTHREAD_MUTEX_LOCK (IMUTEX,ISTAT)
#endif
c
      WRITE (JOUT,'(//5A)') 'Energy map (columns: ',ANG1(1:ILEN(ANG1)),
     & ' rows: ',ANG2(1:ILEN(ANG2)),').'
      WRITE (JOUT,'(A,3(A,F6.1),A,I4,A)') ANG1(1:ILEN(ANG1)),
     & ': from ',FROM1,' to ',TO1,' step ',STEP1,'; ',N1,' points.'
      WRITE (JOUT,'(A,3(A,F6.1),A,I4,A/)') ANG2(1:ILEN(ANG2)),
     & ': from ',FROM2,' to ',TO2,' step ',STEP2,'; ',N2,' points.'
      DO I=0,N1
        WRITE (JOUT,'(10F8.2)') (GRD(I,K),K=0,N2)
      ENDDO  

      RETURN 
       END
