      SUBROUTINE PLACE
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      include 'COMMON.TRACK'
      include 'COMMON.MYCONF'
      include 'COMMON.GEN100'
      include 'COMMON.BONDSX'
      CHARACTER*2 BLANKN
      CHARACTER*2 NAME(16)
      DATA NAME /'A ' ,'B ' ,'C ' ,'D ' ,'E ','F ','G ','H ','A*',
     1   'B*','C*','D*','E*','F*','G*','H*'/
C
      DATA BLANKN /'  '/
      DATA DEG20, DEG50, DEG65 /0.3490658,0.8726645,1.1344638/
      DATA DEG75, DEG115, DEG145 /1.3089967,  2.0071283, 2.530727/
      DATA DEG165, DEG175  /2.8797928, 3.0543257/
C
      DATA C20,C25,C35 /0.93969262,0.90630779,0.81915204/
      DATA C40,C45,C55 /0.76604444,0.70710678,0.57535764/
C     DATA RAD /1.745329E-2/
C
         ZIMMK(1)=BLANKN
         ZIMMK(INUMRS)=BLANKN
      DO 160 J=2,INUMRS-1
         PHI=ANGULO(1,J)
         PSI=ANGULO(2,J)
         IF (COS(PHI+DEG75).LT.C35) GO TO 30
C   A,C OR F
         IF (COS(PSI+DEG50).LT.C40) GO TO 10
         ZIMMK(J)=NAME(1)
         GO TO 160
  10     IF (SIN(PSI).LT.C40) GO TO 20
         ZIMMK(J)=NAME(3)
         GO TO 160
  20     IF (COS(PSI-DEG175).LT.C45) GO TO 60
         ZIMMK(J)=NAME(6)
         GO TO 160
  30     IF (COS(PHI+DEG145).LT.C35) GO TO 60
C   D,E OR G
         IF (COS(PSI-DEG65).LT.C45) GO TO 40
         ZIMMK(J)=NAME(4)
         GO TO 160
  40     IF (COS(PSI-DEG165).LT.C55) GO TO 50
         ZIMMK(J)=NAME(5)
         GO TO 160
  50     IF (COS(PSI+DEG65).LT.C25) GO TO 60
         ZIMMK(J)=NAME(7)
         GO TO 160
  60     IF (SIN(PHI).GT.0.0) GO TO 80
C   H
         IF (COS(PHI+DEG20).LT.C20.AND.COS(PSI+DEG115)
     1     .LT.C25) GO TO 70
         ZIMMK(J)=NAME(8)
         GO TO 160
C   B
  70     ZIMMK(J)=NAME(2)
         GO TO 160
  80     IF (COS(PHI-DEG75).LT.C35) GO TO 110
C   A*,C* OR F*
         IF (COS(PSI-DEG50).LT.C40) GO TO 90
         ZIMMK(J)=NAME(9)
         GO TO 160
  90     IF (-SIN(PSI).LT.C40) GO TO 100
         ZIMMK(J)=NAME(11)
         GO TO 160
 100     IF (COS(PSI+DEG175).LT.C45) GO TO 140
         ZIMMK(J)=NAME(14)
         GO TO 160
 110     IF (COS(PHI-DEG145).LT.C35) GO TO 140
C   D*,E* OR G*
         IF (COS(PSI+DEG65).LT.C45) GO TO 120
         ZIMMK(J)=NAME(12)
         GO TO 160
 120     IF (COS(PSI+DEG165).LT.C55) GO TO 130
         ZIMMK(J)=NAME(13)
         GO TO 160
 130     IF (COS(PSI-DEG65).LT.C25) GO TO 140
         ZIMMK(J)=NAME(15)
         GO TO 160
C   H*
 140     IF (COS(PHI-DEG20).LT.C20.AND.COS(PSI-DEG115)
     1     .LT.C25) GO TO 150
         ZIMMK(J)=NAME(16)
         GO TO 160
C   B*
 150     ZIMMK(J)=NAME(10)
 160  CONTINUE
      RETURN
      END
