C $Date: 1996/02/29 18:06:19 $
C $Revision: 3.3 $
C
C
C  See help for RANDOMV on the PSFSHARE disk to understand these
C  subroutines.  This is the VS Fortran version of this code.
C
C
      SUBROUTINE VRND(VEC,N)
      INTEGER A(250)
      COMMON /VRANDD/ A, I, I147
      INTEGER LOOP,I,I147,VEC(N)
      DO 23000 LOOP=1,N
      I=I+1
      IF(.NOT.(I.GE.251))GOTO 23002
      I=1
23002 CONTINUE
      I147=I147+1
      IF(.NOT.(I147.GE.251))GOTO 23004
      I147=1
23004 CONTINUE
      A(I)=IEOR(A(I147),A(I))
      VEC(LOOP)=A(I)
23000 CONTINUE
      RETURN
      END
C
C
      DOUBLE PRECISION FUNCTION RNDV(IDUM)
      DOUBLE PRECISION RM1,RM2,R(99)
      INTEGER IA1,IC1,M1, IA2,IC2,M2, IA3,IC3,M3, IDUM
      SAVE
      DATA IA1,IC1,M1/1279,351762,1664557/
      DATA IA2,IC2,M2/2011,221592,1048583/
      DATA IA3,IC3,M3/15551,6150,29101/
      IF(.NOT.(IDUM.LT.0))GOTO 23006
      IX1 = MOD(-IDUM,M1)
      IX1 = MOD(IA1*IX1+IC1,M1)
      IX2 = MOD(IX1,M2)
      IX1 = MOD(IA1*IX1+IC1,M1)
      IX3 = MOD(IX1,M3)
      RM1 = 1./DBLE(M1)
      RM2 = 1./DBLE(M2)
      DO 23008 J = 1,99
      IX1 = MOD(IA1*IX1+IC1,M1)
      IX2 = MOD(IA2*IX2+IC2,M2)
      R(J) = (DBLE(IX1)+DBLE(IX2)*RM2)*RM1
23008 CONTINUE
23006 CONTINUE
      IX1 = MOD(IA1*IX1+IC1,M1)
      IX2 = MOD(IA2*IX2+IC2,M2)
      IX3 = MOD(IA3*IX3+IC3,M3)
      J = 1+(99*IX3)/M3
      RNDV = R(J)
      R(J) = (DBLE(IX1)+DBLE(IX2)*RM2)*RM1
      IDUM = IX1
      RETURN
      END
C
C
      SUBROUTINE VRNDST(SEED)
      INTEGER A(250),LOOP,IDUM,SEED
      DOUBLE PRECISION RNDV
      COMMON /VRANDD/ A, I, I147
      I=0
      I147=103
      IDUM=SEED
      DO 23010 LOOP=1,250
      A(LOOP)=INT(RNDV(IDUM)*2147483647)
23010 CONTINUE
      RETURN
      END
C
C
      SUBROUTINE VRNDIN(IODEV)
      INTEGER IODEV, A(250)
      COMMON/VRANDD/ A, I, I147
      READ(IODEV) A, I, I147
      RETURN
      END
C
C
      SUBROUTINE VRNDOU(IODEV)
C       This corresponds to VRNDOUT in the APFTN64 version
      INTEGER IODEV, A(250)
      COMMON/VRANDD/ A, I, I147
      WRITE(IODEV) A, I, I147
      RETURN
      END
      FUNCTION RNUNF(N)
C ==========================================================

#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif

#ifdef WPRNG
C  When doing a non-MPL (non-MPI) run, the program uses the random
C  number generator included in the source code.  On an MPL or MPI
C  run, the program should use the parallel random number generator,
C  prng. 

      INCLUDE 'PARAMET.MP'
      INCLUDE 'COMMON.MP'

      RNUNF = PRNG_NEXT(TASKID)
#endif
#ifdef NAG
      RNUNF = g05daf(0.0d0,1.0d0)
#endif
#ifdef WVRND
      INTEGER IRAN1(2000)

C     Get only one random number, here!    DR  9/1/92
      CALL VRND(IRAN1,1)
      RNUNF= DBLE( IRAN1(1) ) / FCTOR
#endif
C******************************
C     write(6,*) 'rnunf  in rnunf = ',rnunf
      RETURN
      END
c---------------------------------------------------------------------------
      function ran_number(x1,x2)
C Calculate a random real number from the range (x1,x2).
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      real x1,x2
#ifdef WPRNG
      INCLUDE 'PARAMET.MP'
      INCLUDE 'COMMON.MP'
      ran_number=x1+(x2-x1)*prng_next(taskid)
#endif

#ifdef NAG
      ran_number=g05daf(x1,x2)
#endif

#ifdef WVRND
      integer ix(1)
      call vrnd(ix,1)
      ran_number=x1+(x2-x1)*ix(1)/fctor
#endif
      return
      end
c--------------------------------------------------------------------------
      integer function iran_num(n1,n2)
C Calculate a random integer number from the range (n1,n2).
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      integer n1,n2
#ifdef WPRNG
      INCLUDE 'PARAMET.MP'
      INCLUDE 'COMMON.MP'
      iran_num=n1+(n2-n1+1)*prng_next(taskid)
#endif
#ifdef NAG
      iran_num=n1+(n2-n1+1)*g05daf(0.0d0,1.0d0)
#endif
#ifdef WVRND
      integer ix(1)
      call vrnd(ix,1)
      ix(1)=n1+(n2-n1+1)*(ix(1)/fctor)
      if (ix(1).gt.n2) ix(1)=n2
      iran_num=ix(1)
#endif
      return
      end
c--------------------------------------------------------------------------
