C $Date: 1997/03/12 20:54:13 $
C $Revision: 3.15 $
C
C
C
      SUBROUTINE READANG(END_OF_FILE,IOLDNUM,OLDENER,YourOwn)
C THIS SUBROUTINE PRINTS DIHEDRAL ANGLES
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
C ========================================================================
#ifdef MP
      INCLUDE 'PARAMET.MP'
      INCLUDE 'COMMON.MP'
#endif
#ifdef MPI
      INCLUDE 'mpif.h'
      INTEGER IERR, STATUS(MPI_STATUS_SIZE)
#endif
C ========================================================================
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.BONDSX'
      INCLUDE 'COMMON.GEN004'
      INCLUDE 'COMMON.GEN002X'
      INCLUDE 'COMMON.GEN000'
      INCLUDE 'COMMON.PRAMX'
      INCLUDE 'COMMON.EDMC'
      INCLUDE 'COMMON.MYCONF'
      INCLUDE 'COMMON.FILES'
      INCLUDE 'COMMON.CALC'
      INCLUDE 'COMMON.TORQUEX'
      INCLUDE 'COMMON.SETUP'
      INCLUDE 'COMMON.TOR2'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.TRACK'
      INCLUDE 'COMMON.ODONNELL'
      LOGICAL END_OF_FILE, YourOwn
      EXTERNAL ILEN

C    If YourJob = .TRUE. then you are either a non-MPL processor or you
C  you are the MPL master.  In these cases you proceed with READANG as
C  usual.  If YourJob = .FALSE. then you are an MPL worker and your
C  section of the code comes at the very end.  The MASTER must read a
C  conformation and then send it to you.
C    If YourOwn = .TRUE. then you are reading this conformation for
C  your own work.  If not, then you are reading it for another processor
C  (i.e. the MASTER reading for a worker) and hence you read into a
C  temporaty set of variables so as not to corrupt your own data.

      IF (YourJob) THEN
         IF (YourOwn) THEN
            LX=  NREG
50          CONTINUE
            READ (JSAVE,'(I10,4E15.6)',END=500,ERR=600) 
     &      IOLDNUM,ETOT,EES,ENB,EHYDA
            write (*,*) ' IOLDNUM = ', IOLDNUM
C           write (*,*) ' RAD = ', RAD
C The following READ is introduced, because the new EDMC changes the 
C form of the *.ang files.
C READ (JSAVE,'(20I4)',END=600,ERR=600) (LIST(I),I=1,INUMRS)
            READ (JSAVE,*,END=600,ERR=600) (LIST(I),I=1,INUMRS)
C WRITE (JOUT,'(20I4)') (LIST(I),I=1,INUMRS)
            IF (RESTART) THEN

C  A restart condition, Program should  check if conformation was used,
C and if minimization of this conformation ended successfully
C  (i.e. ioldnum.eq.jconfin(j)). If conformation was considered, then
C  continue reading the next one.
               DO J=1, NDOLD
                  IF (IOLDNUM.EQ.JCONFIN(J) ) THEN
                     DO K=1, INUMRS
                        READ(JSAVE,X,END=600,ERR=600)
                     ENDDO
                     GOTO 50
                  ENDIF
               ENDDO
            ENDIF
            IF (IOLDNUM.NE.(IAMCON+1)) WRITE(JOUT,'(/2(a,i4))') 
     & 'CONFORMATION No. ',IAMCON+1,' WAS ORIGINALLY LABELLED No. ',
     &      IOLDNUM
            XX1=0.0
            NT = IABS(LIST(1))+LX
            NBU = NBOND( IABS( LIST(1) ) )
            IF ( NBU .NE. 0 ) THEN
               READ(JSAVE,750,END=600,ERR=600)  (ANGULO(I,1),I=1,NBU)
               DO 100 I=1,NBU
c             ANGULO(I,1)=PINORM(ANGULO(I,1)*RAD)
                 ANGULO(I,1)=ANGULO(I,1)*RAD
                 ANGULO(I,1)=PINORM(ANGULO(I,1))
100            CONTINUE
C              WRITE(JOUT,750) (DEG*ANGULO(I,1),I=1,NBU )
            ELSE
               READ(JSAVE,750,END=600,ERR=600) XX1,XX1
            END IF
            DO 150 I=2,INUMRS-1
               NT=IABS(LIST(I))
               READ(JSAVE,750,END=600,ERR=600)(ANGULO(J,I),J=1,
     &                                                NCHI(NT)+3)
               DO 151 J=1,NCHI(NT)+3
C                 ANGULO(J,I)=PINORM(ANGULO(J,I)*RAD)
                  ANGULO(J,I)=ANGULO(J,I)*RAD
                  ANGULO(J,I)=PINORM(ANGULO(J,I))
151            CONTINUE
C              WRITE(JOUT,750) (DEG*ANGULO(J,I),J=1,NCHI(NT)+3)
150         CONTINUE
            NT = IABS(LIST(INUMRS))+LX
            NBO = NBOND( IABS( LIST(INUMRS) ) )-1
            IF ( NBO .GT. 0 ) THEN
               READ(JSAVE,750,END=600,ERR=600)(ANGULO(I,INUMRS),
     &                                                    I=1,NBO)
               DO 200 I=1,NBO
C                ANGULO(I,INUMRS)=PINORM(ANGULO(I,INUMRS)*RAD)
                 ANGULO(I,INUMRS)=ANGULO(I,INUMRS)*RAD
                 ANGULO(I,INUMRS)=PINORM(ANGULO(I,INUMRS))
200            CONTINUE
C              WRITE(JOUT,750) (DEG*ANGULO(I,INUMRS),I=1,NBO)
            ELSE
               READ(JSAVE,750,END=600,ERR=600) XX1,XX1
            END IF
            IAMCON=IAMCON+1
            MYCON = IAMCON
            GOTO 777
#ifdef MP
         ELSE
            LX=  NREG
250         CONTINUE
            READ (JSAVE,'(I10,4D15.6)',END=500,ERR=600) 
     &      Tioldnum,DESERT(8),DESERT(9),DESERT(10),DESERT(15)
C            Tioldnum,  ETOT,     EES,      ENB,        EHYDA   

            DESERT(5) = REAL(Tioldnum)
C The following READ is introduced, because the new EDMC changes the 
C form of the *.ang files.
C READ (JSAVE,'(20I4)',END=600,ERR=600) (Tlist(I),I=1,INUMRS)
            READ (JSAVE,*,END=600,ERR=600) (Tlist(I),I=1,INUMRS)
C WRITE (JOUT,'(20I4)') (Tlist(I),I=1,INUMRS)
            IF (RESTART) THEN

C  A restart condition, Program should  check if conformation was used,
C and if minimization of this conformation ended successfully
C  (i.e. ioldnum.eq.jconfin(j)). If conformation was considered, then
C  continue reading the next one.
               DO J=1, NDOLD
                  IF (Tioldnum.EQ.JCONFIN(J) ) THEN
                     DO K=1, INUMRS 
                        READ(JSAVE,X,END=600,ERR=600)
                     ENDDO
                     GOTO 250
                  ENDIF
               ENDDO
            ENDIF
            IF (IOLDNUM.NE.(IAMCON+1)) WRITE(JOUT,'(/2(a,i4))') 
     & 'CONFORMATION No. ',IAMCON+1,' WAS ORIGINALLY LABELLED No. ',
     &  IOLDNUM
            XX1=0.0
            NT = IABS(Tlist(1))+LX
            NBU = NBOND( IABS( Tlist(1) ) )
            IF ( NBU .NE. 0 ) THEN
               READ(JSAVE,750,END=600,ERR=600)(Tangulo(I,1),I=1,NBU)
               DO 300 I=1,NBU
c                 Tangulo(I,1)=PINORM(Tangulo(I,1)*RAD)
                  TANGULO(I,1)=TANGULO(I,1)*RAD
                  TANGULO(I,1)=PINORM(TANGULO(I,1))
300            CONTINUE
            ELSE
               READ(JSAVE,750,END=600,ERR=600) XX1,XX1
            END IF
            DO 350 I=2,INUMRS-1
               NT=IABS(Tlist(I))
               READ(JSAVE,750,END=600,ERR=600)(Tangulo(J,I),
     &                                         J=1,NCHI(NT)+3)
               DO 351 J=1,NCHI(NT)+3
c                 Tangulo(J,I)=PINORM(Tangulo(J,I)*RAD)
                  Tangulo(J,I)=Tangulo(J,I)*RAD
                  Tangulo(J,I)=PINORM(Tangulo(J,I))
351            CONTINUE
350         CONTINUE
            NT = IABS(Tlist(INUMRS))+LX
            NBO = NBOND( IABS( Tlist(INUMRS) ) )-1
            IF ( NBO .GT. 0 ) THEN
               READ(JSAVE,750,END=600,ERR=600)
     &                         (Tangulo(I,INUMRS), I=1,NBO)
               DO 400 I=1,NBO
C                 Tangulo(I,INUMRS)=PINORM(Tangulo(I,INUMRS)*RAD)
                  Tangulo(I,INUMRS)=Tangulo(I,INUMRS)*RAD
                  Tangulo(I,INUMRS)=PINORM(Tangulo(I,INUMRS))
400            CONTINUE
            ELSE
               READ(JSAVE,750,END=600,ERR=600) XX1,XX1
            END IF
            IAMCON=IAMCON+1
            DESERT(6) = REAL(IAMCON)
            GOTO 888
#endif
         ENDIF

500      END_OF_FILE=.TRUE.
         IL=ILEN(SAVEFILE)
         WRITE (JOUT,'(/60(1H*)/10X,3A,I5,A/60(1H*)/)')
     &  'End of file ',SAVEFILE(:IL),' last conformation ',IAMCON,'.'
         RETURN

600      END_OF_FILE=.TRUE.
         IL=ILEN(SAVEFILE)
         WRITE (JOUT,'(/60(1H*)/10X,3A,I5,A/60(1H*)/)')
     & 'Error in file ',SAVEFILE(:IL),' at conformation',IAMCON+1,'.'
         RETURN

750      FORMAT(15F8.3)
#ifdef MPL
      ELSE
         CALL SLAVE_MAIL
         CALL MP_BSEND(TASKID,INTSIZE,MASTER,WANTCONF,MSGID)
         CALL MP_BRECV(END_OF_FILE,BOOLSIZE,MASTER,POINTER,NBYTES)
         IF (.NOT.END_OF_FILE) THEN
            CALL MP_BRECV(LIST,LISTSIZE,MASTER,LISTMSG,NBYTES)
            CALL MP_BRECV(ANGLES,ANGLESIZE,MASTER,ANGLEMSG,NBYTES)
            CALL MP_BRECV(DESERT,DESERTSIZE,MASTER,DESMSG,NBYTES)
            ETOT    =      DESERT(8)
            EES     =      DESERT(9)
            ENB     =      DESERT(10)
            EHYDA   =      DESERT(15)
            IOLDNUM =  INT(DESERT(5) + 0.5)
            MYCON   =  INT(DESERT(6) + 0.5)
C           write (*,*) ' Processor', TASKID,' IOLDNUM = ', IOLDNUM
         ELSE
            write (*,*) 'Got eof bcast', TASKID
            RETURN
         ENDIF
#endif
#ifdef MPI
      ELSE
         CALL SLAVE_MAIL
         CALL MPI_SEND(TASKID,1,MPI_INTEGER,MASTER,WANTCONF,
     &                MPI_COMM_WORLD,IERR)
         CALL MPI_RECV(END_OF_FILE,1,MPI_LOGICAL,MASTER,POINTER,
     &                MPI_COMM_WORLD,STATUS,IERR)
         IF (.NOT.END_OF_FILE) THEN
            CALL MPI_RECV(LIST,maxnum_res,MPI_INTEGER,MASTER,LISTMSG,
     &                MPI_COMM_WORLD,STATUS,IERR)
            CALL MPI_RECV(ANGLES,(maxnum_dihe*maxnum_res),MPI_REAL,
     &                MASTER,ANGLEMSG,MPI_COMM_WORLD,STATUS,IERR)
            CALL MPI_RECV(DESERT,DESERTLENGTH,MPI_DOUBLE_PRECISION,
     &                MASTER,DESMSG,MPI_COMM_WORLD,STATUS,IERR)
            ETOT    =      DESERT(8)
            EES     =      DESERT(9)
            ENB     =      DESERT(10)
            EHYDA   =      DESERT(15)
            IOLDNUM =  INT(DESERT(5) + 0.5)
            MYCON   =  INT(DESERT(6) + 0.5)
C           write (*,*) ' Processor', TASKID,' IOLDNUM = ', IOLDNUM
         ELSE
            write (*,*) 'Proc.(', TASKID,') ',' Got eof bcast' 
            RETURN
         ENDIF
#endif
      ENDIF

777   CONTINUE
      OLDENER = ETOT
      DO L=1,NUMVAR
        X(L) = ANGLES( INDXV(L) ) 
      ENDDO
888   CONTINUE
      RETURN

      END
      subroutine read_watom_select(jin,jout,errors)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      logical errflag,errors,blankline
      character*80 line,line1,ucase
      integer iselat(maxnum_atoms), nselat
      common/selatm/iselat, nselat

      nselat=0
      errors=.false.
      read (jin,'(a)') line
      write (jout,'(2a)') '> ',line(1:78)
      do while (index(ucase(line),'$END').eq.0)
        ipos=1
        blankline=.false.
        errflag=.false.
        do while (.not. blankline)
          call mykey(line,line1,ipos,blankline,errflag)
          if (errflag) goto 10 
          errors=errors .or. errflag
          if (.not. blankline .and. .not. errflag) then
            if (nselat.lt.maxnum_atoms) then
               nselat=nselat+1
               read (line1,*,err=10) iselat(nselat)
               write (jout,'(a,i4,a,i6)') 'atom setected(',nselat,')',
     &                                iselat(nselat)
            else
              errors=.true.
              write (jout,1000) nselat,maxnum_atoms
              return
            endif
          endif
        enddo
        read (jin,'(a)') line
        write (jout,'(2a)') '> ',line(1:78)
      enddo
      return
   10 write (jout,'(a/a)') 
     &   'Read error in $READ_WATOMS_SELECT in data line:',line
      errors=.true.
 1000 format ('Error in $READ_WATOMS_SELECT: The number of atoms ',
     & 'read (', i4,') exceeds maximum (',i4,').')
      return
      end
      subroutine angle_decode(angchar,indang,ires)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      character*16 angchar
      character*3 angind(5) /'PHI','PSI','OME','CHI','TAU'/
      character*3 ucase
      include 'COMMON.CNTRL'
      include 'COMMON.IOUNIT'
      include 'COMMON.SETUP'
      include 'COMMON.KVS'
      include 'COMMON.GRID'
      indang=0
      ichi=0
      do i=1,5
        if (ucase(angchar(1:3)).eq.angind(i)) then
          indang=i
          ip1=index(angchar,'(')+1
          ip2=index(angchar,')')-1
          if (ip2.lt.ip1 .or. ip1.lt.4) goto 20
          if (indang.gt.3) then
            if (ip1.lt.5) then
              write (jout,'(a)')
     & 'Must specify angle number for CHI and TAU!'
              indang=0
              return
            endif
            read (angchar(4:ip1-1),*,err=20) ichi
            if (indang.eq.4) ichi=ichi+3
          endif
          read (angchar(ip1:ip2),*,err=20) ires
          ires=ires+1
          if ((ires.eq.1 .or. ires.eq.nres+2) .and. indang.lt.5) then
            write (jout,'(a)') 
     & 'Must specify TAU for grid purpose for the first (last) residue!'
            indang=0
            return
          else if (ires.lt.1 .or. ires.gt.nres+2) then
            write (jout,'(a/a)') 
     & 'Error - angle to be scanned over corresponds to a residue',
     & 'which is outside the residue range.'
            indang=0
            return
          endif
          if (indang.lt.5) then
            indang=indang+ichi
          else
            indang=ichi
          endif
          if (indang.gt.maxnum_dihe) then
            write (jout,'(a)') 
     & 'Error - local angle index out of range.'
            indang=0
            return
          endif
          return
        endif
      enddo 
   20 write (jout,'(3a)') 
     &'Illegal angle specification for grid purpose. Angle: ',angchar,
     &'.'
      indang=0
      return
      end
      subroutine concat(a,b,c)
      character*(*) a,b,c
      character*1 aux
      EXTERNAL ILEN
      ind=0
      c=' '
      do 1 i=1,ilen(a)
        aux=a(i:i)
        if (aux.eq.' ') goto 1
        ind=ind+1
        c(ind:ind)=aux
    1 continue
      do 2 i=1,ilen(b)
        aux=b(i:i)
        if (aux.eq.' ' ) goto 2
        ind=ind+1
        c(ind:ind)=aux
    2 continue
      return
      end
      logical function find_arg(ipos,line,errflag)
      parameter (maxlen=80)
      character*80 line
      character*1 empty /' '/,equal /'='/
      logical errflag, Go
* This function returns .TRUE., if an argument follows keyword keywd; if so
* IPOS will point to the first non-blank character of the argument. Returns
* .FALSE., if no argument follows the keyword; in this case IPOS points
* to the first non-blank character of the next keyword.
       ERRFLAG = .FALSE.
       Go = .TRUE.
       IPOS = IPOS - 1
       DO WHILE (Go)
         IPOS = IPOS + 1
         IF (LINE(IPOS:IPOS).NE.EMPTY) Go = .FALSE.
         IF (IPOS.GE.MAXLEN) THEN
           Go = .FALSE.
           FIND_ARG = .FALSE.
           RETURN
         ENDIF
       ENDDO
C      do while (line(ipos:ipos) .eq. empty .and. ipos.le.maxlen)
C        ipos=ipos+1
C      enddo
C      errflag=.false.
      if (line(ipos:ipos).eq.equal) then
         find_arg=.true.
         ipos=ipos+1
         Go = .TRUE.
         IPOS = IPOS - 1
         DO WHILE (Go)
           IPOS = IPOS + 1
           IF (LINE(IPOS:IPOS).NE.EMPTY) Go = .FALSE.
           IF (IPOS.GE.MAXLEN) THEN
             Go = .FALSE.
             ERRFLAG = .TRUE.
           ENDIF
         ENDDO
C         do while (line(ipos:ipos) .eq. empty .and. ipos.le.maxlen)
C           ipos=ipos+1
C         enddo
C         if (ipos.gt.maxlen) errflag=.true.
      else
         find_arg=.false.
      endif
      return
      end
      logical function find_group(iunit,jout,key1)
      character*(*) key1
      character*80 karta,ucase
      external ilen
      integer ilen
      logical lcom
      rewind (iunit)
      karta=' '
      ll=ilen(key1)
      do while (index(ucase(karta),key1(1:ll)).eq.0.or.lcom(1,karta)) 
        read (iunit,'(a)',end=10) karta
      enddo
      write (jout,'(2a)') '> ',karta(1:78)
      find_group=.true.
      return
   10 find_group=.false.
      return
      end
      logical function iblnk(charc)
      character*1 charc
      integer n
      n = ichar(charc)
      iblnk = (n.eq.9) .or. (n.eq.10) .or. (charc.eq. ' ')
      return
      end
      integer function ilen(string)
      character*(*) string
      character*1 single_char 
      logical iblnk
 
      ilen = len(string)
1     if ( ilen .gt. 0 ) then
          single_char= string(ilen:ilen)
!          if ( iblnk( string(ilen:ilen) ) ) then
         if ( iblnk(single_char) ) then
            ilen = ilen - 1
            goto 1
         endif
      endif
      return
      end
      integer function in_keywd_set(nkey,ikey,narg,keywd,keywdset)
      character*16 keywd,keywdset(1:nkey,0:nkey)
      character*16 ucase
      do i=1,narg
        if (ucase(keywd).eq.keywdset(i,ikey)) then
* Match found
          in_keywd_set=i
          return
        endif
      enddo
* No match to the allowed set of keywords if this point is reached. 
      in_keywd_set=0
      return
      end
      character*(*) function lcase(string)
      integer i, k, idiff
      character*(*) string
      character*1 c
      character*40 chtmp
c
      i = len(lcase)
      k = len(string)
      if (i .lt. k) then
         k = i
         if (string(k+1:) .ne. ' ') then
            chtmp = string
         endif
      endif
      idiff = ichar('a') - ichar('A')
      lcase = string
      do 99 i = 1, k
         c = string(i:i)
         if (lge(c,'A') .and. lle(c,'Z')) then
            lcase(i:i) = char(ichar(c) + idiff)
         endif
   99 continue
      return
      end
      logical function lcom(ipos,karta)
      character*80 karta
      character koment(2) /'!','#'/
      lcom=.false.
      do i=1,2
        if (karta(ipos:ipos).eq.koment(i)) lcom=.true.
      enddo 
      return
      end
      logical function lower_case(ch)
      character*(*) ch
      lower_case=(ch.ge.'a' .and. ch.le.'z')
      return
      end
      subroutine mykey(line,keywd,ipos,blankline,errflag)
* This subroutine seeks a non-empty substring keywd in the string LINE.
* The substring begins with the first character different from blank and
* "=" encountered right to the pointer IPOS (inclusively) and terminates
* at the character left to the first blank or "=". When the subroutine is
* exited, the pointer IPOS is moved to the position of the terminator in LINE.
* The logical variable BLANKLINE is set at .TRUE., if LINE(IPOS:) contains
* only separators or the maximum length of the data line (80) has been reached.
* The logical variable ERRFLAG is set at .TRUE. if the string
* consists only from a "=".
      parameter (maxlen=80)
      character*1 empty /' '/,equal /'='/,comma /','/
      character*(*) keywd
      character*80 line
      logical blankline,errflag,lcom,Go
      errflag=.false.

      Go = .TRUE.
      IPOS = IPOS - 1
      DO WHILE (Go)
        IPOS = IPOS + 1
        if (ipos.gt.maxlen) then
          Go = .FALSE.
          BLANKLINE = .TRUE.
          RETURN
        else
          if (line(ipos:ipos).ne.empty) go = .false.
        ENDIF
      ENDDO
      if (ipos.gt.maxlen .or. lcom(ipos,line) ) then
C At this point the rest of the input line turned out to contain only blanks
C or to be commented out.
        blankline=.true.
        return
      endif
      blankline=.false.
      istart=ipos
C Checks whether the current char is a separator.
c     do while (line(ipos:ipos).ne.empty .and. line(ipos:ipos).ne.equal
c    & .and. line(ipos:ipos).ne.comma .and. ipos.le.maxlen)
c       ipos=ipos+1

      Go = .true.
      ipos = ipos - 1
      do while (go)
        ipos = ipos + 1
        if (ipos.gt.maxlen) then
          go = .false.
        else
          if (line(ipos:ipos).eq.empty .or. line(ipos:ipos).eq.equal
     &       .or. line(ipos:ipos).eq.comma ) go=.false.
        endif

      enddo
      iend=ipos-1
C Error flag set to .true.,if the length of the keyword was found less than 1.

      if (iend.lt.istart) then
        errflag=.true.
        return
      endif

      keywd=line(istart:iend)
      return
      end
      subroutine numstr(inum,numm)
      character*10 huj /'0123456789'/
      character*(*) numm
      inumm=inum
      inum1=inumm/10
      inum2=inumm-10*inum1
      inumm=inum1
      numm(3:3)=huj(inum2+1:inum2+1)
      inum1=inumm/10
      inum2=inumm-10*inum1
      inumm=inum1
      numm(2:2)=huj(inum2+1:inum2+1)
      inum1=inumm/10
      inum2=inumm-10*inum1 
      inumm=inum1
      numm(1:1)=huj(inum2+1:inum2+1)
      return
      end       
      subroutine read_bridge(jin,jout,errors)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      logical errflag,errors,blankline
      character*80 line,line1,ucase
      common/loops/kcys,nhalf,npair(2*maxloop)
      errors=.false.
      nhalf=0
      read (jin,'(a)') line
      write (jout,'(2a)') '> ',line(1:78)
      do while (index(ucase(line),'$END').eq.0)
        ipos=1
        blankline=.false.
        errflag=.false.
        do while (.not. blankline)
          call mykey(line,line1,ipos,blankline,errflag)
          if (errflag) goto 10 
          errors=errors .or. errflag
          if (.not. blankline .and. .not. errflag) then
            if (nhalf.lt.2*maxloop) then
              nhalf=nhalf+1
              read (line1,*,err=10) npair(nhalf)
            else
              errors=.true.
              write (jout,1000) nhalf/2,maxloop
              return
            endif
          endif
        enddo
        read (jin,'(a)') line
        write (jout,'(2a)') '> ',line(1:78)
      enddo
      if (2*(nhalf/2).ne.nhalf) then
        errors=.true.
        write (jout,'(2a,i4,a)') 'Error in $BRIDGE: odd number of',
     & ' bridging residues has been specified (',nhalf,').'
      endif
cd    write (jout,'(16i5)') (npair(i),i=1,nhalf)
      return
   10 write (jout,'(a/a)') 'Read error in $BRIDGE in data line:',line
      errors=.true.
 1000 format ('Error in $BRIDGE: The number of bridges read (',i4,
     & ') exceeds maximum (',i4,').')
      return
      end
      subroutine read_atoms_bound(jin,jout,errors)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      logical errflag,errors,blankline
      character*80 line,line1,ucase
      character*3 chtom(2*maxnum_dist)

      character*3 charbnd(2,maxnum_dist)
      common/bound_atoms/charbnd,npares,rwei(maxnum_dist)
      equivalence (chtom(1),charbnd(1,1) )
      errors=.false.
      npares=0

      read (jin,'(a)') line

      write (jout,'(2a)') '> ',line(1:78)

      do while (index(ucase(line),'$END').eq.0)
        ipos=1
        blankline=.false.
        errflag=.false.
        naread=0
        do while (.not. blankline)
          call mykey(line,line1,ipos,blankline,errflag)
          if (errflag) goto 10 
          errors=errors .or. errflag
          if (.not. blankline .and. .not. errflag) then
            if (npares.lt.2*maxnum_dist) then
              if (naread.lt.2) then
                 npares=npares+1
                 read (line1,'(a3)',err=10) chtom(npares)
                 write (jout,'(a,i4)') chtom(npares),npares
                 naread= naread + 1
              else
                 jj=int(npares/2)
                 read (line1,*,err=10) rwei(jj)
                 write (jout,'(a,f8.3)') 'weight', rwei(jj)
                 naread= 0
              endif
            else
              errors=.true.
              write (jout,1000) npares/2,maxnum_dist
              return
            endif
          endif
        enddo
        read (jin,'(a)') line
        write (jout,'(2a)') '> ',line(1:78)
      enddo
      if (2*(npares/2).ne.npares) then
        errors=.true.
        write (jout,'(2a,i4,a)') 'Error in $READ_ATOMS_BOUND: odd', 
     & ' number of atoms has been specified (',npares,').'
      endif
      write (jout,'(10(a3,1x))') (chtom(i),i=1,npares)
      npares=npares/2
      return
   10 write (jout,'(a/a)') 
     &   'Read error in $READ_ATOMS_BOUND in data line:',line
      errors=.true.
 1000 format ('Error in $READ_ATOMS_BOUND: The number of pairs read (',
     & i4,') exceeds maximum (',i4,').')
      return
      end
      subroutine read_bounds(jin,jout,errflag)
* Number of keywords in this data group
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      parameter (nkwd=10)
      parameter (errind=-1.0D10)
      character*16 keywdset(1:nkwd,0:nkwd) 
     & /'TYPE_INPUT','DELT_R','FIXVAL','PERCENT','WEIGHT','IGNORE_H',
     &  'MAXDIST','MINDIST','FIRST_RESIDUE','RESIDUE_GAP', 
     & 'PDB_NO_ENDG','PDB_WITH_ENDG',8*' ', 
     & 'FIXED','PERCENTAGE',8*' ', 
     & 'NUM',9*' ',
     & 'NUM',9*' ',
     & 'NUM',9*' ',
     & 10*' ',
     & 'NUM',9*' ',
     & 'NUM',9*' ',
     & 'NUM',9*' ',
     & 'NUM',9*' '/
      integer narg(0:nkwd) /10,2,2,1,1,1,0,1,1,1,1/
      dimension flag(0:nkwd)
      character*16 cflag(0:nkwd)
      logical errflag
      include 'COMMON.CNTRL'
      include 'COMMON.BOUNDAT'
      include 'COMMON.TYYY'

      call read_data_group(jin,jout,nkwd,keywdset,narg,flag,cflag)
      errflag=.false.
      do i=0,nkwd
        if (flag(i).eq.errind) errflag=.true.
      enddo
C Default of input file: PDB no end groups.
      itype_inp=1
      if (flag(1).ne.0.0) itype_inp=aint(flag(1))

C default for the type of 
C Upper and Lower bounds can be obtained by:
C a- adding and substracting a fixed value (FIXVAL) to the actual distances.
C b- adding and substracting a percentage (PERCENT) of the actual distance (R) 
C to the computed value of R,  i.e upper bound= R+ (PERCENT/100)*R

C the type of calculation is defined by the DELT_R keyword:
C DELT_R=FIXED  defines scheme (a)
C DELT_R=PERCENTAGE  defines scheme (b)
C default is scheme (b) with PERCENT=10 (10%).
      ideltr=2
      if (flag(2).ne.0.0) then
          ideltr=aint(flag(2))
      endif
      if (ideltr.eq.1) then
C  DELT_R is FIXED
C default value_dr=0.5; in Angstroms
        value_dr=.5
        if  (flag(3).ne.0.0) value_dr=flag(3)
      else
C DELT_R is PERCENTAGE;  
        value_dr=.1
        if  (flag(4).ne.0.0) value_dr=flag(4)*0.01
      endif
      weitb=10.0
      if  (flag(5).ne.0.0) weitb=flag(5)
      ignore_h=(flag(6).gt.0.0)
      rmaxdist=100000.0
      if (flag(7).ne.0.0) rmaxdist=flag(7)
      rmindist=0.0
      if (flag(8).ne.0.0) rmindist=flag(8)
      ifrstrs=1
      if (flag(9).ne.0.0) ifrstrs=aint(flag(9))
      irsgap=0
      if (flag(10).ne.0.0) irsgap=aint(flag(10))
      return
      end
      subroutine read_control(jin,jout,errflag)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
* Number of keywords in this data group
      parameter (nkwd=20)
      parameter (errind=-1.0D10)
      character*16 keywdset(1:nkwd,0:nkwd) /'RUNTYP','VERBOSE',
     & 'CHISCAN','NSTEP','PRINT_CART','OUTFORMAT', 'FILE','NRES',
     & 'RES_CODE','VAR_ANGLES','VAR_RES','TIME','SURFACE_OUT',
     & 'MULT_CONF','MAXIT','SEED','EMINIMA','REFERENCE','NSCAN',
     & 'NO_HYDRG_IN_PDB',
     & 'ENERGY','CHECKGRAD','MINIMIZE','EDMC','RMS_FIT','BOUNDS',
     &   'VTF','ECEPPIZE',12*' ',
     & 20*' ', 
     & 20*' ',
     & 'NUM',19*' ',
     & 20*' ',
     & 'ECEPP','PDB','AMBER','CNDO','CA_PDB','SEL_PDB',14*' ',
     & 'CHAR',19*' ',
     & 'NUM',19*' ',
     & 'ECEPP','THREE_LETTER','ONE_LETTER',17*' ',
     & 'BACK','SIDE','ALL','SPEC','NONE','PHPS','BKSD',13*' ',
     & 'NUM',19*' ', 
     & 'NUM',19*' ',
     & 20*' ',
     & 'READ','RANDOM',18*' ',
     & 'NUM',19*' ',
     & 'NUM',19*' ',
     & 'NUM',19*' ',
     & 20*' ',
     & 'NUM',19*' ',
     & 20*' '/
      integer narg(0:nkwd) /20,8,0,0,1,0,6,1,1,3,7,1,1,0,2,1,1,1,0,1,0/

      dimension flag(0:nkwd)
      character*16 cflag(0:nkwd)
      logical errflag
      external ilen
      include 'COMMON.CNTRL'
      include 'COMMON.FILES'
      include 'COMMON.SETUP'
      include 'COMMON.KVS'
      include 'COMMON.TIME1'
      include 'COMMON.SOLVAT'
      include 'COMMON.EDMC'
      include 'COMMON.RMSPDB'
#ifdef MP
      integer lentsk,ilen
C     include '/usr/include/fexcp.h'
      include 'PARAMET.MP'
      include 'COMMON.MP'
      character*3 tasknu

      call numstr(taskid,tasknu)
      lentsk=ilen(tasknu)
#endif


      call read_data_group(jin,jout,nkwd,keywdset,narg,flag,cflag)
      errflag=.false.
      do i=0,nkwd
        if (flag(i).eq.errind) errflag=.true.
      enddo
      if (flag(1).ne.0.0) iruntyp=aint(flag(1))
      onscreen=(flag(2).gt.0.0)
      chiscan=(flag(3).gt.0.0) 
      nstep=aint(flag(4))
      nscan=aint(flag(19))
      if (nscan.eq.0) nscan=3
      if (chiscan.and.nstep.eq.0) nstep=6
      print=(flag(5).gt.0.0) 
      if (flag(6).ne.0.0) iform=aint(flag(6))
#ifdef MP
      if (cflag(7).ne.' ') coorpref='tsk'//tasknu(:lentsk)//cflag(7)
#else
      if (cflag(7).ne.' ') coorpref=cflag(7)
#endif
      nres=aint(flag(8))
      if (flag(9).ne.0.0) icode=aint(flag(9))
      if (flag(10).ne.0.0) ivarflag=aint(flag(10))
      nvarres=aint(flag(11))
      if (flag(12).gt.0.0) batime=flag(12)
      isfout=aint(flag(13))
      if (flag(14).gt.0.0)  then
         readconfs= .false.
         istartrnd=0
C   read multiple conformations 
         if (aint(flag(14)).eq.1) readconfs= .true.
C   set random generation off.  
         if (aint(flag(14)).eq.2) then
            istartrnd=1
            liczm=1
            if (flag(15).gt.0.0) liczm=aint(flag(15))
            if (flag(16).ne.0.0) iseed=aint(flag(16))
            iseed=-iabs(iseed)
         endif
      endif
C
C ethresh = 'threshold' energy. Conformations with higher energy than this
C value will be omitted.
      if (abs(flag(17)).gt.0.0) ethresh=flag(17)
C refcod: true if ZIMMERMAN code of the given conformation is to
C be used as reference.
      refcod=(flag(18).gt.0.0) 
      no_hydrg=(flag(20).gt.0.0) 
      return
      end
      subroutine read_data_group(jin,jout,nkwd,keywdset,narg,flag,cflag)
* Column 0 of the array keywdset contains the "main" keywords.
* Columns 1 thru nkwd contain the arguments (if any) that correspond
* to the specific keywords of column 0. The numbers of arguments are
* stored in the array narg; the zeroth element of the latter array 
* is the number of "main" keywords.
      parameter (errind=-1.0D10)
      character*16 keywd,keyarg,keywdset(1:nkwd,0:nkwd) 
      character*80 line,ucase
      dimension narg(0:nkwd),flag(0:nkwd)
      character*16 cflag(0:nkwd)
      logical errflag,blankline,found_arg,find_arg
c
      data izero /0/, ione /1/, itwo /2/, ithree /3/,ifour /4/,
     &  ifive /5/, isix /6/, isev /7/

      do i=0,nkwd
        cflag(i)=' '
        flag(i)=0.0
      enddo   
      read (jin,'(a)',end=10) line
      write (jout,'(2a)') '> ',line(1:78)
* Process the following lines of the data group until the end flag is
* met.
      do while (index(ucase(line),'$END').eq.0)
        ipos=1
* Find the first keyword in the current line.
        keywd=' '
        keyarg=' '
        call mykey(line,keywd,ipos,blankline,errflag) 
        do while (.not.blankline)
          if (errflag) then
            flag(0)=errind
            call errout(jout,nkwd,izero,keywd,line,narg,keywdset,ione)
          endif
          if (.not.blankline) then
* Check whether the found keyword is in the keyword set.
            ikey=in_keywd_set(nkwd,0,narg(0),keywd,keywdset)
* Check whether an argument follows the keyword.
            found_arg=find_arg(ipos,line,errflag)
* If an argument was found, read it into the KEYARG string.
            if (.not.errflag .and. found_arg)
     &        call mykey(line,keyarg,ipos,blankline,errflag)
            if (ikey.gt.0) then
* The found keyword does belong to the set of allowed keywords.
              if (narg(ikey).gt.0) then
* Case 1. The found keyword has arguments.
                if (errflag .or. blankline) then
* Errors have occurred when reading the argument.
                  flag(ikey)=errind
                  call errout(jout,nkwd,ikey,keyarg,line,narg,keywdset,
     &                                   itwo)
                else if (.not.found_arg) then
* An argument was expected to follow the keyword, but none was found.
                  flag(ikey)=errind
                  call errout(jout,nkwd,ikey,keywd,line,narg,keywdset,
     &                                   ifour)
                else 
* An argument was expected and received.
                  if (index(keywdset(1,ikey),'NUM').gt.0) then
* A numeric arguments is expected.
                    read (keyarg,*,err=30) flag(ikey)
                    goto 40
   30               flag(ikey)=errind
                    call errout(jout,nkwd,ikey,keyarg,line,narg,
     &                                        keywdset,ithree)
   40               continue
                  else if (index(keywdset(1,ikey),'CHAR').gt.0) then
* Any string is expected as an argument.
                    flag(ikey)=-1
                    cflag(ikey)=keyarg
                  else 
* The argument must belong to the pre-specified set of allowed sub-keywords.
                    iarg=in_keywd_set(nkwd,ikey,narg(ikey),keyarg,
     &                  keywdset)
                    if (iarg.gt.0) then
* Match found. Set FLAG(IKEY) to the position of the argument in 
* the sub-keyword array.
                      flag(ikey)=float(iarg)
                    else
* No match to sub-keywords. 
                      call errout(jout,nkwd,ikey,keyarg,line,narg,
     &                            keywdset,isix)
                      flag(ikey)=errind
                    endif
                  endif 
                endif
              else if (found_arg) then
* Argument received, but not expected to this keyword.
                call errout(jout,nkwd,ikey,keyarg,line,narg,keywdset,
     &                                 ifive)
                flag(ikey)=errind
              else
* Argument not received and not expected. Set FLAG(IKEY) at 1 to indicate 
* that the keyword has appeared.
                flag(ikey)=1.0
              endif
            else
* The keyword doesn't match the allowed-keyword set.
c             ipos=ipos+1
              flag(0)=errind
              call errout(jout,nkwd,0,keywd,line,narg,keywdset,
     &                           iseven)
            endif
          endif
* Find the next keyword in the current line.
          keywd=' '
          keyarg=' '
          call mykey(line,keywd,ipos,blankline,errflag) 
        enddo  
* Read the next line belonging the the curent data group.
        read (jin,'(a)',end=10) line
        write (jout,'(2a)') '> ',line(1:78)
      enddo
      return
   10 write (jout,100) jin
      flag(0)=errind
      return
  100 format (//'******* Error - end of data on unit',i3,' before',
     & ' a valid terminator was found.')
      end
      subroutine read_distcons(jin,jout,errflag)
*  Written by D. ripoll                             Mar-94
*  last modified                                    Feb-95
* Number of keywords in this data group
      parameter (nkwd=14)
      parameter (errind=-1.0D10)
      character*16 keywdset(1:nkwd,0:nkwd) /
     & 'N1PAIR', 'N2PAIR','FULL_RES_NUMBERS', 'DIST_WEIGHT', 
     & 'ADAPT_WEI', 'PERCENT_WEI','MAX_WEI','MIN_WEI','DELTA_PERC_WEI',  
     & 'SOFT_SLOPE','SOFT_SWITCH','NUMBER_OF_GROUPS', 
     & 'CONS_FROM_CONGEN','DIHE_WEIGHT',
     & 'NUM',13*' ',
     & 'NUM',13*' ',
     & 14*' ',
     & 'NUM',13*' ',
     & 14*' ',
     & 'NUM',13*' ',
     & 'NUM',13*' ',
     & 'NUM',13*' ',
     & 'NUM',13*' ',
     & 'NUM',13*' ',
     & 'NUM',13*' ',
     & 'NUM',13*' ',
     & 14*' ',
     & 'NUM',13*' '/
      integer narg(0:nkwd) 
     &    /14,1,1,0,1,0,1,1,1,1,1,1,1,0,1/
      dimension flag(0:nkwd)
      character*16 cflag(0:nkwd)
      logical errflag
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
C     include 'COMMON.VTFEX'
      include 'COMMON.EDMC'
      include 'COMMON.XBOUNDX'

      call read_data_group(jin,jout,nkwd,keywdset,narg,flag,cflag)
      errflag=.false.
      do i=0,nkwd
        if (flag(i).eq.errind) errflag=.true.
      enddo

C define number of bounds pairs to be read in.
C N1PAIR and N2PAIR are two different ways to describe the bounds.
C    'N1PAIR', 'N2PAIR'
      npair1=0
      if (flag(1).gt.0.0) npair1=aint(flag(1))
      npair2=0
      if (flag(2).gt.0.0) npair2=aint(flag(2))
      mpairs=npair1+npair2
C FULL_RES_NUMBERS. 
C Bounds can be associated to residues using the ecepp sequence  number
C (where residue No. 1 is an end-group) or the typical PDB numbering that
C assigns No. 1 to the first full residue.
C ECEPP is the default (i.e., numb_pdb=.false.).
      numb_pdb=.false.
      numb_pdb=(flag(3).gt.0.0)
C
C    & 'DIST_WEIGHT', 'ADAPT_WEI', 
C
C    default for weight of distance constraints energy.
C       wei_ene=10.0
        if (flag(4).gt.0.0) wei_ene=flag(4)
C       
C     modify the weight WEI_ENE on the fly!  This part is not implemented, yet.
        adptwei=(flag(5).gt.0.0)
C
C    & 'STEP_WEI','MAX_WEI','MIN_WEI'
      if (adptwei) then
          perc_wei=100.
          if (wei_ene.gt.0.0)  then
             weitmax = 2*wei_ene
          else
             weitmax = 500.0
          endif
          weitmin = wei_ene
          deltaperc=0.0
          if (flag(6).gt.0.0) perc_wei=flag(6)
          if (flag(7).gt.0.0) weitmax=flag(7)
          if (flag(8).gt.0.0) weitmin=flag(8)
          if (abs(flag(9)).gt.0.0) deltaperc=flag(9)
      endif
C     SOFT_SLOPE','SOFT_PLATEAU','GROUPNUM'
      csw=0.0
      if (flag(10).gt.0.0) csw=flag(10)
      dsw=0.0
      if (flag(11).gt.0.0) dsw=flag(11)
      igroupNum=0
      if (flag(12).gt.0.0) then
         igroupNum=aint(flag(12))
      	 if (igroupNum.lt.2) then
	    write(jout,'(2a)') 'ERROR: GROUP_OVL_RESON=1; At Least two',
     &     '     groups must be specified'
	    errflag=.true.
    	 endif
      endif
C IF Input file with distance constraints provided in CONGEN format:
      if (flag(13).gt.0.0) then
         congenf= .true.
         eceppcf= .false.
      endif
      if (eceppcf.and.(mpairs.le.0.0) )then
          write(jout,'(a)') 
     &       ' Warning: the number of bounds to be read is zero '
C         errflag=.true.
      endif

        if (flag(14).gt.0.0) weitorc=flag(14)
C       
      return
      end
      subroutine read_edmc(jin,jout,errflag)
* Number of keywords in this data group
      parameter (nkwd=51)
      parameter (errind=-1.0D10)
      character*16 keywdset(1:nkwd,0:nkwd) /'MCM','MOTION','CONSTR_MOV',
     &'BACKUP','RESTART','MAXIT','RAND_START','RAND_TO_ELEC','MAX_REPM',
     & 'MAX_RAND','MAX_EL','EFINAL','T_LOW','T_UP','TEMP','NTEMP',
     & 'THERMAL_SHOCK','ADAPT_TEMP','NWIND','SEED',
     & 'MAX_THERMAL','PRINT_SAMPLED','NHEAT','NCOOL','NPRINT_ELEC',
     & 'OMPROB','HISP_CHANGE','CONST_SEQ','TYPE_BKTK','MAX_VAR_BKTK',
     & 'REGION_SAMP','MAX_BCKB_REP','PROMET','NPRINT_CONSTR',
     & 'OMEGA_180','REFERENCE','RMS_CUT','SELECT_CLUST','ECRITICAL',
     & 'RAND_REG_STRUC','RAND_PHIPSI','RAND_DATABASE',
     & 'CFMER_IN_DBASE','NFILE_DBASE','FILNAM_DBASE','PROB_OMG_PRE_PRO',
     & 'AVOID_FIRST_G', 'G_CAV', 'G_SOLV', 'G_HBIND', 'FREE_ENERGY',
     & 51*' ',
     & 'PIELA','CRANKSHAFT','LAMBDA',48*' ',
     & 51*' ',
     & 'NUM',50*' ',
     & 51*' ',
     & 'NUM',50*' ',
     & 51*' ',
     & 'NUM',50*' ',
     & 'NUM',50*' ',
     & 'NUM',50*' ',
     & 'NUM',50*' ','NUM',50*' ','NUM',50*' ','NUM',50*' ','NUM',50*' ',
     & 'NUM',50*' ',51*' ',51*' ','NUM',50*' ','NUM',50*' ',
     & 'NUM',50*' ',51*' ','NUM',50*' ','NUM',50*' ','NUM',50*' ','NUM',
     & 50*' ','NUM',50*' ',51*' ',
     & 'BACK','ALL',49*' ',
     & 'NUM',50*' ',
     &  'UNIFORM','NONUNIFORM',49*' ',
     & 'NUM',50*' ',51*' ','NUM',50*' ',51*' ',51*' ','NUM',50*' ',
     & 'NUM',50*' ', 'NUM',50*' ', 'NUM',50*' ', 'NUM',50*' ',
     & 'NUM',50*' ','NUM',50*' ','NUM',50*' ','CHAR',50*' ',
     & 'NUM',50*' ',
     & 51*' ','NUM',50*' ','NUM',50*' ','NUM',50*' ',51*' '/
      integer narg(0:nkwd)    /51,0,3,0,1,0,1,0,9*1,0,0,1,1,1,
     & 0,5*1,0,2,1,2,1,0,1,0,0,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0/
      dimension flag(0:nkwd)
      character*16 cflag(0:nkwd)
      logical errflag
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      include 'COMMON.CNTRL'
      include 'COMMON.MOVE'
      include 'COMMON.EDMC'
      include 'COMMON.BIAS'
      include 'COMMON.XBOUNDX'
      include 'COMMON.VTFEX'
      include 'COMMON.CLUSTER'
      include 'COMMON.TRIPROB'
      include 'COMMON.FILES'
      include 'COMMON.STRIBE'

      call read_data_group(jin,jout,nkwd,keywdset,narg,flag,cflag)
      errflag=.false.
      do i=0,nkwd
        if (flag(i).eq.errind) errflag=.true.
      enddo
      if (flag(3).gt.0.0) withcnst=.true.
      if (flag(2).ne.0.0) movang=aint(flag(2))
      if (flag(4).ne.0.0) backup=flag(4)
      restart=(flag(5).gt.0.0)
      if (flag(6).gt.0.0) liczm=aint(flag(6))
      ichcnf=aint(flag(7))
      if (flag(1).gt.0.0) then
        arbt=1.0
      else
        if (flag(8).gt.0.0) arbt=flag(8)
      endif
      if (flag(9).gt.0.0) nrepmm=aint(flag(9))
      if (flag(10).gt.0.0) nranm=aint(flag(10))
      if (flag(11).gt.0.0) maxel=aint(flag(11))
      if (flag(12).ne.0.0) efinal=flag(12)
      if (flag(18).gt.0.0) then
        tlow=flag(13)
        if (tlow.eq.0.0) then
           if (flag(15).eq.0.0) then
              tlow=298.0
           else
              tlow=flag(15)
           endif
        endif
        tup=flag(14)
        if (tup.eq.0.0) tup=2980.0
        if (flag(16).ne.0.0) then
          nstepc=aint(flag(16))
          nsteph=nstepc
        endif
        if (flag(23).gt.0.0) nsteph=aint(flag(23))
        if (flag(24).gt.0.0) nstepc=aint(flag(24))
        if (flag(21).gt.0.0) ntermm=aint(flag(21))
      else if (flag(17).gt.0.0) then
        tlow=flag(13)
        if (tlow.eq.0.0) then
           if (flag(15).eq.0.0) then
              tlow=298.0
           else
              tlow=flag(15)
           endif
        endif
        tup=flag(14)
        if (tup.eq.0.0) tup=2980.0
        nstepc=1 
        nsteph=1
        if (flag(21).gt.0.0) ntermm=aint(flag(21))
      else
        if (flag(15).gt.0.0) tlow=flag(15)
        tup=tlow
        ntemp=0
        ntermm=0
        if (flag(21).gt.0.0) ntermm=aint(flag(21))
      endif  
      if (flag(17).gt.0.0) ntemp=1
      if (flag(19).gt.0.0) nwind=aint(flag(19))
      if (flag(20).ne.0.0) iseed=aint(flag(20))
      iseed=-iabs(iseed)
      print_sampled=(flag(22).gt.0)
      if (flag(25).ne.0.0) nprint_elec=aint(flag(25))
      if (flag(26).gt.0.0) omprob=flag(26)
      if (flag(27).gt.0.0) excprh=1.0-flag(27)
      if (excprh.lt.0.0) excprh=0.0
      if (flag(28).gt.0.0) excprh=1.1
      if (flag(29).ne.0.0) itypbk=aint(flag(29))
      if (flag(30).ge.2.0) mxbktrc=aint(flag(30))-2
      regsamp=(flag(31).gt.0.0)
      if(regsamp) itprgsmp=aint(flag(31))
C MAXKZIMM is the maximum number of times that the same backbone
C conformation  can be accepted. When this limit is attained, the
C conformations with same Zimmerman code are rejected, unless is
C an improvement on the current global minimum.
      if (flag(32).gt.0.0) maxkzimm=aint(flag(32))
      promet = (flag(33).gt.0.0)
      if (flag(34).ne.0.0) nprnt_cnst=aint(flag(34))
      omeg180 = (flag(35).gt.0.0)
C refcod: true if ZIMMERMAN code of the given conformation is to
C be used as reference.
      refcod=(flag(36).gt.0.0)
C Cut-off value in clustering
      if (flag(37).gt.0.0) rcut=flag(37)
C Criterion for the selection of clusters in sampling
      if (flag(38).gt.0.0 .and. flag(38).le.1.0) ChooseCluster=flag(38)
      if (flag(38).gt.1.0 .or. flag(38).lt.0.0) write (jout,'(a)')
     &'Warning, input value SelectClust <0 or >1; reset to the default.'
      if  (flag(39).gt.0.0) ecrit = flag(39)
C
C Definitions for RAND_REG_STRUC, RAND_PHIPSI, RAND_DATABASE must be set
C jointly, i.e. the three must be specified or the three are omitted.
      if  (flag(40).gt.0.0) then
         regstruc = flag(40)
         if (regstruc.gt.1.0) then
            write(jout, *)'Error: RAND_REG_STRUC GT 1.0'
            errflag=.true.
         else
            if (regstruc .lt. 0.0) then
               write(jout, *) 'RAND_REG_STRUC should be > 0.0'
               errflag=.true.
            endif
            if ( flag(41).le.0.0 .or. flag(42).le.0.0) then
               write(jout, *)'RAND_PHIPSI and RAND_DATABASE ',
     &                                ' must be also specified.'
               errflag=.true.
            endif
         endif
      endif
      if (flag(41).gt.0.0) then
         phpsmp = flag(41)
         if (phpsmp.gt.1.0) then
            write(jout, *)'Error: RAND_PHIPSI GT 1.0'
            errflag=.true.
         else
               if (phpsmp .lt. 0.0) then
                  write(jout, *) 'RAND_PHIPSI should be > 0.0'
                  errflag=.true.
               endif
            if ( flag(40).le.0.0 .or. flag(42).le.0.0) then
               write(jout, *)'RAND_REG_STRUC  and RAND_DATABASE',
     &                                'must be also specified.'
               errflag=.true.
            endif
         endif
      endif
      if (flag(42).gt.0.0) then
         elowc = flag(42)
         numrsp=flag(43)
         list_tot=flag(44)
         if (cflag(45).ne.' ') tripfile= cflag(45)
         if (elowc.gt.1.0) then
            write(jout, *)'Error: RAND_DATABASE GT 1.0'
            errflag=.true.
         else
            if (elowc .lt. 0.0) then
               write(jout, *) 'RAND_DATABASE should be > 0.0'
               errflag=.true.
            endif
            if ( flag(40).le.0.0 .or. flag(41).le.0.0) then
               write(jout, *)'RAND_REG_STRUC and RAND_PHIPSI',
     &                                'must be also specified.'
               errflag=.true.
            else
               if (regstruc .lt. 0.001) regstruc = 0.0
               if (phpsmp .lt. 0.001) phpsmp = 0.0
               if (elowc .lt. 0.001) elowc = 0.0
               phipsimap= regstruc+phpsmp
               elowconf = regstruc+phpsmp + elowc
               if (elowconf.gt. 1.0) then
                  write(jout, *)
     &           '(RAND_PHIPSI + RAND_REG_STRUC + RAND_DATABASE) > 1.0'
                  errflag=.true.
               endif
            endif
         endif
         if (elowc .gt.0.0 .and. (numrsp.lt.0 .or. list_tot.eq.0)) then
             write(jout, *)'Error:  CFMER_IN_DBASE  & NFILE_DBASE ',
     &                       'must be specified.'
             errflag=.true.
         endif
      else
C set   list_tot to zero
         list_tot=0
         numrsp=0
      endif
C read probability of changing omega's preceeding PRO residues between
C CIS and TRANS.
      if(flag(46).gt.0)   pomgppro=flag(46)

C
C Since computation of the electrostatic solvation takes a considerable amount of time,
C during parallel computations, all processors except for the master are idle 
C during the energy  calculation of the first (initial) conformation.
C This represent a real waste of the  computational resource an a significant  problem. 
C Consequently, the present implementation allows you to avoid the first 
C electrostatic solvation calculation. It assumes that you can calculate the 
C starting energy mimimized conformation, and compute the electrostatic solvation,
C in advance using a single processor. You have to provide the correct numbers for the
C solvation energies through the variables: G_CAV (EHYDA), G_SOLV(DELPHI) & G_HBIND(EPROT).

      jump_prot=(flag(47).gt.0)
      if (jump_prot) then 
         free_ene_cav= flag(48)
         free_ene_solv= flag(49)
         free_ene_hbind=flag(50)
      endif
      lfree_ene=(flag(51).gt.0.0) 

      return
      end
      subroutine read_force_field(jin,jout,errflag)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
C    Number of keywords in this data group
      parameter (nkwd=23)
      parameter (errind=-1.0D10)
      character*16 keywdset(1:nkwd,0:nkwd) /'FORCE_FIELD','SOLVATION',
     & 'RAD_FILE','S_PAR_FILE','OM_TRANS','FORC',
     & 'NO_TORSIONALS','THERMO','TSTART','TEND','NSTEP','NO_SOLV_MIN',
     & 'PH','RES_DBASE','CUTOFF','CONSTR_MOV','CONTACT_ENE',
     & 'OVER_CUTOFF','NON_OVERLAP_ENER','VARDIEL','SURFACE_OUT',
     & 'USE_MSEED','SURFACE_PNTS',
     & 'ECEPP','SIMPLE_POTENTIAL','AMBER','DISCOVER','CHARMM','MM3',
     &   'NONE',16*' ',
     & 'ALL','DELPHI_ELECTR','IBEM_ELECTR','SURFACE' ,'VOLUME',18*' ', 
     & 'CHAR',22*' ',
     & 'CHAR',22*' ',
     & 23*' ',
     & 'NUM',22*' ',
     & 23*' ',
     & 23*' ',
     & 'NUM',22*' ',
     & 'NUM',22*' ',
     & 'NUM',22*' ',
     & 23*' ',
     & 'NUM',22*' ',
     & 'CHAR',22*' ',
     & 'NONE','BLOCK','DISTANCE_CA',20*' ',
     & 23*' ',
     & 'NUM',22*' ',
     & 'NUM',22*' ',
     & 23*' ',
     & 23*' ',
     & 23*' ',
     & 23*' ',
     & 23*' ' /
      integer narg(0:nkwd) 
     &      /23,6,5,1,1,0,1,0,0,1,1,1,0,1,1,3,0,1,1,0,0,0,0,0/
      dimension flag(0:nkwd)
      character*16 cflag(0:nkwd)
      logical errflag
      include 'COMMON.CNTRL'
      include 'COMMON.FILES'
      include 'COMMON.EXTPH'
      include 'COMMON.SOLVAT'
      include 'COMMON.OMTOR'
      include 'COMMON.THERMO'
      include 'COMMON.MOVE'
      include 'COMMON.XBOUNDX'

      call read_data_group(jin,jout,nkwd,keywdset,narg,flag,cflag)
      errflag=.false.
      do i=0,nkwd
        if (flag(i).eq.errind) errflag=.true.
      enddo
C Select force field (ECEPP/3 is the default). Put flag in ICOMP(1).
      icomp(1)=aint(flag(1))
      if (icomp(1).eq.0) icomp(1)=1
      if (icomp(1).eq.narg(1)) icomp(1)=0
C
C Electrostatic solvation? Put flag in ICOMP(3). (NOT supported, yet)
      ifl2=aint(flag(2))
      if (ifl2.gt.3) icomp(3)=0
      if (ifl2.eq.1 .or. ifl2.eq.3) icomp(3)=2
      if (ifl2.eq.2) icomp(3)=1
C
C Surface hydration? YES, if ICOMP(2).eq.1.
      icomp(2)=0
      if (ifl2.eq.1 .or. ifl2.eq.4) icomp(2)=1
cj VOLUME HYDRATION?
      icomp(4) = ifl2
C Minimize with Surface or volume solvation energy? Yes, if SURDER is .TRUE.
      surder=((icomp(2).eq.1).or.(icomp(4).eq.5).and.flag(12).eq.0.0)

C Databases changed? Put new names in atmradfile, solvfile and readfile.
      if (cflag(3).ne.' ') call concat(rsdbs,cflag(3),atmradfile)
      if (cflag(4).ne.' ') call concat(solvdbs,cflag(4),solvfile)
      if (cflag(14).ne.' ') call concat(rsdbs,cflag(14),readfile)
      write(6,'(a,a)') ' solvfile = ',solvfile
C Impose artificial one-fold torsional potential on omegas to keep them trans?
C Put value of the force constant in omcon.
      omcon=(flag(5).gt.0.0)
      forcon=flag(6)
C Zero out torsionals? YES, if INTOR.eq.0.
      intor=-aint(flag(7))+1
C Do thermodynamic calculations? If yes, specify starting and ending temperature
      if (flag(8).gt.0.0) then
        tstart=flag(9)
        tend=flag(10)
        ntherm=aint(flag(11))
      else
        tstart=0.0
        tend=0.0
        ntherm=0
      endif
C Do calculations at a given pH (assuming variable degree of ionization)?
C YES, if a non-zero value of pHs has been specified.
      if (flag(13).ne.0.0) pHs=flag(13)
C Apply cut-off distance in energy calculation? YES, if ICUTOFF.gt.0.
      if (flag(15).ne.0.0) icutoff =aint(flag(15))
C Minimize with distance constraints? YES, if WITHCNST is .TRUE.
      if (flag(16).gt.0.0) withcnst= .true.
      if (flag(17).gt.0.0) coen=flag(17)
      if (flag(18).gt.0.0) over_cutoff=flag(18)
C Energy when atoms do not overlap.
      nonoverlap_ene = (flag(19).gt.0.0) 
C Change dielectric constant? YES, if VARDIEL is .TRUE.
      vardiel= (flag(20).gt.0.0)
C  print surface areas.
      isfout=aint(flag(21))
C outsurf set to true is a request for writing the molecular
C surface.
C default method for surface area calculation in IBEM is SIMS
      use_mseed=.false.
      if (flag(22).gt.0.0) use_mseed=.true.
      outsurf = (flag(23).gt.0.0)
      if (outsurf) psurf=coorpref
      return
      end
      subroutine read_geom(jin,jout,errflag)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      include 'COMMON.BONDSX'
      include 'COMMON.SETUP'
      logical errflag
      character*120 line,ucase
      read (jin,'(a)') line
      write (jout,'(2a)') '> ',line(1:78)
      ires=0
      do while (index(ucase(line),'$END').eq.0 .and. ires.lt.nres+2)
        ires=ires+1
        read (line,'(15F8.3)',err=10,end=10) 
     &                (angulo(i,ires),i=1,maxnum_dihe)
        read (jin,'(a)') line
        write (jout,'(2a)') '> ',line(1:78)
      enddo
      if (index(ucase(line),'$END').eq.0) then
        errflag=.true.
        write (jout,'(2a,/a)') 
     &  'Error in $GEOM: too many dihedral angles',
     &  ' or the $END line missing.', line
      else if (ires.lt.nres+2) then
        errflag=.true.
        write (jout,'(2a,i4,a,i4,a,/a)') 
     & 'Error in $GEOM: dihedral angles specified',
     & ' for ',ires,' residues out of ',nres+2,'.',line
      else
C dihedral angles were read correctly
cd      write (jout,'(a,i4,a)')  
cd   &    'Dihedral angles read for ',ires,' residues.'
      endif
      return
   10 write (jout,'(a)') 'Error in $GEOM when reading dihedral angles.'
      return
      end
      subroutine read_grid(jin,jout,errflag)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
* Number of keywords in this data group
      parameter (nkwd=11)
      parameter (errind=-1.0D10)
      character*16 keywdset(1:nkwd,0:nkwd) /'ANG1','ANG2','FROM1',
     & 'FROM2','TO1','TO2','STEP1','STEP2','N1','N2','OMSCAN-OK',
     & 'CHAR',10*' ',
     & 'CHAR',10*' ',
     & 'NUM',10*' ',
     & 'NUM',10*' ',
     & 'NUM',10*' ',
     & 'NUM',10*' ',
     & 'NUM',10*' ',
     & 'NUM',10*' ',
     & 'NUM',10*' ',
     & 'NUM',10*' ',
     & 11*' '/
      integer narg(0:nkwd) /11,1,1,1,1,1,1,1,1,1,1,0/
      dimension flag(0:nkwd)
      character*16 cflag(0:nkwd)
      logical errflag
      include 'COMMON.CNTRL'
      include 'COMMON.SETUP'
      include 'COMMON.KVS'
      include 'COMMON.GRID'

      call read_data_group(jin,jout,nkwd,keywdset,narg,flag,cflag)
      errflag=.false.
      do i=0,nkwd
        if (flag(i).eq.errind) errflag=.true.
      enddo
      
C We want to read angles scanned over in a convenient format (e.g. phi(2)),
C but if so we cannot fully implement read_data_group to decode angles.

      ang1=cflag(1)
      ang2=cflag(2)
      call angle_decode(cflag(1),indang1,ires1)
      if (indang1.eq.0) errflag=.true.
      iiang1=indang1
      iresng1=ires1
      call angle_decode(cflag(2),indang2,ires2)
      if (indang2.eq.0) errflag=.true.
      iiang2=indang2
      iresng2=ires2

      from1=flag(3)
      from2=flag(4)
      to1=flag(5)
      to2=flag(6)
      step1=flag(7)
      step2=flag(8)
      n1=flag(9)
      n2=flag(10)
      if (from1.eq.to1) then
        to1=from1+n1*step1 
      else if (step1.gt.0.0 .and. n1.gt.0) then
        write (jout,'(a)') 
     & 'Error - FROM1, TO1, STEP1, and N1 specified simultaneously.'
        errflag=.true.
      else if (step1.le.0.0) then
        step1=(to1-from1)/n1
      else if (n1.le.0) then
        n1=aint((to1-from1)/step1+0.5)
        step1=(to1-from1)/n1
      endif
      if (step2.gt.0.0 .and. n2.gt.0) then
        write (jout,'(a)') 
     & 'Error - FROM2, TO2, STEP2, and N2 specified simultaneously.'
        errflag=.true.
      else if (step2.le.0.0) then
        step2=(to2-from2)/n2
      else if (n2.le.0) then
        n2=aint((to2-from2)/step2+0.5)
        step2=(to2-from2)/n2
      endif
      if (from2.eq.to2) to2=from2+n2*step2

      if (from1.eq.to1 .and. from2.eq.to2) then
        write (jout,'(a)') 
     &  'Error - grid requested, but grid size is zero.'
        errflag=.true.
      endif
      inumres=nres + 2
      if (((ires1.ne.1. .and. ires1.ne.inumres .and. indang1.eq.3) .or.
     &    (ires2.ne.1. .and. ires2.ne.inumres .and. indang2.eq.3)) 
     & .and. flag(11).eq.0.0) then
        write (jout,'(a)')  
     & 'Omega to be scanned over? Specify "OMSCAN-OK" to continue.'     
       errflag=.true.
      endif 
      indang1=(ires1-1)*maxnum_dihe+indang1
      indang2=(ires2-1)*maxnum_dihe+indang2
      return
      end
      subroutine read_minim(jin,jout,errflag)
* Number of keywords in this data group
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      parameter (nkwd=13)
      parameter (errind=-1.0D10)
      character*16 keywdset(1:nkwd,0:nkwd) /'MINIMIZER','MAXFUN',
     & 'MAXIT','MAXSTEP','VTNER1','ABSTOL','RELTOL','DSCALE',
     & 'DVALUE','FULL_PRINT','PRINT_RES_XG','PRINT_STAT',
     & 'PRINT_INITIAL_X', 
     & 'SUMSL','SMSNO',11*' ',
     & 'NUM',12*' ', 
     & 'NUM',12*' ', 
     & 'NUM',12*' ', 
     & 'NUM',12*' ', 
     & 'NUM',12*' ', 
     & 'NUM',12*' ', 
     & 'NONE','FIXED','VARIABLE',10*' ',
     & 'NUM',12*' ',
     & 13*' ',
     & 13*' ',
     & 13*' ',
     & 13*' '/
      integer narg(0:nkwd) /13,2,1,1,1,1,1,1,3,1,0,0,0,0/
      dimension flag(0:nkwd)
      character*16 cflag(0:nkwd)
      logical errflag
      include 'COMMON.MINPAR'
      call read_data_group(jin,jout,nkwd,keywdset,narg,flag,cflag)
      errflag=.false.
      do i=0,nkwd
        if (flag(i).eq.errind) errflag=.true.
      enddo
      if (flag(1).gt.0.0) imin=aint(flag(1))
      if (flag(2).gt.0.0) maxfun=aint(flag(2))
      if (flag(3).gt.0.0) maxit=aint(flag(3))
      if (flag(4).gt.0.0) amaxstep=flag(4)
      if (flag(5).gt.0.0) vtner1=flag(5)
      if (flag(6).gt.0.0) abstol=flag(6)
      if (flag(7).gt.0.0) reltol=flag(7)
      idscale=aint(flag(8))
      if (flag(9).gt.0.0) dvalue=flag(9)
      iprint(1)=0
      do i=2,5
        iprint(i)=aint(flag(i+8))
      enddo
      if (iprint(2)+iprint(3)+iprint(4)+iprint(5).gt.0) iprint(1)=9
      return
      end
      subroutine read_regions(jin,jout,errors)

C this subroutine should read the sampling regions for aminoacids
C The sampling can be UNIFORM or NONUNIFORM (this are keywords defined in
C read_vtf and read_edmc). 
C if sample is UNIFORM the input is specified using the following format:
C  residue_no.   region1 region2 .....   regionM
C if sample is NON-uniform the input is specified as:
C  residue_no.   region1 weigth1  region2  weigth2 .....   regionM weigthM 
C
C where:
C - residue no. belongs to  { 2, inumrs}
C - regionI is one of the 16 regions of the PHI-PSI map using the Zimmerman's 
C code A,A*,... H* , or any the four POPOV's regions. H-, H+ (HELIX) and
C  S-, S+ (SHEET).
C - weigthI is an integer indicating the weight used to generate the sampling 
C probability for the associated region.
C example of UNIFORM sampling:
C   3   A  A* C  C*
C example of NONUNIFORM sampling:
C   3   A 40  A* 10  C 30  C* 10

C Arguments passed:
C   izz(1,i) residue no of data listed in the ith order (line).
C   izz(2,i) no. of regions read for the residue read in the ith order.
C   zz(j,i) jth-region specified  for the residue  izz(1,i).
C   iwzz(j,i) weight assigned in the sampling to the jth-region of residue izz(1,i).
C   NARES. No. of residues for which regions were specified.
C
C Continuation line should be indicated by '\'
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      logical errflag,errors,blankline, contline, readwei
      character*80 line,line1,ucase
      include 'COMMON.REGG'
      include 'COMMON.VTFEX'
C     character*2  zz(20,maxnum_res)
C     integer izz(1,maxnum_res)
      CHARACTER*1 onechar
!     CHARACTER*2 KEY(20) 
!    & /'A ','B ','C ','D ','E ','F ','G ','H ','H-','S-',
!    &  'A*','B*','C*','D*','E*','F*','G*','H*','H+','S+'/

!     CHARACTER*2 emptyc / '  ' /, nxtline / '\\ ' /

#ifndef SGI
      CHARACTER*2 KEY(22) 
     & /'A ','B ','C ','D ','E ','F ','G ','H ','H-','S-',
     &  'A*','B*','C*','D*','E*','F*','G*','H*','H+','S+','  ','\ '/
#endif
#ifdef SGI
      CHARACTER*2 KEY(22) 
     & /'A ','B ','C ','D ','E ','F ','G ','H ','H-','S-',
     &  'A*','B*','C*','D*','E*','F*','G*','H*','H+','S+','  ','\\ '/
#endif
      do i=1, maxnum_res
         izz(1,i)=0
         izz(2,i)=0
         do j=1, 20
            zz(j,i)=key(21)
            iwzz(j,i)=1
         enddo
      enddo
      errors=.false.
      contline=.false.
      readwei=.false.
      nares=0

C     write (*,'(a,i4)') 'now in read_regions ',jin
      read (jin,'(a)') line
C     write (*,'(2a)') '> ',line(1:78)
      write (jout,'(2a)') '> ',line(1:78)

      do while (index(ucase(line),'$END').eq.0)
        ipos=1
        blankline=.false.
        errflag=.false.
        if (.not.contline) naread=0
        do while (.not. blankline)
          call mykey(line,line1,ipos,blankline,errflag)
          if (errflag) goto 10 
          errors=errors .or. errflag
          if (.not. blankline .and. .not. errflag) then
            if (nares.lt.maxnum_res) then

C read  sampling regions for residue.
              if (naread.eq.0) then
C read residue number
                 nares=nares+1
                 read (line1,*,err=10) izz(1,nares)
C                write (*,'(a,i4)') 'residue', izz(1,nares)
                 naread= 1
              else if (naread.lt.20) then
                 read (line1,'(a1)',err=10) onechar
		 if (onechar.eq.key(22)(1:1)) then
C continuation line
                   contline=.true.
                 else
                   contline=.false.
                   if ((itprgsmp.eq.2).and.readwei) then 
		     read (line1,*,err=10) iwzz(naread,nares)
                     readwei=.false.
                   else
		     read (line1,'(a2)',err=10) zz(naread,nares)
                     if (itprgsmp.eq.2) readwei=.true.
C                    write (*,'(a,2i4)')zz(naread,nares),naread,nares
C Test if this is a valid region
                     do j=1, 20
                       if(zz(naread,nares).eq. key(j)) goto 20
                     enddo
C                    write (*,'(3a,i4)')   'Invalid region ',
C    &   zz(naread,nares),' was specified for residue ',izz(1,nares)
                     errors=.true.
                     return
                   endif
 20                continue
		   if (.not.readwei) then 
                       write (*,'(a,i4,2a)')'residue',izz(1,nares),
     &                  ' REGION ',key(j)
                       izz(2,nares)=naread
                       naread= naread + 1
                   else
                       write (*,'(a,i4,3a,i4)')'residue',izz(1,nares),
     &                  ' REGION ',key(j),'weight=',iwzz(naread,nares)
                   endif
                 endif
              else
                 write (jout,'(3a,i4,/,2a)') 'WARNING:More than ',
     &           '18 regions were specified for residue ',
     &           izz(1,nares),' Extra content of line=',line1
                 errors=.true.
                 return
              endif
            else
              errors=.true.
              write (jout,1000) nares,maxnum_res
              write (*,1000) nares,maxnum_res
 1000 format ('Error in $READ_REGIONS: The number of residues read (',
     & i4,') exceeds maximum (',i4,').')
              return
            endif
          endif
        enddo
        read (jin,'(a)') line
        write (jout,'(2a)') '> ',line(1:78)
      enddo
      return
C
   10 write (jout,'(a/a)') 
     &   'Read error in $READ_REGIONS: data line:',line
      errors=.true.
      return
      end
      subroutine  read_ecpztion(jin,jout,errflag)
* Number of keywords in this data group
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      parameter (nkwd=11)
      parameter (errind=-1.0D10)
      character*16 keywdset(1:nkwd,0:nkwd) /'TYPE_REF','INIT_RES',
     & 'IFIN_RES','ALL_HVY_ATOMS','ALPHA_CARBONS','BACKBONE',
     & 'SIDE_CHAIN','IGNORE_H','FIRST_RESIDUE','WEI_RMSC','GENERATE_REF' 
     & ,'PDB_NO_ENDG','PDB_WITH_ENDG','ECEPP', 8*' ',
     & 'NUM',10*' ',
     & 'NUM',10*' ',
     & 11*' ',
     & 11*' ',
     & 11*' ',
     & 11*' ',
     & 11*' ',
     & 'NUM',10*' ',
     & 'NUM',10*' ',
     & 11*' '/
      integer narg(0:nkwd) /11,3,1,1,5*0,1,1,0/
      dimension flag(0:nkwd)
      character*16 cflag(0:nkwd)
      logical errflag
      include 'COMMON.CNTRL'
      include 'COMMON.RMSFIT'
      include 'COMMON.TYYY'
      include 'COMMON.RMSCNST'


      call read_data_group(jin,jout,nkwd,keywdset,narg,flag,cflag)
      errflag=.false.
      do i=0,nkwd
        if (flag(i).eq.errind) errflag=.true.
      enddo
      itype_ref=3
      if (flag(1).ne.0.0) itype_ref=aint(flag(1))
      if (flag(2).ne.0.0) then
         kk1=aint(flag(2))
      else
         kk1=1
      endif
      if (flag(3).ne.0.0) then
         lresd=aint(flag(3))
      else
         lresd=999999
      endif
      write(*,*)'itype_ref= ',itype_ref 

      all_hvy=(flag(4).gt.0.0)
      alpha_c=(flag(5).gt.0.0)
      backbone=(flag(6).gt.0.0)
      side_chain=(flag(7).gt.0.0)
      ignore_h=(flag(8).gt.0.0)
      ifrstrs=1
      if (flag(9).ne.0.0) ifrstrs=aint(flag(9))
      wei_rmsd=1.0
      if (flag(10).ne.0.0) wei_rmsd=aint(flag(10))
      generate_ref=(flag(11).gt.0.0)
      return
      end

      subroutine read_rms_fit(jin,jout,errflag)
* Number of keywords in this data group
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      parameter (nkwd=19)
      parameter (errind=-1.0D10)
      character*16 keywdset(1:nkwd,0:nkwd) /'TYPE_REF','TYPE_INPUT',
     & 'INIT_RES','IFIN_RES', 'GENERATE_REF','ALL_HVY_ATOMS',
     &'ALPHA_CARBONS','BACKBONE','SIDE_CHAIN','DISTANCE_RMS','CA_TRACE',
     & 'PDB_ALIGN_HVY','PDB_ALIGN_CA','PDB_ALIGN_BACK','PDB_ALIGN_SIDE',
     & 'IGNORE_H','METHOD','FIRST_RESIDUE','ADOPT_REF_SEQ',
     & 'PDB_NO_ENDG','PDB_WITH_ENDG','ECEPP', 16*' ',
     & 'PDB_NO_ENDG','PDB_WITH_ENDG','ECEPP', 16*' ',
     & 'NUM',18*' ',
     & 'NUM',18*' ',
     & 19*' ',
     & 19*' ',
     & 19*' ',
     & 19*' ',
     & 19*' ',
     & 19*' ',
     & 19*' ',
     & 19*' ',
     & 19*' ',
     & 19*' ',
     & 19*' ',
     & 19*' ',
     & 'KABSCH','GOLUB', 17*' ',
     & 'NUM',18*' ',
     & 19*' ' /
      integer narg(0:nkwd) /19,3,3,1,1,0,0,0,0,0,0,0,0,0,0,0,0,2,1,0/
      dimension flag(0:nkwd)
      character*16 cflag(0:nkwd)
      character*6 method(1:2)/'KABSCH',' GOLUB'/
      logical errflag
      include 'COMMON.CNTRL'
      include 'COMMON.RMSFIT'
      include 'COMMON.TYYY'


      call read_data_group(jin,jout,nkwd,keywdset,narg,flag,cflag)
      errflag=.false.
      do i=0,nkwd
        if (flag(i).eq.errind) errflag=.true.
      enddo
      itype_ref=3
      if (flag(1).ne.0.0) itype_ref=aint(flag(1))
      itype_inp=3
      if (flag(2).ne.0.0) itype_inp=aint(flag(2))
      if (flag(3).ne.0.0) then
      kk1=aint(flag(3))
      else
         kk1=1
      endif
      if (flag(4).ne.0.0) then
      lresd=aint(flag(4))
      else
         lresd=999999
      endif
      generate_ref=(flag(5).gt.0.0)
      write(*,*)'itype_ref= ',itype_ref,' itype_inp= ',itype_inp
      write(*,*)'generate_ref= ',generate_ref

      all_hvy=(flag(6).gt.0.0)
      alpha_c=(flag(7).gt.0.0)
      backbone=(flag(8).gt.0.0)
      side_chain=(flag(9).gt.0.0)
      dist_rms=(flag(10).gt.0.0)
      ca_trace=(flag(11).gt.0.0)
      pdb_align_hvy=(flag(12).gt.0.0)
      pdb_align_ca=(flag(13).gt.0.0)
      pdb_align_back=(flag(14).gt.0.0)
      pdb_align_side=(flag(15).gt.0.0)
      ignore_h=(flag(16).gt.0.0)
C Default is Golub method.
      methrms=2
      if (flag(17).ne.0.0) methrms=aint(flag(17))
      method_rms=method(methrms)
      ifrstrs=1
      if (flag(18).ne.0.0) ifrstrs=aint(flag(18))
      adopt_ref_seq=(flag(19).gt.0.0)
      return
      end
      subroutine read_scan(jin,jout,errors)
      logical errors
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      include 'COMMON.SCAN'
      include 'COMMON.SETUP'
      character*80 line,ucase
      dimension ndihtemp(maxnum_dihe)
      errors=.false.
      nread=0
      read (jin,'(a)') line
      write (jout,'(2a)') '> ',line(1:78)
      do while (index(ucase(line),'$END').eq.0)
        read (line,*,end=50,err=50)
     &       idih,ndiht,(ndihtemp(j),j=1,ndiht)
        if (idih.gt.nres+2) then
          errors=.true.
          write (jout,'(a,i4,a,i4,a)')'Error - $SCAN: residue number (',
     & idih,') exceeds chain length (',nres+2,').'
        else
          nread=nread+1
          ndih(idih)=ndiht
          do j=1,ndiht
            numdih(idih,j)=ndihtemp(j)
          enddo
        endif
        read (jin,'(a)') line
        write (jout,'(2a)') '> ',line(1:78)
      enddo
C     do i=1,nres+2
C       write (jout,'(16i5)') (numdih(i,j),j=1,ndih(i))
C     enddo
      return
   50 write (jout,'(2a)')'Error when reading $SCAN in line: ',line
      return
      end
      subroutine read_seq(jin,jout,errors)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      include 'COMMON.GEN100'
      include 'COMMON.THRLET'
      include 'COMMON.PRAMX'
      include 'COMMON.SETUP'
      include 'COMMON.CNTRL'
      character*80 line,line1,ucase
      character*8 sequence(maxnum_res),temp_str
      character*3 res
      EXTERNAL ILEN
      logical errflag,errors,err_res_nam,blankline,lower_case,lchkres
      errors=.false.
      read (jin,'(a)') line
      write (jout,'(2a)') '> ',line(1:78)
      line1=ucase(line)
      iseq=1
      do while (index(line1,'$END').eq.0)
* Override commented lines.
         ipos=1
         blankline=.false.
         if (icode.lt.3) then 
* Numeric or three-letter code. A separator is required between residue IDs.
           do while (.not. blankline)                 
             call mykey(line,temp_str,ipos,blankline,errflag)
             if (errflag) write (jout,'(2a)')
     & 'Error when reading sequence in line: ',line
             errors=errors .or. errflag
             if (.not. blankline .and. .not. errflag) then
               if (iseq.le.maxnum_res) then
                 sequence(iseq)=temp_str
                 iseq=iseq+1
               else
                 errors=.true.
                 write (jout,1000) iseq,maxnum_res
                 goto 80
               endif
             endif
           enddo
         else
* One-letter code
           do while (.not.blankline)
             line1=' '
             call mykey(line,line1,ipos,blankline,errflag) 
             if (errflag) write (jout,'(2a)')
     & 'Error when reading sequence in line: ',line
             errors=errors .or. errflag
             if (.not. blankline .and. .not. errflag) then
               if (line1(1:1).eq.'@@') then
                 il=2
                 ipos1=3
               else 
                 il=1
                 ipos1=2
               endif
               iend=ilen(line1)
               if (iseq.le.maxnum_res) then
                 sequence(iseq)=line1(1:il)
               else
                 errors=.true.
                 write (jout,1000) iseq,maxnum_res
                 goto 80
               endif
               do while (ipos1.le.iend)
                 if (line1(ipos1:ipos1).eq.'+' .or. 
     &               line1(ipos1:ipos1).eq.'-' .or.
     &               line1(ipos1:ipos1).eq.'<' .or.
     &               line1(ipos1:ipos1).eq.'>' .or.
     &               line1(ipos1:ipos1).eq.':' .or.
     &               line1(ipos1:ipos1).eq.';' .or.
     &               line1(ipos1:ipos1).eq.'*' .or.
     &               line1(ipos1:ipos1).eq.'%' .or.
     &               line1(ipos1:ipos1).eq.'_') then
                   sequence(iseq)=line1(ipos1-il:ipos1)
                   ipos1=ipos1+1
                 else
                   iseq=iseq+1
                   if (ipos1.lt.iend .and. 
     &                      line1(ipos1:ipos1).eq.'@@') then
                     il=2
                     ipos1=ipos1+2
                   else
                     il=1
                     ipos1=ipos1+1
                   endif
                   if (iseq.le.maxnum_res) then
                       sequence(iseq)=line1(ipos1-il:ipos1-1)
                   else
                     errors=.true.
                     write (jout,1000) iseq,maxnum_res
                     goto 80
                   endif
                 endif
               enddo
               iseq=iseq+1
             endif
           enddo
         endif
         read (jin,'(a)') line
         write (jout,'(2a)') '> ',line(1:78)
         line1=ucase(line)
      enddo
   80 continue
cd    write (jout,'(10a8)') (sequence(i),i=1,iseq-1)
* If the user has specified the length of the chain, check whether the 
* found length of the chain is correct.
      length_of_chain=iseq-3
      if (nres.eq.0) nres=length_of_chain
      if (length_of_chain .ne. nres) then
        errors=.true.
        write (jout,'(a,i4,a,i4,a)') 
     & 'Error - the found number of residues (',length_of_chain,
     & ') does not match the number specified in $CNTRL (',nres,').' 
      endif
* Now decode the sequence.
      goto (10,20,30) icode
* Numeric code of the sequence
   10 do ires=1,nres+2
        read (sequence(ires),*,err=100) list(ires)
        goto 40
  100   write (jout,'(a,i4,2a)') 'Error in residue ',ires,': ',
     &   sequence(ires)
        errors=.true.
   40 enddo 
      return
* Three-letter code of the sequence.
   20 do ires=1,nres+2
        ils=ilen(sequence(ires))
        ichir=1
        err_res_nam=.false.
        if (ils.le.3) then
          res=sequence(ires)
          if (lower_case(res(1:1))) ichir=-1 
        elseif ( (ils.eq.4 .and. ucase(sequence(ires)(1:1)).eq.'D') 
     &  .or. (ils.eq.5 .and. ucase(sequence(ires)(1:2)).eq.'D-') ) then
          res=sequence(ires)(ils-2:ils)
          ichir=-1
        else
          err_res_nam=.true.
          errors=.true.
          write (jout,'(3a,i4)') 'Error - bad three-letter code ',
     & sequence(ires),' found in position',ires
        endif
        res=ucase(res)
        if (.not.err_res_nam) then
          i=1
C         do while (res.ne.ares(i) .and. i.le.num_restypes+num_endgrp)
          lchkres= ( res.ne.ares(i) )
          do while (lchkres)
            i=i+1
             if(i.le.num_restypes+num_endgrp) then
                lchkres= res.ne.ares(i) 
              else
                lchkres= .false.
                err_res_nam=.true.
              endif
          enddo
          if (err_res_nam) then
            write (jout,1010) sequence(ires),ires
          else if (ires.ne.1 .and. ires.ne.nres+2) then
            list(ires)=ichir*i
          else
            list(ires)=i
          endif
          if (ires.gt.1 .and. ires.lt.nres+2 .and. i.gt.num_restypes) 
     &    then
            errors=.true.
            write (jout,'(3a,i4,a)') 
     &                      'Error - an end group ',sequence(ires),
     &      ' has been found in the position',ires,' of the chain.'
          elseif ((ires.eq.1 .or. ires.eq.nres+2).and.
     &             i.le.num_restypes) then
            errors=.true.
            if (ires.eq.1) write (jout,'(2a)')
     &         'Error - sequence is started with a full residue ',
     &          sequence(ires)
            if (ires.eq.nres+2) write (jout,'(2a)')
     &         'Error - sequence is terminated with a full residue ',
     &          sequence(ires)
          endif
        endif
      enddo
      list(1)=list(1)-num_restypes
      list(nres+2)=list(nres+2)-num_restypes
      write (jout,'(16i5)') (list(i),i=1,nres+2)
      return 
* One-letter code of the sequence. First process full residues.
   30 do ires=2,nres+1
        ils=ilen(sequence(ires))
        ichir=1
        if (lower_case(sequence(ires)(1:1)) .or. 
     &      lower_case(sequence(ires)(2:2)) ) ichir=-1 
        i=1  
        do while (ucase(sequence(ires)(1:3)).ne.one_let(i) .and. 
     &    i.le.num_restypes)
          i=i+1
        enddo
        if (i.gt.num_restypes) then
          errors=.true.
          write (jout,1010) sequence(ires),ires
        else
          list(ires)=ichir*i    
        endif 
      enddo
* End groups
      do ires=1,nres+2,nres+1
        ils=ilen(sequence(ires))
        i=num_restypes+1
        do while(ucase(sequence(ires)(1:2)).ne.one_let(i) .and. 
     &     i.le.num_restypes+num_endgrp)
          i=i+1
        enddo
        if (i.gt.num_restypes+num_endgrp) then
          errors=.true.
          write (jout,1010) sequence(ires),ires
        else
          list(ires)=i    
        endif 
      enddo
      list(1)=list(1)-num_restypes
      list(nres+2)=list(nres+2)-num_restypes
      write (jout,'(16i5)') (list(i),i=1,nres+2)
      return
 1000 format('Error - the number of residues (',i4,
     & ') has exceeded maximum (',i4,').')
 1010 format ('Error - unrecognized residue or end group ',a8,
     & ' in position',i4)
      end
      subroutine read_spec(jin,jout,errors)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      logical errflag,errors,blankline
      include 'COMMON.KVS'
      include 'COMMON.SETUP'
      include 'COMMON.TOR2'
      include 'COMMON.BONDSX'
      character*80 line,line1,ucase
      errors=.false.
      nvr=0
      numvr0=0
      read (jin,'(a)') line
      write (jout,'(2a)') '> ',line(1:78)
      do while (index(ucase(line),'$END').eq.0)
C
C IVARFLAG=5 (i.e. "NONE") then SPEC card if useless and the information 
C  will not be considered. We read the lines until $END card is found.  
C
        if (ivarflag.eq.5) goto 20
C
        if (ivarflag.eq.4) then
C IVARFLAG=4 means that the user specifies the variable angles explicitly.
          read (line,*,err=10) ires,nvi,(ndxarr0(k,ires),k=1,nvi)
          nv0(ires)=nvi
          numvr0=numvr0+nvi
          nvr=nvr+1  
          numvarres(nvr)=ires
        else
          ipos=1
          blankline=.false.
          errflag=.false.
          do while (.not. blankline)
            call mykey(line,line1,ipos,blankline,errflag)
            errors=errors .or. errflag
            if (errflag) goto 10 
            if (.not. blankline .and. .not. errflag) then
              if (nvr.lt.nres+2) then
                nvr=nvr+1
                read (line1,*,err=10) numvarres(nvr)
              else
                errors=.true.
                write (jout,1000) nres+2
                return
              endif
            endif
          enddo
        endif
 20     read (jin,'(a)') line
        write (jout,'(2a)') '> ',line(1:78)
      enddo
      if (nvarres.eq.0) then
        nvarres=nvr
      elseif (nvr.ne.nvarres) then
        write (jout,'(2a/a,i4,a,i4,a)') 
     &   'Error in $SPEC: the number of residues with ',
     &   'variable dihedrals specified in ','$CNTRL (',nvarres,
     &   ') is not equal to the number read here (',nvr,').'
        errors=.true.
      endif
      if (ivarflag.eq.4) then
        if (nvr.eq.0) then
          write (jout,'(2a/a)')
     &     'Error in $SPEC: VAR_ANGLES=SPEC was ',
     &     'specified in $CNTRL, but ',
     &     'no dihedral angle has been defined in the $SPEC card'
          errors=.true.
        endif
      endif
C Sort the NUMVARRES array and the rows of NDXARR and simultaneously
C check for repetitions. -- AL 11/02/93
      do i=1,nvarres
        imin=i
        ires=numvarres(i)
        nvi=nv0(ires)
        do j=i+1,nvarres
          jres=numvarres(j)
          if (ires.eq.jres) then
            write (jout,'(2a,i3,a)') 'Error in $SPEC data group. ',
     & 'Residue with variable angles',ires,' specified repeatedly.'
            errors=.true.
          else if (ires .gt. jres) then
            imin=j
            ires=jres 
          endif
        enddo
        if (imin.gt.i) call exch(numvarres(i),numvarres(imin))
      enddo             
      if (ivarflag.eq.4) then
        do i=1,nres+2
          nvi=nv0(i)  
          if (nvi .gt. 0) then
            do j=1,nvi
              jmin=j
              ndxji=ndxarr0(j,i)
              do k=j+1,nvi
                ndxki=ndxarr0(k,i)
                if (ndxji.eq.ndxki) then
                  write (jout,'(2a,i2,a,i3,a)') 
     & 'Error in $SPEC data group. ',
     & 'Angle',ndxji,' for residue',i,' specified repeatedly.'
                  errors=.true.
                else if (ndxji.gt.ndxki) then
                  jmin=k
                  ndxji=ndxki
                endif
              enddo
              call exch(ndxarr0(j,i),ndxarr0(jmin,i))
            enddo
          endif
        enddo
      endif
      write (jout,'(16i5)') (numvarres(i),i=1,nvarres)
      return
   10 write (jout,'(2a)')'Error when reading $SPEC in line: ',line
      errors=.true.
      return
 1000 format ('Error - the number of variable residues exceeds the ',
     & /,'total number of residues and end groups (',i4,').')
 1100 format ('Error - VAR_ANGLES and VAR_RES cards have been ',
     & ' specified',/,' simultaneously in $CNTRL.')
      end
      subroutine read_enercalc(jin,jout,errflag)
*  Written by D. ripoll                             JAN-95
* Number of keywords in this data group
      parameter (nkwd=13)
      parameter (errind=-1.0D10)
      character*16 keywdset(1:nkwd,0:nkwd) /
     & 'SINGLE_CONF', 'READ_CONF', 'RAND_START', 'MAXIT', 'SEED',
     & 'REGION_SAMP', 'BACKUP', 'RESTART', 'NO_MINIMIZATION',
     & 'CONSTR_MOV','OMEGA_180','ZIMMERMAN_CODE', 'FREE_ENERGY',
     & 13*' ',
     & 13*' ',
     & 13*' ',
     & 'NUM',12*' ',
     & 'NUM',12*' ',
     &  'UNIFORM','NONUNIFORM',11*' ',
     & 'NUM',12*' ',
     & 13*' ',
     & 13*' ',
     & 13*' ',
     & 13*' ',
     & 13*' ',
     & 13*' '/
      integer narg(0:nkwd) /13,0,0,0,1,1,2,1,0,0,0,0,0,0/
      dimension flag(0:nkwd)
      character*16 cflag(0:nkwd)
      logical errflag
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      include 'COMMON.CNTRL'
      include 'COMMON.EDMC'
      include 'COMMON.MOVE'
      include 'COMMON.VTFEX'
      include 'COMMON.XBOUNDX'

      call read_data_group(jin,jout,nkwd,keywdset,narg,flag,cflag)
      errflag=.false.
      do i=0,nkwd
        if (flag(i).eq.errind) errflag=.true.
      enddo
C   'SINGLE_CONF', 'READ_CONF', 'RAND_START', 'MAXIT', 'SEED' 
      if ( ( (flag(1).gt.0.0).and.(flag(2).gt.0.0) ).or.
     &  ( (flag(1).gt.0.0).and.(flag(3).gt.0.0) ).or.
     &  ( (flag(2).gt.0.0).and.(flag(3).gt.0.0) ) ) then
        errflag=.true.
	write(jout,'(3a/a)')keywdset(1,0),keywdset(2,0),keywdset(3,0),
     & ' are incompatible keywords. Only one of them should be used'
      endif
      if (flag(1).gt.0.0) then
C Actually, this is the default.
         readconfs= .false. 
         istartrnd=0
      elseif (flag(2).gt.0.0) then
         readconfs= .true. 
         istartrnd=0
      elseif (flag(3).gt.0.0) then
         readconfs= .false. 
         liczm=1
         istartrnd=1
         if (flag(4).gt.0.0) liczm=aint(flag(4))
         if (flag(5).ne.0.0) iseed=aint(flag(5))
         iseed=-iabs(iseed)
      endif
C
C  'REGION_SAMP', 'BACKUP', 'RESTART', 'NO_MINIMIZATION', 'CONSTR_MOV',
C  As in Max Vasquez' VTF program, we allow the definition of regions of
C sampling for each amino acids.
C J. of Biomol. Struc & Dyn. vol5 pp 757 (1988)
      regsamp=(flag(6).gt.0.0)
      if(regsamp) itprgsmp=aint(flag(6))

C backup and restart to be implemented.
      if (flag(7).ne.0.0) backup=flag(7)
      restart=(flag(8).gt.0.0)
C NOMINIM=.TRUE. is used to calculate VTF energy from distance constraints EDIS
C (no minimization performed).
      nominim=(flag(9).gt.0.0)
C set  withcnst key to true if distance constraints are required.
      if (flag(10).ne.0.0) withcnst=.true.
C set omegas to 180 degree.
      omeg180 = (flag(11).gt.0.0)
C refcod: true if ZIMMERMAN_CODE of the conformation(s) is requested.
      refcod=(flag(12).gt.0.0) 
      lfree_ene=(flag(13).gt.0.0) 
      return
      end
      subroutine read_vtf(jin,jout,errflag)
*  Written by D. ripoll                             Mar-94
* Number of keywords in this data group
      parameter (nkwd=21)
      parameter (errind=-1.0D10)
      character*16 keywdset(1:nkwd,0:nkwd) /
     & 'SINGLE_CONF', 'READ_CONF', 'RAND_START', 'MAXIT', 'SEED',
     & 'STEP_RANK', 'RANK_ORDER', 'MAX_RANK','REGION_SAMP','BACKUP',
     & 'RESTART','NO_MINIMIZATION','OMEGA_180','ZIMMERMAN_CODE',
     & 'BIG_VIOLATION','STEPS_ON_ERROR','CONST_SEQ','VTF_BY_RANK',
     & 'VARIABLE_WEI','DIMINISH_W_BY','FACTOR_MIN_WEI',
     & 21*' ',
     & 21*' ',
     & 21*' ',
     & 'NUM',20*' ',
     & 'NUM',20*' ',
     & 'NUM',20*' ',
     & 'NUM',20*' ',
     & 'NUM',20*' ',
     &  'UNIFORM','NONUNIFORM',19*' ',
     & 'NUM',20*' ',
     & 21*' ',
     & 21*' ',
     & 21*' ',
     & 21*' ',
     & 'NUM',20*' ',
     & 'NUM',20*' ',
     & 21*' ',
     & 21*' ',
     & 21*' ',
     & 'NUM',20*' ',
     & 'NUM',20*' '/
      integer narg(0:nkwd) 
     &    /21,0,0,0,5*1,2,1,0,0,0,0,1,1,0,0,0,1,1/
      dimension flag(0:nkwd)
      character*16 cflag(0:nkwd)
      logical errflag
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      include 'COMMON.CNTRL'
      include 'COMMON.VTFEX'
      include 'COMMON.EDMC'
      include 'COMMON.MOVE'
      include 'COMMON.XBOUNDX'
      include 'COMMON.SAVEWEI'

C set  withcnst key to true to indicate that distance constraints should
C be read.
      withcnst=.true.

      call read_data_group(jin,jout,nkwd,keywdset,narg,flag,cflag)
      errflag=.false.
      do i=0,nkwd
        if (flag(i).eq.errind) errflag=.true.
      enddo

C   'SINGLE_CONF', 'READ_CONF', 'RAND_START', 'MAXIT', 'SEED' 
      if  ( ( (flag(1).gt.0.0).and.(flag(2).gt.0.0) ).or.
     &  ( (flag(1).gt.0.0).and.(flag(3).gt.0.0) ).or.
     &  ( (flag(2).gt.0.0).and.(flag(3).gt.0.0) )  ) then
        errflag=.true.
	write(jout,'(3a/a)')keywdset(1,0),keywdset(2,0),keywdset(3,0),
     & ' are incompatible keywords. Only one of them should be used'
      endif
      if (flag(1).gt.0.0) then
C Actually, this is the default.
         readconfs= .false. 
         istartrnd=0
      elseif (flag(2).gt.0.0) then
         readconfs= .true. 
         istartrnd=0
      elseif (flag(3).gt.0.0) then
         readconfs= .false. 
         liczm=1
         istartrnd=1
         if (flag(4).gt.0.0) liczm=aint(flag(4))
         if (flag(5).ne.0.0) iseed=aint(flag(5))
         iseed=-iabs(iseed)
      endif
C   'STEP_RANK', 'RANK_ORDER', 'MAX_RANK' 
      if (abs(flag(6)).gt.0.0) iflov=-aint(flag(6))
C
C        iorder=0       default; Order by range, a la Braun-Go
C        iorder=1                Keep order as in input distances
C        iorder=2                Order by growing from N-terminus
        if (flag(7).gt.0.0) iorder=aint(flag(7))
C
C    Only distance constraints up to rank irangmx will be used.
C    default for irangmx is  maximum no. of residues (INUMRS).
        if (flag(8).gt.0.0) irangmx=aint(flag(8))
C
C    & 'REGION_SAMP','BACKUP','RESTART'

C  Original Max Vasquez program allows the definition of regions of
C sampling for each amino acids.
C J. of Biomol. Struc & Dyn. vol5 pp 757 (1988)
      regsamp=(flag(9).gt.0.0)
      if(regsamp) itprgsmp=aint(flag(9))

C backup and restart to be implemented.
      if (flag(10).ne.0.0) backup=flag(10)
      restart=(flag(11).gt.0.0)
C NOMINIM=.TRUE. is used to calculate VTF energy from distance constraints EDIS
C (no minimization performed).
      nominim=(flag(12).gt.0.0)
C set omega's to 180 degree.
      omeg180 = (flag(13).gt.0.0)
C refcod: true if ZIMMERMAN_CODE of the conformation(s) is requested.
      refcod=(flag(14).gt.0.0) 
C Largest  distance violation allowed. During vtf minimization, if an intermediate
C  conformation has a distance-violation greater than "biggest_vio" the minimization will
C be aborted and a new trial conformation will be produced.
       if (flag(15).gt.0.0) biggest_vio=flag(15)
C number of VTF steps in which the violation (distance or energy) is allowed to 
C  excede BIGGEST_VIO. (Usually, after some steps exceding this value, subsequent
C iterations may be able to reduce the error).
       if (flag(16).gt.0.0) maxviostp=flag(16)
C 'CONST_SEQ',  keep the sequence fixed.
      if (flag(17).gt.0.0) excprh=1.1
C 'VTF_BY_RANK'
      if (flag(18).gt.0.0) then
         ivtf=1
       else
         ivtf=0
       endif
C 'VARIABLE_WEI'
       varwei= (flag(19).gt.0.0) 
C 'DIMINISH_W_BY'
       diminw=0.1E0
       if (flag(20).gt.0.0) diminw=flag(20)
C 'FACTOR_MIN_WEI',
       fctminwei=0.1E0
       if (flag(21).gt.0.0) fctminwei=flag(21)


      return
      end
      subroutine read_windows(jin,jout,errors)
      logical errors
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      include 'COMMON.BIAS'
      include 'COMMON.SETUP'
      character*80 line,ucase
      dimension ndihtemp(maxnum_dihe)
      errors=.false.
      nwind=0
      read (jin,'(a)') line
      write (jout,'(2a)') '> ',line(1:78)
      do while (index(ucase(line),'$END').eq.0)
        read (line,*,end=50,err=50) iw1,iw2
        if (iw1.le.0 .or. iw1.gt.nres+2 .or. 
     &      iw2.le.0 .or. iw2.gt.nres+2) then
          errors=.true.
          write (jout,'(2a)')'Error - $WINDOWS: residue numbers ',
     &           'specified that are beyond chain.'
        else
          nwind=nwind+1
          iwind(nwind,1)=iw1
          iwind(nwind,2)=iw2
        endif
        read (jin,'(a)') line
        write (jout,'(2a)') '> ',line(1:78)
      enddo
      return
   50 write (jout,'(2a)')'Error when reading $WINDOWS in line: ',line
      return
      end
c-----------------------------------------------------------------------------
      subroutine read_omeg(jin,jout,errflag)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      logical errflag
      character*80 karta
      dimension icis(maxnum_res)
      include 'COMMON.SETUP'
      include 'COMMON.EDMC'
      read (jin,*,end=10,err=10) ncis,(icis(i),i=1,ncis)
      do i=1,ncis
        if (icis(i).lt.1 .or. icis(i).gt.nres+2) then
          write (jout,'(a,i3,a)') 'Residue ',i,' is outside range.'
          errflag=.true.
          return
        endif
        omref(icis(i))=0.0
      enddo
      errflag=.false.
      write (jout,'(10f8.1)') (omref(i),i=1,nres+2)
      return
   10 errflag=.true.
      return
      end
c-----------------------------------------------------------------------------
      subroutine readkey(jin,jout)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      character*16 keywdup(maxnumdatag) 
     & /'$CNTRL','$FFIELD','$MINIM','$ENERCALC','$EDMC','$SEQ','$SPEC',
     &  '$GEOM','$BRIDGE','$SCAN','$WINDOWS','$RMSFIT','$GRID',
     &  '$BOUND_DEF','$BOUNDS','$VTF', '$DIST_CONST','$REGIONS',
     &  '$OVERLAP_GRP', '$SELEC_PDB','$OMCIS','$SUPAT','$IBEM_SIMS',
     &  '$ECEPPIZE' /
      include 'COMMON.CNTRL'
      include 'COMMON.DATA_READ'
      include 'COMMON.VTFEX'
      include 'COMMON.MOVE'
      include 'COMMON.XBOUNDX'
      character*64 fname
      include 'COMMON.EXTPH'
      logical find_group
      EXTERNAL ILEN
      write (jout,1000)
 1000 format (80(1h*)/'Echo of the input data and error messages of ',
     & 'the data-reading routines:'/)
      do 100 ikey=1,maxnumdatag
        il=ilen(keywdup(ikey))
        rewind (jin)
        if (find_group(jin,jout,keywdup(ikey))) then
          present(ikey)=.true.
!         write (*,'(a,i2,2a)')'present(',ikey,')',keywdup(ikey)
!         write (jout,'(a,i2,a)')'present(',ikey,')'
          goto (110,120,130,140,150,160,170,180,190,200,210,220,
     &       230,240,250,260,270,280,290,300,310,311,320,330) ikey
        endif
        if (ikey.eq.1 .or. ikey.eq.6 .or. ikey.eq.8) then
          write (jout,*)
          write (jout,'(3a)') '******** Fatal error. The data group ',
     &                 keywdup(ikey)(1:il),' is missing. Stop.'
          write (jout,*)
          stop
        endif 
        goto 100
  110   call read_control(jin,jout,errflag(1))
        goto 10
  120   call read_force_field(jin,jout,errflag(2))
        goto 10
  130   if (iruntyp.gt.2) call read_minim(jin,jout,errflag(3))
        goto 10
C 140   if ((iruntyp.eq.1).or.(iruntyp.eq.3) )
  140   if ((iruntyp.ge.1).and.(iruntyp.le.3) )
     &                  call read_enercalc(jin,jout,errflag(4))
        goto 10
  150   if (iruntyp.eq.4) call read_edmc(jin,jout,errflag(5))
        goto 10
  160   continue 
C inputt should be called here!
        call inputt
#ifdef PHCALC
C input of atomic info for IBEM for specific residues 
        call inpresibe
#endif
	call read_seq(jin,jout,errflag(6))
        goto 10
  170   call read_spec(jin,jout,errflag(7))
        goto 10
  180   call read_geom(jin,jout,errflag(8))
        goto 10
  190   call read_bridge(jin,jout,errflag(9))
        goto 10
  200   if (chiscan) call read_scan(jin,jout,errflag(10)) 
        goto 10
  210   call read_windows(jin,jout,errflag(11))
        goto 10
  220   if(iruntyp.eq.5) call read_rms_fit(jin,jout,errflag(12))
        goto 10
  230   call read_grid(jin,jout,errflag(13))
        goto 10
  240   call read_bounds(jin,jout,errflag(14))
        goto 10
  250   call read_atoms_bound(jin,jout,errflag(15))
        goto 10
  260   if (iruntyp.eq.7) call read_vtf(jin,jout,errflag(16))
        goto 10
  270   if (withcnst) then
	  call read_distcons(jin,jout,errflag(17))
!         write (*,*) 'out of read_distcons'
          if (.not. errflag(17)) then
	    call read_Hlab(errflag(17))
!            write (*,*) 'out of read_Hlab'
            if (errflag(17)) write(jout,'(A)') 
     &        'ERROR: problems with read_Hlab'
          endif
          if (.not. errflag(17)) then
	    call read_diehdef(errflag(17))
!            write (*,*) 'out of read_diehdef'
            if (errflag(17)) write(jout,'(A)') 
     &        'ERROR: problems with read_diehdef'
          endif
        endif
        goto 10
  280   continue
        if(regsamp) call read_regions(jin,jout,errflag(18))
        goto 10
  290   continue
C       write(jout,'(a)') 'now  read_Hgrps'
	if(igroupnum.gt.1) call read_hgrps(jin,jout,errflag(19))
        goto 10
  300   if (print.and.(iform.eq.6)) 
     &       call read_watom_select(jin,jout,errflag(20))
        goto 10
  310   call read_omeg(jin,jout,errflag(21))
        goto 10
  311   call read_supat(jin,jout,errflag(22))
        goto 10
#ifdef PHCALC
  320   if(pHs.gt.0.0) 
     &       call read_ibemsims(jin,jout,errflag(23))
#else
  320   write(jout,'(2a)') 
     &   'For pH calulations you should recompile ',
     &   'the program using the correct Make file'   
        errflag(23)=.true.
#endif
        goto 10
  330   call read_ecpztion(jin,jout,errflag(24))
C
C
   10   if (errflag(ikey)) then
          write(jout,111) keywdup(ikey)(1:il)
        else
          write(jout,112) keywdup(ikey)(1:il)
        endif
  100 continue
C
  105 continue
      do ikey=1,maxnumdatag
        if (errflag(ikey)) then
          write (jout,113)
          stop
        endif
      enddo
      write (jout,1010)
 1010 format (/'Input data from the main input file have been read in ',
     & '- no errors detected.'/80(1h*))
      return
  111 format ('Errors detected in data group ',a12,'.')
  112 format ('Normal termination of reading the data group ',a12,'.')
  113 format ('Calculation terminated due to error(s).')
      end 
      character*(*) function ucase(string)
      integer i, k, idiff
      character*(*) string
      character*1 c
      character*40 chtmp
c
      i = len(ucase)
      k = len(string)
      if (i .lt. k) then
         k = i
         if (string(k+1:) .ne. ' ') then
            chtmp = string
         endif
      endif
      idiff = ichar('a') - ichar('A')
      ucase = string
      do 99 i = 1, k
         c = string(i:i)
         if (lge(c,'a') .and. lle(c,'z')) then
            ucase(i:i) = char(ichar(c) - idiff)
         endif
   99 continue
      return
      end
      subroutine read_Hgrps(jin,jout,errflag)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      include 'COMMON.XBOUNDX'
      character*80 line,line1,ucase
      character*20 rname
      logical lcom,blankline,errflag
      character*5 lchara(3)
      integer ival1,ival2
      numbgrp= 0
      ie=1
 10   read (jin,'(a)',end=100) line
!      if (  lcom(1,line(1:1) )  ) goto 10
       if (  lcom(1,line )  ) goto 10
C     write (*,'(a)')  line
      do while (index(ucase(line),'$END').eq.0)
         ipos=1
         blankline=.false.
         errflag=.false.
C read the three first record of the line.
         do k= 1, 3 
            call mykey(line,line1,ipos,blankline,errflag)
            ie=2
            if (errflag) goto 100
            if (.not. blankline .and. .not. errflag) then
               ie=6
               read (line1,'(a3)',end=100,err=100) lchara(k)
            else
               ie=3
               goto 100
            endif
         enddo
C first record is used to indicate the group number.
         ie=4
         read (lchara(1),*,err=100)  igrp
         ie=5
C groupName, name or label used to identify the particular group.
         read (lchara(2),'(a3)',err=100)  groupName(igrp)

C numOfsites, number of H labels under this group.
         ie=6
         read (lchara(3),*,err=100)   inumsit
         numOfsites(igrp)=inumsit

         do l=1, inumsit
C for each group, read two record from the line.
            do k= 1, 2 
               call mykey(line,line1,ipos,blankline,errflag)
               ie=7
               if (errflag) goto 100
               if (.not. blankline .and. .not. errflag) then
                  ie=8
c                 read (line1,'(a3)',end=100,err=100) lchara(k)
                  read (line1,'(a4)',end=100,err=100) lchara(k)
               else
                  ie=9
                  goto 100
               endif
            enddo

C iresNum, no. of protons in group.
            ie=10
            read (lchara(1),*,err=100)  irex
            iresNum(l,igrp) =irex
C atomName, ecepp no. of first proton of the group.
            ie=11
c           read (lchara(2),'(a3)',err=100)  atomName(l,igrp)
            read (lchara(2),'(a4)',err=100)  atomName(l,igrp)
         enddo

C       write(jout,'(i4,2a)') igrp, 'groupName= ', groupName(igrp)
C       write(jout,'(10i4)') (iresNum(l,igrp), l=1,numOfsites(igrp))
C       write(jout,'(10a)') (atomName(l,igrp), l=1,numOfsites(igrp))
   
         numbgrp= numbgrp+1

         ie=12
 20      read (jin,'(a)',end=100) line
!         if (  lcom(1,line(1:1) )  ) goto 20
          if (  lcom(1,line )  ) goto 20
C        write (*,'(a)')  line
C
C End do while loop.
      enddo
      ie=12
      if (numbgrp.ne.igroupNum) then
         write(jout,300) ie, igroupNum
300       FORMAT ( 'ERROR(',i4, ') Number of groups read is not ',i4,
     &    ' as specified by  igroupNum  in DIST_CONST data group.')
      endif

      return
100   write(jout,'(a,i4,a/a/a)') 'ERROR(',ie ,') reading line: ', 
     & line,line1
      stop 88888
      end
      subroutine read_Hlab(errflag)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      include 'COMMON.XBOUNDX'
      include 'COMMON.FILES'
      include 'COMMON.IOUNIT'
      character*80 line,line1
      character*64 fname
      character*20 rname
      logical lcom,blankline,errflag
      character*5 lchara(3)
      integer ival1,ival2,numtot,ilen
      EXTERNAL ILEN

      lenpre=ilen(Hlabelfile)
      fname=Hlabelfile(:lenpre)
      iii=labelH
      write(*,'(a,i2,1x, a)')' opening unit ',iii, fname
#ifdef WINNT
      open (iii,file=fname,status='old',action='read',err=150)
#else
      open (iii,file=fname,status='old',err=150)
#endif

      ie=1
 10   read (labelH,'(a)',end=100) line
C check for comments. If found, omit the line.
!      if (  lcom(1,line(1:1) )  ) goto 10
       if (  lcom(1,line )  ) goto 10
      
C reading total number of residues in data file
      ie=2
      read (line,*,err=100) nres

      do i=1, nres
         ie=3
 20      read (labelH,'(a)',end=100) line
C check for comments. If found, omit the line.
!         if (  lcom(1,line(1:1) )  ) goto 20
         if (  lcom(1,line )  ) goto 20

         ie=4
C        read (line,*,err=100) ires, ival1, ival2, rname
         read (line,*,err=100) ires, ival1, ival2
C     write(jout,'(a,i4)') 'residue= ', ires
         numh(ires)=ival1
         numalth(ires)=ival2
         numtot=ival1+ival2
         do j=1,numtot  
           ie=4
 30        read (labelH,'(a)',end=100) line
!            if (  lcom(1,line(1:1) )  ) goto 30
           if (  lcom(1,line )  ) goto 30
	   ipos=1
           blankline=.false.
           errflag=.false.
C read the three first record of the line.
	   do  k= 1, 3 
             call mykey(line,line1,ipos,blankline,errflag)
             ie=5
             if (errflag) goto 100
             if (.not. blankline .and. .not. errflag) then
               ie=6
c              read (line1,'(a3)',end=100,err=100) lchara(k)
               read (line1,'(a4)',end=100,err=100) lchara(k)
             else
               ie=7
	       goto 100
             endif
           enddo
C first record in this type of file is not used. Should be equal to 
C the index "j".

C nameh, name or label used to identify the particular hydrogen.
           ie=8
c          read (lchara(2),'(a3)',err=100)  nameh(j,ires)
           read (lchara(2),'(a4)',err=100)  nameh(j,ires)

C numgrh, number of groups of H's under the same label.
           ie=9
           read (lchara(3),*,err=100)  numgrh(j,ires)

           do l=1, numgrh(j,ires)
C for each group, read two record from the line.
	      do  k= 1, 2 
                 call mykey(line,line1,ipos,blankline,errflag)
                 ie=10
                 if (errflag) goto 100
                 if (.not. blankline .and. .not. errflag) then
                    ie=11
                    read (line1,'(a3)',end=100,err=100) lchara(k)
                 else
                    ie=12
	            goto 100
                 endif
              enddo

C ihnum, no. of protons in group.
              ie=13
              read (lchara(1),*,err=100)  ihnum(l,j,ires)
C ilock, ecepp no. of first proton of the group.
              ie=14
              read (lchara(2),*,err=100)  ilock(l,j,ires)

C end loop over groups.
           enddo

C        write(jout,'(2a)') 'atom= ', nameh(j,ires)
C        write(jout,'(a,10i4)') nameh(j,ires),numgrh(j,ires),
C    &       (ihnum(l,j,ires), l=1,numgrh(j,ires) ),
C    &       (ilock(l,j,ires), l=1,numgrh(j,ires) )
C end loop over line describing the data for proton.
         enddo

C end loop over residue data file.
      enddo

      close (labelH)
      return
100   write(jout,'(a,i4,a/a/a)') 'ERROR(',ie ,') reading line: ', 
     & line,line1
      errflag=.true.
      return
150   write (*,'(a,i4,/2a)') 'ERR_read_Hlab: can"t open logical unit',
     &      iii, ' file= ', fname
      stop
      end
      subroutine read_fxvol
C Reads atomic parameters for volume solvation.
C DR NOV96
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      include 'COMMON.SOLVAT2'
      include 'COMMON.GEN000'
      include 'COMMON.GEN002X'
      include 'COMMON.GEN004'
      include 'COMMON.CHECK'
      include 'COMMON.FILES'
      include 'COMMON.IOUNIT'
      character*80 line,line1
      character*64 fname
      character*40 rname
      logical lcom,blankline,errflag
      character*20 lchara(4)
      character*3 nameat
      integer ilen
      EXTERNAL ILEN

      lenpre=ilen(fxvolfile)
      fname=fxvolfile(:lenpre)
      write(*,'(a,i2,1x, a)')' opening unit ',iii, fname
#ifdef WINNT
      open (ifxvol,file=fname,status='old',action='read',err=150)
#else
      open (ifxvol,file=fname,status='old',err=150)
#endif

      ie=1
 10   read (ifxvol,'(a)',end=100) line
C check for comments. If found, omit the line.
!      if (  lcom(1,line(1:1) )  ) goto 10
      if (  lcom(1,line )  ) goto 10
      
C reading total number of residues in data file
      ie=2
      read (line,*,err=100) nres, nend
c     write(*,*) 'NRES ',nres,' NEND ',nend
      do i=1, nres
         ie=3
 20      read (ifxvol,'(a)',end=100) line
C check for comments. If found, omit the line.
!         if (  lcom(1,line(1:1) )  ) goto 20
          if (  lcom(1,line )  ) goto 20

         ie=4
C Has to be formated because Residue name may be composed of 
C more than one WORD.
         read (line,'(A20,i5)',err=100)  rname, kindi 
c        write(*,'(a,i4,1x,A40)') 'residue= ', i, rname
c        write(jout,'(a,i4,1x,A40)') 'residue= ', i, rname
         if( kindi.ne. iabs( kndres(i) )  ) then
            write(*,*) 
     &     'Problems with solvation parameters for residue ', rname
            stop 37431
         endif
         do j=1,natoms(i)
           ie=4
 30        read (ifxvol,'(a)',end=100) line
!            if (  lcom(1,line(1:1) )  ) goto 30
           if (  lcom(1,line )  ) goto 30
  	   ipos=1
           blankline=.false.
           errflag=.false.
C read the four first record of the line.
	   do  k= 1, 4 
             call mykey(line,line1,ipos,blankline,errflag)
             ie=5
             if (errflag) goto 100
             if (.not. blankline .and. .not. errflag) then
               ie=6
               read (line1,'(a20)',end=100,err=100) lchara(k)
             else
               ie=7
	       goto 100
             endif
           enddo
C first record in this entry of file is the atom name and it is used 
C to identify the particular atom.
           ie=8
           read (lchara(1),'(a3)',err=100)  nameat
           if (nameat.ne. alpha(j,i)) then
               write(jout,*) 
     &        'Problems with solvation parameters for ',nameat, 
     &        ' in residue ', rname 
               write(*,*) 
     &        'Problems with solvation parameters for ',nameat, 
     &        ' in residue ', rname 
               stop 37432
           endif 
           ie=9
           read (lchara(2),*,err=100) ntyp
           if (ntyp.ne.ntype(j,i) ) then 
c             write(jout,*) 'solvation type is changed for ',nameat,
c    &        ' in residue ', rname 
c             write(*,*) 'solvation type is changed for ',nameat,
c    &        ' in residue ', rname 
              ntype(j,i)= ntyp
           endif
           ie=10
           read (lchara(3),*,err=100) fixvol(j,i) 
           ie=11
           read (lchara(4),*,err=100) redrad(j,i) 


C end loop over line describing the data for one residue.
         enddo

C end loop over residues. 
      enddo
      do i=1, nend
         ie=12
 21      read (ifxvol,'(a)',end=100) line
C check for comments. If found, omit the line.
!         if (  lcom(1,line(1:1) )  ) goto 21
         if (  lcom(1,line )  ) goto 21
         ie=13
         read (line,'(A20,i5)',err=100)  rname, kindi 
c        write(*,'(a,i4,1x,A40)') 'residue= ', i, rname
c        write(jout,'(a,i4,1x,A40)') 'residue= ', i, rname
         if(kindi.ne. iabs( kndend(i) ) ) then
            write(*,*) 
     &     'Problems with solvation parameters for residue ', rname
            stop 37433
         endif
         do j=1,ndatom(i)
           ie=14
 31        read (ifxvol,'(a)',end=100) line
!           if (  lcom(1,line(1:1) )  ) goto 31
           if (  lcom(1,line )  ) goto 31
  	   ipos=1
           blankline=.false.
           errflag=.false.
C read the four first record of the line.
	   do  k= 1, 4 
             call mykey(line,line1,ipos,blankline,errflag)
             ie=15
             if (errflag) goto 100
             if (.not. blankline .and. .not. errflag) then
               ie=16
               read (line1,'(a20)',end=100,err=100) lchara(k)
             else
               ie=17
	       goto 100
             endif
           enddo
C first record in this entry of file is the atom name and it is used 
C to identify the particular atom.
           ie=18
           read (lchara(1),'(a3)',err=100)  nameat
           if (nameat.ne. ealpha(j,i)) then
               write(jout,*) 
     &        'Problems with solvation parameters for ',nameat, 
     &        ' in residue ', rname 
               write(*,*) 
     &        'Problems with solvation parameters for ',nameat, 
     &        ' in residue ', rname 
               stop 37434
           endif 
           ie=19
           read (lchara(2),*,err=100) ntyp
           if (ntyp.ne.netype(j,i) ) then 
c             write(jout,*) 'solvation type is changed for ',nameat,
c    &        ' in residue ', rname 
c             write(*,*) 'solvation type is changed for ',nameat,
c    &        ' in residue ', rname 
              netype(j,i)= ntyp
           endif
           ie=20
           read (lchara(3),*,err=100) dfixvol(j,i) 
           ie=21
           read (lchara(4),*,err=100) dredrad(j,i) 


C end loop over line describing the data for one end group.
         enddo

C end loop over end groups.
      enddo

      close (ifxvol)
      return
100   write(jout,'(a,i4,a/a/a)') 'ERROR(',ie ,') reading line: ', 
     & line,line1
C      errflag=.true.
      stop 44344
150   write (*,'(a,i4,/2a)') 'ERR_Openunits: can"t open logical unit',
     &      iii, ' file= ', fname
      stop
      end

      subroutine read_diehdef(errflag)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      include 'COMMON.XBOUNDX'
      include 'COMMON.FILES'
      include 'COMMON.IOUNIT'
      character*80 line,line1
      character*64 fname
      character*20 rname
      logical lcom,blankline,errflag
      character*5 lchara(10)
      external ilen
      integer ival1,ival2

      lenpre=ilen(dihdefile)
      fname=dihdefile(:lenpre)
      
      iii=99
      write(*,'(a,i2,1x, a)')' opening unit ',iii, fname
#ifdef WINNT
      open (iii,file=fname,status='old',action='read',err=150)
#else
      open (iii,file=fname,status='old',err=150)
#endif

      ie=1
 10   read (iii,'(a)',end=100) line
C check for comments. If found, omit the line.
!     if (  lcom(1,line(1:1) )  ) goto 10
      if (  lcom(1,line )  ) goto 10
      
C reading total number of residues in data file
      ie=2
      read (line,*,err=100) nres

      do i=1, nres
         ie=3
 20      read (iii,'(a)',end=100) line
C check for comments. If found, omit the line.
!         if (  lcom(1,line(1:1) )  ) goto 20
         if (  lcom(1,line )  ) goto 20

         ie=4
         read (line,*,err=100) ires, ival1
C     write(jout,'(a,i4)') 'residue= ', ires
         numbdih(ires)=ival1
         do j=1,numbdih(ires)  
           ie=4
 30        read (iii,'(a)',end=100) line
!            if (  lcom(1,line(1:1) )  ) goto 30
           if (  lcom(1,line )  ) goto 30
	   ipos=1
           blankline=.false.
           errflag=.false.
C read the  first  nine record of the line.
	   do  k= 1, 9 
             call mykey(line,line1,ipos,blankline,errflag)
             ie=5
             if (errflag) goto 100
             if (.not. blankline .and. .not. errflag) then
               ie=6
C              read (line1,'(a3)',end=100,err=100) lchara(k)
               read (line1,'(a5)',end=100,err=100) lchara(k)
             else
               ie=7
	       goto 100
             endif
           enddo

C Each dihedral angle is defined by 4 atoms that may belong to different residues.
C jdihres, identifies the particular residue to which the atom belongs.
C  dihatm, identifies the particular atom 
           do k=1,4
              read (lchara(2*k-1),*,err=100)  jdihres(k,j,ires)
C             read (lchara(2*k),'(a3)',err=100)  dihatm(k,j,ires)
              read (lchara(2*k),'(a4)',err=100)  dihatm(k,j,ires)
           enddo

C
C          read (lchara(9),*,err=100)  jdihecp(j,ires)
C jdihecp is not necessary since we are defining the dihedral angle in the
C correct order.


C end loop over the dihedral angles for a particular residue.
         enddo

C end loop over list od residues. 
      enddo

      close (iii)
      return
100   write(jout,'(a,i4,a/a/a)') 'ERROR(',ie ,') reading line: ', 
     & line,line1
      errflag=.true.
      return
150   write (*,'(a,i4,/2a)')'ERR_read_diehdef: can"t open logical unit',
     &      iii, ' file= ', fname
      stop
      end

#ifdef PHCALC
      subroutine read_ibemsims(jin,jout,errflag)

*  Written by D. Ripoll                             MAR-97
*  Number of keywords in this data group
      parameter (nkwd=19)
      parameter (errind=-1.0D10)
      character*16 keywdset(1:nkwd,0:nkwd) /
     & 'PROBE_RADIUS', 'DOT_DENSITY_H', 'DOT_DENSITY_L','DOT_SURFACE', 
     & 'DOT_FILE', 'PDB_SURFACE', 'DETAIL_OUTPUT', 
     & 'EPS_SOL', 'EPS_MOL', 'RRLOCK', 'RRINTERM', 'NITER_MAX', 
     &  'DELTA_SIGMA', 'LINMETH', 'RRLOCK_EN', 'ICHARATOM', 
     &  'ICHARGROUP', 'IONECENTR', 'POTENTIAL_GRID',
     & 'NUM',18*' ',
     & 'NUM',18*' ',
     & 'NUM',18*' ',
     & 19*' ',
     & 19*' ',
     & 19*' ',
     & 'NUM',18*' ',
     & 'NUM',18*' ',
     & 'NUM',18*' ',
     & 'NUM',18*' ',
     & 'NUM',18*' ',
     & 'NUM',18*' ',
     & 'NUM',18*' ',
     & 'CHAR',18*' ',
     & 'NUM',18*' ',
     & 'NUM',18*' ',
     & 'NUM',18*' ',
     & 'NUM',18*' ',
     & 19*' '/
      integer narg(0:nkwd) /19,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0/
      dimension flag(0:nkwd)
      character*16 cflag(0:nkwd)
      logical errflag
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      include 'param.ibems'
      include 'comm.ibems'
      include 'comm.ibemsav'
      include 'COMMON.EXTPH'

      call read_data_group(jin,jout,nkwd,keywdset,narg,flag,cflag)
      errflag=.false.
      do i=0,nkwd
        if (flag(i).eq.errind) errflag=.true.
      enddo
C   'PROBE_RADIUS',
C  Default Probe radius 
      rp_rpr=1.4d0
      if (flag(1).gt.0.0) then
        rp_rpr=flag(1)
        write(jout,*)'rp_rpr=',rp_rpr
      endif

C   'DOT_DENSITY_H',
C  Default Dot density 
      dotden_h=5.0d0
      if (flag(2).gt.0.0) then
        dotden_h=flag(2)
        write(jout,*)'dotden_h=',dotden_h
      endif


C   'DOT_DENSITY_L',
C  Default Dot density 
      dotden_l=1.0d0
      if (flag(3).gt.0.0)  then
         dotden_l=flag(3)
        write(jout,*)'dotden_l=',dotden_l
      endif


C   'DOT_SURFACE', 
C Create SIMS_dot.sgi and SIMS_mol.pdb files
      OPT_dot_surface=(flag(4).gt.0.0)

C  'DOT_FILE', 
C Create SIMS_dot.xyz file
      OPT_dot_file=(flag(5).gt.0.0)

C  'PDB_SURFACE',
C Create SIMS_mol.pdb file
      OPT_pdb_surface=(flag(6).gt.0.0)

C   'DETAIL_OUTPUT', 
C outdetail level default=regular
      outdetl= -1
      if (flag(7).gt.0.0) then
         outdetl=aint(flag(7))-1
        write(jout,*)'outdetl=',outdetl
      endif


C   'EPS_SOL',
C Value of the dielectric constant of the solvent
      epssol=80.0D0
      if (flag(8).gt.0.0) then
         epssol=flag(8)
      endif
      write(jout,*)'epssol=',epssol

      epssol_sav=epssol

C   'EPS_MOL',
C Value of the dielectric constant of the molecule interior
      epsmol=2.0D0
      if (flag(9).gt.0.0) then
         epsmol=flag(9)
      endif
      write(jout,*)'epsmol=',epsmol

      epsmol_sav=epsmol

C   'RRLOCK',
      rrlock=5.000D0
      if (flag(10).gt.0.0) then
         rrlock=flag(10)
      endif
      write(jout,*)'rrlock=',rrlock


C   'RRINTERM',
      rrinterm=8.0000D0
      if (flag(11).gt.0.0) then
         rrinterm=flag(11)
      endif
         write(jout,*)'rrinterm=',rrinterm


C   'NITER_MAX', 
      niter_mx=50
      if (flag(12).gt.0.0) then
         niter_mx=aint(flag(12))
      endif
         write(jout,*)'niter_mx=',niter_mx

C   'DELTA_SIGMA',
      delta_sigma= 0.0001D0
      if (flag(13).gt.0.0) then
         delta_sigma=flag(13)
      endif
         write(jout,*)'delta_sigma=',delta_sigma

C   'LINMETH',
      linmeth='BCG'
      if (flag(14).gt.0.0)  then
         linmeth=cflag(14)
      endif
         write(jout,*)'linmeth=',linmeth


C   'RRLOCK_EN',
      rrlock_en=10.0D0
      if (flag(15).gt.0.0) then
        rrlock_en=flag(15)
      endif
         write(jout,*)'rrlock_en=',rrlock_en


C   'ICHARATOM', 
      icharatom=0
      if (flag(16).gt.0.0) then
         icharatom=aint(flag(16))
      endif
         write(jout,*)'icharatom=',icharatom


C   'ICHARGROUP',
      ichargroup=1
      if (flag(17).gt.0.0) then
         ichargroup=aint(flag(17))
      endif
         write(jout,*)'ichargroup=',ichargroup

      ichargroup_sav=ichargroup

C   'IONECENTR',
      ionecentr=1
      if (flag(18).gt.0.0) then
         ionecentr=aint(flag(18))
      endif
         write(jout,*)'ionecentr=',ionecentr

      ionecentr_sav=ionecentr

C DR APR99
C write Yury's potential ' a la Delphi'
       opt_potential=(flag(19).gt.0.0)

      return
      end
#endif
