c.. calculation of total free energy for given molecule

        subroutine solv_freng(irg,nsoord,soord,rad_ps,atmq_ps,
     &                      sol_freng,el_freng,hp_freng)         

#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
	include'param.ibems'
	include'comm.ibems'
	include'ecepp_ibems_intrf.h'
        include 'COMMON.MYCONF'
        include 'COMMON.SOLVAT'
c*
        real*8 soord(3,maxat),rad_ps(maxat),atmq_ps(maxat)
        integer nsoord,irg

        integer ivarc,nlev0,nlev1,nlev2
        real*8 sigmalev0(nsmalsemx_t),sigmalev1(nlargsemx_t)
        real*8 sigmalev2(maxat),epsout,epsin

        real*8 en_cl,en_sl,en_frt
        real*8 el_freng,hp_freng,sol_freng
        real*8 gama_a,gama_b,en_frtot
        real*8 area_mol
	real*8 rp,ssacces,cxyzlargsel(3,nlargsemx_t),
     &     vnlargsel(3,nlargsemx_t),arealargsel(nlargsemx_t)
        integer nlargsel,ia,k,i,index
        integer dot_IATNUMS(nsmalsemx_t),dot_ISHAPES(nsmalsemx_t)
        integer dot_IATNUML(nlargsemx_t),dot_ISHAPEL(nlargsemx_t)
 
        if(irg.eq.0)then      
c.........................................................................
           call precal01(nsoord,soord,rad_ps,atmq_ps)

c.. compute high density boundary elements	
           nat=nsoord
	   rp=rp_rpr
           if(outdetl.gt.1)then
              index=1
      	      call timit(index)
C              write(kanalp,*)'calling MSEED from solv_ibems'
           end if

           if (use_mseed) then
              call mseed(soord,rad_ps,2.0d0*rp,nat,dotden_h,
     &         cxyzsmalse_t,vnsmalse_t,areasmalse_t,nsmalse_t)
           else
              ikount=ikount+1
	      call surf_sims(soord, rad_ps,nat,2.0d0*rp,dotden_h,
     &         cxyzsmalse_t,vnsmalse_t,areasmalse_t,
     &         dot_IATNUMS,dot_ISHAPES, nsmalse_t)
           endif

           if (kprotfail.le.-1) return
           area_mol=0.0D0
           do i=1,nsmalse_t
               area_mol=area_mol+areasmalse_t(i)
           enddo
C          write(*,*)'solv_freng: area_mol nsmalse_t', area_mol,nsmalse_t
C          write(*,*)'areasmalse_t'
C          write(*,*)(areasmalse_t(i),i=1,10)

c.......................................................................
c.. compute low  density boundary elements	

           if(outdetl.gt.1)then
               index=1
	       call timit(index)
c              write(kanalp,*)'calling MSEED from solv_ibems'
           end if

           rp=rp_rpr
           if (use_mseed) then
               call mseed(soord,rad_ps,2.0d0*rp,nat,dotden_l,
     &          cxyzlargse_t,vnlargse_t,arealargse_t,nlargse_t)
           else
               ikount=ikount+1
               call surf_sims(soord, rad_ps,nat,2.0d0*rp,dotden_l,
     &          cxyzlargse_t,vnlargse_t,arealargse_t,
     &          dot_IATNUMS,dot_ISHAPES, nlargse_t)

           endif
     
c          write(*,*)'solv_freng: nlargse_t', nlargse_t
c          write(*,*)'arealargse_t'
c          write(*,*)(arealargse_t(i),i=1,10)
           if (kprotfail.le.-1) return

           if(outdetl.gt.1)then
              index=1
	      call timit(index)
c       write(kanalp,*)' finish MSEED low density Surface '
           end if
c.......................................................................

           call connect_ha(nsoord,soord,rad_ps)
           if (kprotfail.le.-1) return
           if(outdetl.gt.1)then
              index=1
	      call timit(index)
c             write(kanalp,*)'connect_ha: finish'
           end if

           call connect_la(nsoord,soord,rad_ps)
           if (kprotfail.le.-1) return
           if(outdetl.gt.1)then
              index=1
	      call timit(index)
c             write(kanalp,*)'connect_la: finish'
           end if

           call connect_lh
           if (kprotfail.le.-1) return
           if(outdetl.gt.1)then
              index=1
	      call timit(index)
c             write(kanalp,*)'connect_lh: finish'
           end if
        
c   KKK_sp matrix       
           call sp_KKK
           if (kprotfail.le.-1) return

        end if ! irg=0
 
        hp_freng= 0.d0 
c-----------------------------------------------------------------
        if(irg.eq.-1)then
c. hydrophobic solvation energy 
           gama_a=0.005d0   ! kcal/ang*2
           gama_b=0.86d0    ! J.Phys.Ch.(1994)V.98,p.1978-1988;B.Honig
           ssacces=0.d0
           if (use_mseed) then
c. need calculation of the solvent accesseable surface area
c. rad_ps are extended by water radius rp_rpr
              rp=rp_rpr
              nat=nsoord

              do i=1,nat
                 rad_ps(i)=rad_ps(i)+rp_rpr
              end do

              call mseed(soord,rad_ps,2.0d0*rp,nat,dotden_l,
     &             cxyzlargsel,vnlargsel,arealargsel,nlargsel)
              do i=1,nlargsel
                 ssacces=ssacces+arealargsel(i)
              end do
              if (kprotfail.le.-1) return
           else
C for SIMS DR MAR97 
              ssacces=area_mol
c             write(*,*)'solv_freng: ssacces(area_mol)', ssacces

              call surf_sims(soord,
     &           rad_ps,nat,2.0d0*rp,dotden_l,
     &           cxyzlargsel,vnlargsel,arealargsel,
     &           dot_IATNUML,dot_ISHAPEL,
     &           nlargsel)

              ssacces=0.d0
              do i=1,nlargsel
                 ssacces=ssacces+arealargsel(i)
              end do

           endif

           hp_freng= ssacces*gama_a+gama_b

           if(outdetl.ge.1)then
              write(*,*)'solv_freng:'
              write(*,*)'Solvent accessible surface(A**2)=',ssacces
              write(*,*)'Cavity creation free en=',hp_freng
           end if

           do i=1,nat
              rad_ps(i)=rad_ps(i)-rp_rpr
           end do
        end if ! irg = -1
c..................................................................

c define list of charged atoms and their geom centr
1010    n_iona=0
        do k=1,3
           xyzonecent(k)=0.0d0
        end do
c      write(*,*) 'solv_freng'
        do ia=1,nsoord
           if(atmq_ps(ia).ne.0.0d0)then
              n_iona=n_iona+1
              iona_list(n_iona)=ia
c        write(*,*) 'iona_list(',n_iona ,')=',iona_list(n_iona)

              do k=1,3
                 xyzonecent(k)=xyzonecent(k)+soord(k,ia)
              end do
           end if !
        end do ! ia

        if(n_iona.ge.1)then
           do k=1,3
              xyzonecent(k)=xyzonecent(k)/float(n_iona)
           end do
        end if
        if(outdetl.gt.1)then
c          write(kanalp,*)'solv_freng:xyzonecent=',xyzonecent 
           write(*,*)'solv_freng:xyzonecent=',xyzonecent 
        end if
c.
c solvation energy
c
         
        if(outdetl.gt.1)then
           index=1
	   call timit(index)
c          write(kanalp,*)'Start : IBEMS induced charge density'
        end if

        call sigma_ibem(soord,rad_ps,atmq_ps)
        if (kprotfail.le.-1) return

        if(outdetl.gt.1)then
           index=1
           call timit(index)
c          write(kanalp,*)'FINISH: IBEMS charge density'
        end if
c.
c        call ssolv_en(nsoord,soord,atmq_ps,en_cl,en_sl,en_frt)
        ivarc=0
   	call ssolv_en(nsoord,soord,atmq_ps,en_cl,en_sl,en_frt,       
     &     ivarc,nlev0,sigmalev0,nlev1,sigmalev1,nlev2,sigmalev2,
     &     epsout,epsin)
        if (kprotfail.le.-1) return
        
        if(outdetl.gt.1)then
           index=1
           call timit(index)
c          write(kanalp,*)' Finish solvation energy'
        end if
c..
        sol_freng=en_sl
        el_freng=en_frt
        en_frtot=en_frt+hp_freng

        if(outdetl.ge.1)then
           write(*,*)'solv_freng:RESULT :'
           write(*,*)'solv_ibems: en_coul=',en_cl
           write(*,*)' solv_en(rect. fld)=',en_sl
           write(*,*)'elect_freng_tot    =',en_frt
           write(*,*)'cavity creat energy=',hp_freng
           write(*,*)'total free en(cl+sl+cv)=',en_frtot
        end if
      
c...............................................................
       
        return
        end
