c.. double precision

	subroutine sp_KKK
c define KKK matrix over surface pieces in global numeration
c.                                                of spieces

#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
	include'param.ibems'
	include'comm.ibems'
        include 'COMMON.TIME1'
        include 'COMMON.ODONNELL'

c*	
        real*8 sn,sd,sd1,sd2,ss,ss1,ss2,ss3
        real*8 rst_min,ddn,rst_min2,rsts_min2
        integer lt,ltg,nslg,ntlg,ls,isg,isf,ip,nlgse
        integer is,it,isl,itl,nssg,ntsg,islg,itlg,lsg,itg,k
         integer iiprint1,ndisref_dd
        real*8 vKKst,vKKts

        iiprint1=1
        ndisref_dd=0

c.  upper bound for matrix elements
c   rst_min - min distance between two sm. se
         ddn=ddn_par 
         rst_min2=1.0d0/(ddn*dotden_l)
         rsts_min2=1.0d0/(ddn*dotden_h)
c
c. KKK_sp over surface pieces   - global 
c
         do is=1,npc_mx
         do it=1,npc_mx
          KKK_sp(it,is)=0.d0
         end do
         end do
c
         do is=1,nsurfp_t

c.......diag.......
         ip=is
         KKK_sp(ip,ip)=0.d0
c.define the number of large se
         nlgse=nsurfp_lg(ip)

         do isl=1,nlgse  
         do itl=isl,nlgse
c. KKK_ll is calculated taking into account curvature of large se
c. define global numbers of large se
         islg=lsurfp_ilg(isl,ip)
         itlg=lsurfp_ilg(itl,ip)
 
         call s_KKll(islg,itlg,ndisref_dd,vKKts,vKKst)

         if(islg.eq.itlg)then
         KKK_ll(islg)=0.d0
         vKKst=0.d0
         if(arealargse_t(islg).ne.0.d0)then
c. diagonal KKK lg se islg
         KKK_ll(islg)=vKKts
         end if
         end if

c. define matrix KKK_sp
         KKK_sp(ip,ip)=KKK_sp(ip,ip)+vKKts*arealargse_t(islg)
     &                             + vKKst*arealargse_t(itlg)
         end do ! itl
         end do ! isl

         KKK_sp(ip,ip)=KKK_sp(ip,ip)/surfp_s(ip)

c.......offf diag...

         do it=is+1,nsurfp_t

c. define collection of  large se
         nslg=nsurfp_lg(is)
         ntlg=nsurfp_lg(it)
         do ls=1,nslg
c. define glob numb
         lsg=lsurfp_ilg(ls,is)
         do lt=1,ntlg
c. define glob numb
         ltg=lsurfp_ilg(lt,it)

         if(ltg.eq.lsg)then
         write(*,*)'KKK_sp ERROR102'
         goto 102
         end if ! 

         call s_KKll(lsg,ltg,ndisref_dd,vKKts,vKKst)

         KKK_sp(it,is)=KKK_sp(it,is)+vKKts*arealargse_t(lsg)
         KKK_sp(is,it)=KKK_sp(is,it)+vKKst*arealargse_t(ltg)

102      end do !lt
         end do !ls


c. define matrix KKK_sp
         KKK_sp(it,is)=KKK_sp(it,is)/surfp_s(is)  
          KKK_sp(is,it)=KKK_sp(is,it)/surfp_s(it)


         end do ! it
         end do ! is
c.................................................................... 
c.. control
         ss=0.d0
         ss1=0.d0
         do it=1,nsurfp_t
         ss2=0.d0
         ss=ss+surfp_s(it)
         if(surfp_s(it).lt.0.1d-10)then
         write(*,*)'sp_KKK: spie low=', surfp_s(it)
         end if

         do is=1,nsurfp_t
         ss2=ss2+KKK_sp(it,is)*surfp_s(is)/surfp_s(it)
         end do! is

c...KKK_sp   normalization 
       ss3=pi*2.0d0/ss2   ! normalization coeff
        if(outdetl.ge.iiprint1)then
        write(*,*)'sp_KKK: norm coeff(on 2pi)=',ss3, 'it=',it !c
c      write(kanalp,*)'sp_KKK: norm coeff(on 2pi)=',ss3, 'it=',it !c
         end if
         do is=1,nsurfp_t
         KKK_sp(it,is)=KKK_sp(it,is)*ss3  
         end do! is

        ss2=0.d0
        do is=1,nsurfp_t
         ss2=ss2+KKK_sp(it,is)*surfp_s(is)/surfp_s(it)
         ss1=ss1+KKK_sp(it,is)*surfp_s(is)
        end do ! is

        end do ! it

       if(outdetl.ge.iiprint1)then
c      write(kanalp,*)'sp_KKK: refined dist=',ndisref_dd
c      write(kanalp,*)'sp_KKK: control KKK_sp(*,*)=',ss1
c      write(kanalp,*)'       expected KKK_sp(*,*)=',2.*pi*ss,'ss=',ss
       write(*,*)'sp_KKK: refined dist=',ndisref_dd
       write(*,*)'sp_KKK: control KKK_sp(*,*)=',ss1
       write(*,*)'       expected KKK_sp(*,*)=',2.*pi*ss,'ss=',ss
       end if

c................................................................
         return
         end
