c.. double precision
c.. three level of surf: loc, interm, dist

	subroutine surf_loc01(iii,soord)
c define local surface - collection of small se 
c         large se and surface pieces
c for given charged atom iii or charged group 
c REGULAR version of apr.18
c assignment are based on comparision of centerI - surf ps dist
c

#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
	include'param.ibems'
	include'comm.ibems'
        include 'COMMON.MYCONF'
        real*8 soord(3,maxat)
c*	
        real*8 sd,sd1,sd2,sn,snl,snd,ss,ssl,ssd,sum,ssi,aanr
        real*8 xyz(3),rrlock2,rrintr2
        integer ns,nlarg,nsg,nlg,nl,nsmal,iil,iii,iatom,ip,k
        integer iiprint0,iiprint1

	iiprint1=1
	iiprint0=0
c
c radius of local surf
        rrlock2=rrlock*rrlock
c           intermediate surf
        rrintr2=rrinterm*rrinterm

C	write(*,*)'start surf_loc with rrlock2=', rrlock2
c        index=1
c        call timit(index) 

c  number of central atom =iatom
          iil=iii
        if(icharatom.eq.1)then
        iatom=iona_list(iil)
C        write(*,*)'surf_loc: option=charged atoms: atom',iatom      
c        write(kanalp,*)'surf_loc: option=charged atoms: atom',iatom      
        do k=1,3
        xyz(k)=soord(k,iatom)
        end do
        end if
  
        if(ichargroup.ge.1)then
        iatom=jchargr_xyz(iil)
c        write(*,*)'surf_loc: option=charged grps:centr at',iatom      
c        write(kanalp,*)'surf_loc: option=charged grps:centr at',iatom      
        do k=1,3
        xyz(k)=soord(k,iatom)
        end do
        end if

        if(ionecentr.eq.1)then
        do k=1,3
        xyz(k)=xyzonecent(k)
         end do
C        write(*,*)'surf_loc: option=ionecentr',(xyz(k),k=1,3)      
         end if

c.search for surface piece number
c.search for surface piece number
         nsmal_loc=0
         nlarg_loc=0
         nlarg_int=0
         nlarg_dis=0
         npiece_dist=0
         npiece_loc=0
         npiece_int=0
         ssl=0.d0
         ssi=0.d0
         ssd=0.d0
c...........................................................
c.  main    loop 
c...........................................................
C       write(*,*)'surf_loc: nsurfp_t=', nsurfp_t
        do 100 ip=1,nsurfp_t
        sd2=0.d0
        do k=1,3
         sd2=sd2+(xyz(k)-surfp_xyz(k,ip))**2
         end do
c.......................................................
         if(sd2.le.rrlock2)then 
c. piece ip included in local surface
c         write(kanalp,*)'surf_loc: piecee ip=',ip,' in local surf'

         npiece_loc=npiece_loc+1
         lsp_loc(npiece_loc)=ip
         nsmal=nsurfp_sm(ip)
         nlarg=nsurfp_lg(ip)

c         write(kanalp,*)'surf_loc: piece ip=',ip, 'consist of nsmal=',
c     &   nsmal, ' and nlarg=',nlarg

c         write(*,*)'surf_loc: piece ip=',ip, 'consist of nsmal=',
c     &   nsmal, ' and nlarg=',nlarg

c.. local surf of small se
         do ns=1,nsmal
         nsmal_loc=nsmal_loc+1
         if(nsmal_loc.gt.nsmallocmx)then
         write(*,*)'in surf_loc_na nsmallocmx is too small=',
     &   nsmallocmx, ' nsmal_loc= ', nsmal_loc
         kprotfail=-170
         return
c        stop
         end if
c.nsg global number of small s.e.
         nsg=lsurfp_ism(ns,ip)
         do k=1,3
         sm_locxyz(k,nsmal_loc)=cxyzsmalse_t(k,nsg)
         sm_locvn(k,nsmal_loc)=vnsmalse_t(k,nsg)
         end do ! k
         sm_locarea(nsmal_loc)=areasmalse_t(nsg)
         ssl=ssl+sm_locarea(nsmal_loc)
         lgsm_loc(nsmal_loc)=nsg
         sm_locq(nsmal_loc)=0.d0

c....         write(kanalp,*)'surf_loc: piece ip include nsg of se=',nsg

         end do ! ns

C         write(*,*)'surf_loc: npiece_loc=',npiece_loc
C         write(*,*)'          nsmal_loc=',nsmal_loc 
C         write(*,*)'          area_loc=',ssl
         SS_loc=ssl

c. local surface of large se
         do nl=1,nlarg
         nlarg_loc=nlarg_loc+1
         if(nlarg_loc.gt.nlarglocmx)then
         write(*,*)'in surf_loc01, nlarglocmx is too small=',
     &   nlarglocmx, ' nlarg_loc= ', nlarg
         kprotfail=-171
         return
c        stop
         end if
c.nsg global number of large s.e.
         nlg=lsurfp_ilg(nl,ip)
         do k=1,3
         lg_locxyz(k,nlarg_loc)=cxyzlargse_t(k,nlg)
         lg_locvn(k,nlarg_loc)=vnlargse_t(k,nlg)
         end do ! k
         lg_locarea(nlarg_loc)=arealargse_t(nlg)
         lglg_loc(nlarg_loc)=nlg
         lg_locq(nlarg_loc)=0.d0

         end do ! nl

c         write(*,*)'surf_loc: nlarg_loc=',nlarg_loc 
c         write(*,*)'surf_loc: npiece_loc=',npiece_loc 
c         write(kanalp,*)'surf_loc: nlarg_loc=',nlarg_loc 
c         write(kanalp,*)'surf_loc: npiece_loc=',npiece_loc 

         end if !sd2
c...........................................................
c.intermediate surface
c.......................................................
         if(sd2.gt.rrlock2.and.sd2.le.rrintr2)then 
c. piece ip included in interm surface
c         write(kanalp,*)'surf_loc(in): piecee ip=',ip,' in intermsurf'

         npiece_int=npiece_int+1
         lsp_int(npiece_int)=ip
         nlarg=nsurfp_lg(ip)

c         write(kanalp,*)'surf_loc(in):interm piece ip=',ip, 
c     &   'consist of  nlarg=',nlarg

c. interm surface of large se
         do nl=1,nlarg
         nlarg_int=nlarg_int+1
         if(nlarg_int.gt.nlargintmx)then
         write(*,*)'in surf_int_na nlargintmx is too small=',         
     &   nlargintmx
c        write(kanalp,*)'in surf_int_na nlargintmx is too small=',         
c    &   nlargintmx
         kprotfail=-172
         return
c        stop
         end if
c.nsg global number of large s.e.
         nlg=lsurfp_ilg(nl,ip)

         do k=1,3
         lg_intxyz(k,nlarg_int)=cxyzlargse_t(k,nlg)
         lg_intvn(k,nlarg_int)=vnlargse_t(k,nlg)
         end do ! k

         lg_intarea(nlarg_int)=arealargse_t(nlg)
         ssi=ssi+lg_intarea(nlarg_int)
         lglg_int(nlarg_int)=nlg
         lg_intq(nlarg_int)=0.d0

         end do ! nl
         SS_int=ssi
c         write(*,*)'surf_loc(in): nlarg_int=',nlarg_int,
c    &   'SS_int=',SS_int 
c         write(kanalp,*)'surf_loc(in): nlarg_int=',nlarg_int,
c     &   'SS_int=',SS_int 

         end if !sd2 interm
c...........................................................
c..............................................................
         if(sd2.gt.rrintr2)then
c. distant surface 
c. a) distant surface pieces

         npiece_dist=npiece_dist+1

         if(npiece_dist.gt.maxat)then
         write(*,*)'in surf_loc_na maxat is too small=',
     &   maxat
         kprotfail=-173
         return
c        stop
         end if

         lsp_dist(npiece_dist)=ip
c..lsp_dist(np)=global ip number of element np in the current collection
c.                                                 of distant surf pieces
         ssd=ssd+surfp_s(ip)
c         write(kanalp,*)'surf_loc: npiece_dist=',npiece_dist
c         write(kanalp,*)'          total loc+dist area=',ssd
         SS_dis=ssd

c.. b) distant surface of large se
      
         nlarg=nsurfp_lg(ip)
         do nl=1,nlarg
         nlarg_dis=nlarg_dis+1
         if(nlarg_dis.gt.nlargdismx)then
         write(*,*)'in surf_loc_na nlargdismx is too small=',
     &   nlargdismx
         kprotfail=-174
         return
c        stop
         end if

c.nsg global number of large s.e.
         nlg=lsurfp_ilg(nl,ip)
         do k=1,3
         lg_disxyz(k,nlarg_dis)=cxyzlargse_t(k,nlg)
         lg_disvn(k,nlarg_dis)=vnlargse_t(k,nlg)
         end do ! k
         lg_disarea(nlarg_dis)=arealargse_t(nlg)
         lg_disq(nlarg_dis)=0.d0

         end do ! nl

c         write(*,*)'surf_loc: nlarg_dis=',nlarg_dis 
c         write(kanalp,*)'surf_loc: nlarg_dis=',nlarg_dis 


          end if ! dist
c.................................................................
100      continue
c..................................................................
c
c         if(outdetl.ge.iiprint1)then
c         write(kanalp,*)'surf_loc: nsmal_loc(local se)=',nsmal_loc
c         write(kanalp,*)'npiece_loc=',npiece_loc,'ss_loc=',SS_loc 
c         write(kanalp,*)'npiece_int=',npiece_int, 'ss_intr=',SS_int
c         write(kanalp,*)'npiece_dist=',npiece_dist, 'ss_dist=',SS_dis
c         ss=SS_loc+SS_int+SS_dis
c         write(kanalp,*)'surf_loc: cont of Tot area(loc+int+dis)=',ss
c        end if
         
         if(outdetl.ge.iiprint1)then
         write(*,*)'surf_loc: nsmal_loc(local se)=',nsmal_loc
         write(*,*)'npiece_loc=',npiece_loc,'ss_loc=',SS_loc 
         write(*,*)'npiece_int=',npiece_int, 'ss_intr=',SS_int
         write(*,*)'npiece_dist=',npiece_dist, 'ss_dist=',SS_dis
         ss=SS_loc+SS_int+SS_dis
         write(*,*)'surf_loc: cont of Tot area(loc+int+dis)=',ss
         end if

c        index=1
c        call timit(index) 
c
c        write(kanalp,*)'surf_loc: local K matrix start'
c.........................................................................
         
          return
          end
