c  March18
c.. double precision
c.. three level of surf: loc, interm, dist

	subroutine surf_loc02(iii,soord)
c define local surface - collection of small se 
c         large se and surface pieces
c for given charged atom iii or charged group 

#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
	include'param.ibems'
	include'comm.ibems'
        include 'COMMON.MYCONF'
        real*8 soord(3,maxat)
        integer iii
c*	
        real*8 sd,sd1,sd2,sn,ss,sss,sum,ssi,aanr
        real*8 ss2,ss1,sn1,sn2,sd3,ssls,sslt
        real*8 sn3,sn4
        real*8 xyz(3),aa,bb,cc,rlockl2
        real*8 rst_min,aKK_mx,ddn,rst_min2,rat_av,sinv
        real*8 aa1,aa2,ff,vKKts,vKKst
        real*8 conv_crit1(nvect_uvmx)
        real*8 conv_crit2(nvect_uvmx)
        integer index,k,ndistref_ii,ndistref_ll,ndistref_li
        integer it,is,iv,nd,nl,il,nlg,nlarg,isl,ipg,ip,nnn
        integer isp,ndistref_di,nnli,itp,ls,islg,itlg,itl
        integer nssg,itg,ntsg,isg,itpg,ism,ispg,nslg
        integer iiprint1,iiprint2
        integer iiprint0
c
	 iiprint0=0
         iiprint1=1
         iiprint2=2
c.  MATRIX  
c defenition of Unified vector: local + interm + distant
         do is=1,nvect_uvmx
         area_uv(is)=0.d0
         end do

         nvect_uv=0
          ss=0.0d0
         if(nsmal_loc.gt.0)then
         do is=1,nsmal_loc
         area_uv(is)=sm_locarea(is)
         ss=ss+area_uv(is)
         end do !is
         nvect_uv=nsmal_loc
         end if

         if(nlarg_int.gt.0)then
         do nl=1,nlarg_int
         area_uv(nl+nvect_uv)=lg_intarea(nl)
         ss=ss+area_uv(nl+nvect_uv)
         end do
         nvect_uv=nvect_uv+nlarg_int
         end if

         if(npiece_dist.gt.0)then
         do nd=1,npiece_dist
         area_uv(nd+nvect_uv)=surfp_s(lsp_dist(nd))
         ss=ss+area_uv(nd+nvect_uv)
         end do
         nvect_uv=nvect_uv+npiece_dist
         end if
         
         if(nvect_uv.gt.nvect_uvmx)then
          write(*,*)'ERROR too small nvect_uvmx=',nvect_uvmx,
     &    ' increase !'
             kprotfail=-180
             return
          end if
c test
          if(outdetl.ge.iiprint1)then
         write(*,*)'TEST surf_loc02:'
c        write(kanalpl,*)'TEST surf_loc02:'
         do iv=1,nvect_uv
         if(area_uv(iv).lt.0.1d-10)
     &   write(*,*)'area_uv(iv)=',area_uv(iv),'iv=',iv
c        if(area_uv(iv).lt.0.1d-10)
c    &   write(kanalpl,*)'area_uv(iv)=',area_uv(iv),'iv=',iv
         end do
          end if
c test
         if(outdetl.ge.iiprint1)then
         write(*,*)'surf_loc02:nvect_uv=',nvect_uv
         write(*,*)'nsmal_loc, nlarg_int,npiece_dist=',
     &   nsmal_loc,nlarg_int,npiece_dist
         write(*,*)'surf_loc02: ss=',ss
c        write(kanalpl,*)'surf_loc02:nvect_uv=',nvect_uv
c        write(kanalpl,*)'nsmal_loc, nlarg_int,npiece_dist=',
c    &   nsmal_loc,nlarg_int,npiece_dist
c        write(kanalpl,*)'surf_loc02: ss=',ss
         end if

         if(dabs(ss-sstot_sm).gt.0.1d-8)then
            write(*,*)'surf_loc02: ERROR1,ss,sstot_sm',ss,sstot_sm
            kprotfail=-181
            return
         end if

c--------------------------------------------------------------------------
c     MATRIX  KKK_uv in block representation
c
c              KKK_LL  KKK_LI   KKK_LD
c     KKK_uv=  KKK_IL  KKK_II   KKK_ID
c              KKK_DL  KKK_DI   KKK_DD
c
c    vector X =L() +   I( )  +  D()
c
c    Dimension:
c    nvect_uv =nsmal_loc+nlarg_int+npiece_dist
c---------------------------------------------------------------------------
         do it=1,nvect_uvmx
         do is=1,nvect_uvmx
             KKK_uv(is,it)=0.d0
         end do
         end do
c local KKK_LL matrix of small se
c filtering of KKK_LL
c  upper bound for matrix elements 
c   rst_min - min distance between two sm. se
         ddn=ddn_par 
         rst_min2=1.0d0/(ddn*dotden_h)   ! 
         rst_min=dsqrt(rst_min2)

         if(nsmal_loc.gt.1)then
         ndistref_ll=0
         do is = 1,nsmal_loc-1
         do it = is+1,nsmal_loc
         sd=0.d0
         sd2=0.d0
         sn=0.d0
         do k=1,3 
         sd=sm_locxyz(k,is)- sm_locxyz(k,it)
         sd2=sd2+sd*sd
         end do! k


c.. filtering
          if(sd2.lt.rst_min2)then
             ndistref_ll=ndistref_ll+1
           if(outdetl.ge.iiprint2)then
             write(*,*)'KKK_LL: smal rst=',dsqrt(sd2)
     &                                  ,'rst_min=',rst_min
             write(*,*)'it,is=',it,is,'ndistref_ll=',ndistref_ll
c            write(kanalpl,*)'KKK_LL: smal rst=',dsqrt(sd2)
c    &                                  ,'rst_min=',rst_min
c            write(kanalpl,*)'it,is=',it,is,'ndistref_ll=',ndistref_ll
             end if
c. redefine distance rst if too small - it is eqvivalent to xyz change

           sd1=dsqrt(sm_locarea(is))+dsqrt(sm_locarea(it))*0.5d0
           sd2=sd1*sd1
           if(outdetl.ge.iiprint2)then
           write(*,*)'Refined rst=',sd1
c          write(kanalpl,*)'Refined rst=',sd1
           end if
          else
          sd1=dsqrt(sd2)
            end if

         sd3=1.d0/(sd1*sd2)

         KKK_uv(it,is)=sd3
        
         end do! it
         end do ! is
c

         do is = 2,nsmal_loc
         do it = 1,is-1
         KKK_uv(it,is)=KKK_uv(is,it)
         end do! it
         end do ! is

         sum=0.d0
         ss=0.d0

         do is = 1,nsmal_loc
         KKK_uv(is,is)=0.d0
         do it = 1,nsmal_loc
         sn=0.d0
         do k=1,3 
                     sn=sn+(sm_locxyz(k,is)- sm_locxyz(k,it))*
     &                                            sm_locvn(k,is)
         end do! k
         KKK_uv(it,is)=KKK_uv(it,is)*sn*sm_locarea(it)

         end do! it
         end do ! is
c.
         if(outdetl.ge.iiprint1)then
        index=1
        call timit(index) 
        write(*,*)'surf_loc02: local KKK_LL matrix finish'
        write(*,*)'KKK_LL refined dist=',ndistref_ll
c       write(kanalpl,*)'surf_loc02: local KKK_LL matrix finish'
c       write(kanalpl,*)'KKK_LL refined dist=',ndistref_ll
         end if

        end if ! nsmal_loc

c...... end KKK local............................................
c................................................................
c.  matrix KKK_LI(l,s) - define E field on local sm se,s, by interm 
c.          large se l
         ndistref_li=0

         if(nlarg_int.ge.1)then
         do is=1,nsmal_loc
         do il=1,nlarg_int  

         isg=lgsm_loc(is)
         itlg=lglg_int(il)

         call s_KKsl(isg,itlg,ndistref_li,vKKts,vKKst)

         KKK_uv(il+nsmal_loc,is)=vKKts 
         KKK_uv(is,il+nsmal_loc)=vKKst
         
          end do ! il
          end do ! is

         end if ! interm  

          if(outdetl.ge.iiprint1)then
        index=1
        call timit(index) 
        write(*,*)'surf_loc02: local KKK_LI matrix finish'
        write(*,*)'refined dist rst=',ndistref_li
c       write(kanalpl,*)'surf_loc02: local KKK_LI matrix finish'
c       write(kanalpl,*)'refined dist rst=',ndistref_li
         end if
c
c......................................................................
c..
c................................................................
c. local matrix KKK_LD(p,s) - define E field on local sm se,s, by distant
c.                                                       surface  piece p   
         if(npiece_dist.ge.1)then
         nnn=nsmal_loc+nlarg_int
         do is=1,nsmal_loc
         do ip=1,npiece_dist
         ss2=0.d0
         ss1=0.d0
         ss=0.d0
c. define large se in piece ip
c. ipg = global piece number
         ipg=lsp_dist(ip)
         nlarg=nsurfp_lg(ipg)
         do nl=1,nlarg
c.nsg global number of large s.e.
         nlg=lsurfp_ilg(nl,ipg) 

         ss=ss+arealargse_t(nlg)
         sd2=0.d0
         sn1=0.d0
         sn2=0.d0
         do k=1,3
         sd=sm_locxyz(k,is)-cxyzlargse_t(k,nlg)
         sn1=sn1 + sm_locvn(k,is)*sd
         sn2=sn2 - vnlargse_t(k,nlg)*sd
         sd2=sd2+sd*sd
         end do! k

         sd1=dsqrt(sd2)
         sd2=sd1*sd2
          sd3=1.0d0/sd2
         ss1=ss1+sn1*arealargse_t(nlg)*sd3
         ss2=ss2+sn2*arealargse_t(nlg)*sd3
         end do !nl

c..
         if(dabs(ss-surfp_s(ipg)).gt.0.1d-8)then
                     write(*,*)' KKK_LD ERROR,ss,surfp_s=',
     &                                          ss,surfp_s(ipg)
                     kprotfail=-182
                     return
         end if

         KKK_uv(ip+nnn,is)=ss1
         KKK_uv(is,ip+nnn)=ss2*sm_locarea(is)/surfp_s(ipg)
  
          end do ! ip
          end do ! is

         end if ! distant
c......................................................................
c        index=1
c        call timit(index) 
c
c        write(kanalpl,*)'surf_loc02: local K_LI and K_LD matrix finish'
c........................................................................
c
c..KKK_II block
          
         ndistref_ii=0

         if(nlarg_int.gt.0)then
         do isl = 1,nlarg_int
         do itl = isl,nlarg_int
c. define global numbers of large se

         islg=lglg_int(isl)
         itlg=lglg_int(itl)
        
          call s_KKll(islg,itlg,ndistref_ii,vKKts,vKKst)
c. define block KKK_II
 
          KKK_uv(itl+nsmal_loc,isl+nsmal_loc)=vKKts
          KKK_uv(isl+nsmal_loc,itl+nsmal_loc)=vKKst
         end do ! itl
         end do ! isl

         end if ! nlarg

          if(outdetl.ge.iiprint1)then
        index=1
        call timit(index) 
        write(*,*)'surf_loc02: local KKK_II matrix finish'
        write(*,*)'refined dist rst=',ndistref_ii
c       write(kanalpl,*)'surf_loc02: local KKK_II matrix finish'
c       write(kanalpl,*)'refined dist rst=',ndistref_ii
         end if
c-----------------------------------------------------------------------------
c    end of KKK_II block
c....................................................................... 

c  KKK_ID and KKK_DI  blocks
c
         ndistref_di=0

         if(nlarg_int.gt.0)then
         nnli=nsmal_loc+nlarg_int

         do itl=1,nlarg_int
c. define global numbers of large se
         itlg=lglg_int(itl)

         if(npiece_dist.gt.0)then
          do isp=1,npiece_dist

c. define global num of ips and collection of large s.e.
          ispg=lsp_dist(isp)
         nslg=nsurfp_lg(ispg)
          ss1=0.d0
          ss2=0.d0
         do ls=1,nslg
c. define glob numb of lg s.e.
         islg=lsurfp_ilg(ls,ispg)

         call s_KKll(islg,itlg,ndistref_di,vKKts,vKKst)

          ss1=ss1+vKKst*arealargse_t(islg)
          ss2=ss2+vKKts*arealargse_t(islg)
          end do !ls

          KKK_uv(isp+nnli,itl+nsmal_loc)=ss1/surfp_s(ispg)
          KKK_uv(itl+nsmal_loc,isp+nnli)=ss2/surfp_s(ispg)
          end do ! isp
            end if
          end do ! itl
            end if !
          if(outdetl.ge.iiprint1)then
        index=1
        call timit(index) 
        write(*,*)'surf_loc02: local KKK_DI+ ID finish'
        write(*,*)'refined dist rst=',ndistref_di
c       write(kanalpl,*)'surf_loc02: local KKK_DI+ ID finish'
c       write(kanalpl,*)'refined dist rst=',ndistref_di
         end if
c-------------------------------------------------------------------------  
c    KKK_DD block
c    take from full KKK_pp
          if(npiece_dist.gt.0)then
          nnli=nsmal_loc+nlarg_int

          do itp=1,npiece_dist
           itpg=lsp_dist(itp)
          do isp=1,npiece_dist
           ispg=lsp_dist(isp)
         
          KKK_uv(itp+nnli,isp+nnli)=KKK_sp(itpg,ispg)
          end do ! isp
          end do ! itp
          end if ! npiece_dist
c-------------------------------------------------------------------------
c CONTROL
c
         bb=0.d0
         sss=0.d0
         do it=1,nvect_uv
         ss=0.d0
         aa=0.d0
         conv_crit1(it)=0.d0
         conv_crit2(it)=0.d0

         do is=1,nvect_uv
         ss=ss+KKK_uv(it,is)*area_uv(is)
         if(dabs(KKK_uv(it,is)).gt.aa)then
         aa=dabs(KKK_uv(it,is))
         ism=is
         end if
         end do!is

         sss=sss+ss
         aanr=2.0d0*pi*area_uv(it)

         if(ss.ne.0.d0)then
         aanr=aanr/ss
         else
         aanr=1.0d0
         end if

         bb=bb+aanr

         if(outdetl.ge.iiprint1)then
         if(ss.eq.0.0d0)
     &   write(*,*)'it=',it,'KKK(it,*)=',ss,'norm='
     &  ,aanr,'area(it)=',area_uv(it)
         end if

c. KKK norma by strings
         do is=1,nvect_uv
         KKK_uv(it,is)=aanr*KKK_uv(it,is)
         end do !is

         end do !it

c KKKtranspose
         do it=1,nvect_uv
         do is=1,nvect_uv
         KKKt_uv(it,is)=KKK_uv(is,it)
         end do
          end do

c. average norma
         aanr=bb/dfloat(nvect_uv)
c. control

         if(outdetl.ge.iiprint1)then
         write(*,*)'KKK_uv control'
         write(*,*)'KKK_uv: average ratio=',aanr 
         write(*,*)'KKK_uv(*,*)=',sss,'Expected=',2.0*pi*sstot_sm
c        write(kanalpl,*)'KKK_uv control'
c        write(kanalpl,*)'KKK_uv: average ratio=',aanr 
c        write(kanalpl,*)'KKK_uv(*,*)=',sss,'Expected=',2.0*pi*sstot_sm
         end if

      
c. convergence rate
         ff=(epsmol-epssol)/(epsmol+epssol)/(2.0*pi)
c        write(*,*)'surf_loc02: epssol, epsmol ',epssol, epsmol
c        write(*,*)' ff ',ff,' nvect_uv ', nvect_uv
         ss=0.d0
         sss=0.d0
         do is=1,nvect_uv
         do it=1,nvect_uv
           conv_crit1(is)=conv_crit1(is)+dabs(KKK_uv(it,is))
           conv_crit2(it)=conv_crit2(it)+dabs(KKK_uv(it,is))
         end do
         end do
c        write(*,*)' conv_crit1 '
c        write(*,*)(conv_crit1(is),is=nvect_uv-10,nvect_uv)
c        write(*,*)' conv_crit2 '
c        write(*,*)(conv_crit2(is),is=1,10)

         bb=0.d0
         ss=0.d0
         do it=1,nvect_uv
         aa=dabs(ff*KKK_uv(it,it)-1.0d0) 
         aa1=dabs(ff*conv_crit1(it)/aa) 
          if(bb.lt.aa1)bb=aa1
         aa2=dabs(ff*conv_crit2(it)/aa) 
         end do
c        write(*,*)' ff aa aa1',ff,aa,aa1

         if(bb.gt.1.0d0)then
         if(outdetl.ge.iiprint1)then
         write(*,*)'Gauss_Seidel convergence is not expected'
         write(*,*)' convergence radius >=',bb
c        write(kanalpl,*)'Gauss_Seidel convergence is not expected'
c        write(kanalpl,*)' convergence radius >=',bb
         end if
         end if
         if(bb.lt.1.0d0)then
         if(outdetl.ge.iiprint1)then
         write(*,*)'Gauss_Seidel convergence is expected'
         write(*,*)' convergence radius  =',bb
c        write(kanalpl,*)'Gauss_Seidel convergence is expected'
c        write(kanalpl,*)' convergence radius  =',bb
         end if
         end if

         return 
         end
c...
c...K_ll calculation
       subroutine s_KKll(isl,itl,ndistref,vKKts,vKKst)
c. matrix elements large-large isl,itl - global
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
	include'param.ibems'
	include'comm.ibems'
        include 'COMMON.MYCONF'
        integer isl,itl,ndistref
        real*8 vKKts,vKKst
        real*8 ss1,ss2,sn1,sn2,ss,sss,sd,sd1,sd2,sd3
        real*8 ddn,rst_min2,rlockl2,ssls,sn3,sn4
        integer islg,itlg,k,nssg,ntsg,is,isg,it,itg
        integer iiprint1,iiprint2

c  upper bound for matrix elements 
c   rst_min - min distance between two sm. se
c   rat_av - average radius for atoms
         ddn=ddn_par         
         rst_min2=1.d0/(ddn*dotden_h)
c   rlockl2 -defines a distances after that lg seare considered as a collection
c                                                  of a small se
         rlockl2=4.5d0
c        rlockl2=6.5d0
         rlockl2=rlockl2/dotden_l
                  
         iiprint1=1
         iiprint2=2
c. define global numbers of large se

         islg=isl
         itlg=itl

          ss1=0.d0
          ss2=0.d0
          sn1=0.d0
          sn2=0.d0
         sd2=0.d0
         
         do k=1,3
         sd=cxyzlargse_t(k,islg)-cxyzlargse_t(k,itlg)
         sd2=sd2+sd*sd
         end do
c
c distant isl-itl elements     
         if(sd2.gt.rlockl2)then
         do k=1,3
         sd=cxyzlargse_t(k,islg)-cxyzlargse_t(k,itlg)
          sn1=sn1+sd*vnlargse_t(k,islg)
          sn2=sn2-sd*vnlargse_t(k,itlg)
         end do

         sd1=dsqrt(sd2)
         sd3=sd1*sd2

         sd3=1.0d0/sd3
          ss1=sn1*arealargse_t(itlg)*sd3
          ss2=sn2*arealargse_t(islg)*sd3
         

         end if !sd2 distant 

c----------------------------------------------------------------------
c.close isl-itl elements : define ss1 and ss2 from small s.e.
         if(sd2.le.rlockl2)then
c------------------------------------------------------------------------------
c. KKK_ll is calculated taking into account curvature of large se
c. define collection of  small se for large elements islg, itlg
         nssg=nsmalse_ilg(islg)
         ntsg=nsmalse_ilg(itlg)
           if (ntsg.gt.nsmalse_lgmx) then
              write (*,*)'NTSG:',ntsg,' exceeds',nsmalse_lgmx
              write (*,*)'Conformation discarded.'
              kprotfail=-183
              return
           endif
               
          ss1=0.d0
          ss2=0.d0
          ssls=0.d0
         if(arealargse_t(islg).eq.0.d0.or.
     &      arealargse_t(itlg).eq.0.d0)then
         goto 201
         end if
         if(nssg.gt.0.and.ntsg.gt.0)then
         do is=1,nssg
c. define glob numb of smal se in large se islg
         isg=lsmalse_ilg(is,islg)
         ssls=ssls+areasmalse_t(isg)

         do it=1,ntsg
c. define glob numb
         itg=lsmalse_ilg(it,itlg)
         

         if(itg.eq.isg)then
         goto 101
         end if ! itg
 

          sd2=0.0d0
          sn1=0.d0
          sn2=0.d0

         do k=1,3
         sd=cxyzsmalse_t(k,isg)-cxyzsmalse_t(k,itg)
         sn1=sn1+sd*vnsmalse_t(k,isg)
         sn2=sn2-sd*vnsmalse_t(k,itg)
         sd2=sd2+sd*sd
         end do !k

         ss=areasmalse_t(itg)*areasmalse_t(isg)

c. filtering ------------------------------------------------
         if(sd2.lt.rst_min2)then
         ndistref=ndistref+1
         if(outdetl.ge.iiprint2)then
         write(*,*)'subr:KKK_II:short  rst=',dsqrt(sd2),
     &                       'ndistref_ii=',ndistref,
     &                              'isg,itgt=',isg,itg
         end if
c. redefine distance rst if too small - it is eqvivalent to xyz change
         sd1=0.5d0*(dsqrt(areasmalse_t(itg))+dsqrt(areasmalse_t(isg)))       
         sd2=sd1*sd1   
         if(outdetl.ge.iiprint2)then
         write(*,*)'subr:KKK_II refined rst=',sd1
c        write(kanalpl,*)'subr:KKK_II refined rst=',sd1
          end if
         else
         sd1=dsqrt(sd2)
         end if
c------------------------------------------------------------

         sd3=1.0d0/(sd1*sd2)
         sn3=sd3*sn1
         sn4=sd3*sn2
        
         ss1=ss1+sn3*ss
         ss2=ss2+sn4*ss


101      end do !it

         end do !is
c control
         if(dabs(ssls-arealargse_t(islg)).gt.1.0d-9)then
         write(*,*)'subKKll ERRORKKK_II1:ssls=',ssls,
     &   arealargse_t(islg)
                 kprotfail=-184
                 return
         end if
c..
          end if ! nssg or ntsg =0

         ss1=ss1/arealargse_t(islg)
         ss2=ss2/arealargse_t(itlg)  
c-------------------------------------------------------------------------
           end if !closed isl-itl
c..................................................
 
201       continue
          vKKts=ss1
          vKKst=ss2

          return
          end
c...
c...K_sl calculation
       subroutine s_KKsl(iss,itl,ndistref,vKKts,vKKst)
c. matrix elements small-large iss,itl - global
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
	include'param.ibems'
	include'comm.ibems'
        include 'COMMON.MYCONF'
        integer iss,itl,ndistref
        real*8 vKKts,vKKst
        real*8 ss1,ss2,sn1,sn2,ss,sss,sd,sd1,sd2,sd3
        real*8 ddn,rst_min2,rlockl2,ssls,sn3,sn4
        integer issg,itlg,k,nssg,ntsg,is,isg,it,itg
        integer iiprint1
        integer iiprint2


c  upper bound for matrix elements 
c   rst_min - min distance between two sm. se to apply smoothing
         ddn=ddn_par         
         rst_min2=1.d0/(ddn*dotden_h)
         rlockl2=4.0d0     
c rlockl2 - defines minimal distance when large s.e. represented as a collection
c of                                                             small s.e.         
         rlockl2=rlockl2/dotden_l
                  
         iiprint1=1
         iiprint2=2
c. define global numbers of large se

         issg=iss
         itlg=itl

          ss1=0.d0
          ss2=0.d0
          sn1=0.d0
          sn2=0.d0
         sd2=0.d0
         
         do k=1,3
         sd=cxyzsmalse_t(k,issg)-cxyzlargse_t(k,itlg)
         sd2=sd2+sd*sd
         end do
c
c distant isl-itl elements     
         if(sd2.gt.rlockl2)then
         do k=1,3
         sd=cxyzsmalse_t(k,issg)-cxyzlargse_t(k,itlg)
          sn1=sn1+sd*vnsmalse_t(k,issg)
          sn2=sn2-sd*vnlargse_t(k,itlg)
         end do

         sd1=dsqrt(sd2)
         sd3=sd1*sd2
         sd3=1.0d0/sd3
          ss1=sn1*arealargse_t(itlg)*sd3
          ss2=sn2*areasmalse_t(issg)*sd3
         end if !sd2 distant 

c----------------------------------------------------------------------
c.close iss-itl elements : define ss1 and ss2 from small s.e.
         if(sd2.le.rlockl2)then
c------------------------------------------------------------------------------
c. define collection of  small se for large element  itlg
         ntsg=nsmalse_ilg(itlg)
               
          ss1=0.d0
          ss2=0.d0
          ssls=0.d0
         if(arealargse_t(itlg).eq.0.d0)then
         goto 201
         end if
         if(ntsg.gt.0)then
         do it=1,ntsg
c. define glob numb
         itg=lsmalse_ilg(it,itlg)

         if(itg.eq.issg)then
         goto 101
         end if ! itg
 
          sd2=0.0d0
          sn1=0.d0
          sn2=0.d0

         do k=1,3
         sd=cxyzsmalse_t(k,issg)-cxyzsmalse_t(k,itg)
         sn1=sn1+sd*vnsmalse_t(k,issg)
         sn2=sn2-sd*vnsmalse_t(k,itg)
         sd2=sd2+sd*sd
         end do !k

         ssls=ssls+areasmalse_t(itg)
         ss=areasmalse_t(itg)*areasmalse_t(issg)

c. filtering ------------------------------------------------
         if(sd2.lt.rst_min2)then
         ndistref=ndistref+1
         if(outdetl.ge.iiprint2)then
         write(*,*)'subr:s_KKsl:short  rst=',dsqrt(sd2),
     &                       'ndistref_ii=',ndistref,
     &                              'isg,itg=',issg,itg
         end if
c. redefine distance rst if too small - it is eqvivalent to xyz change
         sd1=0.5d0*(dsqrt(areasmalse_t(itg))+dsqrt(areasmalse_t(issg)))       
         sd2=sd1*sd1   
         if(outdetl.ge.iiprint2)then
         write(*,*)'subr:KKK_II refined rst=',sd1
c        write(kanalpl,*)'subr:KKK_II refined rst=',sd1
          end if
         else
         sd1=dsqrt(sd2)
         end if
c------------------------------------------------------------

         sd3=1.0d0/(sd1*sd2)
         sn3=sd3*sn1
         sn4=sd3*sn2
        
         ss1=ss1+sn3*ss
         ss2=ss2+sn4*ss


101      end do !it
         end if !ntsg
c control
         if(dabs(ssls-arealargse_t(itlg)).gt.1.0d-9)then
         write(*,*)'subKKll ERRORKKK_II1:ssls=',ssls,
     &   arealargse_t(itlg)
              kprotfail=-185
              return
         end if
c..

         ss1=ss1/areasmalse_t(issg)
         ss2=ss2/arealargse_t(itlg)  
c-------------------------------------------------------------------------
           end if !closed isl-itl
c..................................................
 
201       continue
          vKKts=ss1
          vKKst=ss2

          return
          end
