C $Date: 1996/10/02 18:01:27 $
C $Revision: 3.4 $
C
C
C
      SUBROUTINE CHAIN(J)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.ATOMSS'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.GEN002X'
      INCLUDE 'COMMON.BONDSX'
      INCLUDE 'COMMON.TORPX'
      INCLUDE 'COMMON.PRAMX'
      INCLUDE 'COMMON.CHECK'
      INCLUDE 'COMMON.NNDRUK'
      INCLUDE 'COMMON.CHAINS'
      DIMENSION DANCHI(num_chi),PGAIN(num_chi)
      DIMENSION LSTA(40),NDIP(40),DIP(3),AXIS(3),REF(3),FIEL(3)
      DIMENSION REF1(3),REF2(3),REFX2(3),DIP1(3),FIEL1(3)
      DATA IZERO /0/
C
C
C
C     WRITE(JOUT,12)
C12    FORMAT('        CHAIN                    ')
      NA=NPRE(J)
      K=IABS(LIST(J))
      NX=NCHI(K)
C     IF(NUK.NE.0)WRITE(JOUT,1683)NX
1683  FORMAT('Number of chis ',I4)
      NSCDEF=0
      IF ( NX .EQ. 0) RETURN
C THIS MEANS THAT THE RESIDUE DOESN'T HAVE NCHI
      NATOM=NATOMS(K)
      DO 10 I=1,NX
      IF (NCHVAR(J,I+3) .EQ. 0) THEN
         PGAIN(I)=0.0
         DANCHI(I)=0.0
         GO TO 10
      END IF
      NATX1=NDPT1(I,K)+NA
      NATX2=NDPT2(I,K)+NA
C     WRITE(JOUT,56)NATX1,NATX2
C56    FORMAT('NATX1',I4,'  NATX2',I4)
      LSTA(1)=NATX1
      LSTA(2)=NATX2
      NDIP(1)=NATX2
C NATX1 & NATX2 DETERMINE THE AXIS OF ROTATION
C LSTA IS A MATRIX WHOSE ELEMENTS ARE THE EXCLUDED ATOMS WHEN THE FIELD
C IS CALCULATED.
C NDIP IS A MATRIX INCLUDING THE ATOMS WHOSE DIPOLAR MOMENT WILL BE
C CALCULATED
C
C THE NEXT INSTRUCTIONS DETERMINE IF THERE IS A BIFURCATION ON THE SIDE
C CHAIN.
      IF (I .EQ. NX) THEN
         LATSI=100
C  100 IS ARBITRARY ONLY A NUMBER GREATER THE MAXIMUM NUMBER OF ATOMS
C IN A SIDE CHAIN IS NEEDED.
      ELSE
         LATSI=NDPT2(I+1,K)
      END IF
      LRT=LRT1(I,K)
      IF (LRT .LE. LATSI) THEN
C        THIS IS NOT A BIFURCATION .
         NFF=NATOM-LRT+1
      ELSE
C        A BIFURCATION HAS OCCURRED
         NFF=NUM(I,K)
      END IF
c     WRITE(JOUT,564)NATOM,LRT,NFF
c564   FORMAT('NATOM ',I4,' LRT1',I4,' NFF',I3)
      DO 20 L=1,NFF
      LSTA(L+2)=NA+LRT+L-1
      NDIP(L+1)=NA+LRT+L-1
20    CONTINUE
C
      NAT=NFF+1
      NATEXC=NFF+2
C     WRITE(JOUT,350)(LSTA(KK),KK=1,NATEXC)
C350   FORMAT('EXCLUDED ',40I4)
      CALL REFER(NAT,NDIP,REF)
      CALL DIPP(NAT,NDIP,REF,DIP)
      CALL FIELD(IZERO,J,REF,NATEXC,LSTA,FIEL)
C     WRITE(JOUT,153)I,(DIP(II),II=1,3),(FIEL(III),III=1,3)
C153  FORMAT('D&E for Chi( ',I3,')',2(2X,3F10.5))
      DO 30 LJ=1,3
      AXIS(LJ)= COORD(LJ,NATX2)-COORD(LJ,NATX1)
30    CONTINUE
C ROTATION AXIS DIRECTION (UNNORMALIZED)
      DO 35 JL=1,3
      REFX2(JL)=REF(JL)-COORD(JL,NATX2)
35    CONTINUE

      CALL ORTPAL(REFX2,AXIS,REF1,REF2)
      DREF1=DLENG(REF1)
C     IF(NUK.NE.0)WRITE(JOUT,3200)DREF1

3200  FORMAT('Distance from the centre of charge to the axis',F8.3)

      CALL ORIENT(DIP,FIEL,AXIS,DANGU,GAIN,DIP1,FIEL1)
C THE ANGLE BETWEEN DIPOLE AND ELECTRIC FIELD IS COMPUTED
C DANGU IS THE ANGLE TO BE ADDED TO CHI IN ORDER TO OBTAIN THE BETTER
C ALIGNMENT BETWEEN THE DIPOLE & FIELD.GAIN GIVES THE EXPECTED
C ELECTROSTATIC FREE ENERGY GAIN.
      PREGN = GAIN
      IF (PREGN .GT. 0.0 ) THEN
         PGAIN(I) =0.0
         DANCHI(I)=0.0
      ELSE
         PGAIN(I)=PREGN
         DANCHI(I)=DANGU
      END IF
10    CONTINUE
      CGAIN=0.0
      NN=0
      DO 60 L=1,NX
      ALWVA=0.2-(L-1)*0.01
C ALWVA IS THE MINIMUM PREDICTED GAIN THAT WILL BE CONSIDERED A DEFECT.
C BOND THAT ARE FURTHER FROM THE BACKBONE ARE,POSSIBLY, IN WEAKER
C ELECTRIC FIELDS, SO WE ARE TRYING TO CONSIDERED THIS FACT, HERE.
      IF (ABS(PGAIN(L)) .GT. ALWVA) THEN
        NSCDEF=NSCDEF+1
        VACHI(NSCDEF)=DANCHI(L)
        GNCHI(NSCDEF)=PGAIN(L)
        NNCHI(NSCDEF)=L+3
        NN=L+3
        IF (NUK.NE.0) THEN
C         WRITE(JOUT,1543)NN,VACH,GNCHI(NSCDEF)
          VACH=DANCHI(L)/RAD
        END IF
      END IF
60    CONTINUE
1543  FORMAT('Selected axis=',I4,' angle=',F8.3,' predicted gain=',F8.3)

      END
      SUBROUTINE DIPP(NAT,NATDIP,REF,DIP)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.ATOMSS'
      INCLUDE 'COMMON.GEN100'
      DIMENSION REF(3),NATDIP(40),DIP(3)
C THIS PROGRAM CALCULATES THE DIPOLE MOMENT OF A SET OF ATOMS
C NAT IS THE NUMBER OF ATOMS OF THE SYSTEM THE DIPOLE MOMENT OF IS
C CALCULATED, IN NATDIP ARE THE NUMBERS CORRESPONDING TO THESE ATOMS
C IN REF ARE THE COORDINATES OF THE REFERENCE POINT
      DIP(1)=0.
      DIP(2)=0.
      DIP(3)=0.
      DO 1 I=1,NAT
      DO 1 J=1,3
      DIP(J)=DIP(J)+CHARGE(NATDIP(I))*(COORD(J,NATDIP(I))-REF(J))
1     CONTINUE
      RETURN
      END
      SUBROUTINE ENDGRP(J,NTE,NC,NN2,JC,NATX,LSTAT)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.CHECK'
      INCLUDE 'COMMON.NNDRUK'
      INCLUDE 'COMMON.IOUNIT'
      DIMENSION natx(4),LSTAT(40)
      LOGICAL LAMI_END
      JJ=J-1
      IBIE=NPRE(J)
      IPOP=NPRE(JJ)
      IF(J.EQ.2) THEN                                                
        KD1=ABS(KNDEND(LIST(1))) 
        LAMI_END=.TRUE.
      ELSE 
        KD1=ABS(KNDEND(LIST(INUMRS)))  
        LAMI_END=.FALSE.
      END IF                                                         
C 
C Based on a model of a peptide unit between and end-group and neighboring 
C residue, the following parameters are defined. 
C  NTE: the total number of atoms to be excluded in the calculation of the 
C       Electric field. 
C  NC: the number of atoms to be excluded from the field calculation,
C      that belong to the (J-1) residue (or amino-end-group) LESS 
C      (a) 1 (one), if there is a peptide bond. 
C      (b) 0 (zero), if there is no peptide bond.
C  NN2: the number of atoms to be excluded that belong the J residue LESS 
C      (a) 1 (one), if there is a peptide bond. 
C      (b) 0 (zero), if there is no peptide bond.
C
      IF(KD1.EQ.1)THEN                                               
C     AMINO-H2                                                          
        NTE=4                                                     
        NC=1                                                      
        NN2=2                                                     
      ELSE IF (KD1.EQ.2) THEN                                        
C     AMINO-H3+                                                        
        NTE=5                                                     
        NC=2                                                      
        NN2=2                                                     
      ELSE IF (KD1 .EQ.3) THEN                                       
C     AMINO-CH3                                                         
        NTE=7                                                     
        NC=4                                                      
        NN2=2                                                     
      ELSE IF ((KD1.EQ.4).OR.(KD1.EQ.6).OR.(KD1.EQ.7).OR.(KD1.EQ.8).OR.
     &      (KD1.EQ.9).OR.(KD1.EQ.19).OR.(KD1.EQ.21).OR.(KD1.EQ.22).OR.
     &     (KD1.EQ.23).OR.(KD1.EQ.25).OR.(KD1.EQ.26).OR.(KD1.EQ.27).OR.
     &   (KD1.EQ.28).OR.(KD1.EQ.29).OR.(KD1.EQ.30).OR.(KD1.EQ.32)) THEN                                        
     &      
C     AMINO-COCH3,END-PRO,CIS-H,END-PRO,TRANS-H,END-H2+-PRO, PYROGLUTAMIC
C     AMINO-T-BOC, MPA ( B-MERCAPTOPROPIONIC), 
C     DMP(B,B-DIMETHYL-B-MERCAPTOPROPIONIC), 
C     CPP(AX)[B,B-CYCLOPENTHAMETHYLENE-B-MERCAPTOPROPIONIC],
C     OCA(AX),OCA(EQ),SCA(AX),SCA(EQ),
C     CPP(EQ),DANSYL, AMINO-CYNAMONIC.
        NTE=6                                                     
        NC=2                                                      
        NN2=2                                                     
      ELSE IF(KD1.EQ.5) THEN                                         
C     FORMYL                                                            
        NTE=6                                                     
        NC=3                                                      
        NN2=2                                                     
      ELSE IF (KD1.EQ.10) THEN                                       
C     AMINO                                                             
        NTE=3                                                     
        NC=0                                                      
        NN2=2                                                     
C NOW FOR THE LAST END GROUP                                            
      ELSE IF (KD1.EQ.11) THEN                                       
C     CARBOXYL-COOH                                                     
        NTE=5                                                     
        NC=4                                                      
        NN2=0                                                     
      ELSE IF (KD1.EQ.12) THEN                                       
C     CARBOXYL-O-                                                       
        NTE=4                                                     
        NC=3                                                      
        NN2=0                                                     
      ELSE IF (KD1.EQ.13) THEN                                       
C     CARBOXYL-CH3                                                      
        NTE=7                                                     
        NC=6                                                      
        NN2=0                                                     
      ELSE IF (KD1.EQ.14) THEN                                       
C     CARBOXYL-NH2                                                      
        NTE=6                                                     
        NC=5                                                      
        NN2=0                                                     
      ELSE IF (KD1.EQ.15) THEN                                       
C     CARBOXYL-NHCH3                                                    
        NTE=9                                                     
        NC=8                                                      
        NN2=0                                                     
      ELSE IF (KD1.EQ.16) THEN                                       
C     N, N - DIMETHYL 
        NTE=12                                                    
        NC=11                                                     
        NN2=0                                                     
      ELSE IF (KD1.EQ.17) THEN                                       
C     METHYL ESTER
        NTE=8                                                     
        NC=7                                                      
        NN2=0                                                     
      ELSE IF (KD1.EQ.18) THEN                                       
C     ETHYL ESTER
        NTE=11                                                    
        NC=10                                                     
        NN2=0                                                     
      ELSE IF(KD1.EQ.20) THEN                                        
C     CARBOXYL                                                          
        NTE=3                                                     
        NC=2                                                      
        NN2=0                                                     
      ELSE IF(KD1.EQ.24) THEN                                        
C CARBOXYL-CH2F
        NTE=6  
        NC=7                                                      
        NN2=0                                                     
      ELSE IF(KD1.EQ.31) THEN                                        
C     CARBOXYL                                                          
        NTE=3 
        NC=2                                                      
        NN2=0                                                     
      ELSE                                                           
        WRITE(JPRINT,5000)KD1                                     
5000  FORMAT('End group',I3,'  cannot be treated by   S C E F ')        
      END IF                                                         
      IF(NUK.NE.0)WRITE(JPRINT,5010)KD1                         
5010  FORMAT('End group',I3)                                            
C     WRITE(JPRINT,5210)NTE,NC,NN2                              
C5210  FORMAT('NTE',I3,' NC',I3,' NN2',I3)                              
C     NOW WE ARE GOING TO DEFINE THE ATOMS TO BE EXCLUDED IN THE        
C     FIELD CALCULATION AND THOSE WHICH DEFINE THE AXES OF ROTATION.    
      IF (LAMI_END) THEN    
        LSTAT(NTE)=IBIE+3                                         
        NAT2X2=IBIE+3                                             
C          C-ALFA                                                 
        IF (NC.NE.0) THEN                                         
          DO 110 I=1,NC                                        
             LSTAT(I)=IBIE-I+1                                    
110       CONTINUE                                             
        END IF                                                    
        DO 120 I=1,NN2                                            
          LSTAT(I+NC)=IBIE+I                                        
120     CONTINUE                                                  
        NAT1X2=LSTAT(NC+1)                                        
C         N                                                       
        JC=NTE-(NC+NN2+1)                                         
        IF(JC .NE. 0)THEN                                         
          LSTAT(NTE-1)=IBIE-2                                  
          NAT1X1=IBIE-2                                        
C             C PREV.                                          
          NAT2X1=IBIE                                          
C             C                                                
        END IF                                                    
      ELSE                                                           
C      THE C-TERMINAL END GROUP.
        LSTAT(NC+NN2+1)=IPOP+3                                    
        NAT1X1=IPOP+3                                             
C         C-ALFA PREV                                             
        LSTAT(1)=IPOP+6                                           
        LSTAT(2)=IPOP+7                                           
        NAT2X1=IPOP+6                                             
C            C                                                    
        JA=NTE-3                                                  
        JB=NN2+NC-2                                               
        IF(JA .EQ.JB) THEN                                        
          LIM=JA                                               
        ELSE                                                      
          LIM=JA-1                                             
          LSTAT(NTE)=IBIE+JA                                   
          NAT1X2=IBIE+1                                        
C              N                                               
          NAT2X2=IBIE+JA                                       
C              C POST.                                         
        END IF                                                    
        IF (LIM .NE.0) THEN                                       
          DO 130 I=1,LIM                                       
             LSTAT(2+I)=IBIE+I                                    
130       CONTINUE                                             
        END IF                                                    
        JC=NTE-(NC+NN2+1)                                         
      END IF                                                         
      NATX(1)=NAT1X1
      NATX(2)=NAT2X1
      NATX(3)=NAT1X2
      NATX(4)=NAT2X2
      RETURN
      END
      SUBROUTINE FIELD(N,J,REF,NATEXC,LSTAT,FIEL)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.ATOMSS'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.IOUNIT'
      DIMENSION REF(3),FIEL(3),CRD(3),LSTAT(40)
C IF N=-1,0,+1 THE FIELD FROM LEFT,TOTAL,RIGHT PART OF THE MOLECULE
C IS CALCULATED EXCEPT FROM ATOMS DESIGNATED IN LSTAT. THE FIELD
C IS CALCULATED AT POINT REF, J MEANS THE J-TH RESIDUE. NUMBER OF
C ATOMS EXCLUDED (I.E.GIVEN IN LSTAT) IS NATEXC. THE FIELD
C CALCULATED IS IN FIEL
      FIEL(1)=0.
      FIEL(2)=0.
      FIEL(3)=0.
      IF(N.EQ.-1.OR.N.EQ.0)ISTART=1
      IF(N.EQ.+1)ISTART=NPRE(J)+4
      IF(N.EQ.-1)IEND=NPRE(J)
      IF(N.EQ.0.OR.N.EQ.+1)IEND=NPRE(INUMRS+1)
      DO 40 IATOM=ISTART,IEND
      ICONT=1
      DO 1 I=1,NATEXC
      IF(IATOM.EQ.LSTAT(I))ICONT=0
1     CONTINUE
      IF(ICONT.EQ.0)GO TO 40
      DO 100 I=1,3
      CRD(I)=COORD(I,IATOM)
100   CONTINUE
      RR=DISTA(CRD,REF)
      DO 2 K=1,3
      FIEL(K)=FIEL(K)+CHARGE(IATOM)*(REF(K)-CRD(K))/(RR**3)
2     CONTINUE
40    CONTINUE
      RETURN
      END
      SUBROUTINE THETA                                                  
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      parameter (nsuppl=maxnum_dihe-3)
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.ATOMSS'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.GEN002X'
      INCLUDE 'COMMON.CHECK'
      INCLUDE 'COMMON.NNDRUK'
      INCLUDE 'COMMON.MOVE'
      INCLUDE 'COMMON.BRAIN'
      INCLUDE 'COMMON.CHAINS'
      INCLUDE 'COMMON.BIAS'
      INCLUDE 'COMMON.PEPT'
      INCLUDE 'COMMON.PICK'
      CHARACTER*3 ANGCHAR(maxnum_dihe)/'phi','psi','ome',nsuppl*'chi'/
      DIMENSION REF(3),FIEL(3),LSTAT(40),DIP(3),NDIP(40)                
     &,DIPC(3),FIELC(3),DIPN(3),FIELN(3),AXISC(3),AXISN(3),AXISCC(3)
      DIMENSION NATX(4)
      DATA IZERO /0/, IONE /1/, MONE /-1/ 
C
C    This subroutine calculates the dipole moments of CO , NH           
C   CONH for each peptide unit. These dipole moments are calculated   
C   with respect to the centers of charge (for CO & NH) or with         
C   respect to the midpoint of the N-C' bond. then the electric field   
C   at the same points is calculated. This electric field is produced   
C   usually by 1)the left part of the molecule with respect to the peptide,
C   2) the right part...3)the whole molecule. the contributions from atom
C   with unchangeable positions with respect to the peptide are not calculated.
C   Then, i calculate the orthogonal components of the dipole moment and
C   the field with respect to some rotation axes. The axis in case 1) is
C   N -CA (except pept 2, where N-CA) 2) The same 3)N-CA.               
C   The angle between these components is calculated and the corresponding
C   energy gain expected if both vectors were colinear.                 
C                                                                       
C If NUK is set to a non zero value some prints of dipole mom, electric 
C field, angles between them are done                                   
C
cd    write (jout,*) 'nst=',nst,' nen=',nen

!     write(*,*) 'IN THETA'

      IF (NUK.NE.0) WRITE (JOUT,'(/2A/)')
     & '******** Electrostatically predicted dihedral-angle',
     & ' changes ********'
      NUMDEF=0                                                          
      NNST=2
      NNEN=INUMRS
      IF (MOVANG.EQ.3) THEN
        NNST=NST+1
        NNEN=NEN
      ENDIF

      DO 1830 J=NNST,NNEN                                                
                                                                        
      IF(IABS(LIST(J)).EQ.13) GO TO 1830                                
C THIS WILL EXCLUDE AN ATTEMPT IN THE SCEF PREDICTION TO CHANGE         
C FI OF PRO.                                                            

* Change 6/29/93 Skip, if the residue is out of windows.
C 9/26/96 AL Also avoid residue J-1 being out of windows.
      DO I=1,NWIND
        IF (J-1.GE.IWIND(I,1).AND.J.LE.IWIND(I,2)) GOTO 1850
      ENDDO
      GOTO 1830
1850  JJ=J-1                                                            
* End of change.
      IF (NUK.NE.0)WRITE(JOUT,45)JJ,J                                 
45    FORMAT('Peptide unit between residues ',I4,' and',I4)            
      IBIE=NPRE(J)                                                      
      IPOP=NPRE(JJ)                                                     
      IF ((J.EQ.2) .OR. (J.EQ.INUMRS)) THEN                             
         CALL ENDGRP(J,NTE,NC,NN2,JC,NATX,LSTAT) 
         NAT1X1=NATX(1)
         NAT2X1=NATX(2)
         NAT1X2=NATX(3)
         NAT2X2=NATX(4)
      ELSE                                                              
C*******************************************************************    
C     THIS IS FOR  2 < J < INUMRS                                       
         NTE=6                                                          
         NC=2                                                           
         NN2=2                                                          
         LSTAT(1)=IPOP+6                                                
         NAT2X1=IPOP+6                                                  
C          C'                                                           
         LSTAT(2)=IPOP+7                                                
C          OXYGEN                                                       
         LSTAT(3)=IBIE+1                                                
         NAT1X2=IBIE+1                                                  
C          N                                                            
         LSTAT(4)=IBIE+2                                                
C          H                                                            
         LSTAT(5)=IPOP+3                                                
         NAT1X1=IPOP+3                                                  
C          CALFA PREV.                                                  
         LSTAT(6)=IBIE+3                                                
         NAT2X2=IBIE+3                                                  
C          CALFA                                                        
      END IF                                                            
      NTAT=NC+NN2                                                       
      DO 140 I=1,NTAT                                                   
      NDIP(I)=LSTAT(I)                                                  
140   CONTINUE                                                          
C     NDIP IS A MATRIX CONTAINING THE NUMBER OF THE ATOMS FORMING THE   
C     DIPOLE.                                                           
                                                                        
C     IF(MOVANG.EQ.2) THEN                                              
C THE NEXT INSTRUCTIONS ARE FOR ROTATIONS OF THE PEPTIDE PLANE ONLY.    
                                                                        
cd       write (jout,*)'ntat=',ntat
cd       write (jout,*)(ndip(i),i=1,ntat)
         CALL REFER(NTAT,NDIP,REF)                                      
         CALL DIPP(NTAT,NDIP,REF,DIP) 
cd       print *,'theta: calling field' 
cd       write(jout,*)'ref=',ref(1),ref(2),ref(3) 
*
*  MOVANG.EQ.2 indicates crankshaft type movement when phi and psi angles are
*  changed simultaneously so that only the orientation of the particular
*  dipole is changed and the total conformation remains approximately unaffec-
*  ted.
* 
cd       print *,'THETA: calling FIELD'
         IF (MOVANG.GT.1) 
     1                  CALL FIELD(IZERO,J,REF,NTE,LSTAT,FIEL) 
cd       print *,'THETA: exit FIELD'
cd       write(jout,*)'theta: REF=',ref(1),ref(2),ref(3) 
cd   1          , ' fiel =',fiel (1),fiel (2),fiel (3)
cd       pause
C                                                                       
C ******************************************************************    
C ALWAYS REMEMBER!, BEFORE CALLING DIPP(WHICH CALCULATES THE DIPOLE     
C MOMENT) YOU HAVE TO PROVIDE:                                          
C 1)NUMBER OF ATOMS FOR WHICH THE DIPOLE MOMENT HAS TO BE CALCULATED    
C 2)MATRIX NDIP CONTAINING # OF THESE ATOMS.                            
C 3)REFERENCE POINT(VECTOR) IN REF(3).                                  
C                                                                       
C BEFORE CALLING FIELD YOU HAVE TO PROVIDE:                             
C 1)NUMBER -1,0,+1 WHICH MEANS WHETHER WE ARE GOING TO CALCULATE THE    
C   FIELD FROM THE LEFT PART, FROM THE TOTAL MOLECULE OR FROM THE       
C   RIGHT PART OF THE MOLECULE                                          
C 2)J                                                                   
C 3)REFERENCE POINT IN REF(3)                                           
C 4)LSTAT() I.E.THE LIST OF ATOMS EXCLUDED FROM GIVING CONTRIBUTIONS    
C   TO THE ELECTRIC FIELD                                               
C ******************************************************************    
                                                                        
*
*  LAMBDA TYPE CORRECTION
*        
         IF (MOVANG.EQ.3) THEN
           MOV=0
           IF (J.EQ.INUMRS) NAT2X2=IAT(INUMRS,1)
           DO I=1,3
             AXISCC(I)=COORD(I,NAT2X2)-COORD(I,NAT1X1)
           ENDDO
cd         print *,'THETA: calling ORIENT'
           CALL ORIENT(DIP,FIEL,AXISCC,AGCC,GAINCC,DIPC,FIELC)
cd         print *,'THETA: exit ORIENT'
cd         write(jout,*)'J=',J,'MOV=',MOV,' NAT1X1=',
cd   &     NAT1X1,' NAT2X2=',NAT2X2
cd         write (jout,*)'DIP=',DIP(1),DIP(2),DIP(3)
cd         write (jout,*)'FIEL=',FIEL(1),FIEL(2),FIEL(3)
cd         write (jout,*)'AXISCC=',AXISCC(1),AXISCC(2),AXISCC(3)
cd         write (jout,*)'AGCC=',AGCC,' GAINCC=',GAINCC
cd         write (jout,*)'DIPC=',DIPC(1),DIPC(2),DIPC(3)
cd         write (jout,*)'FIELC=',FIELC(1),FIELC(2),FIELC(3)
cd         aleng=dleng(axiscc)
cd         dd1=axiscc(1)*dip(1)+axiscc(2)*dip(2)+axiscc(3)*dip(3)
cd         dd1=dd1/aleng 
cd         dd2=dip(1)*dip(1)+dip(2)*dip(2)+dip(3)*dip(3)
cd         dd2=dd2-dd1*dd1
cd         dd2=sqrt(dd2)
cd         write (jout,*) 'dip_!_ ',dd2,dleng(dipc)
         ELSE
                                                                        
           MOV=0                                                          
C MOV=0 INDICATES THAT THE TWO AXES ROTATE,IN THE CASE OF THE END       
C GROUPS,THERE MAY BE ONE OR TWO AXES.IF THERE IS ONLY ONE,             
C MOV INDICATES WHICH IS THE EXISTING AXIS,1 STANDS FOR                 
C (CALFA PREV - C') AXIS AND 2 FOR (N-CALFA) AXIS.                      
                                                                        
           IF ((J.EQ.2) .AND. (JC .EQ. 0)) THEN                           
                MOV=2                                                     
                GO TO 160                                                 
           END IF                                                         
C           WRITE(JOUT,5030)NAT1X1,NAT2X1                               
C5030       FORMAT ('Axis 1, atom1=',I5,' atom2=',I5)                     
           DO 150 I=1,3                                                   
           AXISC(I)=COORD(I,NAT2X1)-COORD(I,NAT1X1)                       
150        CONTINUE 

*
*  PIELA TYPE CORRECTION. ONLY LEFT FIELD PART IS CONSIDERED
*
           IF (MOVANG.EQ.1) CALL FIELD(MONE,J,REF,NTE,LSTAT,FIEL)
                                                                        
           CALL ORIENT(DIP,FIEL,AXISC,AGXC,GAINXC,DIPC,FIELC) 
cd       print *,'J=     ',J     ,'MOV=',MOV,
cd   #         'DIP=',DIP(1),DIP(2),DIP(3),
cd   1         ' FIEL=',FIEL(1),FIEL(2),FIEL(3),' AXISC=',
cd   2          AXISC(1),AXISC(2),AXISC(3),' AGXC=',AGXC,
cd   3          ' GAINXC=',GAINXC,' DIPC=',DIPC(1),DIPC(2),
cd   4          DIPC(3),' FIELC=',FIELC(1),FIELC(2),FIELC(3)
                                                                        
           IF((J.EQ.INUMRS) .AND.(JC.EQ.0)) THEN                          
                MOV=1                                                     
                GO TO 180                                                 
           END IF                                                         
C           WRITE(JOUT,5040)NAT1X2,NAT2X2                               
 5040       FORMAT ('Axis 2, atom1=',I5,' atom2=',I5)                     
                                                                        
160        DO 170 I=1,3                                                   
           AXISN(I)=COORD(I,NAT2X2)-COORD(I,NAT1X2)                       
170        CONTINUE 
*
*  PIELA TYPE CORRECTION. ONLY RIGHT FIELD PART IS CONSIDERED
*                    
           IF (MOVANG.EQ.1) CALL FIELD(IONE,J,REF,NTE,LSTAT,FIEL) 
                                                                        
           CALL ORIENT(DIP,FIEL,AXISN,AGXN,GAINXN,DIPN,FIELN)             
cd       print *,'J=     ',J     ,'MOV=',MOV,
cd   #          'DIP=',DIP(1),DIP(2),DIP(3),
cd   1         ' FIEL=',FIEL(1),FIEL(2),FIEL(3),' AXISN=',
cd   2          AXISN(1),AXISN(2),AXISN(3),' AGXN=',AGXN,
cd   3          ' GAINXN=',GAINXN,' DIPN=',DIPN(1),DIPN(2),
cd   4          DIPN(3),' FIELN=',FIELN(1),FIELN(2),FIELN(3)
         ENDIF                                                               
180      NSCDEF=0                                                       
         IF (J.NE.INUMRS)THEN                                           
            CALL CHAIN(J)                                             
         END IF                                                         
         NNBK=1                                                         
         IF (MOV.EQ.0) THEN                                            
            IF (MOVANG.NE.3) THEN 
              NDX=(JJ-1)*maxnum_dihe+2 
            ELSE
              NDX=JJ
            ENDIF
*           write(jout,*) 'movang=',movang
            IF(NUK.NE.0) THEN
              IF (MOVANG.NE.3) THEN
                DAGXC=AGXC/RAD                                            
                DAGXN=AGXN/RAD
                WRITE(JOUT,190)DAGXC,DAGXN 
                WRITE(JOUT,48)GAINXC,GAINXN                 
              ELSE
                WRITE(JOUT,191)AGCC/RAD
                WRITE(JOUT,192)GAINCC
              ENDIF
            ENDIF
190         FORMAT('Predicted angle for XC=',F8.3,' for XN=',F8.3)    
191         FORMAT('Predicted lambda=',F15.3)    
192         FORMAT('Energy gain=',F10.2)   
48          FORMAT('Individual energy gains for XC and XN=',2F10.2)   
              
            IF (MOVANG.EQ.2) THEN
*
*  CORRECTION FOR CRANKSHAFT TYPE MOVEMENT
*
              GAINBK=(GAINXC+GAINXN)/2   
              IF ((AGXC.GT.0.0).AND.(AGXC.LT.PI)) THEN                  
                   IF ((AGXN.GT.0.0).AND.(AGXN.LT.PI)) THEN             
                        ANGBK=(AGXC+AGXN)/2                             
                   ELSE                                                 
                        AGXN=2*PI+AGXN                                  
                        DIF=AGXN-AGXC                                   
                        ANGU=(AGXN+AGXC)/2                              
                        IF (DIF .LT. PI) THEN                            
                             ANGBK=PINORM(ANGU)                         
                        ELSE                                            
                             ANGUD=ANGU-PI                      
                             ANGBK=PINORM(ANGUD)                      
                        END IF                                          
                   END IF                                               
              ELSE 
                   IF ((AGXN .GT.0.0).AND.(AGXN.LT.PI))THEN             
                        AGXC=2*PI-AGXC                                  
                        DIF=AGXC-AGXN                                   
                        ANGU=(AGXC+AGXN)/2                              
                        IF(DIF .LT.PI) THEN                             
                             ANGBK=PINORM(ANGU)                         
                        ELSE                                            
                             ANGUD=ANGU-PI                      
                             ANGBK=PINORM(ANGUD)                      
                        END IF                                          
                   ELSE                                                 
                        ANGBK=(AGXC+AGXN)/2                             
                   END IF                                               
              ENDIF
              NRO=2                                                     
              DANBK1=ANGBK/RAD                                          
              DANBK2=-ANGBK/RAD
            ELSE IF (MOVANG.EQ.1) THEN
*
* Correction for Piela type movement
*
                GAINBK=GAINXC+GAINXN   
            ELSE
*
* Correction for lambda type movement
*
                GAINBK=GAINCC
                ANGBK=AGCC
              ENDIF
              NRO=2
C     IF(NUK.NE.0)WRITE(JOUT,206)DANBK1,DANBK2                        
206   FORMAT('Add to axis1',1X,F7.1,' add to axis2',1X,F7.1)            
C     IF(NUK.NE.0)WRITE(JOUT,4848)GAINBK                              
4848  FORMAT('Expected energy gain ',F8.2)                              
              IF (J.EQ.2)THEN                                           
                   IF((NCHVAR(1,1).NE.1).OR.(NCHVAR(2,1).NE.1))THEN     
                        NNBK=0                                          
                   END IF                                               
              ELSE                                                      
                   IF((NCHVAR(JJ,2).NE.1).OR.(NCHVAR(J,1).NE.1))THEN    
                        NNBK=0                                          
                        GAINBK=0.0                                      
                   END IF                                               
            END IF                                                    
         ELSE IF (MOV.EQ.2) THEN                                        
              ANGBK=-AGXN                                               
C ROTATION OF FI(J=2) WHICH GIVE ALIGNMENTS OF THE DIPOLE&TOT FIELD     
C WHEN MOVING AXIS AXIS 2 THE FIELD IS GOING TO VARY AND THE DIPOLE     
C IS FIXED,THE ANGLE OF THE ROTATION HAS THE OPPOSITE SIGN.             
              GAINBK=GAINXN                                             
              NRO=1                                                     
              NDX=maxnum_dihe+1
              DANBK=ANGBK/RAD                                           
              IF(NUK.NE.0.)WRITE(JOUT,402)J,DANBK,GAINBK              
402           FORMAT('Add to phi',i2,1x,f7.2,' gain ',F6.2)              
              IF (NCHVAR(2,1).NE.1)THEN                                 
                   NNBK=0                                               
                   GAINBK=0.0                                           
              END IF                                                    
         ELSE                                                           
C THE ANGLE CONSIDERED IS ANGULO(2,INUMRS-1)                            
              ANGBK=AGXC                                                
              GAINBK=GAINXC                                             
              NRO=1                                                     
              NDX=(JJ-1)*maxnum_dihe+2    
C ROTATION OF PSI(J=INUMRS) WHICH GIVE ALIGNMENT OF THE                 
C DIPOLE&TOT FIELD OF THE CARBOXYL END.                                 
              DANBK=ANGBK/RAD                                           
              IF(NUK.NE.0)WRITE(JOUT,403)JJ,DANBK,GAINXC              
403           FORMAT('Add to psi',I2,1X,F7.2,' gain ',F6.2)             
              IF (NCHVAR(JJ,2).NE.1) THEN                               
                   NNBK=0                                               
                   GAINBK=0.0                                           
              END IF                                                    
         END IF                                                         
C        DELTA(J)=0.0                                                   
         NII0=NUMDEF                                                    
        IF(NUK.NE.0)WRITE(JOUT,2722) JJ                               
2722     FORMAT('****** Defects at peptide plane No',I4,' *******'/)      
         GGAIBK = ABS(GAINBK)                                           
         IF ((NNBK .EQ.1).AND.(GGAIBK.GT.0.2)) THEN                     
              NUMDEF=NUMDEF+1                                           
              NROT(NUMDEF,1)=NRO                                        
C NROT(NUMDEF,1) INDICATES THE NUMBER OF AXES WHICH ROTATE.             
              NROT(NUMDEF,2)=NDX                                        
C NROT(NUMDEF,2)IS CARRYING THE INDXV FOR CRANKSHAFT AND PIELA TYPE
C MOVEMENT OR THE NUMBER OF RESIDUE TO WHICH VARIABLE LAMBDA IS ASSIGNED
C FOR LAMBDA TYPE MOVEMENT.                                  
C              
              DELTA(NUMDEF)=GGAIBK      
              IF (MOVANG.EQ.1) THEN
                RTANG1(NUMDEF)=AGXC 
                RTANG2(NUMDEF)=AGXN
              ELSE 
                RTANG1(NUMDEF)=ANGBK
                DTANG1=RTANG1(NUMDEF)/RAD
                IF(NUK.NE.0)THEN
                  IF (MOVANG.EQ.2) THEN
                      CALL NDX_DECODE(NROT(NUMDEF,2),IDD,IANGG)
                      IF (IANGG.GT.3) THEN
                        WRITE(JOUT,1571) NROT(NUMDEF,1),             
     &                  ANGCHAR(IANGG),IANGG-3,IDD,DTANG1,DELTA(NUMDEF) 
                      ELSE
                        WRITE(JOUT,1573) NROT(NUMDEF,1),             
     &                  ANGCHAR(IANGG),IDD,DTANG1,DELTA(NUMDEF) 
                      ENDIF
                  ELSE
                    WRITE(JOUT,1572) NROT(NUMDEF,2),
     &              RTANG1(NUMDEF)/RAD,DELTA(NUMDEF)     
                  ENDIF
                ENDIF
              ENDIF
 1572 FORMAT('dlambda(',I3,')=',F8.3,' energy gain:',F8.3)
         END IF                                                         
         IF (NSCDEF.GT.0) THEN                                          
              DO 1370 KI=1,NSCDEF                                       
              NUMDEF=NUMDEF+1                                           
              NROT(NUMDEF,1)=1                                          
              NROT(NUMDEF,2)=maxnum_dihe*(J-1)+NNCHI(KI)
              RTANG1(NUMDEF)=VACHI(KI)                                  
              DELTA(NUMDEF)=ABS(GNCHI(KI))
              DTANG1=RTANG1(NUMDEF)/RAD                                 
              IF (NUK.NE.0) THEN
                CALL NDX_DECODE(NROT(NUMDEF,2),IDD,IANGG)
                IF (IANGG.GT.3) THEN
                  WRITE(JOUT,1571) NROT(NUMDEF,1),             
     &            ANGCHAR(IANGG),IANGG-3,IDD,DTANG1,DELTA(NUMDEF) 
                ELSE
                  WRITE(JOUT,1573) NROT(NUMDEF,1),             
     &            ANGCHAR(IANGG),IDD,DTANG1,DELTA(NUMDEF) 
                ENDIF
              ENDIF
1370          CONTINUE                                                  
              NLL0=NUMDEF-NII0                                          
              IF(NUK.NE.0)WRITE(JOUT,2733) NLL0                       
2733          FORMAT('Number of defects=',I4)                           
         END IF                                                         
C     END IF                                                            
CD    DO I=1,NUMDEF
CD      WRITE (JOUT,*) 'I=',I,' NROT=',NROT(I,2),' ANG=',RTANG1(I)/RAD
CD    ENDDO
1830  CONTINUE                                                          
CAL I think the following statements are rather necessary, but am not sure 
C   whether it should be placed right here... Let's see anyway...
       
C     write (jout,*) 'THETA: Now calling DECIS'
      CALL DECIS (M2)
      L1=NUMDEF
CD     write (jout,*) 'THETA: L1',L1,' NUMDEF',NUMDEF
!     write (*,*) 'Out of theta'
      RETURN                                                            
1571  FORMAT('No rot axes',I2,' predicted change in ',A3,I2,'(',I3,')=',
     &   F8.3,' Delta=',F9.4)  
1573  FORMAT('No rot axes',I2,' predicted change in ',A3,'(',I3,')=',
     &   F8.3,' Delta=',F9.4)  
      END                                                               
      SUBROUTINE ORIENT(DIP,FIEL,CRD,ANGULO,GAIN,DIP1,FIEL1)
      DIMENSION DIP(3),FIEL(3),CRD(3),FIEL1(3),FIEL2(3),DIP1(3),DIP2(3)
C THERE ARE TWO VECTORS:DIP&FIEL(DIPOLE&FIELD) AND AN AXIS GIVEN BY
C VECTOR CRD. WE CALCULATE THE ORTHOGONAL COMPONENTS OF DIP & FIEL
C WITH RESPECT TO THE AXIS CRD, THEN WE CALCULATE ANGLE ANGULO BETWEEN
C THEM AND THE ENERGY GAIN EXPECTED WHEN ONE ROTATED THE DIPOLE MOMENT
C ALONG THE FIELD. DIP1&FIEL1 ARE THE COMPONENTS PERPENDICULAR TO THE
C AXIS GIVEN BY CRD.THE PARALLEL COMPONENTS  DIP2&FIEL2 ARE NOT USED
C HERE.
      CALL ORTPAL(FIEL,CRD,FIEL1,FIEL2)
      CALL ORTPAL(DIP,CRD,DIP1,DIP2)
      ANGULO=ANGLTHET(DIP1,FIEL1,CRD)
      GAIN=TOGAIN(FIEL1,DIP1)
      RETURN
      END
******************************************************************************
      SUBROUTINE REFER(NAT,NATM,REF)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.ATOMSS'
      DIMENSION REF(3),NATM(40)
      SMALL= 1.0E-30

      XCOSUM=0.0
      DO 10 I=1,3
      REF2=0.0
      C2=0.0
      DO 20 J=1,NAT
      XCOOR = COORD(I,NATM(J))
      XCOSUM = XCOSUM + XCOOR
      C1=ABS(CHARGE(NATM(J)))
      C2=C1+C2
      REF1=C1*XCOOR
      REF2=REF1+REF2
20    CONTINUE
C  To Avoid problems when all the partial charges are zero. DR Jan-93
      IF(C2.LT.SMALL) THEN
         REF(I)= XCOSUM
      ELSE
         REF(I)=REF2/C2
      END IF
10    CONTINUE
      RETURN
      END
******************************************************************************
      FUNCTION TOGAIN(A,B)
      DIMENSION A(3),B(3)
      C=-SCAL(A,B)
      D=-DLENG(A)*DLENG(B)
      TOGAIN=D-C
      RETURN
      END
