set ECEPP_ROOTNT=h:\users\ripoll\eceppak
set BATCH_DIR=ripoll-eceppak
set MPI_COMM=TCP

@echo on
t:
rmdir /s /q %BATCH_DIR%
mkdir %BATCH_DIR%
cd %BATCH_DIR%
REM T: is the scratch space where you stick your files and
REM executeables during a batch run


@echo Beginning files copying  at: > time.txt
@date /T >> time.txt
@time /T >> time.txt

REM normally when you enter date or time the computer asks for a new date or
REM time, which is annoying
REM so the /T switch just prints the date/time

REM my stuff is in  H:\users\ripoll\ which is accessible to the cluster
copy %ECEPP_ROOTNT%\Data\Hydration\* 
copy %ECEPP_ROOTNT%\Data\Residue\* 
copy %ECEPP_ROOTNT%\Data\IBEM\* 
copy %ECEPP_ROOTNT%\bin\eceppakpH-NT-MPI.exe 
REM copy %ECEPP_ROOTNT%\bin\eceppak-NT-MPI.exe 


h:
copy *.inp t:\%BATCH_DIR%
copy outo.* t:\%BATCH_DIR%
copy bounds.* t:\%BATCH_DIR%
copy *.pdb t:\%BATCH_DIR%

@echo Ending copying  at: >> time.txt
@time /T >> time.txt
