      SUBROUTINE CHARGED_CONF

#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.LIST0'
      INCLUDE 'COMMON.IOUNIT'
      DATA IZERO /0/

c   ************************
C AMINO END
      LT=LIST0(1) 
      IF (LT.EQ.1) THEN
C  AMINO-END IS CHARGED
              LIST(1)=2
      ELSE IF ((LT.EQ.6).OR.(LT.EQ.7)) THEN
C  AMINO-END FOR PROLINE IS CHARGED
              LIST(1)=8
      ENDIF

C   NOW FULL RESIDUES
      DO J=2,INUMRS-1
         LT=ABS( LIST0(J) )
C NOW LET'S SEE IF THIS IS AN "L" OR "D" RESIDUE
         ISIGNO=ISIGN( 1, LIST0(J) )
         IF (LT.EQ.2) THEN
C  ASPARTATE
                  LIST(J)=ISIGNO*31
         ELSE IF (LT.EQ.4) THEN
C  GLUTAMATE
                  LIST(J)=ISIGNO*32
         ELSE IF ((LT.EQ.7).OR.(LT.EQ.25)) THEN
C  HISTIDINE  D or E TO  HISTIDINE CHARGED - HIP
                  LIST(J)=ISIGNO*28
         ELSE IF (LT.EQ.9) THEN
C  LYSINE CHARGED
                  LIST(J)=ISIGNO*29
         ELSE IF (LT.EQ.15) THEN
C  ARGININE CHARGED
                  LIST(J)=ISIGNO*30
         ELSE IF (LT.EQ.20) THEN
C  TYROSINE CHARGED
                  LIST(J)=ISIGNO*36
         ELSE IF (LT.EQ.24) THEN
C  ORNITHINE CHARGED
                  LIST(J)=ISIGNO*27
         ENDIF
      ENDDO

C CARBOXYL END GROUP
      LT=LIST0(INUMRS)
      IF (LT.EQ.11) THEN
C  CARBOXYL-END IS CHARGED
              LIST(INUMRS)=12
      ENDIF

C There may be a problem here for positively charged residues: 
C there is an extra atom and this may have atomic overlaps.

      CALL SETUP_X(IZERO)

      RETURN
      END
