c.. connection of high density dots with all heavy atoms    
c. creation of surface pieces       
c.nov.94 
c Double precision 

	subroutine connect_ha(nsoord,soord,rad_ps)          

#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
	include'param.ibems'
	include'comm.ibems'
        include 'COMMON.MYCONF'
        real*8 soord(3,maxat),rad_ps(maxat),atmq_ps(maxat)
        integer nsoord

c.. 
	real*8 xyz(3),vnor(3)
	real*8 od,big,blow,ssb,dmin,dist1,dtemp,sd,sc
        character*1 atname
        integer natomt,natmse_t
        integer is,ib,nbsenew,ip,lsmal,nlzero,j,ntot,i,nsmatm
        integer k,nh,jl,ih,ipos,iiprint0,iiprint1,iiprint2
c..

        iiprint0=0
        iiprint1=1
        iiprint2=2
        od = 0.d0

	big=9.9d10
	blow=0.0d0
        nsmatm=nsmse_pmx
        natomt=nsoord

c       if(outdetl.gt.iiprint0)then
c        write(*,*)
c        write(*,*)'connect_ha:'
c        do ia=1,nnmlat
c        write(*,*)'ia=',ia, 'xyz=',(soord(k,ia),k=1,3)
c        end do! ia
c       end if
c.. 
	do 100 i=1,MAXAT    
	areaatmse_t(i)=od
        latom_ip(i)=0
        lsurfp_ia(i)=0

	do 110 j=1,nsmatm     
110	ismal_atm(j,i)=0
100	nsmalt_atm(i)=0
c..assembling  of smalse with heavy atoms  n.e. 'H'

c        write(kanalp,*)'connect_ha: nsmalse_t=',nsmalse_t

	ntot=0 
        sstot_s=0.d0
	do 200 ih=1,nsmalse_t
        sstot_s=sstot_s+areasmalse_t(ih)
        if(areasmalse_t(ih).le.0.d0)then
        write(*,*)'Smse area negive ih,ar=',ih,areasmalse_t(ih)
        end if
	ssb=od
	dmin=big
	ipos=0

	do 210 jl=1,natomt  
        atname=atnamel(jl)(1:1)
        if(atname.eq.'H')goto 210

	dist1=od  
	sc=od
        
	do 220 k=1,3
	dtemp= soord(k,jl)-cxyzsmalse_t(k,ih)
	dist1=dist1 + dtemp*dtemp
220	continue
        
          dist1=dist1/rad_ps(jl)-rad_ps(jl)

	if(dist1.le.dmin)then
	ipos=jl
	dmin=dist1
		end if
210	continue
	if(ipos.ne.0)then
	ntot=ntot+1
	nsmalt_atm(ipos)=nsmalt_atm(ipos)+1
	nh=nsmalt_atm(ipos)  
c nsmalt_atm(ia)= total number of sm se which belong to atom ia

	if(nh.gt.nsmatm)then
        write(*,99)nh          
        kprotfail=-101
        return
c       stop 
        end if

c list of sm se which are belong to atom ipos
	ismal_atm(nh,ipos)=ih  

c.. ismalty_atm(,) defines type if se. if concave se then=1
        if(dist1.le.0.1d-9)itypesmal_t(ih)=1
        if(dist1.gt.0.1d-9)itypesmal_t(ih)=2
c. pointer to atom number connected with this surf. element ( sm se ih)
c        iatom_nsm(ih)=ipos

	areaatmse_t(ipos)=areaatmse_t(ipos)+areasmalse_t(ih)
		end if
200	continue
  
        sstot_sm=sstot_s
        if(outdetl.ge.iiprint1)then
        write(*,*)
        write(*,*)'SMAL s.e.: nsmalse_t=',nsmalse_t
        write(*,*)'sstot_sm=',sstot_s
         end if
c.......................................................................
c.
c        do ia=1,nnmlat
c        write(*,*)'atom=',ia,' sumb of se=',nsmalt_atm(ia),
c     &  'area expos=',areaatmse_t(ia)
c        end do ! ia
c.
c..creation of surface pieces=surface expoused atoms

	nlzero=0
	nbsenew=0
	do 400 ib=1,natomt  
	if(nsmalt_atm(ib).eq.0)then
        latom_ip(ib)=0
	nlzero=nlzero+1
	goto 400
		end if ! nsmalt_atm

	if(nsmalt_atm(ib).ne.0)then
        nbsenew=nbsenew+1
        if(nbsenew.gt.npc_mx)then
        write(*,*)'ERROR no SPACE: increase param NPC_MX:',npc_mx
        kprotfail=-102
        return
c       stop
        end if

c        write(*,*)'connect:atom ib, nbsenew=',ib,nbsenew
c.
         nsurfp_sm(nbsenew)=nsmalt_atm(ib)
c nsurfp_sm(ip)=tot numb of sm se which belongs to surf piece ip

         latom_ip(ib)=nbsenew
         lsurfp_ia(nbsenew)=ib
         surfp_q(nbsenew)=0.d0
         do k=1,3
        surfp_xyz(k,nbsenew)=0.d0
         end do ! k
         surfp_s(nbsenew)=areaatmse_t(ib) 
    
        do 402 is=1,nsmalt_atm(ib)
        lsmal=ismal_atm(is,ib)
        lsurfp_ism(is,nbsenew)=ismal_atm(is,ib)
c lsurf_ism(is,ip)=list of sm se which belong to spiece ip
402     continue

c.  position of the surface piece is equal to atom's position
        do k=1,3
        surfp_xyz(k,nbsenew)=soord(k,ib)
        end do! k
c..    
	end if ! nsmalt_atm
400	continue

        nsurfp_t=nbsenew
	natmse_t=natomt
        sstot_p=0.d0
        do ip=1,nsurfp_t
        sstot_p=sstot_p+surfp_s(ip)
        end do ! ip

c. pieces results
        if(outdetl.ge.iiprint1)then
	write(*,*)' connect_ha: atoms of zero surf area=', nlzero
        write(*,*)'number of surf_p=',nsurfp_t
        write(*,*)'connect_ha: sstot_s=',sstot_s
        write(*,*)'connect_ha: sstot_p=',sstot_p
        write(*,*)'connect_ha: AREA of SURFACE ATOMS'
        do ip=1,nsurfp_t
        write(*,*)'ip=',ip,'at=',lsurfp_ia(ip),'surf_p',surfp_s(ip)
        end do
        end if
        if(outdetl.ge.iiprint2)then
        do ip=1,nsurfp_t
        write(*,*)'n sm se=',nsurfp_sm(ip),'sm se list:'
        write(*,'(14i5)')(lsurfp_ism(is,ip),is=1,nsurfp_sm(ip))
c       write(*,*)'xyz=',(surfp_xyz(k,ip),k=1,3)
        end do
        end if

c.. 
c.	write(*,*)' connect_h_a: atms having zero area=', nlzero


99 	format(2x,' CONNECT_la: too low NSMATM low than nh=',i5,
     & /,'         !increse NSMSE_PMX parameter')

    	return
	end
