        subroutine en_ggg000(xxinit,xxfinal,ggg00)
c energy ggg000- desolvatation energy due to recharging

#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif

        include'param.ibems'
        include'comm.ibems'
        include'COMMON.TIME1'
        include'COMMON.ODONNELL'
        include'COMMON.MYCONF'

        real*8 elfren_s(nres_mx),elfren_ps(nres_mx) 
        integer nsoord,irg,ix
        real*8 soord(3,maxat),rad_ps(maxat),atmq_ps(maxat)
        integer xxinit(nres_mx),xxfinal(nres_mx),xxdelt(nres_mx)
        real*8 elfren,hpfren,solfren,ggg00

        integer i,l,is,il,ip,ia,k,natm,iiprint0,iiprint1,idumm
        logical stopx

        idumm=0
 
        iiprint0=0
        iiprint1=1
c.
c.
c. define xxdelt(i)
        do i=1,npolres_t 
        xxdelt(i)=abs(xxfinal(i))-abs(xxinit(i))
        end do
c.
c. define polarization surface charge  sigma_PS+i
c. keep soord as it is for main PS+ molecule-atmxyz
c. redefine charges atmq_ps() for a given S+i-
c..
       nsoord=nnmlat
       do ia=1,nsoord
       rad_ps(ia)=atmrad(ia)
       do k=1,3
       soord(k,ia)=atmxyz(k,ia)
       end do
       end do
c..
c..loop over xxdelt
c..
       ggg000=0.d0
       irg= 0
       ix=0
1000   ix=ix+1
       if(ix.gt.npolres_t)goto 1010
       elfren_ps(ix)=0.d0
       elfren_s(ix)=0.d0
       if(xxdelt(ix).eq.0)goto 1000
       
c..define charges of PSi+
       do i=1,nsoord
       atmq_ps(i)=0.d0
       end do
c.
       natm=natm_polrs(ix)
       do ia=1,natm
       k=latm_polrs(ia,ix)
       atmq_ps(k)=atmcha(k)
       end do
c.
       if(outdetl.ge.iiprint1)then
       write(*,*)'en_gg00:PS(ix)=',ix,'nsoord=',nsoord,'atmq_ps()='
c      write(kanalp,*)'en_gg00:PS(ix)=',ix,'nsoord=',nsoord,'atmq_ps()='
       do i=1,nsoord
       write(*,'(5f8.3)') atmq_ps(i),rad_ps(i),(soord(k,i),k=1,3)
c      write(kanalp,('(5f8.3)'))atmq_ps(i),rad_ps(i),(soord(k,i),k=1,3)
       end do
       end if

       if(outdetl.ge.iiprint0)then
       write(*,*)
       write(*,*)'en_ggg000 (1):  Solvation of  PS+ ix=',ix, 
     &             'natm=',natm
       end if
c.
       call solv_freng(irg,nsoord,soord,rad_ps,atmq_ps,
     &                  solfren,elfren,hpfren)
       if (kprotfail.le.-1) return

!       timeint=tcpu()-tstar0
!       if (YourJob) write(kanalp,*)'time after solv_freng(1) ',timeint

        if (stopx(idumm)) then
          write(*,*) 'Aborting in en_ggg000'
          kprotfail=-999
          return
        endif

       irg=irg+1
       elfren_ps(ix)=elfren
       
c      if(outdetl.ge.iprint0)then
c      write(kanalp,*)
c      write(kanalp,*)'en_ggg000:PS+ ix=',ix,' elfren=',elfren
c      end if
        
c.. keep surface of main molecule PS+
c.     
        if(irg.eq.1)then
c        write(kanalp,*)'en_ggg000: keep surface PS+'
        do is=1,nsmalse_t
        areasmalse_tm(is)=areasmalse_t(is)
        do k=1,3
        cxyzsmalse_tm(k,is)=cxyzsmalse_t(k,is)
        vnsmalse_tm(k,is)=vnsmalse_t(k,is)
        end do
        end do
        sstot_sm=sstot_s
        nsmalse_tm=nsmalse_t
c.
        do il=1,nlargse_t
        arealargse_tm(il)=arealargse_t(il)
        do k=1,3
        cxyzlargse_tm(k,il)=cxyzlargse_t(k,il)
        vnlargse_tm(k,il)=vnlargse_t(k,il)
        end do
        end do
        sstot_lm=sstot_l
        nlargse_tm=nlargse_t
c.
        do ip=1,nsurfp_t
        surfp_sm(ip)=surfp_s(ip)
        do k=1,3
        surfp_xyzm(k,ip)=surfp_xyz(k,ip)
        end do ! k
        end do ! i
        nsurfp_tm=nsurfp_t
        sstot_pm=sstot_p
c
        do il=1,nlargsemx_t
        nsmalse_ilgm(il)=nsmalse_ilg(il)
        do k=1,nsmalse_lgmx
        lsmalse_ilgm(k,il)=lsmalse_ilg(k,il)
        end do
        end do
c
         do ip=1,maxat
         nsurfp_smm(ip)=nsurfp_sm(ip)
         nsurfp_lgm(ip)=nsurfp_lg(ip)
         latom_ipm(ip)=latom_ip(ip)
         lsurfp_iam(ip)=lsurfp_ia(ip)

         do i=1,nsmse_pmx
         lsurfp_ismm(i,ip)=lsurfp_ism(i,ip)
         end do !i
c
         do l=1,nlgse_pmx
         lsurfp_ilgm(l,ip)=lsurfp_ilg(l,ip)
         end do !i

         end do ! ip
c..
        if(outdetl.ge.iiprint1)then
        write(*,*)'en_ggg000: nsmalse_tm, nlargse_tm=',
     &                             nsmalse_tm,nlargse_tm
        end if
c.
        end if ! keep PSm       
c.
c. keep sigma for PS+i
        if(outdetl.gt.iiprint1)then
        write(*,*)'en_ggg000: keep sigma_PS+ix=',ix
c       write(kanalp,*)'en_ggg000: keep sigma_PS+ix=',ix
        end if
        do is=1,nsmalse_tm
        sigmasmt_tv(is,ix)=sigmasmt_t(is)
        end do
c.
        do il=1,nlargse_tm
        sigmalgt_tv(il,ix)=sigmalgt_t(il)
        end do
c..
        do ip=1,nsurfp_tm
        surfp_qv(ip,ix)=surfp_q(ip)
        end do
c.
        qmlcurv(ix)=qmlcur
c.
       goto 1000
1010   continue
c
c.
       if(outdetl.ge.iiprint0)then
c       write(kanalp,*)
c       write(kanalp,*)'en_ggg000: Solvation of S+i free energy start'
        write(*,*)'en_ggg000: Solvation of S+i free energy start'
       end if
c----------------------------------------------------------------------
c  part II isolated residues-------------------------------------------

       irg=0
       ix=0
2000   ix=ix+1
       if(ix.gt.npolres_t)goto 2010
       elfren_s(ix)=0.d0
       if(xxdelt(ix).eq.0)goto 2000
c. define elfreeng for isolated residue S+i
c.        
       natm=natm_polrs(ix)
       nsoord=natm
       do ia=1,natm
       l=latm_polrs(ia,ix)
       atmq_ps(ia)=atmcha(l)
       rad_ps(ia)=atmrad(l)
       do k=1,3
       soord(k,ia)=atmxyz(k,l)
       end do
       end do
        
       if(outdetl.ge.iiprint0)then
c      write(kanalp,*)
c      write(kanalp,*)'en_ggg000 (2): S+(ix),ix=',ix,
c    &             'natm=',natm
       write(*,*)'en_ggg000 (2): S+(ix),ix=',ix,
     &             'natm=',natm
       end if

       if(outdetl.ge.iiprint1)then
c      write(kanalp,*)'nsoord=',nsoord
c      write(kanalp,*)'iat=,atmq=,atmrad=,xyz='
       write(*,*)'nsoord=',nsoord
       write(*,*)'iat=,atmq=,atmrad=,xyz='
        do i=1,nsoord
c      write(kanalp,('(i5,5f8.3)'))i,atmq_ps(i),rad_ps(i),
c    & (soord(k,i),k=1,3)
       write(*, '(i5,5f8.3)') i,atmq_ps(i),rad_ps(i),
     & (soord(k,i),k=1,3)
        end do
c.
        end if !outdtl
c.
c.
       irg=0
       call solv_freng(irg,nsoord,soord,rad_ps,atmq_ps,
     &                  solfren,elfren,hpfren)
       if (kprotfail.le.-1) return
       
!       timeint=tcpu()-tstar0
!       if (YourJob) write(kanalp,*)'time after solv_freng(2) ',timeint

        if (stopx(idumm)) then
          write(*,*) 'Aborting in en_ggg000'
          kprotfail=-999
          return
        endif

       elfren_s(ix)=elfren
c      if(outdetl.ge.iprint1)then
c      write(kanalp,*)'en_ggg000:S+ ix=',ix,' elfren=',elfren
c       end if
c..
       ggg000_is(ix)=xxdelt(ix)*(elfren_ps(ix)-elfren_s(ix))
       ggg000=ggg000+ggg000_is(ix)
       ggg00=ggg000
  
c..
       goto 2000
2010   continue
c
        if(outdetl.ge.iiprint1)then
c       write(kanalp,*)'en_ggg000: desolvation energies of residues='
        write(*,*)'en_ggg000: desolvation energies of residues='
        do ix=1, npolres_t
c       write(kanalp,*)'res ix=',ix,' desolv enrg=',ggg000_is(ix)
        write(*,*)'res ix=',ix,' desolv enrg=',ggg000_is(ix)
        end do
c       write(kanalp,*)'total desolvation energy=',ggg000
        write(*,*)'total desolvation energy=',ggg000
        end if !outdetl
c
       return
       end
