cag
cag...Oct 2nd 1991. This code has been modified to compute 
cag...the analytical area for each convex face. The code in 
cag...lower case has been added by AG. Note in this version there 
cag...is still a problem when convex faces with interior cycles 
cag...(holes) are encountered. This will be fixed next release.
cag
      SUBROUTINE CCNX(IRET)
      IMPLICIT REAL*8 (A-H,O-Z)
C
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      PARAMETER(MAXATO=maxnum_atoms)
c     PARAMETER(MAXAX =10)
c     PARAMETER(MAXCNX=MAXFAC)
C
      PARAMETER (PI2=PI*2.0D0)
C
      REAL*8 P(3),V(3),PTES(3)
      REAL*8 PCNX(3,MAXORS),QCNX(3,MAXORS)
      REAL*8 RCNX(3,MAXORS)
CDR   INTEGER*4 LMAR(2,MAXTOR)
CDR   INTEGER*4 LAX(MAXAX,MAXATO),LNAX(MAXATO)
      INTEGER   LMAR(2,MAXTOR)
      INTEGER   LAX(MAXAX,MAXATO),LNAX(MAXATO)
C
      include 'COMMON.SOLVAT'
      include 'COMMON.SOLVAT3'
      include 'COMMON.IOUNIT'
c     COMMON /COOR/XYZ(3,MAXATO),RADII(MAXATO),DP,RADMX,NAT
c     COMMON /CONC/LFAC(3,MAXFAC),CNT(MAXFAC,3),
c    *             LFPT(3,MAXFAC),LFPTO(3,MAXFAC),NFAC
c     COMMON /TORI/LTOR(2,MAXTOR),LTPF(2,MAXTOR),LTPFO(2,MAXTOR),NTOR
c     COMMON /CNX/LCNX(MAXORS,MAXCNX,2),LNCNX(MAXCNX),LICNX(MAXCNX),NCNX     
c    *           ,LBNX(MAXAX,MAXCNX),LNBNX(MAXCNX)
cag
cag...this commoninserted  by AG to facilitate computation of the face areas.
c     COMMON /ANGL/BETA(MAXFAC,3),TORPHI(MAXTOR),CTET(MAXTOR,2)      
cag...this new common added by AG to save convex face areas.
c     common /cnxa/acnx(maxcnx)
C
      IRET=0
      RP=0.5D0*DP
C      
C INITIALIZE COMMON CNX
C
      DO ITOR=1,NTOR
       DO IORD=1,2
        LMAR(IORD,ITOR)=0
       ENDDO
      ENDDO
      NCNX=0
      DO ITOR=1,NTOR
       DO IORD=1,2
        IF(LMAR(IORD,ITOR).EQ.0) THEN
         NCNX=NCNX+1
cag
cag...added to compute area of convex face NCNX
         alpha=0.0d0
         othang=0.0d0
         KTOR=ITOR
         KORD  =IORD
         KORDIV=1+MOD(KORD,2)
         NF  =LTPF(KORDIV,KTOR)
         LNCNX(NCNX)=1
         LICNX(NCNX)   =LTOR(KORDIV,KTOR)
         LCNX(1,NCNX,1)=LTOR(KORD,KTOR)
         LCNX(1,NCNX,2)=NF
         NORF=LTPFO(KORDIV,KTOR)
         KAT =LFAC(NORF,NF)
         NLASTF=NF
 100     CONTINUE
          IF(LMAR(KORD,KTOR).NE.0) THEN
	   write (jout,'(a,i7,a,i5,1h./a,i7,a,i7,a,i7,a,i7,1h./a)') 
     &     '(W) Error in CCNX:',
     &     ' Two circuits have met at vertex ',LTOR(KORD,KTOR),
     &     ' on atom ',KAT,
     &     'One circuit started at edge ',ITOR,' vertex ',IORD,
     &     '  and is now at edge ',KTOR,' vertex ',KORD
	   iret=-1
	   return
c          STOP
          ENDIF
          LMAR(KORD,KTOR)=1
cag
cag...accumulate angles for this convex face:          
          xx=ctet(ktor,kordiv)
          othang=othang+torphi(ktor)*xx
          alpha=alpha-beta(nf,norf)
          NEWORF=1+MOD(NORF+1,3)
          KTOR=LFPT(NEWORF,NF)
          KORD  =LFPTO(NEWORF,NF)
          KORDIV=1+MOD(KORD,2)
          NF  =LTPF(KORDIV,KTOR)
          LNCNX(NCNX)=LNCNX(NCNX)+1
          LCNX(LNCNX(NCNX),NCNX,1)=LTOR(KORD,KTOR)
          LCNX(LNCNX(NCNX),NCNX,2)=NF
          NORF=LTPFO(KORDIV,KTOR)
          KAT =LFAC(NORF,NF)
         IF(NF.NE.NLASTF) GOTO 100
         LNCNX(NCNX)=LNCNX(NCNX)-1
cag
cag...Complete calculation of convex face area. Note this formula
cag...is only correct if there are no interior cycles.
         acnx(ncnx)=(pi2+alpha+othang)*radii(kat)**2
        ENDIF
       ENDDO
      ENDDO
C
C INITIALIZE POINTERS ON CONVEX PIECES 
C
      DO IAT=1,NAT
       LNAX(IAT)=0
      ENDDO
      DO ICNX=1,NCNX
       IAT=LICNX(ICNX)
       LNAX(IAT)=LNAX(IAT)+1
       LAX(LNAX(IAT),IAT)=ICNX
      ENDDO
C
C FIND WHETHER CYCLES ARE INSIDE ARE OUTSIDE ONE ANOTHER
C
      DO ICNX=1,NCNX
       LNBNX(ICNX)=0
      ENDDO
      DO IAT=1,NAT
       DO IAX=1,LNAX(IAT)
        ICNX=LAX(IAX,IAT)
        IFAC=LCNX(1,ICNX,2)
        DO K=1,3
         P(K)=CNT(IFAC,K)
        ENDDO 
        CALL NORM(XYZ(1,IAT),P,V)
        DO K=1,3
         PTES(K)=XYZ(K,IAT)+RADII(IAT)*V(K)
        ENDDO 
        DO JAX=1,LNAX(IAT)
         IF(JAX.NE.IAX) THEN
          JCNX=LAX(JAX,IAT)
          NORS=LNCNX(JCNX)
          DO IORS=1,NORS
           JAT=LCNX(IORS,JCNX,1)
           DO K=1,3
            QCNX(K,IORS)=XYZ(K,IAT)-XYZ(K,JAT)
           ENDDO 
           SS=DSQRT(QCNX(1,IORS)**2+QCNX(2,IORS)**2+QCNX(3,IORS)**2)
           DO K=1,3
            QCNX(K,IORS)=QCNX(K,IORS)/SS
           ENDDO
           JFAC=LCNX(IORS,JCNX,2)
           DO K=1,3
            P(K)=CNT(JFAC,K)
           ENDDO 
           CALL NORM(XYZ(1,IAT),P,V)
           DO K=1,3
            PCNX(K,IORS)=XYZ(K,IAT)+RADII(IAT)*V(K)
           ENDDO 
          ENDDO
          DO IORS=1,NORS
           JORS=1+MOD(IORS+NORS-2,NORS)
           DO K=1,3
            V(K)=PCNX(K,IORS)-PCNX(K,JORS)
           ENDDO
           RCNX(1,IORS)=V(2)*QCNX(3,IORS)-V(3)*QCNX(2,IORS)
           RCNX(2,IORS)=V(3)*QCNX(1,IORS)-V(1)*QCNX(3,IORS)
           RCNX(3,IORS)=V(1)*QCNX(2,IORS)-V(2)*QCNX(1,IORS)
           SS=DSQRT(RCNX(1,IORS)**2+RCNX(2,IORS)**2+RCNX(3,IORS)**2)
           DO K=1,3
            RCNX(K,IORS)=RCNX(K,IORS)/SS
           ENDDO 
          ENDDO
C
          INSDE=0
C         CALL DOTCHK(PTES,PCNX,QCNX,NORS,INSDE,KK)
C         IF(INSDE.EQ.1) THEN
C          PRINT*,'CCNX : WARNING, DOTCH2 IS USED'
C          CALL DOTCH2(P,XYZ(1,IAT),RADII(IAT),PCNX,QCNX,
C    *                 RCNX,NORS,INSDE)
C         ENDIF
          IF(INSDE.EQ.1) THEN
           write (jout,'(2a)') 
     &   'CCNX: warning, interior cycle JCNX such that'
     *           ,' ICNX inside of JCNX.'
           LNBNX(JCNX)=LNBNX(JCNX)+1
           LBNX(LNBNX(JCNX),JCNX)=ICNX
           ENDIF
         ENDIF
        ENDDO
       ENDDO
      ENDDO
      RETURN
      END
C
C
C
C
      SUBROUTINE DOX(DENS,IRET)
      IMPLICIT REAL*8 (A-H,O-Z)
C
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      PARAMETER (MAXATO=maxnum_atoms)
c     PARAMETER(MAXCNX=MAXFAC)
c     PARAMETER(MAXAX =10)
c     PARAMETER(MAXDOX=20000)
c     PARAMETER(MAXDOT=100000)

      PARAMETER (PI2=PI*2.0D0)
      PARAMETER (PI4=PI*4.0D0)
      PARAMETER (PIOV2=PI/2.0D0)
      PARAMETER (PIOV3=PI/3.0D0)
C
      REAL*8 P(3),PTES(3),V(3)
      REAL*8 PCNX(3,MAXORS),QCNX(3,MAXORS)
      REAL*8 RCNX(3,MAXORS)
      REAL*8 POLE(3),POLX(3),POLY(3),POLZ(3),DOTX(3,MAXDOX),
     &       dotxn(3,maxdox)
CDR   INTEGER*4 LSUC(MAXDOX),LMARX(MAXCNX)
      INTEGER   LSUC(MAXDOX),LMARX(MAXCNX)
C
      include 'COMMON.SOLVAT'
      include 'COMMON.SOLVAT3'
      include 'COMMON.IOUNIT'
c     COMMON /COOR/XYZ(3,MAXATO),RADII(MAXATO),DP,RADMX,NAT
c     COMMON /CONC/LFAC(3,MAXFAC),CNT(MAXFAC,3),
c    *             LFPT(3,MAXFAC),LFPTO(3,MAXFAC),NFAC
c     COMMON /SURF/AREA(MAXATO)
c     COMMON /CNX/LCNX(MAXORS,MAXCNX,2),LNCNX(MAXCNX),LICNX(MAXCNX),NCNX 
c    *           ,LBNX(MAXAX,MAXCNX),LNBNX(MAXCNX)
c     COMMON /DOTT/DOTC(3,MAXDOT),DOTN(3,MAXDOT),DOTA(MAXDOT),
c    *             LDOTT(MAXDOT),NDOTT
cag...this new common added by AG to save convex face areas.
c     common /cnxa/acnx(maxcnx)
C
      IRET=0
C      NDOTT=0
      NDOT=0
      RP=0.5D0*DP
C
C DETERMINE POLES
C
      DO ICNX=1,NCNX
       LMARX(ICNX)=0 
      ENDDO
      DO ICNX=1,NCNX 
       IF(LMARX(ICNX).EQ.1) GOTO 250
       IAT=LICNX(ICNX)
       NORS=LNCNX(ICNX)
       DO IORS=1,NORS
        JAT =LCNX(IORS,ICNX,1)
        DO K=1,3
         QCNX(K,IORS)=XYZ(K,IAT)-XYZ(K,JAT)
        ENDDO 
        SS=DSQRT(QCNX(1,IORS)**2+QCNX(2,IORS)**2+QCNX(3,IORS)**2)
        DO K=1,3
         QCNX(K,IORS)=QCNX(K,IORS)/SS
        ENDDO
        IFAC=LCNX(IORS,ICNX,2)
        DO K=1,3
         P(K)=CNT(IFAC,K)
        ENDDO 
        CALL NORM(XYZ(1,IAT),P,V)
        DO K=1,3
         PCNX(K,IORS)=XYZ(K,IAT)+RADII(IAT)*V(K)
        ENDDO 
C       WRITE(2,*) PCNX(1,IORS),PCNX(2,IORS),PCNX(3,IORS)
       ENDDO
       DO IORS=1,NORS
        JORS=1+MOD(IORS+NORS-2,NORS)
C       WRITE(3,'(6F8.3)') PCNX(1,JORS),PCNX(2,JORS),PCNX(3,JORS)
C       WRITE(3,'(6F8.3)') PCNX(1,IORS),PCNX(2,IORS),PCNX(3,IORS)
        DO K=1,3
         V(K)=PCNX(K,IORS)-PCNX(K,JORS)
        ENDDO
        RCNX(1,IORS)=V(2)*QCNX(3,IORS)-V(3)*QCNX(2,IORS)
        RCNX(2,IORS)=V(3)*QCNX(1,IORS)-V(1)*QCNX(3,IORS)
        RCNX(3,IORS)=V(1)*QCNX(2,IORS)-V(2)*QCNX(1,IORS)
        SS=DSQRT(RCNX(1,IORS)**2+RCNX(2,IORS)**2+RCNX(3,IORS)**2)
        DO K=1,3
         RCNX(K,IORS)=RCNX(K,IORS)/SS
        ENDDO
       ENDDO 
       DO K=1,3
        P(K)=0.0D0
       ENDDO
       DO IORS=1,NORS
        DO K=1,3
         P(K)=P(K)+PCNX(K,IORS)
        ENDDO
       ENDDO
       DO K=1,3
        P(K)=P(K)/DFLOAT(NORS)
       ENDDO
       CALL NORM(XYZ(1,IAT),P,V)
       DO K=1,3
        POLE(K)=XYZ(K,IAT)+RADII(IAT)*V(K)
       ENDDO
C      DO K=1,3
C       POLE(K)=PCNX(K,1)
C      ENDDO
       CALL NORM(XYZ(1,IAT),POLE,POLZ) 
       IF(DABS(POLZ(1)).GT.1.0D-2) THEN
        SS=DSQRT(POLZ(2)**2+POLZ(3)**2)
        POLX(1)=0.0D0
        POLX(2)=-POLZ(3)/SS
        POLX(3)= POLZ(2)/SS
       ELSE
        IF(DABS(POLZ(2)).GT.1.0D-2) THEN
         SS=DSQRT(POLZ(1)**2+POLZ(3)**2)
         POLX(1)=-POLZ(3)/SS
         POLX(2)=0.0D0
         POLX(3)= POLZ(1)/SS
        ELSE 
         SS=DSQRT(POLZ(1)**2+POLZ(2)**2)
         POLX(1)=-POLZ(2)/SS
         POLX(2)= POLZ(1)/SS
         POLX(3)=0.0D0
        ENDIF
       ENDIF
       POLY(1)=POLZ(2)*POLX(3)-POLZ(3)*POLX(2)
       POLY(2)=POLZ(3)*POLX(1)-POLZ(1)*POLX(3)
       POLY(3)=POLZ(1)*POLX(2)-POLZ(2)*POLX(1)
C
C GENERATE DOTS 
C
       NDOT=0
       NVERT=INT(2.0D0*PI*RADII(IAT)*DSQRT(DENS))/2
       IF(NVERT.LT.1) NVERT=1
       IVERT=-1
 200   CONTINUE
        IVERT=IVERT+1
        FI=PI*DFLOAT(IVERT)/DFLOAT(NVERT)
cag... cos-->dcos
        ALT=DCOS(FI)
cag... sin-->dsin
        XY=DSIN(FI)
        NHOR=INT(DFLOAT(NVERT)*2.0D0*XY)
        IF(NHOR.LT.1) NHOR=1
        DO IHOR=0,NHOR-1
         FJ=PI2*DFLOAT(IHOR)/DFLOAT(NHOR)
cag... cos-->dcos
         PTES(1)=DCOS(FJ)*XY
cag... sin-->dsin
         PTES(2)=DSIN(FJ)*XY
         PTES(3)=ALT
         DO K=1,3
          V(K)=PTES(1)*POLX(K)+PTES(2)*POLY(K)+PTES(3)*POLZ(K)
         ENDDO
         DO K=1,3
          PTES(K)=XYZ(K,IAT)+RADII(IAT)*V(K)
         ENDDO
         CALL DOTCHK(PTES,PCNX,QCNX,NORS,INSDE,KK)
         IF(INSDE.EQ.1) THEN
          CALL DOTCH2(PTES,XYZ(1,IAT),RADII(IAT),PCNX,QCNX,
     *                RCNX,NORS,INSDE,iret)
	 if (iret.eq.-1) return
         ENDIF
         IF(INSDE.EQ.1) THEN
          NDOT=NDOT+1
          DO K=1,3
           DOTX(K,NDOT)=PTES(K)
           dotxn(k,ndot)=v(k)
          ENDDO
         ENDIF
        ENDDO
C
C END LOOP OVER ALL THE DOTS OF A CIRCLE
C
       IF(IVERT.LT.NVERT) GOTO 200 
C
C END LOOP OVER ALL CIRCLES
C 
C
C NOW CHECK INTERIOR CYCLES
C
       DO IDOT=1,NDOT
        LSUC(IDOT)=1
       ENDDO
       DO IAX=1,LNBNX(ICNX)
        JCNX=LBNX(IAX,ICNX)
        KAX=0
        DO JAX=1,LNBNX(JCNX)
         IF(LBNX(JAX,JCNX).EQ.ICNX) KAX=JAX
        ENDDO
        IF(KAX.NE.0) THEN
         write (jout,'(2a)') 
     & 'DOX: Warning, interior cycle JCNX such that'
     *         ,' ICNX inside of JCNX.'
         LMARX(JCNX)=1
         NORS=LNCNX(JCNX)
         DO JORS=1,NORS
          JAT=LCNX(JORS,JCNX,1)
          DO K=1,3
           QCNX(K,JORS)=XYZ(K,IAT)-XYZ(K,JAT)
          ENDDO 
          SS=DSQRT(QCNX(1,JORS)**2+QCNX(2,JORS)**2+QCNX(3,JORS)**2)
          DO K=1,3
           QCNX(K,JORS)=QCNX(K,JORS)/SS
          ENDDO
          JFAC=LCNX(JORS,JCNX,2)
          DO K=1,3
           P(K)=CNT(JFAC,K)
          ENDDO 
          CALL NORM(XYZ(1,IAT),P,V)
          DO K=1,3
           PCNX(K,JORS)=P(K)+RADII(IAT)*V(K)
          ENDDO 
         ENDDO
         DO JORS=1,NORS
          KORS=1+MOD(JORS+NORS-2,NORS)
          DO K=1,3
           V(K)=PCNX(K,JORS)-PCNX(K,KORS)
          ENDDO
          RCNX(1,JORS)=V(2)*QCNX(3,JORS)-V(3)*QCNX(2,JORS)
          RCNX(2,JORS)=V(3)*QCNX(1,JORS)-V(1)*QCNX(3,JORS)
          RCNX(3,JORS)=V(1)*QCNX(2,JORS)-V(2)*QCNX(1,JORS)
          SS=DSQRT(RCNX(1,JORS)**2+RCNX(2,JORS)**2+RCNX(3,JORS)**2)
          DO K=1,3
           RCNX(K,JORS)=RCNX(K,JORS)/SS
          ENDDO
         ENDDO 
         DO IDOT=1,NDOT
          CALL DOTCHK(DOTX(1,IDOT),PCNX,QCNX,NORS,INSDE,KK) 
          IF(INSDE.EQ.1)
     *     CALL DOTCH2(DOTX(1,IDOT),XYZ(1,IAT),RADII(IAT),PCNX,QCNX,
     *                 RCNX,NORS,INSDE,iret)
	  if (iret.eq.-1) return
          IF(INSDE.EQ.0) LSUC(IDOT)=0
         ENDDO
        ENDIF
       ENDDO  
cag
cag...use nfirst to determine how many dots survive on face.
       nfirst=ndott+1
       DO IDOT=1,NDOT
        IF(LSUC(IDOT).EQ.1) THEN
         NDOTT=NDOTT+1
cag
cag...record dot type (1=convex, 2=saddle, 3=concave)
         ldott(ndott)=1
         DO K=1,3
          DOTC(K,NDOTT)=DOTX(K,IDOT)
cag...compute  dot normal
          dotn(k,ndott)=dotxn(k,idot)
         ENDDO
        ENDIF
       ENDDO 
cag
cag...save area of each dot
       nsucc=ndott-nfirst+1
       if(nsucc .gt.0) then
        darea=acnx(icnx)/dfloat(nsucc)
       else
        darea=0.0d0
cyu        print *,'convex face with no dot '
       endif
       do idot=nfirst,ndott
        dota(idot)=darea
       end do
cag
 250   CONTINUE
      ENDDO
             
cyu      DO IDOTT=1,NDOTT
cyu      WRITE(10,'(3F8.3)') DOTC(1,IDOTT),DOTC(2,IDOTT),DOTC(3,IDOTT)
cyu      ENDDO
C
C END LOOP OVER ALL ICNX
C
      RETURN
      END
C
C
C
      SUBROUTINE DOTCHK(P,CYC,CYCN,NORS,INSDE,IORS)
      IMPLICIT REAL*8 (A-H,O-Z)
C
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      REAL*8 P(3),CYC(3,MAXORS),CYCN(3,MAXORS),V(3)
      INSDE=1
      IORS=0
150   CONTINUE
       IORS=IORS+1
       DO K=1,3
        V(K)=P(K)-CYC(K,IORS)
       ENDDO
       XX=CYCN(1,IORS)*V(1)+CYCN(2,IORS)*V(2)+CYCN(3,IORS)*V(3)
       IF(XX.LT.-1.D-5) INSDE=0
C     IF(IORS.LT.NORS) GOTO 150
      IF((INSDE.EQ.1).AND.(IORS.LT.NORS)) GOTO 150
      RETURN
      END
C
C
C
      SUBROUTINE DOTCH2(P,P0,RADIUS,CYC,CYCN,CYCN2,NORS,INSDE,iret)
      IMPLICIT REAL*8 (A-H,O-Z)
C
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      include 'COMMON.IOUNIT'
CDR   INTEGER*4 LINTER(MAXORS)
      INTEGER   LINTER(MAXORS)
      REAL*8 P(3),P0(3),CYC(3,MAXORS),CYCN(3,MAXORS)
      REAL*8 CYCN2(3,MAXORS)
      REAL*8 P2(3),V2(3),PT(3,MAXORS,2),DIS(MAXORS,2)
      REAL*8 V(3)
C
C FIND THE INTERSECTIONS BETWEEN THE BASE CIRCLES OF THE EDGES, AND A 
C CIRCLE ON THE IAT SPHERE CONTAINING P AND CYC(1,1)  
C
      INSDE=1


      IF(DABS(P(1)-CYC(1,1))+DABS(P(2)-CYC(2,1)).GT.1.0D-5) THEN
       ICORD=1
       V(1)=CYC(2,1)-P(2)
       V(2)=P(1)-CYC(1,1)
       V(3)=0.0D0
      ELSE
       IF(DABS(P(3)-CYC(3,1)).GT.1.0D-5) THEN
        write (jout,'(a)') 'DOTCH2: warning, PCNX(1,1)-P // 0,0,1.'
        ICORD=2
        V(1)=0.0D0
        V(2)=CYC(3,1)-P(3)
        V(3)=P(2)-CYC(2,1)
       ELSE
C       PRINT*,'DOTCH2 : WARNING, P = PCNX(1,1)'
        RETURN
       ENDIF
      ENDIF
      DO IORS=1,NORS
       LINTER(IORS)=0
       V2(1)=V(2)*CYCN(3,IORS)-V(3)*CYCN(2,IORS)
       V2(2)=V(3)*CYCN(1,IORS)-V(1)*CYCN(3,IORS)
       V2(3)=V(1)*CYCN(2,IORS)-V(2)*CYCN(1,IORS)
       SSV2=V2(1)**2+V2(2)**2+V2(3)**2
       IF(SSV2.LT.4.0D-10) THEN
        IF(DABS((P(1)-CYC(1,IORS))*CYCN(1,IORS)+(P(2)-CYC(2,IORS))*
     *  CYCN(2,IORS)+(P(3)-CYC(3,IORS))*CYCN(3,IORS)).LT.1.0D-2) THEN
         write (jout,'(a)') 'DOTCH2: Warning, P on an edge.'
         SS=(P(1)-CYC(1,IORS))*CYCN2(1,IORS)
     *     +(P(2)-CYC(2,IORS))*CYCN2(2,IORS)
     *     +(P(3)-CYC(3,IORS))*CYCN2(3,IORS)
         IF(SS.LT.-1.0D-5) INSDE=0
         RETURN
        ELSE
         write (jout,'(a)') 
     &  'DOTCH2: warning, plan // to one of the edges plan.'
        ENDIF
       ELSE
C
C FIND P2
C
        IF(ICORD.EQ.1) THEN
C        IF(ABS(CYCN(3,IORS)).GT.1.0D-5) THEN
         IF(DABS(CYCN(3,IORS)).GT.1.0D-5) THEN
          P2(1)=P(1)
          P2(2)=P(2)
          P2(3)=CYC(3,IORS)+((CYC(1,IORS)-P(1))*CYCN(1,IORS)
     *         +(CYC(2,IORS)-P(2))*CYCN(2,IORS))/CYCN(3,IORS)
         ELSE
c.yu     PRINT*,'WARNING : ICORD = 1 and Abs(cycn(3,iors)) > 1.0D-5 '
          P2(3)=P(3)
          A=V(1)*P(1)+V(2)*P(2)
          B=CYCN(1,IORS)*CYC(1,IORS)+CYCN(2,IORS)*CYC(2,IORS)  
     *     +CYCN(3,IORS)*(CYC(3,IORS)-P(3))
          P2(1)=(CYCN(2,IORS)*A-V(2)*B)/V2(3)
          P2(2)=(V(1)*B-CYCN(1,IORS)*A)/V2(3)
         ENDIF
        ELSE
C        IF(ABS(CYCN(1,IORS)).GT.1.0D-5) THEN
         IF(DABS(CYCN(1,IORS)).GT.1.0D-5) THEN
c.yu          PRINT*,' WARNING : ICORD = 2'
          P2(2)=P(2)
          P2(3)=P(3)
          P2(1)=CYC(1,IORS)+((CYC(2,IORS)-P(2))*CYCN(2,IORS)
     *         +(CYC(3,IORS)-P(3))*CYCN(3,IORS))/CYCN(1,IORS)
         ELSE
c.yu     PRINT*,'WARNING : ICORD = 2 and Abs(cycn(3,iors)) > 1.0D-5 '
          P2(1)=P(1)
          A=V(2)*P(2)+V(3)*P(3)
          B=CYCN(2,IORS)*CYC(2,IORS)+CYCN(3,IORS)*CYC(3,IORS)  
     *     +CYCN(1,IORS)*(CYC(1,IORS)-P(1))
          P2(2)=(CYCN(3,IORS)*A-V(3)*B)/V2(1)
          P2(3)=(V(2)*B-CYCN(2,IORS)*A)/V2(1)
         ENDIF
        ENDIF
C
C END OF FIND P2
C
        SS=V2(1)*(P0(1)-P2(1))
     *    +V2(2)*(P0(2)-P2(2))
     *    +V2(3)*(P0(3)-P2(3))
        DS=(P0(1)-P2(1))**2
     *    +(P0(2)-P2(2))**2
     *    +(P0(3)-P2(3))**2
        TAU2=RADIUS**2+SS**2/SSV2-DS
        IF(TAU2.GE.0.0D0) THEN
         TAU=DSQRT(TAU2/SSV2)
         XS=SS/SSV2
         LINTER(IORS)=1
         DO K=1,3
          PT(K,IORS,1)=P2(K)+(XS-TAU)*V2(K)
          PT(K,IORS,2)=P2(K)+(XS+TAU)*V2(K)
         ENDDO
        ENDIF
       ENDIF
      ENDDO
C
C FIND THE DOT NEAR P
C
      KORS=0
      KSYM=0
      DMIN=1.0D+38
      DO ISYM=1,2
       DO IORS=1,NORS
        IF(LINTER(IORS).EQ.1) THEN
         SS=(P(1)-PT(1,IORS,ISYM))**2+(P(2)-PT(2,IORS,ISYM))**2
     *     +(P(3)-PT(3,IORS,ISYM))**2
         DIS(IORS,ISYM)=SS
         IF(SS.LT.DMIN) THEN
          KSYM=ISYM
          KORS=IORS
          DMIN=SS
         ENDIF
        ENDIF
       ENDDO 
      ENDDO
      IF(KORS.EQ.0) THEN 
       write (JOUT,'(a)') '(F) DOTCH2 error: KORS = 0. The program',
     & ' will recover by trying another conformation.'
       iret=-1
       return
c      STOP
      ENDIF
C
C CHECK WETHER THIS DOT IS ON AN EDGE OR NOT
C
      ICHK=0
      DO ISYM=1,2
       DO IORS=1,NORS
        IF(DABS(DIS(IORS,ISYM)-DIS(KORS,ISYM)).LT.1.0D-5) THEN
         IF(KORS*IORS.NE.2) THEN
          SS=(PT(1,IORS,KSYM)-CYC(1,IORS))*CYCN2(1,IORS)
     *      +(PT(2,IORS,KSYM)-CYC(2,IORS))*CYCN2(2,IORS)
     *      +(PT(3,IORS,KSYM)-CYC(3,IORS))*CYCN2(3,IORS)
          IF(SS.GT.-1.0D-5) ICHK=1
         ENDIF
        ENDIF
       ENDDO
      ENDDO
      IF(ICHK.EQ.0) INSDE=0
      RETURN
      END

      subroutine sadx(dens,iret)
c     implicit none 
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      integer maxato
      parameter(maxato=maxnum_atoms )
c     parameter(maxdot=100000)
      real*8 piov2     
      parameter (piov2=pi/2.0d0)
      include 'COMMON.SOLVAT'
      include 'COMMON.SOLVAT3'
c     common /angl/beta(maxfac,3),torphi(maxtor),ctet(maxtor,2)
c       real*8 beta,torphi,ctet
c     common /coor/xyz(3,maxato),radii(maxato),dp,radmx,nat
c       integer nat
c       real*8 xyz,radii,dp,radmx
c     common /conc/lfac(3,maxfac),cnt(maxfac,3),
c    &             lfpt(3,maxfac),lfpto(3,maxfac),nfac
c       integer lfac,lfpt,lfpto,nfac
c       real*8  cnt
c     common /tori/ltor(2,maxtor),ltpf(2,maxtor),ltpfo(2,maxtor),ntor
c       integer ltor,ltpf,ltpfo,ntor
c     common /dott/dotc(3,maxdot),dotn(3,maxdot),dota(maxdot),
c    &             ldott(maxdot),ndott
c       integer ldott,ndott
c       real*8 dota,dotc,dotn    
cag
cag...Declare local variables
cag
      integer iatom,idott,iret,itor,jatom,k,nfirst,i
      real*8 ai(3),aj(3),darea,dens,dij2,farea,ftotal,
     &       pijk(3),radi,radip,radj,radjp,ratio,rij,
     &       rp,thi,thj,tij(3),uij(3),vpi(3)

cyu      print*,'sadx.f release 1.1 last change oct 3rd  1991 '

      rp=0.5d0*dp
      ftotal = 0.0d0
      do itor=1,ntor
       nfirst=ndott+1
       iatom=ltor(1,itor)
       jatom=ltor(2,itor)
       radi=radii(iatom)
       radj=radii(jatom)
       radip=radi+rp
       radjp=radj+rp
       thi=piov2 - dacos(ctet(itor,1))
       thj=piov2 - dacos(ctet(itor,2))
       do k=1,3
        ai(k)=xyz(k,iatom)
        aj(k)=xyz(k,jatom)
       end do
       dij2=(aj(1)-ai(1))**2 + (aj(2)-ai(2))**2 + (aj(3)-ai(3))**2
       ratio=(radip**2-radjp**2)/dij2
       do k=1,3
        pijk(k)=cnt(ltpf(1,itor),k)
        vpi(k)=(radi*pijk(k)+rp*xyz(k,iatom))/radip
        tij(k)=0.5d0*(ai(k)+aj(k)) + 0.5d0*(aj(k)-ai(k))*ratio
       end do
       call norm(ai,aj,uij)
cag...Saddle area (note rij=radip*cos(thi) = radjp*cos(thj))
       rij=radip*dcos(thi)
       farea=rij*(thi+thj) - rp*(dsin(thi)+dsin(thj))
       farea=rp*torphi(itor)*farea
       ftotal = ftotal + farea

       call sdots(itor,iatom,jatom,radi,radj,
     &            rp,dens,thi,thj,torphi(itor),
     &            pijk,vpi,uij,tij)
c             
       darea=farea/(dfloat(ndott-nfirst+1))
       do idott=nfirst,ndott
        dota(idott)=darea
       end do
      end do

cyu      print*,'total saddle area ',ftotal

      return 
      end 
c...... ................................................................
      subroutine sdots(itor,iatom,jatom,radi,radj,rp,dens,thi,thj,
     &                 swrap,pijk,vpi,uij,tij)
c     implicit none
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      
c     integer maxarc,maxdot
c     parameter(maxarc=500)
c     parameter(maxdot=100000)
      include 'COMMON.SOLVAT3'
      include 'COMMON.IOUNIT'
c     common /dott/dotc(3,maxdot),dotn(3,maxdot),dota(maxdot),
c    &             ldott(maxdot),ndott
c       integer ldott,ndott
c       real*8 dota,dotc,dotn    
cag...Declare local variables        
      integer iarc,iatom,irot,itor,jatom,i,j,k,narc0,nrot0

      real*8 alt(3),avh,dens,densq,ghgd(3,3),gmat(3,3),
     &       gmatd(3,3),lnrm(3),phi,pijk(3),pow(3,3),radi,radj,ratio,
     &       rij,rp,swidth,swrap,thi,thj,tij(3),uij(3),v0(3),v1(3),
     &       v2(3),vbs(3), vbs0(3,maxarc),vpi(3),vps0(3,maxarc),
     &       xrot(3,3),zrot(3,3)

      densq = dsqrt(dens)       
      swidth= thi + thj

      rij=0.0d0
      do k=1,3
       alt(k)=pijk(k)-tij(k)
       rij=rij+alt(k)**2
       gmat(k,1)=uij(k)
      end do
      rij=dsqrt(rij)
      call norm(tij,pijk,gmat(1,2)) 
      gmat(1,3)=gmat(2,1)*gmat(3,2)-gmat(3,1)*gmat(2,2)
      gmat(2,3)=gmat(3,1)*gmat(1,2)-gmat(1,1)*gmat(3,2)
      gmat(3,3)=gmat(1,1)*gmat(2,2)-gmat(2,1)*gmat(1,2)

      do i=1,3
       do j=1,3
        gmatd(i,j)=gmat(j,i)
       end do
      end do
              
      narc0=int(swidth*rp*densq)
      if(narc0.lt.1) then
       narc0=1
      else
       if(narc0.gt.maxarc) then 
        write (jout,'(a)') 
     &  '(F) MSEED error: MAXARC exceeded. Reset parameter in sdots.'
        stop
       endif
      endif
                   
      phi=swidth/(dfloat(narc0))
                
      do k=1,3
       v1(k)=vpi(k)-pijk(k)
      end do

      call multv(v1,gmatd,v0)            

      call idmatx(zrot)
      zrot(1,1)=dcos(phi)
      zrot(1,2)=-dsin(phi)
      zrot(2,1)=-zrot(1,2)
      zrot(2,2)=zrot(1,1)

      call idmatx(pow)
      do iarc=1,narc0
       call multv(v0,pow,v2)       
       call multv(v2,gmat,vps0(1,iarc))
       do k=1,3
        vbs0(k,iarc)=vps0(k,iarc)+alt(k)
       end do
       call cat(pow,zrot)
      end do
      
      ratio=radi/(radi+rp) + radj/(radj+rp)
      avh=(dabs(rij-rp) +rij*ratio)/3
      nrot0=int(densq*swrap*avh)
      if(nrot0.lt.1) nrot0=1
      phi=swrap/dfloat(nrot0)

      call idmatx(xrot)
      xrot(2,2)=dcos(phi)
      xrot(3,3)=xrot(2,2)
      xrot(3,2)=dsin(phi)
      xrot(2,3)=-xrot(3,2)
       
      do i=1,3
       do j=1,3
        ghgd(i,j)=gmat(i,1)*xrot(1,1)*gmatd(1,j)+
     &            gmat(i,2)*xrot(2,1)*gmatd(1,j)+
     &            gmat(i,3)*xrot(3,1)*gmatd(1,j)+
     &            gmat(i,1)*xrot(1,2)*gmatd(2,j)+
     &            gmat(i,2)*xrot(2,2)*gmatd(2,j)+
     &            gmat(i,3)*xrot(3,2)*gmatd(2,j)+
     &            gmat(i,1)*xrot(1,3)*gmatd(3,j)+
     &            gmat(i,2)*xrot(2,3)*gmatd(3,j)+
     &            gmat(i,3)*xrot(3,3)*gmatd(3,j)
       end do
      end do

      call idmatx(pow)
      do irot=1,nrot0
       do iarc=1,narc0
        ndott = ndott + 1
        call multv(vbs0(1,iarc),pow,vbs)
        call multv(vps0(1,iarc),pow,lnrm)
        ldott(ndott)=2
        do k=1,3
         dotc(k,ndott)=tij(k)+vbs(k)
         dotn(k,ndott)=-lnrm(k)/rp
        end do

c.           write(22,'(3f10.4)') (dotc(k,ndott),k=1,3)

       end do
       call cat(pow,ghgd)
      end do
      return 
      end

      subroutine cnvx(dens,iret)
c     implicit none 

      integer maxato
      real*8  piov3,pi2
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      parameter(maxato=maxnum_atoms)
c     parameter(maxdot=100000)
c     parameter(maxpvc=5000)
      parameter (piov3=pi/3.0d0)
      parameter (pi2=2.0d0*pi)
      include 'COMMON.SOLVAT'
      include 'COMMON.SOLVAT3'
c     common /angl/beta(maxfac,3),torphi(maxtor),ctet(maxtor,2)
c       real*8 beta,torphi,ctet
c     common /coor/xyz(3,maxato),radii(maxato),dp,radmx,nat
c       integer nat
c       real*8 dp,radii,radmx,xyz
c     common /conc/lfac(3,maxfac),cnt(maxfac,3),
c    &             lfpt(3,maxfac),lfpto(3,maxfac),nfac
c       integer lfac,lfpt,lfpto,nfac
c       real*8  cnt
c     common /dott/dotc(3,maxdot),dotn(3,maxdot),dota(maxdot),
c    &            ldott(maxdot),ndott
c       integer ldott,ndott
c       real*8 dota,dotc,dotn    

cag...declare local variables

      integer iatom,idott,iedge,ifac,ihor,insde,iors,iret,ivec,
     &        ivert,jatom,jedge,k,kk,katom,nfirst,nhor,nvec,nvert
       real*8 alt,darea,dens,farea,fi,fj,ftotal,pijk(3),pvec(3,maxpvc),
     &        pole(3), polx(3),poly(3),polz(3),ptes(3),qcnx(3,3),
     &        radi,radj,radk,rp,rpsq,ss,vp(3,3),xy,v1(3),v2(3)

cyu      print*,'cnvx.f release 1.1 last code change Oct 3rd  1991 '

      rp=0.5d0*dp
      rpsq=rp*rp
      ftotal=0.0d0
      nvec=0
      nvert=int(2.0d0*pi*rp*dsqrt(dens))/2
      if(nvert.lt.1) nvert=1
      do ivert=0,nvert
       fi=pi*dfloat(ivert)/dfloat(nvert)
       alt=dcos(fi)
       xy=dsin(fi)
       nhor=int(dfloat(nvert)*2.0d0*xy)
        if(nhor.lt.1) nhor=1
        do ihor=0,nhor-1            
         fj=pi2*dfloat(ihor)/dfloat(nhor)
         nvec=nvec+1
         if(nvec.gt.maxpvc) then 
          print*,'maxpvc (number of dots on probe) exceeded in cnvx'
         else 
         pvec(1,nvec)=dcos(fj)*xy
         pvec(2,nvec)=dsin(fj)*xy
         pvec(3,nvec)=alt       
         endif
        end do
      end do

      do ifac=1,nfac
       farea=0.0d0
       nfirst=ndott+1
       do k=1,3
        farea=farea + rpsq*(beta(ifac,k)-piov3)
       end do
       ftotal = ftotal + farea
       iatom=lfac(1,ifac)
       jatom=lfac(2,ifac)
       katom=lfac(3,ifac)
       radi=radii(iatom)
       radj=radii(jatom)
       radk=radii(katom)
       do k=1,3
        pijk(k)=cnt(ifac,k)
        vp(k,1)=(radi*pijk(k)+rp*xyz(k,iatom))/(radi+rp)
        vp(k,2)=(radj*pijk(k)+rp*xyz(k,jatom))/(radj+rp)
        vp(k,3)=(radk*pijk(k)+rp*xyz(k,katom))/(radk+rp)
       end do

       do iedge=1,3
        jedge=1 + mod(iedge,3)
        call norm(vp(1,iedge),pijk,v1)
        call norm(vp(1,iedge),vp(1,jedge),v2)
        qcnx(1,iedge) =v1(2)*v2(3) - v1(3)*v2(2)
        qcnx(2,iedge) =v1(3)*v2(1) - v1(1)*v2(3)
        qcnx(3,iedge) =v1(1)*v2(2) - v1(2)*v2(1)
       end do

       do k=1,3
        v1(k)=0.0d0
       end do
       do iedge=1,3
        do k=1,3
         v1(k)=v1(k)+vp(k,iedge)
        end do
       end do
       do k=1,3
        v1(k)=v1(k)/dfloat(3)
       end do
       call norm(pijk,v1,v2)
       do k=1,3
        pole(k)=pijk(k)+rp*v2(k)
       end do

       call norm(pijk,pole,polz)
       if(dabs(polz(1)).gt.1.0d-2) then 
        ss=dsqrt(polz(2)**2+polz(3)**2)
        polx(1)=0.0d0
        polx(2)=-polz(3)/ss
        polx(3)=polz(2)/ss
       else
        if(dabs(polz(2)).gt.1.0d-2) then         
         ss=dsqrt(polz(1)**2+polz(3)**2)
         polx(1)=-polz(3)/ss
         polx(2)=0.0d0
         polx(3)=polz(1)/ss
        else
         ss=dsqrt(polz(1)**2+polz(2)**2)
         polx(1)=-polz(2)/ss
         polx(2)=polz(1)/ss
         polx(3)=0.0d0
        endif
       endif
       poly(1)=polz(2)*polx(3) - polz(3)*polx(2)
       poly(2)=polz(3)*polx(1) - polz(1)*polx(3)
       poly(3)=polz(1)*polx(2) - polz(2)*polx(1)

       do ivec=1,nvec
        do k=1,3
         v1(k)=polx(k)*pvec(1,ivec)+
     &         poly(k)*pvec(2,ivec)+
     &         polz(k)*pvec(3,ivec)
        end do
        do k=1,3
         ptes(k)=pijk(k)+ (v1(k)*rp)
        end do

        call dotchk(ptes,vp,qcnx,3,insde,iors)
        if(insde.eq.1) then 
         ndott=ndott+1
         ldott(ndott)=3
         do k=1,3
          dotc(k,ndott)=ptes(k)
          dotn(k,ndott)=-v1(k)
c..          print*,'ndott k dotn ',ndott,k,dotn(k,ndott)
         end do
	
c..          write(34,'(3f10.4)') (ptes(k),k=1,3)

       endif
       end do
       darea=farea/(dfloat(ndott-nfirst+1))
       do idott=nfirst,ndott
        dota(idott)=darea
       end do
cag end loop over ifac 
      end do
cyu      print*,'total concave area ',ftotal
      return
      end
      subroutine multv(v,a,r)
      implicit none
      integer k
      real*8 a(3,3),r(3),v(3)
      do k=1,3
       r(k)=a(k,1)*v(1)+a(k,2)*v(2)+a(k,3)*v(3)
      end do
      return
      end

       subroutine idmatx(a)
       implicit none
       integer i,j
       real*8 a(3,3)

       do i=1,3
        do j=1,3
         a(i,j)=0.0d0
        end do
        a(i,i)=1.0d0
       end do
      return
      end

      subroutine cat(a,b)
      implicit none

      integer i,j
      real*8 a(3,3),b(3,3),t(3,3)

      do i=1,3
       do j=1,3
        t(i,j)=a(i,1)*b(1,j) + a(i,2)*b(2,j) + a(i,3)*b(3,j)
       end do
      end do

      do i=1,3
       do j=1,3
        a(i,j)=t(i,j)
       end do
      end do
      return
      end
