      SUBROUTINE READ_DBASE_LOWE(NUMRSP,LIST_TOT,
     &           ANGUL,ETTAL,IPEPSQ,IPEPLST,PEPNAM)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.GEN002X'
      INCLUDE 'COMMON.FILES'
      INCLUDE 'COMMON.IOUNIT'

      LOGICAL END_OF_FILE, END_OF_LIST
      PARAMETER (max_nprob= 30)
      REAL ETTAL(max_nprob,LIST_TOT)
      REAL ANGUL(maxnum_dihe, NUMRSP,max_nprob,LIST_TOT)
      INTEGER ILIS(3),IPEPSQ(NUMRSP,LIST_TOT),IPEPLST(LIST_TOT)
      CHARACTER*9  PEPNAM(LIST_TOT)
      EXTERNAL ILEN
      CHARACTER*64 PROBFILE
      CHARACTER*3 NUMM
      CHARACTER*9 ITMPNM, ITMPNM2
      CHARACTER*64 CFF

C    If YourJob = .TRUE. then you are either a non-MPI processor or you
C  you are the MPI master.  
C     JPROB=66
      NLISF=1
      END_OF_LIST=.FALSE.

      DO WHILE(.NOT.END_OF_LIST) 
         CALL NUMSTR(NLISF,NUMM)
         CALL CONCAT(tripfile,NUMM,CFF)
         CALL CONCAT('outo.',CFF,PROBFILE)
 
c        write (*,*) ' Opening file  = ', PROBFILE
         OPEN (JPROB,FILE=PROBFILE,STATUS='OLD', ERR=300)

         ISCNF=1
         END_OF_FILE=.FALSE.
         DO WHILE(.NOT.END_OF_FILE) 
            READ (JPROB,'(I10,4E15.6)',END=500,ERR=600) 
     &                IDNUM, ETTAL(ISCNF, NLISF)
c           write (*,*) ' IDNUM = ', IDNUM
C           write (*,*) ' RAD = ', RAD
            READ (JPROB,*,END=600,ERR=600) 
     &           ILL1,(ILIS(I),I=1,NUMRSP),ILL2
            XX1=0.0
            READ(JPROB,750,END=600,ERR=600) XX1,XX1

            DO I=1,NUMRSP
               NT=IABS(ILIS(I))
               READ(JPROB,750,END=600,ERR=600) 
     &                  (ANGUL(J,I,ISCNF,NLISF),J=1,NCHI(NT)+3)
               DO J=1,NCHI(NT)+3
                  ANGUL(J,I,ISCNF,NLISF)=ANGUL(J,I,ISCNF,NLISF)*RAD
                  ANGUL(J,I,ISCNF,NLISF)=PINORM(ANGUL(J,I,ISCNF,NLISF))
               ENDDO
c              WRITE(JOUT,750) (DEG*ANGUL(J,I,ISCNF,NLISF),
c    &                       J=1,NCHI(NT)+3)
            ENDDO

            READ(JPROB,750,END=600,ERR=600) XX1,XX1
            ISCNF=ISCNF+1
            GOTO  550

500         END_OF_FILE=.TRUE.
            WRITE (JOUT,'(/60(1H*)/10X,3A,I5,A/60(1H*)/)')
     &       'End of Probability distr. file ',PROBFILE,
     &       ' last conformation ',ISCNF,'.'
550         CONTINUE
         ENDDO
         CLOSE (JPROB)
         ipeplst(NLISF)=ISCNF-1
         ITMPNM=' '
         DO I=1,NUMRSP
            IPEPSQ(I,NLISF)=ILIS(I)
            CALL NUMSTR(ILIS(I),NUMM)
            ITMPNM2= ITMPNM(1:ILEN(ITMPNM))
            CALL CONCAT(ITMPNM2,NUMM,ITMPNM)
         ENDDO
         PEPNAM(NLISF)= ITMPNM(1:ILEN(ITMPNM))
c        write(*,*) 'NAME TRIPEP(',NLISF,') = ', PEPNAM(NLISF),
c    &                ' len= ', ILEN(ITMPNM)
c        write(*,*) 'SEQ TRIPEP(',NLISF,') = ', (ILIS(I),I=1,NUMRSP)
         NLISF=NLISF+1
         IF(NLISF.GT.LIST_TOT) END_OF_LIST=.TRUE.
      ENDDO
      RETURN

600   WRITE (JOUT,'(/60(1H*)/10X,3A,I5,A/60(1H*)/)')
     &    'Error in Probability distr. file ',PROBFILE,
     &    ' at conformation ',ISCNF+1,'.'
      STOP 6044
      

300   WRITE (JOUT,'(/60(1H*)/10X,3A)')
     &    'Unable to OPEN Probability distr. file ',PROBFILE,
     &    ' It is not found, or its format is incorrect.'
      STOP 6045 


750   FORMAT(15F8.3)
      END
      subroutine dbasesel(numrchg)

#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.PROB'
      integer ithree
      logical get_other
      data ithree /3/

C Three residues at most, will be moved.
      if (numrchg.gt.ithree) numrchg=ithree

C select a residue
      get_other=.true.
      do while(get_other)
         call rndndx(inumrs,probrs,initrndres)
         if (initrndres.ne.1.and.initrndres.ne.inumrs) 
     &                                   get_other=.false.
      enddo
      lstrndres= initrndres + numrchg-1
      if (lstrndres.gt.(inumrs-1)) then
C  initial residue will be (INUMRS - 1) - NUMRCHG
         initrndres = inumrs -1 - numrchg 
      endif
C get the set of conformers (nlisf) from which one will be selected.
      call asstrip(numrchg,initrndres,nlisf,lposre) 

C select the conformer and replace dihedral angles 
      if (nlisf.ne.0) then
         call pepprob(numrchg,initrndres,nlisf,lposre)
         do i=1,numrchg
            itrials(initrndres+i-1)=itrials(initrndres+i-1)+1
         enddo
      else
C No data in the database for this residue.  Generate a change 
C in one residue with PHI-PSI to avoid sending a conformation 
C unaltered to minimization.
         itrials(initrndres)=itrials(initrndres)+1
         call rangux(initrndres)
      endif
      return 
      end

      subroutine asstrip(nchge,iresy,nlst,lposre)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      include 'COMMON.GEN100'
      include 'COMMON.FILES'
      include 'COMMON.IOUNIT'
      include 'COMMON.TRIPROB'
      character*3 numm
      character*9 itmpnm,itmpnm2,tripepnam
      integer lassigl(2,maxnum_trip), iresy,nlst, nchge
      external ilen

      nlst= 0
      lposre=0
c     write(*,*) 'list_tot ', list_tot 
c     write(*,*) 'nchge ', nchge, iresy
c     write(jout,*) 'number of residues modified ', nchge, 
c    &             ' first residue= ', iresy
      do j=1,list_tot
         lassigl(j,1)= 0
         lassigl(j,2)= 0
      enddo
C Now generate character variables using the list array and 
C associate the starting residue with the database of sequences 
c     write(*,*)'Entering do loop ', inumrs, numrsp
      itmpnm=' '
      do j=1,nchge
        call numstr(list(iresy+j-1),numm)
        itmpnm2= itmpnm(1:ilen(itmpnm))
        call concat(itmpnm2,numm,itmpnm)
      enddo
      ilnch= ilen(itmpnm)
      tripepnam= itmpnm(1:ilnch)
c     write(*,'(A)') tripepnam
      nchk=0
C     ilnchmx= 3*numrsp
      irag= int(ilnch/3)

      do j=1,list_tot
         do m=0,(numrsp-irag)
C The character variables  pepnam and tripepnam have been built using 
C 3 characters per residue (list number).
            ist=3*m+1
            iend=3*(m+irag)
            if( pepnam(j)(ist:iend).eq. tripepnam) then
               nchk=1+nchk
               lassigl(nchk,1)= j
               lassigl(nchk,2)= m
            endif
         enddo
      enddo
c     write(*,'(i5)' ) nchk
      if (nchk.eq.0) then
         write(*,'(3A)' ) 'Low-energy conformations for ',
     &          tripepnam, ' not found in database.'
c        write(jout,'(3A)') 'Low-energy conformations TRIPEP ',
c    &          tripepnam, ' not found.'
      else if (nchk.eq.1) then
c        write(*,'(3A,i5)' )'Low-energy conformations TRIPEP ',
c    &          tripepnam, ' found in ',lassigl(1,1)
c        write(jout,'(3A,i5)' )'Low-energy conformations TRIPEP ',
c    &          tripepnam, ' found in ',lassigl(1,1)
         nlst= lassigl(1,1)
         lposre=lassigl(1,2)
      else 
c        write(*,'(i5,2A)' ) nchk,'cases with:',tripepnam
c        write(*,'(10i4)' )(lassigl(k,1), k=1,nchk) 
         irndl=iran_num(1,nchk)
C  select one random          
         nlst= lassigl(irndl,1)
         lposre=lassigl(irndl,2)
c        write(*,'(A,i5)' ) 'selected list of conformers ', nlst
      endif

      return 
      end

      subroutine  pepprob(nchge,iresi,isel_pep,isel_posr)
c   Set dihedral angles based on tripeptide lowest-energy conformations
C
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.REGG'
      INCLUDE 'COMMON.BONDSX'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.GEN002X'
      INCLUDE 'COMMON.GEN004'
      INCLUDE 'COMMON.PRAMX'
      INCLUDE 'COMMON.COSACO'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.CHECK'
      INCLUDE 'COMMON.TOR2'
      INCLUDE 'COMMON.TORQUEX'
      INCLUDE 'COMMON.SETUP'
      INCLUDE 'COMMON.VTFEX'
      INCLUDE 'COMMON.NNDRUK'
      INCLUDE 'COMMON.TRIPROB'
      LOGICAL lprolin

C Obtain a random number to determine the conformation from the database that
C will be used.

      write(jout,*)'Using Database to change ',nchge, 
     &             ' residues. Initial is: ', iresi

      icn= iran_num(1,ipeplst(isel_pep) )
c     write(*,*) 'Selected database set ',isel_pep, 
c    &       ' conformation is: ',icn  
      write(jout,*) 'Selected database set ',isel_pep, 
     &       ' Conformation No: ',icn  

C if first residue is PRO, the omega from previous residue could be in 
C cis conformation.  We get the dihedral angle from the database.
C To save space, this omega dihedral angle was stored as in the location of chi(1)
C for PRO 

      if (lprolin(iresi) ) then 
          if(nchvar(iresi-1,3).EQ. 1) then
             angulo(3,iresi-1)= angel(4,1+isel_posr,icn,isel_pep)
             write(jout,*)'Omega preceeding PRO was changed'
             write(jout,*)'Residue ', iresi-1, 'omega= ',
     &                 angulo(3,iresi-1)*deg
          end if
      end if

      do i=1, nchge
         iirs= iresi+i-1
         nt= list(iirs)
         do j=1,nchi(nt)+3
            if(nchvar(iirs,j).eq. 1) angulo(j,iirs)= 
     &                      angel(j,i+isel_posr,icn,isel_pep)
         enddo
c        write(jout,*)'Residue ', iirs, 
c    &                 (angulo(j,iirs)*deg, j=1, nchi(nt)+3)
      enddo
      return
      end
