      subroutine protonation (fail)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      include 'COMMON.CNTRL'
      include 'COMMON.IOUNIT'
      include 'COMMON.GEN100'
      include 'COMMON.ATOMSS'
      include 'COMMON.THRLET'
      include 'COMMON.CALC'
      include 'COMMON.LIST0'
      include 'COMMON.MYCONF'
      include 'COMMON.FILES'
      include 'COMMON.EDMC'
      include 'COMMON.SOLVAT'
      INCLUDE 'param.ibems'
      include 'ecepp_ibems_intrf.h'
      logical ldebug,fail
      dimension list_tmp(maxnum_res)
      real*8 fre_cav,fre_solv,fre_hbind,fre_tot
      character*3 numm
      character*64 cff,old_prefix
      data izero /0/,itrein /30/, ebig /1.0E20/

C  First, pass coordinates of neutral molecule, alpha...
     
      ldebug=.false.
      fail=.false.
      if (ldebug) then
      write (jout,'(a)') 'LIST array before charging:'
      write (jout,'(16i5)')  (list(i),i=1,inumrs)
      print *,'Enter protonation: IAMCON=',iamcon
      endif
      natom_ei=npre(inumrs+1)
      do i=1,natom_ei
	 atnamel_ei(i)=alph(i)
	 iatnumbl_ei(i)=i
         if (i.le.npre(2)) then
           iresi=1
         elseif (i.gt.npre(inumrs)) then
           iresi=inumrs
         else 
           iresi=kax(i)+1
         endif
         listi=iabs(list(iresi))
         if (iresi.eq.1 .or. iresi.eq.inumrs) then
	   resnamel_ei(i)=ares(listi+num_restypes)
         else
	   resnamel_ei(i)=ares(listi)
         endif   
	 resnumbl_ei(i)=iresi
	 headl_ei(i)='ATOM'
	 do j=1,3
	   atxyzl_ei(j,i)=coord(j,i)
         enddo
      enddo           
C We need to modify the name of the C' atom of the last full residue.
C we shouldn't now DR OCT/24/97
c     if (iabs(list(inumrs)).eq.11) then
c       atnamel_ei(npre(inumrs-1)+6)='CTC'
c       atnamel_ei(npre(inumrs-1)+7)='OTC'
c     endif   
C Control printout
      if (ldebug) then

c        print *,'natom_ei=',natom_ei
C Uncomment following instructions to read the coordinates of UNcharged
C molecule from disk.
cd       read (55,'(a)')
cd       read (55,'(a)')
cd       read (55,'(a)')
cd       do i=1,natom_ei
cd         read (55,'(30x,3d12.7)') (atxyzl_ei(j,i),j=1,3)
cd         print *,i,(atxyzl_ei(j,i),j=1,3)
cd       enddo

         do i=1,natom_ei
           write (jout,'(a4,i4,i4,a4,3f12.7)') atnamel_ei(i),
     &     iatnumbl_ei(i),resnumbl_ei(i),resnamel_ei(i),
     &     (atxyzl_ei(j,i),j=1,3)
         enddo
 
      endif

      do i=1,inumrs
         ilisti=iabs(list(i))
         if ( (i.eq.1) .or.(i.eq.inumrs) )
     &            ilisti = iabs(list(i)) + num_restypes
         resname_IBEM(i,1)= ares(ilisti)
         ireslist_IBEM(i,1)=ilisti
C Save last atom of each residue for charged form of molecule
         npre_IBEM(i,1)= npre(i)
C And save original neutral sequence
         list_tmp(i) = list(i)
      enddo
      npre_IBEM(inumrs+1,1)= npre(inumrs+1)

C modify list to generate fully charged seq.
      call charged_conf
      if (ldebug) then
         write (jout,'(a)') 'LIST array after charging:'
         write (jout,'(16i5)')  (list(i),i=1,inumrs)
      endif

C last, call setup_X and gener.
C pass coordinates of charged seq, alph....
      natomp_ei=npre(inumrs+1)
      do i=1,natomp_ei
	 atnamelp_ei(i)=alph(i)
	 iatnumblp_ei(i)=i
         if (i.le.npre(2)) then
           iresi=1
         elseif (i.gt.npre(inumrs)) then
           iresi=inumrs
         else 
           iresi=kax(i)+1
         endif
         listi=iabs(list(iresi))
	 resnumblp_ei(i)=iresi
         if (iresi.eq.1 .or. iresi.eq.inumrs) then
	   resnamelp_ei(i)=ares(listi+num_restypes)
         else
	   resnamelp_ei(i)=ares(listi)
         endif   
	 headlp_ei(i)='ATOM'
	 do j=1,3
	   atxyzlp_ei(j,i)=coord(j,i)
         enddo
      enddo           
C We need to modify the name of the C' atom of the last full residue.
C we shouldn't now DR OCT/24/97
c     if (iabs(list(inumrs)).eq.12) then
c       atnamelp_ei(npre(inumrs-1)+6)='CT-'
c     endif   
C Control printout
      if (ldebug) then

C Uncomment the following lies to read the coordinates of charged molecule
C from the disk.
cd    read (56,'(a)')
cd    read (56,'(a)')
cd    read (56,'(a)')
cd    print *,'natomp_ei=',natomp_ei
cd    do i=1,natomp_ei
cd      read (56,'(30x,3d12.7)') (atxyzlp_ei(j,i),j=1,3)
cd      print *,i,(atxyzlp_ei(j,i),j=1,3)
cd    enddo

      do i=1,natomp_ei
        write (jout,'(a4,i4,i4,a4,3f12.7)') atnamelp_ei(i),
     &  iatnumblp_ei(i),resnumblp_ei(i),resnamelp_ei(i),
     &  (atxyzlp_ei(j,i),j=1,3)
      enddo
 
      endif
cd    write (jout,*) 'natom_ei=',natom_ei,' natomp_ei=',natomp_ei

      npre_IBEM(inumrs+1,2)= npre(inumrs+1)
      do i=1,inumrs
         ilisti=iabs(list(i))
         if ( (i.eq.1) .or.(i.eq.inumrs) )
     &            ilisti = iabs(list(i)) + num_restypes
         resname_IBEM(i,2)= ares(ilisti)
         ireslist_IBEM(i,2)=ilisti
C Save last atom of each residue in charged form of molecule
         npre_IBEM(i,2)= npre(i)
C And return to original neutral sequence
         list(i) = list_tmp(i)
      enddo

      call setup_x(izero)


C Now the endgroups don't have to be neutral.

      kprotfail=1
cd    print *,'Call solv_ibem0: INDPH,NPH,LOGICPH,IAMCON=',
cd   & indph,nph,logicph,kprotfail
      call solv_eqpb(fre_cav,fre_solv,fre_hbind,fre_tot)
cd    print *,'Exit solv_ibem0: KPROTFAIL=',kprotfail
      if (kprotfail.eq.-999) then
cd     time limit was reached.
           fail=.true.
           return
      else if (kprotfail.lt.0) then
C is kprotfail=-2  it is a molecular surf calculation
        if (kprotfail.eq.-2) then
           fre_cav=0.0D0
           fre_solv=0.0D0
           fre_hbind=0.0D0
        else
           write (jout,'(a11,i4)') 'kprotfail= ', kprotfail
           iformtmp=iform
           iform=2
           old_prefix=coorpref
           if(runtyp.eq.4) Then
              call numstr(iamcon,numm)
              coorpref=old_prefix//'ERR_'
              call concat(coorpref,numm,cff)
              coorpref=cff
              call outnw(izero,itrein,iamcon)
           else
              call numstr(mycon,numm)
              coorpref=old_prefix//'ERR_'
              call concat(coorpref,numm,cff)
              coorpref=cff
              call outnw(izero,itrein,mycon)
           endif
           coorpref=old_prefix
           iform=iformtmp
           fail=.true.
           fre_cav=ebig
           fre_solv=ebig
           fre_hbind=ebig
        endif
      endif
      ETOT=ETOT-EHYDA
      EHYDA=fre_cav
      DELPHI=fre_solv
      EPROT=fre_hbind
      ETOT=ETOT+EHYDA+DELPHI+EPROT

c     call close_app(jouibem,ibeoutfile)

      return
      end
