      SUBROUTINE INPRESIBE

C THIS SUBROUTINE READS THE RESIDUE DATA FOR IBEM AND STORES THEM IN
C APPROPRIATE ARRAYS.
C
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'param.ibems'
      INCLUDE 'comm.ibems'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.FILES'

       integer nreg,nend,i,k

       character*3 aribe
       integer kk,ix,numi,joibe
       logical poibe, ionzab, chribe, lprn
c      real*8 chibe(matres,LXX),radibe(matres,LXX)

C
C
c     JIBEMCHG=14
C     OPEN(UNIT=14, FILE='resibem', STATUS='OLD',FORM='FORMATTED')
      READ (JIBEMCHG,*) NREG,NEND
      IF(OUTDETL.GE.IIPRINT1)
     &  PRINT *,'inpresibe: nreg=',NREG,' nend=',NEND
C
C THE FOLLOWING SECTION IS FOR FULL AMINO ACID RESIDUES:
C
      LPRN=.FALSE.

      DO I=1,NREG
C read
C KK= residue "list" number 
C ARIBE= res.  name, 
C NUMI = number of atoms in database for this residue, 
C JOIBE= add atoms to other_group for atoms from end groups 
C POIBE= is residue POLAR ?
C IONZAB= is residue IONIZABLE ?
C CHRIBE = is residue IONIZED or CHARGED ?
         READ(JIBEMCHG,210) KK,ARIBE,NUMI,JOIBE,POIBE,IONZAB,CHRIBE
         IF(OUTDETL.GE.IIPRINT1)
     &    WRITE(*,210) KK,ARIBE,NUMI,JOIBE,POIBE,IONZAB,CHRIBE
         ARESIBE(KK)= ARIBE
         NUMAI(KK)=NUMI
         JOINR(KK)=JOIBE
         POLRIB(KK)=POIBE
         IONIZABLE(KK)=IONZAB
         CHRR(KK)=CHRIBE
         DO J = 1,NUMI
            READ(JIBEMCHG,240) ALPHIB(J,KK),(LPARIB(K,J,KK), K=1,4),
     &        CHIBE(J,KK),RADIBE(J,KK)
         ENDDO
      ENDDO
C
C THE FOLLOWING SECTION IS FOR END GROUPS:
C
      DO I=1,NEND
         READ(JIBEMCHG,210) IX,ARIBE,NUMI,JOIBE,POIBE,IONZAB,CHRIBE
         KK=IX+num_restypes
         IF(OUTDETL.GE.IIPRINT1)
     &    WRITE(*,210) KK,ARIBE,NUMI,JOIBE,POIBE,IONZAB,CHRIBE
         ARESIBE(KK)= ARIBE
         NUMAI(KK)=NUMI
         JOINR(KK)=JOIBE
         POLRIB(KK)=POIBE
         IONIZABLE(KK)=IONZAB
         CHRR(KK)=CHRIBE
         DO J = 1,NUMI
            READ(JIBEMCHG,240) ALPHIB(J,KK),(LPARIB(K,J,KK), K=1,4),
     &        CHIBE(J,KK),RADIBE(J,KK)
         ENDDO
      ENDDO
      CLOSE(JIBEMCHG)
      RETURN
210   FORMAT(I3,3X,A3,2X,2I5,3(4X,L1))
240   FORMAT(4X,A3,4I7,5x,2f8.3)
      END
