      SUBROUTINE BETARS
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.ATOMSS'
      INCLUDE 'COMMON.SOLVAT'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.FILES'
      REAL TGTARS(maxnum_res)
C
C  *************************************************
      INTEGER NRES
        NGD=0
        NSOL=0
        OPEN(JTGTAR,FILE=TGTARSFILE,STATUS='OLD',FORM=
     &                                    'FORMATTED',ERR=100)
        DO 1380 I=2,INUMRS-1
           READ(JTGTAR,*)TGTARS(I)
c          WRITE(JOUT,*)TGTARS(I),I
1380    CONTINUE
        CLOSE(JTGTAR)
        DO 1280 I=1,INUMRS
           IBEG=NPRE(I)+1
           IEND=NPRE(I+1)
           DO 1290 J=IBEG,IEND
              NBI=NBTYPE(J)
              IF (NBI.NE.1.AND.NBI.NE.3) THEN
                 NSOL=NSOL+1
                 IF (LIST(I).NE.6) THEN
                    I1=INDEX(SALPH(NSOL),'B')
                 ELSE
                    I1=INDEX(SALPH(NSOL),'A')
                 END IF
                 IF (I1.NE.0) THEN
                    NGD=NGD+1
                    ICTSOL(J)=NGD
                    IOLTEC(NGD)=J
                    TGTS(NGD)=TGTARS(I)
                    RADII(NGD)=BRAD(LIST(I))
                 ELSE
                    ICTSOL(J)=0
                 END IF
              ELSE
                 ICTSOL(J)=0
              END IF
1290       CONTINUE
1280    CONTINUE
        NSOL=NGD
      RETURN
100   WRITE (*,'(a,i4,/2a)') 'ERR% BETARS: can"t open logical unit',
     &      III, ' file= ', FNAME
      STOP
      END
      SUBROUTINE CALFEH(NATM)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.ATOMSS'
      INCLUDE 'COMMON.SOLVAT'
      INCLUDE 'COMMON.SOLVAT2'
      INCLUDE 'COMMON.DERIV'
      INCLUDE 'COMMON.CNTRL'
      INCLUDE 'COMMON.IOUNIT'
      REAL*8 AREAT
C
C CALCULATION OF WATER ACCESSIBLE VOLUMES AND FREE ENERGIES OF HYDRATION
C OF EACH GROUP OF PEPTIDES.
C
C  MAXIMUM ALLOWED NUMBER OF ATOMS IS MAXAT.
C
C  PROGRAMMED BY Y.K. KANG, JULY 8, 1987.
c heavily modified by Roger Williams and Jorge Vila
      DO 49 I=1,NATM
C RED should to be defined only ONCE in SOLPAM. After calling GRN5X RADH might
C be contaminated which causes errors in solvation energy!!! --- AL 1/27/94
C        RED(I)=RADII(I)
         DO 199 K=1,3
              DOORD(K,I)=XYZ(K,I)
199      CONTINUE
   49 CONTINUE
      CALL GRN(IAMCON)
      AREAT=0.0
      DO 200 II=1,NATM
c         AARS(II,1)=AREA(II,3)
C Change 2/23/95 - Introduce Yuri's mseed
          AARS(II,1)=AREA(II)
c         AREAT=AREAT+AREA(II,3)
          AREAT=AREAT+AREA(II)
200   CONTINUE
      IF (ISFOUT.EQ.1) THEN
         WRITE(JOUT,*) 'TOTAL AREA = ',AREAT
         WRITE (JOUT,'(T3,A,T23,A,T50,A,T59,A/65(1H-))') 
     &   'Atom ','Coordinates','Radius','Surface'
         DO 765 I=1,NATM
            WRITE(JOUT,'(A3,1H(,I5,1H),2x,3F10.5,5X,2F10.5)')
     &      ALPH(IOLTEC(I)),I,(XYZ(JJ,I),JJ=1,3),RADII(I),AARS(I,1)
765      CONTINUE
      END IF
C++++++++++++++++++ SURFACE DERIVATIVE +++++++++++++++++++
      IF (SURDER) THEN
         DO 201 IAT=1,NATM
             DO 202 IOR=1,LNDER(IAT)
                NBI=NSTYPE(IAT)
                FIAT= F0HYD(NBI)
                JAT= LDER(IOR,IAT)
                IEC=IOLTEC(JAT)
                DO 203 K=1,3
                    CGE(K,IEC,ICG)=DER(IOR,K,IAT)*FIAT+CGE(K,IEC,ICG)
203             CONTINUE
202          CONTINUE
201      CONTINUE
      END IF

C +++++++++++++++++           END          ++++++++++++++++++++++
C
C  CALCULATION OF FREE ENERGY OF HYDRATION
C
   80 CONTINUE
      FHYDA=0.0
      DO 50 I=1,NATM
         NBI=NSTYPE(I)
         IF (IREP.NE.1) THEN
             FHA=F0HYD(NBI)*AARS(I,1)
         ELSE
             FHA=(AARS(I,1)-TGTS(I))**2
         END IF
         FHYDA=FHYDA+FHA
   50 CONTINUE
      RETURN
      END
      SUBROUTINE CALFH
      INCLUDE 'COMMON.IOUNIT'
C
C SUBROUTINE CORDUA GENERATE THE UNITED ATOM COORDINATES FROM
C COORD(I,J) TO SOORD(I,J).
C
      CALL CORDUA(NSTM)
C
C SUBROUTINE CALFEH CALLS THE SUBROUTINES WHICH GENERATE THE ATOMIC
C COORDINATES AND COMPUTE THE FEH:
C
      CALL CALFEH(NSTM)
C
      RETURN
      END
      SUBROUTINE CORDUA(NSTM)

#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.ATOMSS'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.SOLVAT'
      REAL CRDMN(3)

C THIS SUBROUTINE GENERATES THE UNITED ATOMIC COORDINATES FROM 
C COORD(I,J) TO SOORD(I,J):


      NATMS=NPRE(INUMRS+1)
      DO 200 I=1,3
         CRDMN(I)=9.9E23
200   CONTINUE
      KGD=0
      DO 100 K=1,NSOL
            I=IOLTEC(K)
            CHGH(K)=CHARGE(I)
            DO 110 J=1,3
               IF (COORD(J,I).LT.CRDMN(J))CRDMN(J)=COORD(J,I)
               XYZ(J,K)=COORD(J,I)
  110       CONTINUE
  100 CONTINUE
      NSTM=NSOL
      RETURN
      END
      SUBROUTINE GRN(IPON)
      IMPLICIT REAL*8 (A-H,O-Z)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      CHARACTER*3  FORMI
      INCLUDE 'COMMON.SOLVAT'
      INCLUDE 'COMMON.SOLVAT2'
      INCLUDE 'COMMON.SOLVAT3'
      INCLUDE 'COMMON.IOUNIT'
C
      IPON=0
      ICOOR=1
      IDATA=3
C
C UNCOMMENT NEXT LIGNE FOR INTERACTIVE INPUT
C
C     IDATA=5
C     PI=3.1415926535
C     PRINT*,'NUMBER OF CONFORMATIONS   '
C     READ(IDATA,*) NIM
      NIM=1
      NAT=NSOL
      FORMI='PDB'
      RP=0.0
      R0=3.7
      RADMX=R0
      DP=2.*RP
      IDER=1
      DUMMY=0.0
C
        DO IAT=1,NAT
C        READ(1,*)RADII(IAT)
        RADII(IAT)=RED(IAT)
        ENDDO
C       REWIND(1)
        DO I=1,NAT
          DO K=1,3
            XYZ(K,I)=DOORD(K,I)
          END DO
        END DO
C      OPEN(UNIT=70,FILE='PDBOUT',FORM='FORMATTED')
C       DO U=1,NAT
C         WRITE(75,*) (SOORD(JJ,U),JJ=1,3),RED(U),U
C       END DO
C      CLOSE(UNIT=70)
      DO IIM=1,NIM
       IERR=0
50     CONTINUE
       CALL SEED(IRET)
       if (iret.eq.-1) then
         ipon=-1
         return
       endif
       IERR=IERR+1
       IF(IERR.GT.50) THEN
        IPON=-1
        WRITE(JOUT,*)'TOO MANY ERRORS !!',IPON
*       PRINT*,'TOO MANY ERRORS !!',IPON
*       STOP
        RETURN
       ENDIF
       IF(IRET.EQ.1) THEN
        DO IAT=1,NAT
         RADII(IAT)=RADII(IAT)+.01
        ENDDO
       ENDIF
       IF(IRET.EQ.1) GOTO 50
C      PRINT*,'END OF SEED'
       CALL AREAC(IRET,IDER)
C      PRINT*,'END OF AREC'
C
C      PRINT*,' '
C      PRINT*,'CONFORMATION  NB : ',IIM
C Change 2/23/95 to conform with Yuri's mseed
c      DO K=3,3
        AREAT=0.0
        DO IAT=1,NAT
c        AREAT=AREAT+AREA(IAT,K)
         AREAT=AREAT+AREA(IAT)
        ENDDO
C       WRITE(JOUT,*) 'TOTAL AREA = ',AREAT,' FOR K =  ',K
       ENDDO
C
c     ENDDO
C
C
 
      RETURN
C     STOP
      END
      SUBROUTINE SEED(IRET)
      IMPLICIT REAL*8 (A-H,O-Z)
C
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      include 'COMMON.SOLVAT'
      include 'COMMON.SOLVAT3'
      include 'COMMON.IOUNIT'

      REAL*8 TEMX(MAXTEM),TEMY(MAXTEM),TEMZ(MAXTEM)
      REAL*8 TEMR2(MAXTEM)
      REAL*8 ALTAX(MAXTEM),ALTAY(MAXTEM),ALTAZ(MAXTEM)
      REAL*8 RHORI(MAXTEM),CENTX(MAXTEM),CENTY(MAXTEM),CENTZ(MAXTEM)
      REAL*8 V1X(MAXTEM),V1Y(MAXTEM),V1Z(MAXTEM)
      REAL*8 V2X(MAXTEM),V2Y(MAXTEM),V2Z(MAXTEM)
      REAL*8 ANG(MAXTEM)
C
      REAL*8 PM(3),V(3),PC(3),P(3),P1(3),P2(3),U(3),VOR1(3),V1(3)
      REAL*8 ALT3(3)
      REAL*8 CRDMN(3)
      REAL*8 DDOT
C
cmsp  INTEGER*4 LTEM(maxnum_atoms)
      INTEGER   LTEM(maxnum_atoms)
      REAL*8 CENT(3,MAXFAC)
      REAL*8 RAD2(maxnum_atoms)
      INTEGER   LMAR(3,MAXFAC)
      INTEGER   LATO(MAXORS,maxnum_atoms),LNATO(maxnum_atoms)
      INTEGER   LPIL(MAXPIL),NPIL
C
C
C
cd    print *,'in SEED'
      IRET=0
      NPILMX=0
      NORSMX=0
      NNBRMX=0
      NNBRMN=99999
      NANG=0
      NPLE=0
      RP=0.5D0*DP
      DTMAX=2.D0*(RADMX+RP)
Cd    write (20,*) 'NAT:',NAT
C     write (*,*) 'RP:',RP
      DO IAT=1,NAT
       RAD2(IAT)=(RADII(IAT)+RP)**2
C Diagnostic output.
cd          write (20,'(i3,2f10.5,5x,3f10.5)') iat,rad(iat),rad2(iat),
cd   &    (xyz(k,iat),k=1,3) 
      ENDDO
      NTOPBR=0
      DO IAT=1,NAT
       LNATO(IAT)=0
       LNBR(IAT) =0
       LFBR(IAT) =0
      ENDDO
      NFAC=0
      NTOR=0
      NPIL=0
      DO K=1,3
       CRDMN(K)=1.D+38
      ENDDO
      DO IAT=1,NAT
       DO K=1,3
        IF(XYZ(K,IAT).LT.CRDMN(K)) THEN
         CRDMN(K)=XYZ(K,IAT)
        ENDIF
       ENDDO
      ENDDO
C
C FILL IN THE TABLE OF NEIGHBORS
C
      DO K=1,3
       LCUMX(K)=0
      ENDDO
      DO IAT=1,NAT
       DO K=1,3
        IXYZ=INT((XYZ(K,IAT)-CRDMN(K))/DTMAX)+1
        LXYZ(K,IAT)=IXYZ
        IF(IXYZ.GT.LCUMX(K)) THEN
         IF(IXYZ.GT.MAXCUB) THEN
          WRITE (JOUT,'(/a,i10,a/)') 
     &      '(F) MSEED error: not enough cubes; need',ixyz,
     &      ' - increase MAXCUB'
          STOP
         ENDIF
         LCUMX(K)=IXYZ
        ENDIF
       ENDDO
      ENDDO
      DO KCUB=1,LCUMX(3)
       DO JCUB=1,LCUMX(2)
        DO ICUB=1,LCUMX(1)
         LCUB(ICUB,JCUB,KCUB)=0
        ENDDO
       ENDDO
      ENDDO
      DO IAT=1,NAT
       LPTR(IAT)=0
      ENDDO
      DO IAT=1,NAT
       ICUB=LXYZ(1,IAT)
       JCUB=LXYZ(2,IAT)
       KCUB=LXYZ(3,IAT)


C Change 8/13/95 A. Liwo
 
       if (icub.gt.maxcub .or. jcub.gt.maxcub .or. kcub.gt.maxcub) then
         write (jout,'(a)') 'Error, max. # of cubes exceeded.'
         stop 8888
       endif
 
       if (icub*jcub*kcub.gt.0) then
         NVAL=LCUB(ICUB,JCUB,KCUB)
       else
         nval=0
         write (jout,'(a,3i15,a,i5)')
     &  'Warning: icub jcub kcub=',icub,jcub,kcub,' for atom #',iat
         write (jout,'(a,3(1pe15.5))')
     &   'The coordinates of this atom are ',(xyz(k,iat),k=1,3)
       endif
       IF(NVAL.EQ.0) THEN
        LPTR(IAT)=-1
       ELSE
        LPTR(IAT)=NVAL
       ENDIF
       if (icub*jcub*kcub.gt.0) LCUB(ICUB,JCUB,KCUB)=IAT
      ENDDO
C
C FIND A SEED FOR EXPLORING THE EXTERIOR SURFACE
C
      YMN=1.D+38
      N1=0
      DO IAT=1,NAT
       S=XYZ(2,IAT)-RADII(IAT)
       IF(S.LT.YMN) THEN
        N1=IAT
        YMN=S
       ENDIF
      ENDDO
      CALL NEIGHB(N1)
      NBR1=LNBR(N1)
      NFBR1=LFBR(N1)
      IF(NBR1.GT.NNBRMX) NNBRMX=NBR1
      IF(NBR1.LT.NNBRMN) NNBRMN=NBR1
      YINT=YMN+2.0D0*RADII(N1)+RP
      N2=0
      DO JBR=NFBR1,NFBR1+NBR1-1
       JAT=LBR(JBR)
       DO K=1,3
        V(K)=XYZ(K,JAT)-XYZ(K,N1)
       ENDDO
       DOTV=DDOT(V,V)
       ALPHA=(RAD2(JAT)-RAD2(N1))/(2.0D0*DOTV)
       DO K=1,3
        PM(K)=(0.5D0+ALPHA)*XYZ(K,N1)+(0.5D0-ALPHA)*XYZ(K,JAT)
       ENDDO
       P(1)=V(2)*V(1)
       P(2)=V(2)**2-DOTV
       P(3)=V(2)*V(3)
       S=DDOT(P,P)
       IF(S.LT.1.D-10) THEN
C
C NEIGHBOUR IS JUST ABOVE SPHERE N1
C
        YY=PM(2)
       ELSE
        S=(RAD2(N1)-DOTV*(0.5D0-ALPHA)**2)/S
        IF(S.LT.0.0D0) THEN
C
C NEIGHBOUR IS INSIDE SPHERE N1
C
         YY=1.D+38
        ELSE
         YY=PM(2)+DSQRT(S)*P(2)
        ENDIF
       ENDIF
       IF(YY.LT.YINT) THEN
        N2=JAT
        YINT=YY
       ENDIF
      ENDDO
C     write(jout,*)  'n2', n2
      IF(N2.EQ.0) THEN
       WRITE (JOUT,'(2a)')'(W) MSEED error. Cannot find a seed.',
     & ' The program will recover by trying another conformation.'
       iret=-1
       return
c      STOP
      ENDIF
      NFAC=NFAC+1
      LFAC(1,1)=N1
      LFAC(2,1)=N2
      LFAC(3,1)=1
      CENT(1,1)=XYZ(1,N1)
      CENT(2,1)=XYZ(2,N1)-(RADII(N1)+RP)
      CENT(3,1)=XYZ(3,N1)
      LMAR(1,1)=0
      LMAR(2,1)=1
      LMAR(3,1)=1
      NPIL=NPIL+1
      IF(NPIL.GT.NPILMX) THEN
       NPILMX=NPIL
       IF(NPILMX.EQ.MAXPIL) THEN
        WRITE (JOUT,'(2a,i5,a)')'(F) MSEED error. Stack is too small',
     &   ' need',npilmx,' - increase MAXPIL.'
        STOP
       ENDIF
      ENDIF
      LPIL(1)=1
C     PRINT*,' N1,N2 ',N1,' ',N2

C     PRINT*,' A SEED HAS BEEN FOUND'
C
C LOOP OVER ALL VERTICES IN THE STACK
C
 100  CONTINUE
C
C TAKE THE VERTEX FROM THE TOP OF THE STACK
C
       NFAC1=LPIL(NPIL)
       NPIL=NPIL-1
       DO K=1,3
        PC(K)=CENT(K,NFAC1)
       ENDDO
C
C EXPLORE THE EDGES COMING FROM THIS VERTEX
C
       DO IORF1=1,3
C
C IF AN EDGE IS UNMARKED, EXPLORE IT
C
        IF(LMAR(IORF1,NFAC1).EQ.0) THEN
         N1=LFAC(IORF1,NFAC1)
         N2=LFAC(1+MOD(IORF1,3),NFAC1)
         DO K=1,3
          P1(K)=XYZ(K,N1)
          P2(K)=XYZ(K,N2)
         ENDDO
         R2P1=RAD2(N1)
         R2P2=RAD2(N2)
         CALL NORM(P1,P2,U)
         CALL NORM(P2,PC,V1)
C        write (jout,*) 'u=',u,' v1=',v1
         DO K=1,3
          VOR1(K)=V1(K)-DDOT(U,V1)*U(K)
         ENDDO
C        write (jout,*) 'vor1=',vor1
         S=DSQRT(DDOT(VOR1,VOR1))
         DO K=1,3
          VOR1(K)=VOR1(K)/S
         ENDDO
C        write (jout,*) 'S=',S,'VOR1=',(vor1(kkkk),kkkk=1,3)
         IREF=0
         IOTH=N2
         IF(LFBR(N1).NE.0) THEN
          IREF=N1
         ENDIF
         IF(LFBR(N2).NE.0) THEN
          IREF=N2
          IOTH=N1
         ENDIF
         IF(IREF.EQ.0) THEN
C
C GET A LIST OF NEIGHBORING ATOMS
C
          CALL NEIGHB(N1)
          IREF=N1
          IF(LNBR(N1).LT.NNBRMN) NNBRMN=LNBR(N1)
          IF(LNBR(N1).GT.NNBRMX) NNBRMX=LNBR(N1)
         ENDIF
C
C LOOP OVER ALL POSSIBLE SPHERES N3 THAT INTERSECT N1 AND N2
C
         ANGMIN=4.1D0
         ITEMN3=0
         N3=0
         DORI=DP+RADII(IOTH)
         NTEM=0
         IBEG=LFBR(IREF)
         IEND=IBEG+LNBR(IREF)-1
         XOTH=XYZ(1,IOTH)
         YOTH=XYZ(2,IOTH)
         ZOTH=XYZ(3,IOTH)
         DO KBR=IBEG,IEND
          KAT=LBR(KBR)
          IF((KAT.NE.N1).AND.(KAT.NE.N2)) THEN
           P3X=XYZ(1,KAT)
           P3Y=XYZ(2,KAT)
           P3Z=XYZ(3,KAT)
           IF((P3X-XOTH)**2+
     *        (P3Y-YOTH)**2+
     *        (P3Z-ZOTH)**2-(RADII(KAT)+DORI)**2.LE.0.0D0) THEN
            NTEM=NTEM+1
            IF(NTEM.EQ.MAXTEM) THEN
             WRITE (JOUT,'(2a,i5,a)') '(F) MSEED error:',
     &      ' Too few space to store angles; need',i5,
     &      ' - increase MAXTEM.'
             STOP
            ENDIF
            TEMX(NTEM)=P3X
            TEMY(NTEM)=P3Y
            TEMZ(NTEM)=P3Z
            TEMR2(NTEM)=RAD2(KAT)
            LTEM(NTEM)=KAT
           ENDIF
          ENDIF
         ENDDO
C
C COMPUTE INTERMEDIATE QUANTITIES FOR ALL TRIPLES
C
         CALL PLEIN(P2,R2P2,P1,R2P1,TEMX,TEMY,TEMZ,TEMR2,
     *        RHORI,CENTX,CENTY,CENTZ,V1X,V1Y,V1Z,V2X,V2Y,V2Z,NTEM)
         NPLE=NPLE+NTEM
         KK=0
         DO ITEM=1,NTEM
          IF(RHORI(ITEM).GT.0.0D0) THEN
C
C THE THREE SPHERES INTERSECT
C
           KK=KK+1
           LTEM(KK)=LTEM(ITEM)
           CENTX(KK)=CENTX(ITEM)
           CENTY(KK)=CENTY(ITEM)
           CENTZ(KK)=CENTZ(ITEM)
           RHORI(KK)=RHORI(ITEM)
           V1X(KK)=V1X(ITEM)
           V1Y(KK)=V1Y(ITEM)
           V1Z(KK)=V1Z(ITEM)
           V2X(KK)=V2X(ITEM)
           V2Y(KK)=V2Y(ITEM)
           V2Z(KK)=V2Z(ITEM)
          ENDIF
         ENDDO
         NTEM=KK
cd       write (20,*) 'NTEM=',ntem
C
C COMPUTE DIHEDRAL ANGLES FOR ALL INTERSECTING TRIPLES
C
         CALL ANGLO(U,VOR1,P2,CENTX,CENTY,CENTZ,RHORI,V1X,V1Y,
     *        V1Z,V2X,V2Y,V2Z,ALTAX,ALTAY,ALTAZ,0.0D0,ANG,NTEM)
         NANG=NANG+NTEM
C
C FIND WHICH TRIPLE CORRESPONDS TO THE SMALLEST DIHEDRAL ANGLE
C
         DO ITEM=1,NTEM
cd        write (20,*) 'ITEM=',ITEM,' ANG=',ANG(ITEM)
          IF(ANG(ITEM).LT.ANGMIN) THEN
           ITEMN3=ITEM
           ANGMIN=ANG(ITEM)
          ENDIF
         ENDDO
         IF(ITEMN3.EQ.0) THEN
          WRITE (JOUT,'(2a,2i5/2a)') '(W) MSEED error: Cannot find',
     &    ' vertex on edge between spheres ',N1,N2,
     &    'is RAD+RP too small? The program will recover by trying ',
     &    'another conformation.'
          iret=-1
	  return
c         STOP
         ENDIF
C
C KEEP THE COORDINATES OF THE NEW VERTEX
C
         N3=LTEM(ITEMN3)
         ALT3(1)=ALTAX(ITEMN3)
         ALT3(2)=ALTAY(ITEMN3)
         ALT3(3)=ALTAZ(ITEMN3)
         IF(N3.EQ.0) THEN
          WRITE (JOUT,'(2a/a)') 
     &   '(W) MSEED error: N3 for the next vertex is zero; ',
     &   'is RAD+RP too small?',
     &   'The program will recover by trying another conformation.'
	  iret=-1
	  return
C         STOP
         ENDIF
C
C NEXT VERTEX HAS BEEN FOUND, TOGETHER WITH THE SPHERE N3
C
C DETERMINE IF THIS VERTEX ALREADY EXISTS
C
         NFACS=0
         KBORS=0
         DO IORS=1,LNATO(N2)
          IFAC=LATO(IORS,N2)
          DO K=1,3
           IF((LFAC(K         ,IFAC).EQ.N1).AND.
     *        (LFAC(1+MOD(K,3),IFAC).EQ.N3)) THEN
            KBORS=1+MOD(K+1,3)
            NFACS=LATO(IORS,N2)
           ENDIF
          ENDDO
         ENDDO
         IF(NFACS.EQ.0) THEN
C
C NEW VERTEX
C
          NFAC=NFAC+1
          IF(NFAC.EQ.MAXFAC) THEN
           WRITE (JOUT,'(2a,i5,a)') '(F) MSEED error:',
     &    ' Too little space to store vertices; need',nfac,
     &    ' - increase MAXFAC.'
           STOP
          ENDIF
          NFACS=NFAC
          KBORS=1
          LFAC(1,NFAC)=N2
          LFAC(2,NFAC)=N1
          LFAC(3,NFAC)=N3
          LNATO(N1)=LNATO(N1)+1
          IF(LNATO(N1).GT.NORSMX) NORSMX=LNATO(N1)
          LATO(LNATO(N1),N1)=NFAC
          LNATO(N2)=LNATO(N2)+1
          IF(LNATO(N2).GT.NORSMX) NORSMX=LNATO(N2)
          LATO(LNATO(N2),N2)=NFAC
          LNATO(N3)=LNATO(N3)+1
          IF(LNATO(N3).GT.NORSMX) NORSMX=LNATO(N3)
          LATO(LNATO(N3),N3)=NFAC
          IF(NORSMX.EQ.MAXORS-1) THEN
           WRITE (JOUT,'(2a,i5,a)') '(F) MSEED error:',
     &  ' Too many vertices on one atom; need',norsmx,
     &  ' - increase MAXORS.'
           STOP
          ENDIF
C
C STORE THE COORDINATES OF THE NEW VERTEX
C
          DO K=1,3
           CENT(K,NFAC)=ALT3(K)
           LMAR(K,NFAC)=0
          ENDDO
C
C ADD THE NEW VERTEX TO THE STACK
C
          NPIL=NPIL+1
          IF(NPIL.GT.NPILMX) THEN
           NPILMX=NPIL
           IF(NPILMX.EQ.MAXPIL) THEN
            WRITE (JOUT,'(a,i5,a)') 
     &    '(F) MSEED error: Not enough space to store vertices; need',
     &    NPILMX,' - increase MAXPIL.'
            STOP
           ENDIF
          ENDIF
          LPIL(NPIL)=NFAC
         ENDIF
C
C MARK THE LATEST EDGE TO SHOW THAT IT HAS BEEN EXPLORED
C
         LMAR(IORF1,NFAC1)=1
         IF(NFAC1.NE.1) THEN
          IF(LMAR(KBORS,NFACS).NE.0) THEN
C
C THE EDGE HAS ALREADY BEEN EXPLORED
C
           WRITE (JOUT,'(2a,2i5,a/a)') 
     &   '(W) MSEED error: The manifold is undefined.',
     &   ' Edge connecting ',N1,N2,' was covered twice.',
     &   'The program will recover by increasing atomic radii.'
           WRITE (JOUT,'(a,3i15)')'LMAR(KBORS,NFACS), KBORS, NFACS',
     &                             LMAR(KBORS,NFACS), KBORS, NFACS
           IRET=1
           RETURN
          ENDIF
          LMAR(KBORS,NFACS)=1
         ENDIF
C
C ADD THE LATEST EDGE
C
C EACH EDGE IS LABELLED BY ITS SPHERES AND BY ITS VERTICES
C
         IF(NFAC1.NE.1) THEN
          NTOR=NTOR+1
          IF(NTOR.EQ.MAXTOR) THEN
           WRITE (JOUT,'(a,i5,a)') 
     & '(F) MSEED error: Not enough space to store edges; need',
     & ntor,' - increase MAXTOR.'
           STOP
          ENDIF
          LTOR(1,NTOR)=N1
          LTOR(2,NTOR)=N2
          LTPF(1,NTOR)=NFAC1-1
          LTPF(2,NTOR)=NFACS-1
          LTPFO(1,NTOR)=IORF1
          LTPFO(2,NTOR)=KBORS
          LFPT(IORF1,NFAC1-1)=NTOR
          LFPT(KBORS,NFACS-1)=NTOR
          LFPTO(IORF1,NFAC1-1)=1
          LFPTO(KBORS,NFACS-1)=2
         ENDIF
        ENDIF
       ENDDO
C
C IF THE STACK IS NOT EMPTY, CONTINUE
C
      IF(NPIL.GE.1) GOTO 100
C
C REMOVE THE SPURIOUS FIRST VERTEX
C
      DO IFAC=2,NFAC
       DO K=1,3
        LFAC(K,IFAC-1)=LFAC(K,IFAC)
       ENDDO
       CNT(IFAC-1,1)=CENT(1,IFAC)
       CNT(IFAC-1,2)=CENT(2,IFAC)
       CNT(IFAC-1,3)=CENT(3,IFAC)
      ENDDO
      NFAC=NFAC-1
C TO ANALYSE THE PROGRAM, REMOVE THE COMMENT SIGNS FROM THE NEXT LINES
C
cyu       PRINT*,'Number of vertices                           ',NFAC
c       PRINT*,'Number of edges                              ',NTOR
c       PRINT*,'Minimum no. of neighbours per atom           ',NNBRMN
c       PRINT*,'Maximum no. of neighbours per atom           ',NNBRMX
c       PRINT*,'Largest no. of vertices on any atom          ',NORSMX
c       PRINT*,'Greatest size reached by the stack           ',NPILMX
c       PRINT*,'Number of calls to PLEIN                     ',NPLE
c       PRINT*,'Number of calls to ANGLO                     ',NANG

C
      RETURN
      END
      SUBROUTINE PLEIN(P1,R2P1,P2,R2P2,TEMX,TEMY,TEMZ,TEMR2,
     *           RHORI,CENTX,CENTY,CENTZ,V1X,V1Y,V1Z,V2X,V2Y,V2Z,NTEM)
C
      IMPLICIT REAL*8 (A-H,O-Z)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      include 'COMMON.IOUNIT'
      REAL*8 TEMX(MAXTEM),TEMY(MAXTEM),TEMZ(MAXTEM)
      REAL*8 TEMR2(MAXTEM)
      REAL*8 RHORI(MAXTEM),CENTX(MAXTEM),CENTY(MAXTEM),CENTZ(MAXTEM)
      REAL*8 V1X(MAXTEM),V1Y(MAXTEM),V1Z(MAXTEM)
      REAL*8 V2X(MAXTEM),V2Y(MAXTEM),V2Z(MAXTEM)
      REAL*8 DET(MAXTEM),C1(MAXTEM),C2(MAXTEM)
      REAL*8 DET1(MAXTEM),DET2(MAXTEM)
C
      REAL*8 VVZ(MAXTEM),U1(MAXTEM),U2(MAXTEM)
      REAL*8 A1(MAXTEM),A2(MAXTEM),A3(MAXTEM)
      REAL*8 P1(3),P2(3)
C
      TOL=1.0D-3
      DO ITEM=1,NTEM
       V1X(ITEM)=TEMX(ITEM)-P2(1)
       V1Y(ITEM)=TEMY(ITEM)-P2(2)
       V1Z(ITEM)=TEMZ(ITEM)-P2(3)
       V2X(ITEM)=TEMX(ITEM)-P1(1)
       V2Y(ITEM)=TEMY(ITEM)-P1(2)
       V2Z(ITEM)=TEMZ(ITEM)-P1(3)
       VVZ(ITEM)=V1X(ITEM)*V2X(ITEM)+V1Y(ITEM)*V2Y(ITEM)+
     *           V1Z(ITEM)*V2Z(ITEM)
       U1(ITEM)  =V1X(ITEM)**2+V1Y(ITEM)**2+V1Z(ITEM)**2
       U2(ITEM)  =V2X(ITEM)**2+V2Y(ITEM)**2+V2Z(ITEM)**2
       DET(ITEM) =VVZ(ITEM)**2-U1(ITEM)*U2(ITEM)
       C1(ITEM)  =(TEMR2(ITEM)-R2P2+U1(ITEM))*0.5D0
       C2(ITEM)  =(TEMR2(ITEM)-R2P1+U2(ITEM))*0.5D0
       DET1(ITEM)=C1(ITEM)*VVZ(ITEM)-C2(ITEM)*U1(ITEM)
       DET2(ITEM)=C2(ITEM)*VVZ(ITEM)-C1(ITEM)*U2(ITEM)
      ENDDO
      DO ITEM=1,NTEM
       IF(DABS(DET(ITEM)).LE.TOL) THEN
        RHORI(ITEM)=1.0D+20
        A1(ITEM)=0.0D0
        A2(ITEM)=0.0D0
       ELSE
        RHORI(ITEM)=1.0D0
        A1(ITEM)=DET1(ITEM)/DET(ITEM)
        A2(ITEM)=DET2(ITEM)/DET(ITEM)
       ENDIF
      ENDDO
      DO ITEM=1,NTEM
       A3(ITEM)=1.0D0-A1(ITEM)-A2(ITEM)
       CENTX(ITEM)=A1(ITEM)*P1(1)+A2(ITEM)*P2(1)+A3(ITEM)*TEMX(ITEM)
       CENTY(ITEM)=A1(ITEM)*P1(2)+A2(ITEM)*P2(2)+A3(ITEM)*TEMY(ITEM)
       CENTZ(ITEM)=A1(ITEM)*P1(3)+A2(ITEM)*P2(3)+A3(ITEM)*TEMZ(ITEM)
       RHORI(ITEM)=-RHORI(ITEM)*((P1(1)-CENTX(ITEM))**2+
     *                           (P1(2)-CENTY(ITEM))**2+
     *                           (P1(3)-CENTZ(ITEM))**2)+R2P1
      ENDDO
      RETURN
      END
      SUBROUTINE ANGLO(U,VOR1,P0,CENTX,CENTY,CENTZ,RHORI,V1X,V1Y,
     *     V1Z,V2X,V2Y,V2Z,ALTAX,ALTAY,ALTAZ,SEUIL,ANG,NTEM)
C
      IMPLICIT REAL*8 (A-H,O-Z)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      include 'COMMON.IOUNIT'
      REAL*8 VOR1(3),U(3),P0(3)
      REAL*8 ALTAX(MAXTEM),ALTAY(MAXTEM),ALTAZ(MAXTEM)
      REAL*8 RHORI(MAXTEM),CENTX(MAXTEM),CENTY(MAXTEM),CENTZ(MAXTEM)
      REAL*8 V1X(MAXTEM),V1Y(MAXTEM),V1Z(MAXTEM)
      REAL*8 V2X(MAXTEM),V2Y(MAXTEM),V2Z(MAXTEM)
      REAL*8 WWX(MAXTEM),WWY(MAXTEM),WWZ(MAXTEM),DUV(MAXTEM),XX(MAXTEM)
      REAL*8 ANG(MAXTEM),HH(MAXTEM)
      REAL*8 PERPX(MAXTEM),PERPY(MAXTEM),PERPZ(MAXTEM)
      REAL*8 VOR2X(MAXTEM),VOR2Y(MAXTEM),VOR2Z(MAXTEM)
C
      XXMAX=1.0D0
      DO ITEM=1,NTEM
       PERPX(ITEM)=V2Y(ITEM)*V1Z(ITEM)-V2Z(ITEM)*V1Y(ITEM)
       PERPY(ITEM)=V2Z(ITEM)*V1X(ITEM)-V2X(ITEM)*V1Z(ITEM)
       PERPZ(ITEM)=V2X(ITEM)*V1Y(ITEM)-V2Y(ITEM)*V1X(ITEM)
       HH(ITEM)=DSQRT(RHORI(ITEM)/(PERPX(ITEM)**2+PERPY(ITEM)**2
     *              +PERPZ(ITEM)**2))
Cd     if (item .eq.1) then
cd       write (20,*) 'PERP:',perpx(ITEM),perpy(item),perpz(item),
cd   &   ' rhori=',rhori(item),' HH=',hh(item) 
cd     endif
       ALTAX(ITEM)=CENTX(ITEM)+PERPX(ITEM)*HH(ITEM)
       ALTAY(ITEM)=CENTY(ITEM)+PERPY(ITEM)*HH(ITEM)
       ALTAZ(ITEM)=CENTZ(ITEM)+PERPZ(ITEM)*HH(ITEM)
       WWX(ITEM)=ALTAX(ITEM)-P0(1)
       WWY(ITEM)=ALTAY(ITEM)-P0(2)
       WWZ(ITEM)=ALTAZ(ITEM)-P0(3)
       DUV(ITEM)=U(1)*WWX(ITEM)+U(2)*WWY(ITEM)+U(3)*WWZ(ITEM)
       VOR2X(ITEM)=WWX(ITEM)-DUV(ITEM)*U(1)
       VOR2Y(ITEM)=WWY(ITEM)-DUV(ITEM)*U(2)
       VOR2Z(ITEM)=WWZ(ITEM)-DUV(ITEM)*U(3)
cd     if (item .eq.1) then
Cd       write (20,*) 'VOr1:',vor1(1),vor1(2),vor1(3)
cd     endif
       ANG(ITEM)=(VOR1(1)*VOR2X(ITEM)+VOR1(2)*VOR2Y(ITEM)+
     * VOR1(3)*VOR2Z(ITEM))/
     * DSQRT(VOR2X(ITEM)**2+VOR2Y(ITEM)**2+VOR2Z(ITEM)**2)
       WWX(ITEM)=VOR1(2)*VOR2Z(ITEM)-VOR1(3)*VOR2Y(ITEM)
       WWY(ITEM)=VOR1(3)*VOR2X(ITEM)-VOR1(1)*VOR2Z(ITEM)
       WWZ(ITEM)=VOR1(1)*VOR2Y(ITEM)-VOR1(2)*VOR2X(ITEM)
       XX(ITEM)=WWX(ITEM)*U(1)+WWY(ITEM)*U(2)+WWZ(ITEM)*U(3)
cd     if (item .eq.1) then
cd       write (20,*) 'VOr2:',vor2x(ITEM),vor2y(item),vor2z(item),
cd   &   ' ang=',ang(item)
cd     endif
      ENDDO
      DO ITEM=1,NTEM
       IF(ANG(ITEM).GT.XXMAX) ANG(ITEM)=1.0D0
       IF(ANG(ITEM).LT.-XXMAX) ANG(ITEM)=-1.0D0
       ANG(ITEM)=1.-ANG(ITEM)
       IF(XX(ITEM).LE.0.0D0) ANG(ITEM)=4.0D0-ANG(ITEM)
      ENDDO
      RETURN
      END
      SUBROUTINE NEIGHB(IAT)
      IMPLICIT REAL*8 (A-H,O-Z)
C
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      PARAMETER(MAXATO=maxnum_atoms)

      REAL*8 TEMX(MAXTNB),TEMY(MAXTNB),TEMZ(MAXTNB)
      REAL*8 TEMR(MAXTNB),TEMD(MAXTNB)
cmsp  INTEGER*4 LTEM(maxnum_atoms)
      INTEGER   LTEM(maxnum_atoms)
      include 'COMMON.IOUNIT'
      include 'COMMON.SOLVAT'
      include 'COMMON.SOLVAT3'
c     COMMON /COOR/XYZ(3,MAXATO),RADII(MAXATO),DP,RADMX,NAT
c     COMMON /CUBE/LXYZ(3,MAXATO),LPTR(MAXATO),
c    *             LCUB(MAXCUB,MAXCUB,MAXCUB),LCUMX(3)
c     COMMON /NEIB/LBR(MAXIMNBR),LFBR(MAXATO),LNBR(MAXATO),
c    *             NTOPBR
C
      IF(IAT.GT.NAT) THEN
       write (jout,'(a,i5,a)') 
     & '(F) MSEED error: Atom index (',iat,
     & ') exceeds max. # of atoms.'
       STOP
      ENDIF
      LFBR(IAT)=NTOPBR+1
      RADIAT=RADII(IAT)
      DORI=RADIAT+DP
      NTEM=0
      PX=XYZ(1,IAT)
      PY=XYZ(2,IAT)
      PZ=XYZ(3,IAT)
      ICUB=LXYZ(1,IAT)
      JCUB=LXYZ(2,IAT)
      KCUB=LXYZ(3,IAT)
      IMIN=MAX(ICUB-1,1)
      JMIN=MAX(JCUB-1,1)
      KMIN=MAX(KCUB-1,1)
      IMAX=MIN(ICUB+1,LCUMX(1))
      JMAX=MIN(JCUB+1,LCUMX(2))
      KMAX=MIN(KCUB+1,LCUMX(3))
      DO KK=KMIN,KMAX
       DO JJ=JMIN,JMAX
        DO II=IMIN,IMAX
         NVAL=LCUB(II,JJ,KK)
         IF(NVAL.NE.0) THEN
 100      CONTINUE
           IF(NVAL.NE.IAT) THEN
            NTEM=NTEM+1
            LTEM(NTEM)=NVAL
            TEMX(NTEM)=XYZ(1,NVAL)
            TEMY(NTEM)=XYZ(2,NVAL)
            TEMZ(NTEM)=XYZ(3,NVAL)
            TEMR(NTEM)=RADII(NVAL)
           ENDIF
           NVAL=LPTR(NVAL)
          IF(NVAL.NE.-1) GOTO 100
         ENDIF
        ENDDO
       ENDDO
      ENDDO
C
      DO ITEM=1,NTEM
       TEMD(ITEM)=(PX  -TEMX(ITEM))**2+(PY  -TEMY(ITEM))**2+
     *            (PZ  -TEMZ(ITEM))**2-(DORI+TEMR(ITEM))**2
      ENDDO
      DO ITEM=1,NTEM
       IF(TEMD(ITEM).LE.0.0D0) THEN
        NTOPBR=NTOPBR+1
        LBR(NTOPBR)=LTEM(ITEM)
       ENDIF
      ENDDO
      LNBR(IAT)=NTOPBR+1-LFBR(IAT)
      IF(NTOPBR.GE.(maximnbr-maxnum_atoms)) THEN
       WRITE (JOUT,'(2a,i5,a)') 
     & '(F) MSEED error: Not enough space for neighbors; ',
     & 'need',NTOPBR+maxnum_atoms,' - increase MAXIMNBR.'
       STOP
      ENDIF
C
      RETURN
      END
      SUBROUTINE AREAC(IRET,IDER)
      IMPLICIT REAL*8 (A-H,O-Z)
C
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      PARAMETER(MAXATO=maxnum_atoms)
      PARAMETER (PI2=PI*2.0D0)
      PARAMETER (PI4=PI*4.0D0)
      PARAMETER (PIOV2=PI/2.0D0)
      PARAMETER (PIOV3=PI/3.0D0)
      PARAMETER (TOL=1.0D0)
C
C BETA,  DIHEDRAL ANGLES AT VERTICES; PHI, ARC LENGTHS OF EDGES;
C THETA, EQUATORIAL ANGLES OF EDGES.
C
      REAL*8 CBET(MAXFAC,3),SBET(MAXFAC,3)
      REAL*8 CPHI(MAXTOR),SPHI(MAXTOR)
C
C ARRAYS NEEDED FOR COMPUTING SURFACE AREA
C
      REAL*8 UNI(MAXFAC,3,3),SUN(MAXFAC,3),SUN2(MAXFAC,3),
     *       UN(MAXFAC,3,3)
      REAL*8 VNI(MAXFAC,3,3),SVN(MAXFAC,3),VN(MAXFAC,3,3)
      REAL*8 TVN(MAXTOR,3,3),TXYZ(MAXTOR,3,2),RIJ(MAXTOR,2)
      REAL*8 TUN(MAXTOR,3,2)
      REAL*8 TORAXI(MAXTOR,3),STORAX(MAXTOR),TORAX(MAXTOR,3)
cmsp  INTEGER*4 LMAR(2,MAXTOR)
      INTEGER   LMAR(2,MAXTOR)
C
C ARRAYS NEEDED FOR COMPUTING DERIVATIVES
C
      REAL*8 RHORI(MAXFAC),CENT(MAXFAC,3)
      REAL*8 V1(MAXFAC,3)
      REAL*8 V2(MAXFAC,3)
      REAL*8 DET(MAXFAC),C1(MAXFAC),C2(MAXFAC)
      REAL*8 DET1(MAXFAC),DET2(MAXFAC)
      REAL*8 VVZ(MAXFAC),U1(MAXFAC),U2(MAXFAC)
      REAL*8 A(MAXFAC,3)
      REAL*8 HH(MAXFAC)
      REAL*8 PERP(MAXFAC,3),SPERP(MAXFAC)
      REAL*8 D(MAXTOR,4,3),E(MAXFAC,3,3),G(MAXFAC,3,3)
      REAL*8 DUN(MAXFAC,3,3,3),DVN(MAXFAC,3,3,3)
      REAL*8 DTN(MAXTOR,4,3,2),DTAX(MAXTOR,2,3)
      REAL*8 DCNT(MAXFAC,3,3)
      REAL*8 DBET(MAXFAC,3,3,3),DPHI(MAXTOR,4,3),DTET(MAXTOR,2,2,3)
      include 'COMMON.SOLVAT'
      include 'COMMON.SOLVAT3'
      include 'COMMON.IOUNIT'
      IRET=0
      RP=0.5D0*DP
      DO IAT=1,NAT
       AREA(IAT)=0.0D0
       LNDER(IAT)=0
      ENDDO
C COMPUTE DIHEDRAL ANGLES AT VERTICES
      DO IUM=1,3
       DO IFAC=1,NFAC
        DO K=1,3
         UNI(IFAC,K,IUM)=XYZ(K,LFAC(IUM,IFAC))
        ENDDO
        SUN(IFAC,IUM)=RADII(LFAC(IUM,IFAC))+RP
        SUN2(IFAC,IUM)=SUN(IFAC,IUM)**2
       ENDDO
       DO K=1,3
        DO IFAC=1,NFAC
         UN(IFAC,K,IUM)=(UNI(IFAC,K,IUM)-CNT(IFAC,K))/SUN(IFAC,IUM)
        ENDDO
       ENDDO
      ENDDO
      DO IUM=1,3
       N1=IUM
       N2=1+MOD(N1,3)
       N3=1+MOD(N2,3)
       DO IFAC=1,NFAC
        VNI(IFAC,1,N3) = UN(IFAC,2,N1) * UN(IFAC,3,N2) -
     *                   UN(IFAC,3,N1) * UN(IFAC,2,N2)
        VNI(IFAC,2,N3) = UN(IFAC,3,N1) * UN(IFAC,1,N2) -
     *                   UN(IFAC,1,N1) * UN(IFAC,3,N2)
        VNI(IFAC,3,N3) = UN(IFAC,1,N1) * UN(IFAC,2,N2) -
     *                   UN(IFAC,2,N1) * UN(IFAC,1,N2)
        SVN(IFAC,N3)=DSQRT(VNI(IFAC,1,N3)**2+
     *                    VNI(IFAC,2,N3)**2+
     *                    VNI(IFAC,3,N3)**2)
        VN(IFAC,1,N3)=VNI(IFAC,1,N3)/SVN(IFAC,N3)
        VN(IFAC,2,N3)=VNI(IFAC,2,N3)/SVN(IFAC,N3)
        VN(IFAC,3,N3)=VNI(IFAC,3,N3)/SVN(IFAC,N3)
       ENDDO
      ENDDO
      DO IUM=1,3
       N1=IUM
       N2=1+MOD(N1,3)
       N3=1+MOD(N2,3)
       DO IFAC=1,NFAC
        CBET(IFAC,N3)=VN(IFAC,1,N1)*VN(IFAC,1,N2)+
     *                VN(IFAC,2,N1)*VN(IFAC,2,N2)+
     *                VN(IFAC,3,N1)*VN(IFAC,3,N2)
       ENDDO
       DO IFAC=1,NFAC
        SBET(IFAC,N3)=UN(IFAC,1,N3)*(VN(IFAC,2,N1)*VN(IFAC,3,N2)
     *                              -VN(IFAC,3,N1)*VN(IFAC,2,N2))
     *               +UN(IFAC,2,N3)*(VN(IFAC,3,N1)*VN(IFAC,1,N2)
     *                              -VN(IFAC,1,N1)*VN(IFAC,3,N2))
     *               +UN(IFAC,3,N3)*(VN(IFAC,1,N1)*VN(IFAC,2,N2)
     *                              -VN(IFAC,2,N1)*VN(IFAC,1,N2))
       ENDDO
       DO IFAC=1,NFAC
        BETA(IFAC,N3) = DATAN2(-SBET(IFAC,N3),-CBET(IFAC,N3))
       ENDDO
      ENDDO
      DO ITOR=1,NTOR
       DO IUM=1,2
        DO K=1,3
         TXYZ(ITOR,K,IUM)=XYZ(K,LTOR(IUM,ITOR))
        ENDDO
        RIJ(ITOR,IUM)=RADII(LTOR(IUM,ITOR))+RP
       ENDDO
      ENDDO
      DO K=1,3
       DO ITOR=1,NTOR
        TORAXI(ITOR,K)=TXYZ(ITOR,K,2)-TXYZ(ITOR,K,1)
       ENDDO
      ENDDO
      DO ITOR=1,NTOR
       STORAX(ITOR)=TORAXI(ITOR,1)**2+TORAXI(ITOR,2)**2+
     *              TORAXI(ITOR,3)**2
       STORAX(ITOR)=DSQRT(STORAX(ITOR))
       TORAX(ITOR,1)=TORAXI(ITOR,1)/STORAX(ITOR)
       TORAX(ITOR,2)=TORAXI(ITOR,2)/STORAX(ITOR)
       TORAX(ITOR,3)=TORAXI(ITOR,3)/STORAX(ITOR)
      ENDDO
C COMPUTE ARC LENGTHS OF EDGES
      DO ITOR=1,NTOR
       DO IUM=1,2
        DO K=1,3
         TVN(ITOR,K,IUM)=VN(LTPF(IUM,ITOR),K,
     *                  1+MOD(LTPFO(IUM,ITOR)+1,3))
        ENDDO
       ENDDO
      ENDDO
      DO ITOR=1,NTOR
       CPHI(ITOR)=TVN(ITOR,1,1)*TVN(ITOR,1,2)+
     *            TVN(ITOR,2,1)*TVN(ITOR,2,2)+
     *            TVN(ITOR,3,1)*TVN(ITOR,3,2)
      ENDDO
      DO ITOR=1,NTOR
       TVN(ITOR,1,3)=TVN(ITOR,2,1)*TVN(ITOR,3,2)-
     *               TVN(ITOR,3,1)*TVN(ITOR,2,2)
       TVN(ITOR,2,3)=TVN(ITOR,3,1)*TVN(ITOR,1,2)-
     *               TVN(ITOR,1,1)*TVN(ITOR,3,2)
       TVN(ITOR,3,3)=TVN(ITOR,1,1)*TVN(ITOR,2,2)-
     *               TVN(ITOR,2,1)*TVN(ITOR,1,2)
       SPHI(ITOR)=TORAX(ITOR,1)*TVN(ITOR,1,3)+
     *            TORAX(ITOR,2)*TVN(ITOR,2,3)+
     *            TORAX(ITOR,3)*TVN(ITOR,3,3)
      ENDDO
      DO ITOR=1,NTOR
       TORPHI(ITOR)=DATAN2(-SPHI(ITOR),-CPHI(ITOR))
       IF (TORPHI(ITOR).LT.0.0D0) TORPHI(ITOR)=TORPHI(ITOR)+PI2
      ENDDO
C COMPUTE GEODESIC CURVATURES OF EDGES
      DO ITOR=1,NTOR
       DO IUM=1,2
        DO K=1,3
         TUN(ITOR,K,IUM)=UN(LTPF(1,ITOR),K,
     *                     1+MOD(LTPFO(1,ITOR)+IUM+1,3))
        ENDDO
       ENDDO
      ENDDO
      DO IUM=1,2
       IF(IUM.EQ.1) THEN
        SENS=-1.0D0
       ELSE
        SENS=1.0D0
       ENDIF
       DO ITOR=1,NTOR
        CTET(ITOR,IUM)=TUN(ITOR,1,IUM)*TORAX(ITOR,1)+
     *                 TUN(ITOR,2,IUM)*TORAX(ITOR,2)+
     *                 TUN(ITOR,3,IUM)*TORAX(ITOR,3)
       ENDDO
       DO ITOR=1,NTOR
        IF(CTET(ITOR,IUM).LT.-TOL) CTET(ITOR,IUM)=-TOL
        IF(CTET(ITOR,IUM).GT.TOL) CTET(ITOR,IUM)=TOL
       ENDDO
       DO ITOR=1,NTOR
        CTET(ITOR,IUM)=SENS*CTET(ITOR,IUM)
       ENDDO
      ENDDO
      IF(IDER.GT.0) THEN
       DO IFAC=1,NFAC
        DO K=1,3
         V1(IFAC,K)=UNI(IFAC,K,3)-UNI(IFAC,K,2)
         V2(IFAC,K)=UNI(IFAC,K,3)-UNI(IFAC,K,1)
        ENDDO
        VVZ(IFAC)=V1(IFAC,1)*V2(IFAC,1)+V1(IFAC,2)*V2(IFAC,2)+
     *            V1(IFAC,3)*V2(IFAC,3)
        U1(IFAC)  =V1(IFAC,1)**2+V1(IFAC,2)**2+V1(IFAC,3)**2
        U2(IFAC)  =V2(IFAC,1)**2+V2(IFAC,2)**2+V2(IFAC,3)**2
        DET(IFAC) =VVZ(IFAC)**2-U1(IFAC)*U2(IFAC)
        C1(IFAC)  =(SUN2(IFAC,3)-SUN2(IFAC,2)+U1(IFAC))*0.5D0
        C2(IFAC)  =(SUN2(IFAC,3)-SUN2(IFAC,1)+U2(IFAC))*0.5D0
        DET1(IFAC)=C1(IFAC)*VVZ(IFAC)-C2(IFAC)*U1(IFAC)
        DET2(IFAC)=C2(IFAC)*VVZ(IFAC)-C1(IFAC)*U2(IFAC)
        A(IFAC,1)=DET1(IFAC)/DET(IFAC)
        A(IFAC,2)=DET2(IFAC)/DET(IFAC)
        A(IFAC,3)=1.0D0-A(IFAC,1)-A(IFAC,2)
        DO K=1,3
         CENT(IFAC,K)=A(IFAC,1)*UNI(IFAC,K,1)+
     *                A(IFAC,2)*UNI(IFAC,K,2)+A(IFAC,3)*UNI(IFAC,K,3)
        ENDDO
        RHORI(IFAC)=-((UNI(IFAC,1,1)-CENT(IFAC,1))**2+
     *                (UNI(IFAC,2,1)-CENT(IFAC,2))**2+
     *                (UNI(IFAC,3,1)-CENT(IFAC,3))**2)+SUN2(IFAC,1)
        PERP(IFAC,1)=V2(IFAC,2)*V1(IFAC,3)-V2(IFAC,3)*V1(IFAC,2)
        PERP(IFAC,2)=V2(IFAC,3)*V1(IFAC,1)-V2(IFAC,1)*V1(IFAC,3)
        PERP(IFAC,3)=V2(IFAC,1)*V1(IFAC,2)-V2(IFAC,2)*V1(IFAC,1)
        SPERP(IFAC)=PERP(IFAC,1)**2+PERP(IFAC,2)**2+PERP(IFAC,3)**2
        HH(IFAC)=DSQRT(RHORI(IFAC)/SPERP(IFAC))
       ENDDO
       DO KCOR=1,3
        KCOR1=1+MOD(KCOR ,3)
        KCOR2=1+MOD(KCOR1,3)
        DO IFAC=1,NFAC
         D(IFAC,1,1)=0.0D0
         D(IFAC,2,1)=-2.0D0*V1(IFAC,KCOR)
         D(IFAC,3,1)= 2.0D0*V1(IFAC,KCOR)
         D(IFAC,1,2)=-2.0D0*V2(IFAC,KCOR)
         D(IFAC,2,2)=0.0D0
         D(IFAC,3,2)= 2.0D0*V2(IFAC,KCOR)
         D(IFAC,1,3)=-V1(IFAC,KCOR)
         D(IFAC,2,3)=-V2(IFAC,KCOR)
         D(IFAC,3,3)=V1(IFAC,KCOR)+V2(IFAC,KCOR)
         DO ID=1,3
          E(IFAC,ID,1)=C1(IFAC)         *D(IFAC,ID,3)
     *                +0.5D0*D(IFAC,ID,1) *VVZ(IFAC)
     *                -C2(IFAC)         *D(IFAC,ID,1)
     *                -0.5D0*D(IFAC,ID,2) *U1(IFAC)
          E(IFAC,ID,2)=C2(IFAC)         *D(IFAC,ID,3)
     *                +0.5D0*D(IFAC,ID,2) *VVZ(IFAC)
     *                -C1(IFAC)         *D(IFAC,ID,2)
     *                -0.5D0*D(IFAC,ID,1) *U2(IFAC)
          E(IFAC,ID,3)=2.0D0*VVZ(IFAC)*D(IFAC,ID,3)
     *                 -U1(IFAC)    *D(IFAC,ID,2)
     *                 -D(IFAC,ID,1)*U2(IFAC)
         ENDDO
         DO ID=1,3
          D(IFAC,ID,1)=E(IFAC,ID,1)/DET(IFAC)
     *                -DET1(IFAC)*E(IFAC,ID,3)/DET(IFAC)**2
          D(IFAC,ID,2)=E(IFAC,ID,2)/DET(IFAC)
     *                -DET2(IFAC)*E(IFAC,ID,3)/DET(IFAC)**2
          D(IFAC,ID,3)=-D(IFAC,ID,1)-D(IFAC,ID,2)
         ENDDO
         DO ID=1,3
          DO ITY=1,3
           E(IFAC,ID,ITY)=D(IFAC,ID,1)*UNI(IFAC,ITY,1)
     *                   +D(IFAC,ID,2)*UNI(IFAC,ITY,2)
     *                   +D(IFAC,ID,3)*UNI(IFAC,ITY,3)
          ENDDO
          E(IFAC,ID,KCOR)=E(IFAC,ID,KCOR)+A(IFAC,ID)
         ENDDO
         DO ID=1,3
          G(IFAC,ID,1)=(UNI(IFAC,1,1)-CENT(IFAC,1))*E(IFAC,ID,1)
     *                +(UNI(IFAC,2,1)-CENT(IFAC,2))*E(IFAC,ID,2)
     *                +(UNI(IFAC,3,1)-CENT(IFAC,3))*E(IFAC,ID,3)
         ENDDO
         G(IFAC,1,1)=G(IFAC,1,1)-(UNI(IFAC,KCOR,1)-CENT(IFAC,KCOR))
         DO ID=1,3
          D(IFAC,ID,KCOR )=0.0D0
         ENDDO
         D(IFAC,1,KCOR1)= V1(IFAC,KCOR2)
         D(IFAC,2,KCOR1)=-V2(IFAC,KCOR2)
         D(IFAC,3,KCOR1)= V2(IFAC,KCOR2)-V1(IFAC,KCOR2)
         D(IFAC,1,KCOR2)=-V1(IFAC,KCOR1)
         D(IFAC,2,KCOR2)= V2(IFAC,KCOR1)
         D(IFAC,3,KCOR2)= V1(IFAC,KCOR1)-V2(IFAC,KCOR1)
         DO ID=1,3
          G(IFAC,ID,2)=PERP(IFAC,1)*D(IFAC,ID,1)
     *                +PERP(IFAC,2)*D(IFAC,ID,2)
     *                +PERP(IFAC,3)*D(IFAC,ID,3)
         ENDDO
         DO ID=1,3
          G(IFAC,ID,3)=(G(IFAC,ID,1)/SPERP(IFAC)-RHORI(IFAC)*
     *                  G(IFAC,ID,2)/SPERP(IFAC)**2)/HH(IFAC)
         ENDDO
         DO ID=1,3
          DO ITY=1,3
           DCNT(IFAC,ID,ITY)=E(IFAC,ID,ITY)+
     *     PERP(IFAC,ITY)*G(IFAC,ID,3)+D(IFAC,ID,ITY)*HH(IFAC)
          ENDDO
         ENDDO
        ENDDO
        DO IFAC=1,NFAC
         DO IUM=1,3
          DO ITY=1,3
           DO ID=1,3
            DUN(IFAC,ID,ITY,IUM)=-DCNT(IFAC,ID,ITY)/SUN(IFAC,IUM)
           ENDDO
          ENDDO
          DUN(IFAC,IUM,KCOR,IUM)=DUN(IFAC,IUM,KCOR,IUM)
     *                          +1.0D0/SUN(IFAC,IUM)
         ENDDO
        ENDDO
        DO IUM=1,3
         N1=IUM
         N2=1+MOD(N1,3)
         N3=1+MOD(N2,3)
         DO IFAC=1,NFAC
          DO ID=1,3
           DVN(IFAC,ID,1,N3)= DUN(IFAC,ID,2,N1)*UN(IFAC,3,N2)
     *                       +UN(IFAC,2,N1)*DUN(IFAC,ID,3,N2)
     *                       -DUN(IFAC,ID,3,N1)*UN(IFAC,2,N2)
     *                       -UN(IFAC,3,N1)*DUN(IFAC,ID,2,N2)
           DVN(IFAC,ID,2,N3)= DUN(IFAC,ID,3,N1)*UN(IFAC,1,N2)
     *                       +UN(IFAC,3,N1)*DUN(IFAC,ID,1,N2)
     *                       -DUN(IFAC,ID,1,N1)*UN(IFAC,3,N2)
     *                       -UN(IFAC,1,N1)*DUN(IFAC,ID,3,N2)
           DVN(IFAC,ID,3,N3)= DUN(IFAC,ID,1,N1)*UN(IFAC,2,N2)
     *                       +UN(IFAC,1,N1)*DUN(IFAC,ID,2,N2)
     *                       -DUN(IFAC,ID,2,N1)*UN(IFAC,1,N2)
     *                       -UN(IFAC,2,N1)*DUN(IFAC,ID,1,N2)
           D(IFAC,ID,1)= DVN(IFAC,ID,1,N3)*VNI(IFAC,1,N3)
     *                  +DVN(IFAC,ID,2,N3)*VNI(IFAC,2,N3)
     *                  +DVN(IFAC,ID,3,N3)*VNI(IFAC,3,N3)
           DO ITY=1,3
            DVN(IFAC,ID,ITY,N3)=DVN(IFAC,ID,ITY,N3)/SVN(IFAC,N3)
     *                        -VNI(IFAC,ITY,N3)*D(IFAC,ID,1)/
     *                         SVN(IFAC,N3)**3
           ENDDO
          ENDDO
         ENDDO
        ENDDO
        DO IUM=1,3
         N1=IUM
         N2=1+MOD(N1,3)
         N3=1+MOD(N2,3)
         DO IFAC=1,NFAC
          DO ID=1,3
           D(IFAC,ID,1)=DVN(IFAC,ID,1,N1)*VN(IFAC,1,N2)
     *                 +DVN(IFAC,ID,1,N2)*VN(IFAC,1,N1)
     *                 +DVN(IFAC,ID,2,N1)*VN(IFAC,2,N2)
     *                 +DVN(IFAC,ID,2,N2)*VN(IFAC,2,N1)
     *                 +DVN(IFAC,ID,3,N1)*VN(IFAC,3,N2)
     *                 +DVN(IFAC,ID,3,N2)*VN(IFAC,3,N1)
           D(IFAC,ID,2)=DUN(IFAC,ID,1,N3)*(VN(IFAC,2,N1)*VN(IFAC,3,N2)
     *                                    -VN(IFAC,3,N1)*VN(IFAC,2,N2))
     *                 +DUN(IFAC,ID,2,N3)*(VN(IFAC,3,N1)*VN(IFAC,1,N2)
     *                                    -VN(IFAC,1,N1)*VN(IFAC,3,N2))
     *                 +DUN(IFAC,ID,3,N3)*(VN(IFAC,1,N1)*VN(IFAC,2,N2)
     *                                    -VN(IFAC,2,N1)*VN(IFAC,1,N2))
     *                 +DVN(IFAC,ID,1,N1)*(VN(IFAC,2,N2)*UN(IFAC,3,N3)
     *                                    -VN(IFAC,3,N2)*UN(IFAC,2,N3))
     *                 +DVN(IFAC,ID,2,N1)*(VN(IFAC,3,N2)*UN(IFAC,1,N3)
     *                                    -VN(IFAC,1,N2)*UN(IFAC,3,N3))
     *                 +DVN(IFAC,ID,3,N1)*(VN(IFAC,1,N2)*UN(IFAC,2,N3)
     *                                    -VN(IFAC,2,N2)*UN(IFAC,1,N3))
     *                 +DVN(IFAC,ID,1,N2)*(UN(IFAC,2,N3)*VN(IFAC,3,N1)
     *                                    -UN(IFAC,3,N3)*VN(IFAC,2,N1))
     *                 +DVN(IFAC,ID,2,N2)*(UN(IFAC,3,N3)*VN(IFAC,1,N1)
     *                                    -UN(IFAC,1,N3)*VN(IFAC,3,N1))
     *                 +DVN(IFAC,ID,3,N2)*(UN(IFAC,1,N3)*VN(IFAC,2,N1)
     *                                    -UN(IFAC,2,N3)*VN(IFAC,1,N1))
           DBET(IFAC,ID,N3,KCOR)=D(IFAC,ID,2)*CBET(IFAC,N3)
     *                          -D(IFAC,ID,1)*SBET(IFAC,N3)
          ENDDO
         ENDDO
        ENDDO
        DO ITOR=1,NTOR
         DO ITY=1,3
          KK=LTPFO(1,ITOR)
          KK1=1+MOD(KK ,3)
          KK2=1+MOD(KK1,3)
          DTN(ITOR,1,ITY,1)=DVN(LTPF(1,ITOR),KK ,ITY,KK2)
          DTN(ITOR,2,ITY,1)=DVN(LTPF(1,ITOR),KK1,ITY,KK2)
          DTN(ITOR,3,ITY,1)=DVN(LTPF(1,ITOR),KK2,ITY,KK2)
          DTN(ITOR,4,ITY,1)=0.0D0
          KK=LTPFO(2,ITOR)
          KK1=1+MOD(KK ,3)
          KK2=1+MOD(KK1,3)
          DTN(ITOR,2,ITY,2)=DVN(LTPF(2,ITOR),KK ,ITY,KK2)
          DTN(ITOR,1,ITY,2)=DVN(LTPF(2,ITOR),KK1,ITY,KK2)
          DTN(ITOR,4,ITY,2)=DVN(LTPF(2,ITOR),KK2,ITY,KK2)
          DTN(ITOR,3,ITY,2)=0.0D0
         ENDDO
        ENDDO
cag float changed to dfloat by ag Sept 20th '91
        DO ID=1,2
         SENS=DFLOAT(ID)*2.0D0-3.0D0
         DO ITOR=1,NTOR
          DO ITY=1,3
           DTAX(ITOR,ID,ITY)=-TORAX(ITOR,ITY)*TORAX(ITOR,KCOR)*SENS
     *                       /STORAX(ITOR)
          ENDDO
          DTAX(ITOR,ID,KCOR)=DTAX(ITOR,ID,KCOR)+SENS/STORAX(ITOR)
         ENDDO
        ENDDO
        DO ITOR=1,NTOR
         DO ID=1,2
          D(ITOR,ID,1)=DTN(ITOR,ID,1,1)*TVN(ITOR,1,2)+
     *                 DTN(ITOR,ID,1,2)*TVN(ITOR,1,1)+
     *                 DTN(ITOR,ID,2,1)*TVN(ITOR,2,2)+
     *                 DTN(ITOR,ID,2,2)*TVN(ITOR,2,1)+
     *                 DTN(ITOR,ID,3,1)*TVN(ITOR,3,2)+
     *                 DTN(ITOR,ID,3,2)*TVN(ITOR,3,1)
          D(ITOR,ID,2)=DTAX(ITOR,ID,1)*TVN(ITOR,1,3)
     *                +DTAX(ITOR,ID,2)*TVN(ITOR,2,3)
     *                +DTAX(ITOR,ID,3)*TVN(ITOR,3,3)
     *                +DTN(ITOR,ID,1,1)*(TVN(ITOR,2,2)*TORAX(ITOR,3)
     *                                  -TVN(ITOR,3,2)*TORAX(ITOR,2))
     *                +DTN(ITOR,ID,2,1)*(TVN(ITOR,3,2)*TORAX(ITOR,1)
     *                                  -TVN(ITOR,1,2)*TORAX(ITOR,3))
     *                +DTN(ITOR,ID,3,1)*(TVN(ITOR,1,2)*TORAX(ITOR,2)
     *                                  -TVN(ITOR,2,2)*TORAX(ITOR,1))
     *                +DTN(ITOR,ID,1,2)*(TORAX(ITOR,2)*TVN(ITOR,3,1)
     *                                  -TORAX(ITOR,3)*TVN(ITOR,2,1))
     *                +DTN(ITOR,ID,2,2)*(TORAX(ITOR,3)*TVN(ITOR,1,1)
     *                                  -TORAX(ITOR,1)*TVN(ITOR,3,1))
     *                +DTN(ITOR,ID,3,2)*(TORAX(ITOR,1)*TVN(ITOR,2,1)
     *                                  -TORAX(ITOR,2)*TVN(ITOR,1,1))
         ENDDO
         D(ITOR,3,1)=DTN(ITOR,3,1,1)*TVN(ITOR,1,2)+
     *               DTN(ITOR,3,2,1)*TVN(ITOR,2,2)+
     *               DTN(ITOR,3,3,1)*TVN(ITOR,3,2)
         D(ITOR,3,2)=TORAX(ITOR,1)*(DTN(ITOR,3,2,1)*TVN(ITOR,3,2)
     *                             -DTN(ITOR,3,3,1)*TVN(ITOR,2,2))
     *              +TORAX(ITOR,2)*(DTN(ITOR,3,3,1)*TVN(ITOR,1,2)
     *                             -DTN(ITOR,3,1,1)*TVN(ITOR,3,2))
     *              +TORAX(ITOR,3)*(DTN(ITOR,3,1,1)*TVN(ITOR,2,2)
     *                             -DTN(ITOR,3,2,1)*TVN(ITOR,1,2))
         D(ITOR,4,1)=DTN(ITOR,4,1,2)*TVN(ITOR,1,1)+
     *               DTN(ITOR,4,2,2)*TVN(ITOR,2,1)+
     *               DTN(ITOR,4,3,2)*TVN(ITOR,3,1)
         D(ITOR,4,2)=TORAX(ITOR,1)*(TVN(ITOR,2,1)*DTN(ITOR,4,3,2)
     *                             -TVN(ITOR,3,1)*DTN(ITOR,4,2,2))
     *              +TORAX(ITOR,2)*(TVN(ITOR,3,1)*DTN(ITOR,4,1,2)
     *                             -TVN(ITOR,1,1)*DTN(ITOR,4,3,2))
     *              +TORAX(ITOR,3)*(TVN(ITOR,1,1)*DTN(ITOR,4,2,2)
     *                             -TVN(ITOR,2,1)*DTN(ITOR,4,1,2))
         DO ID=1,4
          DPHI(ITOR,ID,KCOR)=D(ITOR,ID,2)*CPHI(ITOR)
     *                      -D(ITOR,ID,1)*SPHI(ITOR)
         ENDDO
        ENDDO
        DO IUM=1,2
         DO ITY=1,3
          DO ITOR=1,NTOR
           KK=LTPFO(1,ITOR)
           KK1=1+MOD(KK,3)
           DTN(ITOR,1,ITY,IUM)=DUN(LTPF(1,ITOR),KK,ITY,
     *                         1+MOD(LTPFO(1,ITOR)+IUM+1,3))
           DTN(ITOR,2,ITY,IUM)=DUN(LTPF(1,ITOR),KK1,ITY,
     *                         1+MOD(LTPFO(1,ITOR)+IUM+1,3))
          ENDDO
         ENDDO
        ENDDO
        DO IUM=1,2
         IF(IUM.EQ.1) THEN 
          SENS=-1.0D0
         ELSE
          SENS=1.0D0
         ENDIF
         DO ITOR=1,NTOR
          DO ID=1,2
           D(ITOR,ID,IUM)=  DTN(ITOR,ID,1,IUM)*TORAX(ITOR,1)+
     *                      TUN(ITOR,1,IUM)*DTAX(ITOR,ID,1)+
     *                      DTN(ITOR,ID,2,IUM)*TORAX(ITOR,2)+
     *                      TUN(ITOR,2,IUM)*DTAX(ITOR,ID,2)+
     *                      DTN(ITOR,ID,3,IUM)*TORAX(ITOR,3)+
     *                      TUN(ITOR,3,IUM)*DTAX(ITOR,ID,3)
           DTET(ITOR,ID,IUM,KCOR)=D(ITOR,ID,IUM)*SENS
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDIF
C COMPUTE AREA, AND DERIVATIVES, OF EACH FACE
      DO ITOR=1,NTOR
       DO IORD=1,2
        LMAR(IORD,ITOR)=0
       ENDDO
      ENDDO
      NVERT=0
      DO ITOR=1,NTOR
       DO IORD=1,2
        IF(LMAR(IORD,ITOR).EQ.0) THEN
         NVERT=NVERT+1
         ALPHA=0.0D0
         OTHANG=0.0D0
         KTOR=ITOR
         KORD  =IORD
         KORDIV=1+MOD(KORD,2)
         NF  =LTPF(KORDIV,KTOR)
         NORF=LTPFO(KORDIV,KTOR)
         KAT =LFAC(NORF,NF)
         IF(IDER.GT.0) THEN
          KATNEW=LFAC(1+MOD(NORF,3),NF)
          KAT2=LFAC(1+MOD(LTPFO(KORD,KTOR)+1,3),LTPF(KORD,KTOR))
          IF(LNDER(KAT).EQ.0) THEN
           LNDER(KAT)=1
           LDER(1,KAT)=KAT
           DO K=1,3
            DER(1,K,KAT)=0.0D0
           ENDDO
          ENDIF
          IOR2  =0
          IORNEW=0
          DO IOR=1,LNDER(KAT)
           IF(LDER(IOR,KAT).EQ.KATNEW) IORNEW=IOR
           IF(LDER(IOR,KAT).EQ.KAT2)     IOR2=IOR
          ENDDO
          IF(IOR2.EQ.0) THEN
           LNDER(KAT)=LNDER(KAT)+1
           IOR2=LNDER(KAT)
           LDER(IOR2,KAT)=KAT2
           DO K=1,3
            DER(IOR2,K,KAT)=0.0D0
           ENDDO
          ENDIF
          IF(IORNEW.EQ.0) THEN
           LNDER(KAT)=LNDER(KAT)+1
           IORNEW=LNDER(KAT)
           LDER(IORNEW,KAT)=KATNEW
           DO K=1,3
            DER(IORNEW,K,KAT)=0.0D0
           ENDDO
          ENDIF
         ENDIF
         NLASTF=NF
 100     CONTINUE
          IF(LMAR(KORD,KTOR).NE.0) THEN
           WRITE (JOUT,'(a,i7,a,i5,1h./a,i7,a,i7,a,i7,a,i7,1h./a)') 
     &   '(W) MSEED error: Two circuits have met at vertex ',
     &   LTOR(KORD,KTOR),' on atom ',KAT,
     &   'One circuit started at edge ',ITOR,' vertex ',IORD,
     &   ' and is now at edge ',KTOR,' vertex ',KORD,
     &   'The program will recover by trying another conformation.'
	   iret=-1
	   return
c          STOP
          ENDIF
          LMAR(KORD,KTOR)=1
          XX=CTET(KTOR,KORDIV)
          OTHANG=OTHANG+TORPHI(KTOR)*XX
          ALPHA =ALPHA-BETA(NF,NORF)
          NEWORF=1+MOD(NORF+1,3)
          IF(IDER.GT.0) THEN
           NORF2=1+MOD(NORF,3)
           KATOLD=KAT2
           KAT2=KATNEW
           KATNEW=LFAC(NEWORF,NF)
           IOROLD=IOR2
           IOR2=IORNEW
           IORNEW=0
           DO IOR=1,LNDER(KAT)
            IF(LDER(IOR,KAT).EQ.KATNEW) IORNEW=IOR
           ENDDO
           IF(IORNEW.EQ.0) THEN
            LNDER(KAT)=LNDER(KAT)+1
            IORNEW=LNDER(KAT)
            LDER(IORNEW,KAT)=KATNEW
            DO K=1,3
             DER(IORNEW,K,KAT)=0.0D0
            ENDDO
           ENDIF
           DO K=1,3
            DER(1,K,KAT)=DER(1,K,KAT)+DPHI(KTOR,KORDIV,K)*XX
     *                  +TORPHI(KTOR)*DTET(KTOR,KORDIV,KORDIV,K)
     *                  -DBET(NF,NORF,NORF,K)
            DER(IOR2,K,KAT)=DER(IOR2,K,KAT)+DPHI(KTOR,KORD,K)*XX
     *                  +TORPHI(KTOR)*DTET(KTOR,KORD,KORDIV,K)
     *                  -DBET(NF,NORF2,NORF,K)
            DER(IORNEW,K,KAT)=DER(IORNEW,K,KAT)
     *                  +DPHI(KTOR,KORDIV+2,K)*XX
     *                  -DBET(NF,NEWORF,NORF,K)
            DER(IOROLD,K,KAT)=DER(IOROLD,K,KAT)
     *                  +DPHI(KTOR,KORD+2,K)*XX
           ENDDO
          ENDIF
          KTOR=LFPT(NEWORF,NF)
          KORD  =LFPTO(NEWORF,NF)
          KORDIV=1+MOD(KORD,2)
          NF  =LTPF(KORDIV,KTOR)
          NORF=LTPFO(KORDIV,KTOR)
          KAT =LFAC(NORF,NF)
         IF(NF.NE.NLASTF) GOTO 100
         AREA(KAT)=AREA(KAT)+(PI2+ALPHA+OTHANG)
         IF(AREA(KAT).GT.PI4) AREA(KAT) =AREA(KAT)-PI4
        ENDIF
       ENDDO
      ENDDO
      DO IAT=1,NAT
       AREA(IAT)=AREA(IAT)*RADII(IAT)**2
      ENDDO
      IF(IDER.GT.0) THEN
       DO IAT=1,NAT
        DO IOR=1,LNDER(IAT)
         DO K=1,3
          DER(IOR,K,IAT)=DER(IOR,K,IAT)*RADII(IAT)**2
         ENDDO
        ENDDO
       ENDDO
      ENDIF
C
C     PRINT*,'NVERT ',NVERT
C     PRINT*,'NFAC  ',NFAC
      RETURN
      END
      SUBROUTINE HYDRAT

#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.CALC'
      INCLUDE 'COMMON.SOLVAT'
      INCLUDE 'COMMON.IOUNIT'
      EHYDA=0.0D0
      IF (WGHSUR.GT.0.0) THEN
C SURDER(T) Minimization will involve both components: ECEPP/3 and Hydration.
         CALL CALFH
         EHYDA=FHYDA*WGHSUR
C SURDER(F) only ECEPP/3 energy will be minimized. Hydration will be
C added after minimization is completed.
      END IF


      RETURN
      END
      SUBROUTINE HINPUT
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.SOLVAT'
      INCLUDE 'COMMON.SOLVAT2'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.CNTRL'

C  *************************************************
C
C THIS SUBROUTINE READS THE STANDARD RESIDUE DATA FOR THE HYDRATION
C AND STORES THEM IN APPROPRIATE ARRAYS:
C
C  *************************************************

C
C READ THE FILE WITH SOLVENT PARAMETERS (HYDRATED RADIUS AND FREE
C     ENERGY DENSITY)
      DO 310 I=1,30
         READ(JSOLV,*)J,RV(I),RH(I),F0HYD(I),NPOT(I)
C        WRITE(6,*)J,RV(I),RH(I),F0HYD(I),NPOT(I)
310   CONTINUE

      FOURPI=3.141593*4.0
      READ(JSOLV,*)WGHSUR,RP
C     WRITE(6,*) 'RP',RP
cj
      if(icomp(4) .eq. 5) then
cj readin alpha,beta values for hydration volume  jda  6/13/96
         read(jsolv,*) alphasolv, betasolv
C        write(6,*) 'alph,beta =',alphasolv,betasolv
C Read Fixed volumes of solvation.  DR NOV/18/96
         call read_fxvol
      else
         READ(JSOLV,*)ICART
      endif
      IF (IREP.EQ.1) THEN
C        OPEN(UNIT=JRAD,FILE='RESRAD',FORM='FORMATTED')
         DO 1790 I=1,num_restypes
           READ(JRAD,*)BRAD(I)
1790     CONTINUE
C        CLOSE(UNIT=JRAD)
      END IF

C     WRITE(6,*)'WGHSUR,RP',WGHSUR,RP
      DO 106 I=1,30
         S0WA(I)=FOURPI*(RH(I))**2
106   CONTINUE
      RETURN
  200 FORMAT(2I5)
  210 FORMAT(4A4)
  220 FORMAT(5X,A5,2I5)
      END
      SUBROUTINE SETUP_SOLV

#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.SOLVAT'
      INCLUDE 'COMMON.SOLVAT2'
      INCLUDE 'COMMON.SETUP'
      INCLUDE 'COMMON.CNTRL'
      INCLUDE 'COMMON.ATOMSS'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.GEN100'
      LOGICAL LPROLIN

cj
cj   then next section sets up for MSEED. the following section sets
cj   up for volume hydration.     jda  6/13/96 
cj
      IF ( ICOMP(4) .EQ. 4) THEN

C  INITIALIZATION OF SOLVATION VARIABLES.
      NATIN=NPRE(INUMRS+1)
      NSOL=0
      DO 870 I=1,NATIN
        NBI=NBTYPE(I)
        IF (NBI.NE.1.AND.NBI.NE.3.AND.NBI.NE.5) THEN
          NSOL=NSOL+1
          ICTSOL(I)=NSOL
          IOLTEC(NSOL)=I
        ELSE
          ICTSOL(I)=0
         END IF
870     CONTINUE
C MAKE RESIDUE LISTS
        DO 3033 I=1,INUMRS
          NATSDE(I)=0
          NATMNE(I)=0
          NTPRES(I)=0
          KBEG=NPRE(I)+1
          KEND=NPRE(I+1)
          II=0
          DO 3034 K=KBEG,KEND
            II=II+1
            KSOL=ICTSOL(K)
            IF (KSOL.GT.0) THEN
              NTPRES(I)=NTPRES(I)+1
              IRESNO(KSOL)=I
              SDATOM(KSOL)=.FALSE.
C             IF (ABS(LIST(I)).NE.13.AND.ABS(LIST(I)).NE.22) THEN
C We should rather employ LPROLIN() here; there are more proline-type  
C residues than jus those two (AL)
              IF (.NOT.LPROLIN(I)) THEN
                IF (II.GE.5.AND.II.NE.6.AND.II.NE.7) THEN
C THIS IS A SIDE CHAIN ATOM
                  SDATOM(KSOL)=.TRUE.
                END IF
              ELSE
                IF (II.GE.8) SDATOM(KSOL)=.TRUE.
                IF (II.EQ.2.OR.II.EQ.5) SDATOM(KSOL)=.TRUE.
              END IF
              IF (SDATOM(KSOL)) NATSDE(I)=NATSDE(I)+1
              IF (.NOT.SDATOM(KSOL)) NATMNE(I)=NATMNE(I)+1
            END IF
3034      CONTINUE
3033    CONTINUE
       ELSE
cj
cj       volume set up
cj
       natoms = npre(inumrs+1)
       nsol = 0
       ioltec(1) = 0
       istart = 0
       do jm1=1,natoms
          if(nstype(jm1) .ne. 0) then
             nsol = nsol + 1
             ictsol(jm1) = nsol
             jst = nstype(jm1)
             do km = jm1+1, natoms
                kso = nstype(km)
                if(kso .ne. 0) then
                   hj = rh(jst)*rh(jst) + rdrad(km)*rdrad(km)
                   vj = rv(jst)*rv(jst) + rdrad(km)*rdrad(km)
cj
cj   fj and fk are the scaled free energy of hydration densities for j,k
cj   signs of sconst(i+1,3,5,7) are such that all have an additive
cj   contribution.
             fj = alphasolv*alphasolv*(sqrt(betasolv*pi))**3*f0hyd(jst)
             fk = alphasolv*alphasolv*(sqrt(betasolv*pi))**3*f0hyd(kso)
             sconst(istart+1) = -fj*(rh(jst)*rdrad(km)/sqrt(hj))**3
             sconst(istart+2) = -1.0 / (betasolv*hj)
             sconst(istart+3) = fj*(rv(jst)*rdrad(km)/sqrt(vj))**3 
             sconst(istart+4) = -1.0 / (betasolv*vj)
             hk = rh(kso)*rh(kso) + rdrad(jm1)*rdrad(jm1)
             vk = rv(kso)*rv(kso) + rdrad(jm1)*rdrad(jm1)
             sconst(istart+5) = -fk*(rh(kso)*rdrad(jm1)/sqrt(hk))**3 
             sconst(istart+6) = -1.0 / (betasolv*hk)
             sconst(istart+7) = fk*(rv(kso)*rdrad(jm1)/sqrt(vk))**3 
             sconst(istart+8) = -1.0 / (betasolv*vk)
cj
                    istart = istart + 8
                 endif
             enddo
             ioltec(nsol+1) = istart
          else
             ictsol(jm1) = 0
          endif
       enddo
cj
cj     end of volume setup
cj
        ENDIF      
C SUBROUTINE SOLPAM SETS UP ARRAYS FOR THE CALCULATION OF FEH,
C WHICH CONTAIN ATOM TYPE (NSTYPE) AND POLARIZATION FREE ENERGY (IPGRP)
cd      WRITE(JOUT,'(A)') 'SOLPAM '
        if(icomp(4) .eq. 4) CALL SOLPAM
        RETURN
        END
      SUBROUTINE SOLPAM

#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.SOLVAT'
      INCLUDE 'COMMON.SOLVAT2'
      INCLUDE 'COMMON.GEN002X'
      INCLUDE 'COMMON.GEN004'
      INCLUDE 'COMMON.ATOMSS'
      INCLUDE 'COMMON.THRLET'
      INCLUDE 'COMMON.PRAMX'
C  CAREFUL!  SCHAR is used to convert from ANAME or AENAME to SALPH
      REAL*8 SCHAR(maxnum_atoms)
      EQUIVALENCE(SALPH(1),SCHAR(1))
      LOGICAL LPROLIN
C                                                   dr 8-93
      logical lprnt
      lprnt=.false.
c     lprnt=.true.
C

C THIS SUBROUTINE ASSIGNS VALUES TO ARRAYS CONTAINING THE FOLLOWING
C INFORMATION FOR EACH ATOM OR UNITED ATOM OF THE SPECIFIED POLYPEPTIDE:
C ATOM TYPE (NSTYPE) AND INFORMATION FOR THE CALCULATION OF FREE ENERGY
C CHANGE OF POLARIZATION (IPGRP).

C     IREG=33
C     IEND=18
C
C ASSIGN PARAMETERS FOR THE AMINO END GROUP FROM THE STANDARD RESIDUE
C DATA, INCLUDING THE FIRST THREE ATOMS OF THE FIRST FULL AMINO ACID
C RESIDUE:
C
      NSPRE(1) = 0
      JPRE(1)=0
      LAMIN=LIST(1)
      LAMIN=IABS(LAMIN)
C     IF(LAMIN.GE.7) LAMIN=LAMIN-1
      NA = NEATM(LAMIN)
C     NJP=JEPMX(LAMIN)
      RADMX=-9.9E23
      DO 10 I = 1,NA
         SCHAR(I)=AENAME(I,LAMIN)
         NSTYPE(I)=NETYPE(I,LAMIN)
         RADII(I)=RH(NSTYPE(I))
         IF (RADII(I).GT.RADMX)RADMX=RADII(I)
C        IPGRP(I)=JEGRP(I,LAMIN)
   10 CONTINUE
C
      NA = NA - 3
C
C BEGINNING OF LOOP FOR EACH FULL AMINO ACID RESIDUE:
C
 20   LASTFL = INUMRS - 1
      DO 35 I = 2,LASTFL
         LISTI=LIST(I)
         LISTI = IABS(LISTI)
C        IF(LISTI.EQ.33.OR.LISTI.EQ.34) LISTI=13
C        IF(LISTI.EQ.35.OR.LISTI.EQ.36) LISTI=22
c What is this?   this may cause problems.            DR.  OCT92
C Niet czielowieka, niet probliemy (towariszcz Stalin).
C        IF(LISTI.EQ.num_restypes) LISTI=33
c **************************************************************
         NATOM = NSATM(LISTI)
         NSPRE(I) = NA
         JPRE(I)=NJP
C
C K INDEXES (IN THE STANDARD RESIDUE DATA) THE FIRST ATOM WHOSE
C PARAMETERS WILL BE ASSIGNED TO THE POLYPEPTIDE ARRAYS.  IN GENERAL,
C K IS SET TO 1, INDEXING THE STARTING NITROGEN ATOM.  IF THIS IS THE
C FIRST FULL RESIDUE, K=4, SINCE PARAMETERS FOR THE FIRST 3 ATOMS HAVE
C ALREADY BEEN TAKEN FROM THE END GROUP DATA SET.  EXCEPTIONS ARE
C GLYCINE, PROLINE, HYDROXYPROLINE, AND IONIZED ASPARTIC ACID:
C
         K = 1
         IF (I.NE.2) GO TO 25
C
C     IF (LISTI.NE.6.AND.LISTI.NE.13.AND.LISTI.NE.22.AND.LISTI.NE.31)
C
C The instruction commented out above has been changed, because the ECEPP
C database numbers now match the solvation-database numbers (so we have 
C to use the LPROLIN() logical function to check whether the residue is 
C proline). 
C (DR & AL; 8/13/93).
C
C Check N-methylated aspartate; changes might also be necessary here!
C
      IF (LISTI.NE.6.AND..NOT.LPROLIN(I).AND.LISTI.NE.31)
     1   K=4
         IF(LAMIN.EQ.2.AND.(LISTI.EQ.6.OR.LISTI.EQ.31)) K=3
C
C IF THE FIRST FULL RESIDUE IS A PROLINE OR HYDROXYPROLINE AND AN
C IMPROPER AMINO END GROUP (TYPE 1, 2, OR 3) WAS SPECIFIED, PRINT AN
C ERROR MESSAGE AND STOP:
C
C        IF (LISTI.NE.13.AND.LISTI.NE.22) GO TO 25
C
C See the comment above (DR & AL).
C
         IF ( .NOT.LPROLIN(I) ) GO TO 25
         IF (LAMIN.EQ.1.OR.LAMIN.EQ.2.OR.LAMIN.EQ.3) GO TO 70
C
C ASSIGN THE REQUIRED PARAMETERS FOR THIS AMINO ACID RESIDUE FROM THE
C STANDARD RESIDUE DATA:
C
 25      DO 30 L=K,NATOM
            N = NA + L
C What NAMES here!!! Do we need any more, if we have already named the atoms 
C acc. to the ECEPP code?!!!
C           SCHAR(N)=ANAME(L,LISTI)
            NSTYPE(N)=NTYPE(L,LISTI)
            RADII(N)=RH(NSTYPE(N))
            IF (RADII(N).GT.RADMX)RADMX=RADII(N)
C           IPGRP(N)=JGRP(L,LISTI)+(JPRE(I)-1)*10
C           IF(JGRP(L,LISTI).EQ.0) IPGRP(N)=0
C           if(lprnt) write(jout,*) SALPH(N)
            if(lprnt) write(jout,'(a3,3i5,f10.5)') 
     &         alph(ioltec(n)),n,nbtype(ioltec(n)),nstype(n),radii(n)
30       CONTINUE
C
C IF THE FIRST FULL RESIDUE IS A GLYCINE OR AN IONIZED ASPARTIC ACID,
C AND THE END GROUP IS TYPE 1, 2 OR 3, CORRECT SCHAR(SALPH):
C
         IF(I.NE.2) GOTO 36
         IF(LISTI.NE.6.AND.LISTI.NE.31) GO TO 36
         IF(LAMIN.GT.3) GO TO 36
         GO TO (101,102,103),LAMIN
C
C 101    SCHAR(3)=SCHAR(1)
  101    NSTYPE(2)=NETYPE(2,1)
         RADII(2)=RH(NSTYPE(2))
         IF (RADII(2).GT.RADMX)RADMX=RADII(2)
         NSTYPE(3)=NETYPE(3,1)
         RADII(3)=RH(NSTYPE(3))
         IF (RADII(3).GT.RADMX)RADMX=RADII(3)
         GO TO 36
C
C 102 SCHAR(4)=SCHAR(1)
  102 NSTYPE(2)=NETYPE(2,2)
      RADII(2)=RH(NSTYPE(2))
      IF (RADII(2).GT.RADMX)RADMX=RADII(2)
      NSTYPE(4)=NETYPE(4,2)
      RADII(4)=RH(NSTYPE(4))
      IF (RADII(4).GT.RADMX)RADMX=RADII(4)
      GO TO 36
C
103   CONTINUE
      NSTYPE(2)=NETYPE(2,3)
      RADII(2)=RH(NSTYPE(2))
      IF (RADII(2).GT.RADMX)RADMX=RADII(2)
C
C END OF LOOP FOR EACH FULL AMINO ACID RESIDUE:
C
   36 NJP=NJP+JPMX(LISTI)-1
      NA = NA + NATOM
C     if(lprnt) write(jout,*) 'SALPH ', (SALPH(N), N=1,3)
   35 CONTINUE
C
C ASSIGN PARAMETERS FOR THE CARBOXYL END GROUP FROM THE STANDARD
C RESIDUE DATA, FOR ALL ATOMS EXCEPT THE CARBONYL OXYGEN:
C
      NSPRE(INUMRS) = NA
      JPRE(INUMRS)=NJP
      ICARB=0
      LCARB = LIST(INUMRS)
      LCARB=IABS(LCARB)
C Because there's no separate database for atom-solvation types, the 
C following instruction is no longer necessary (AL).
C     IF(LCARB.GE.7) LCARB=LCARB-1
      NATOM = NEATM(LCARB)
      NSPRE(INUMRS + 1) = NSPRE(INUMRS) + NATOM - 1
      JPRE(INUMRS+1)=JPRE(INUMRS)+JEPMX(LCARB)-1
C Shifted because of changing of residue-numbering scheme.
C     IF(LCARB.EQ.11.OR.LCARB.EQ.12) ICARB=1
      IF(LCARB.EQ.12.OR.LCARB.EQ.13) ICARB=1
      IF (NATOM .EQ. 1) GO TO 45
C     NA = NA - 1
C	
C Change 10/20/93 (AL) Assign explicitly the solvation type for the carbonyl 
C                      oxygen of the C-terminal end group.
C
      N = NSPRE(INUMRS-1)+6
      NSTYPE(N)=NETYPE(1,LCARB)
      RADII(N)=RH(NSTYPE(N))
      IF (RADII(N).GT.RADMX)RADMX=RADII(N)
C     IPGRP(N)=JEGRP(1,LCARB)+(JPRE(INUMRS)-1)*10
C     IF(JEGRP(1,LCARB).EQ.0) IPGRP(N)=0
C
C End of change
C
c     DO 40 I = 1,NATOM
      DO 40 I = 2,NATOM
c     N = NA + I
      N = NA + I -1
C     IF(ICARB.EQ.0.AND.I.EQ.1) GO TO 40
C     SCHAR(N)=AENAME(I,LCARB)
      NSTYPE(N)=NETYPE(I,LCARB)
      RADII(N)=RH(NSTYPE(N))
      IF (RADII(N).GT.RADMX)RADMX=RADII(N)
C     IPGRP(N)=JEGRP(I,LCARB)+(JPRE(INUMRS)-1)*10
C     IF(JEGRP(I,LCARB).EQ.0) IPGRP(N)=0
   40 CONTINUE
C
   45 NSTM=NSPRE(INUMRS+1)
      IF (IREP.EQ.1) THEN
        CALL BETARS
      END IF
      if (lprnt) then
        write (jout,*) 'nsol=',nsol
        do i=1,nsol
          write(jout,'(a4,4i5,f10.5)') alph(ioltec(i)),
     &   i,ioltec(i),nbtype(ioltec(i)),nstype(i),radii(i)
        enddo
      endif
      lprnt=.false.
C At this point define the RED array. --- AL 1/27/94
      DO I=1,NSOL
        RED(I)=RADII(I)
      ENDDO
      RETURN
   70 WRITE (JPRINT,80)
      STOP
   80 FORMAT(/47H USE ENDGROUP 6, 7, OR 8 INSTEAD OF 1, 2, OR 3./)
      END
      SUBROUTINE TRANSLATE_ATOM_TYPES

#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.SOLVAT'
      INCLUDE 'COMMON.SOLVAT2'
      INCLUDE 'COMMON.GEN002X'
      INCLUDE 'COMMON.GEN004'
      INCLUDE 'COMMON.ATOMSS'
      INCLUDE 'COMMON.THRLET'
      INCLUDE 'COMMON.PRAMX'
C                                                   dr 8-93
      logical lprnt
      lprnt=.false.
      if (lprnt) then 
        write(jout,'(/a/)')'********** SOLPAM **********'
        write (jout,'(a)') 
     & 'The numbers & solv. types of atoms in regular residues:'
        do i=1,nreg
          write (jout,'(a3,2i5)') ares(i),i,natoms(i)
          write (jout,'(2i5)') (j,ntype(j,i),j=1,natoms(i))
          write (jout,*)
        enddo
        write (jout,'(a)')
     & 'The numbers & solv. types of solvatable atoms in end groups:'
        do i=1,nend
          write (jout,'(a3,2i5)') ares(num_restypes+i),i,ndatom(i)
          write (jout,'(2i5)') (j,netype(j,i),j=1,ndatom(i))
          write (jout,*)
        enddo
        write (jout,'(a)') 
     & 'Solvation radii of the consecutive types if atoms'
        do i=1,30
          write (jout,'(i3,f10.5)') i,rh(i)
        enddo
      endif
      lprnt=.false.
C
C Calculate the numbers of atoms contributing to solvation energy for
C the regular residues (DR & AL). 
C
      do i=1,nreg
        nsatmi=0
        natomsi=natoms(i)
        do j=1,natomsi
          if (ntype(j,i).ne.0) then
            nsatmi=nsatmi+1 
            ntype(nsatmi,i)=ntype(j,i)
          endif 
        enddo
        nsatm(i)=nsatmi
      enddo
C 
C Calculate the numbers of atoms contributing to solvation energy for 
C the end groups (DR & AL). 
C 
      do i=1,nend
        neatmi=0
        ndatomi=ndatom(i)
        do j=1,ndatomi
          if (netype(j,i).ne.0) then
            neatmi=neatmi+1
            netype(neatmi,i)=netype(j,i)
          endif
        enddo 
        neatm(i)=neatmi 
      enddo 
      return
      end
      FUNCTION DDOT(A,B)
      REAL*8 A(3),B(3), DDOT
      DDOT=A(1)*B(1)+A(2)*B(2)+A(3)*B(3)
      RETURN
      END
      SUBROUTINE NORM(A,B,C)
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 A(3),B(3),C(3)
      DO K=1,3
       C(K)=B(K)-A(K)
      ENDDO
CDRR   S=DSQRT(C(1)**2+C(2)**2+C(3)**2)
      SINV=1.0D0/DSQRT(C(1)**2+C(2)**2+C(3)**2)
      DO K=1,3
CDRR   C(K)=C(K)/S
       C(K)=C(K)*SINV
      ENDDO
      RETURN
      END

