c.. double precision

	subroutine ssint_en(iirs,nsoord,soord,atmq_ps,en_cl,
     &                                        en_sl,en_frt)       
c  calculation of energy of interaction between charges defined by
c                        atmq_ps() with coord xyz= soord(,)  AND
c. total potential(dircoulmbic+reaction) due to charged residue iirs
c. induced charges SIGMA are on main surf. PS+(all).


#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
	include'param.ibems'
	include'comm.ibems'
        include 'COMMON.MYCONF'

        integer n_ionaii,ionaii_list(maxat)
        integer n_ionajj,ionajj_list(maxat)
        integer nsoord
        real*8 soord(3,maxat),atmq_ps(maxat)
        real*8 soordii(3,natinrs_mx),atmq_ii(natinrs_mx)
        real*8 en_cl,en_sl,en_frt
        real*8 react_en,coul_en
c*	
        real*8 qinl,qind,ss,rrlock2
        real*8 sd,sd1,sd2,sn,snl,snd,ffg,qqtot,qat,senl,send,sent
        real*8 xyz(3),ssm,ssl,ssp,qsm,qsl,qsp,sm,sl,sq,qs,ql,pd2
        integer ns,nsg,l,is,jl,ip,iirs,nsmal,nlarg,ia,ix,isg,ilg
        integer nsoordii,ii,jatom,iatom,index,k,il,jj,i
c
        ffg=1.0/epsmol -1.0/epssol
        qqtot=0.d0

c radius of calculation by small se
        rrlock2=rrlock_en*rrlock_en

c	write(*,*)'ssint_en'
c	write(*,*)'rrlock2',rrlock2
c        index=1
c        call timit(index)
c.............................................
c. check induced sigma
c        write(*,*)'ssint_en: check induced sigma gr iirs=',iirs
        qsm=0.d0
        qsp=0.d0
        qsl=0.d0
        ssm=0.d0
        ssp=0.d0
        ssl=0.d0
        do is=1,nsmalse_tm
        ssm=ssm+areasmalse_tm(is)
        qsm=qsm+sigmasmt_tv(is,iirs)*areasmalse_tm(is)
        end do !is
c        write(*,*)'total ind qqq(smalse)=',qsm,'tot surf=',ssm
        
        do il=1,nlargse_tm
        ssl=ssl+arealargse_tm(il)
        qsl=qsl+sigmalgt_tv(il,iirs)*arealargse_tm(il)
        end do !il
c        write(*,*)'total ind qqq(large )=',qsl,'tot surf=',ssl
        qsm=0.d0
        qsp=0.d0
        qsl=0.d0
        ssm=0.d0
        ssp=0.d0
        ssl=0.d0
        do ip=1,nsurfp_tm

        sm=0.d0
        qs=0.d0
        nsmal=nsurfp_smm(ip)

        do is=1,nsmal
        isg=lsurfp_ismm(is,ip)
        sm=sm+areasmalse_tm(isg)
        qs=qs+areasmalse_tm(isg)*sigmasmt_tv(isg,iirs)
        end do !is
c       write(*,*)'sm qs ',sm,qs

        qsm=qsm+qs
        ssm=ssm+sm
        qs=qs/sm
        if(dabs(sm-surfp_sm(ip)).gt.0.1d-9)then
        write(*,*)'ssint_en: ERROR0 surf sm ne. sp ip=',ip,
     &  'sm=',sm,'sp=',surfp_s(ip)
        kprotfail=-150
        return
c       stop
        end if
        if(dabs(qs-surfp_qv(ip,iirs)).gt.0.1d-9)then
        write(*,*)'ssint_en: ERROR01 sig sm, sig sp=',
     &  qs,surfp_q(ip), 'ip=',ip
        kprotfail=-151
        return
c       stop
        end if

        sl=0.d0
        ql=0.d0
        nlarg=nsurfp_lgm(ip)
        do il=1,nlarg     
        ilg=lsurfp_ilgm(il,ip)  
        sl=sl+arealargse_tm(ilg)
        ql=ql+arealargse_tm(ilg)*sigmalgt_tv(ilg,iirs)
        end do !il
        qsl=qsl+ql
        ssl=ssl+sl
        ql=ql/sl

        if(dabs(sl-surfp_sm(ip)).gt.0.1d-10)then
        write(*,*)'sintv_en: ERROR03 surf lg ne. sp ip=',ip,
     &  'sl=',sl,'sp=',surfp_s(ip)
        kprotfail=-152
        return
c       stop
        end if

        if(dabs(ql-surfp_qv(ip,iirs)).gt.0.1d-9)then
        write(*,*)'ssint_en: ERROR04 sig lg, sig sp=',
     &  ql,surfp_q(ip), 'ip=',ip
        kprotfail=-153
        return
c       stop
        end if

        qsp=qsp+surfp_sm(ip)*surfp_qv(ip,iirs)
        ssp=ssp+surfp_sm(ip)
        end do !ip

        qmlcur=qmlcurv(iirs)

        if(outdetl.gt.1)then
        write(*,*)'total expected ind charge=',-qmlcur*ffg
        write(*,*)'total ind qqq(smalse)=',qsm,'tot surf=',ssm
        write(*,*)'total ind qqq(largse)=',qsl,'tot surf=',ssl
        write(*,*)'total ind qqq(spiece)=',qsp,'tot surf=',ssp
        end if
c...................................................................
c...................................................................
c...................................................................
c. define charged atoms in soord, atmq_ps() set
        n_ionajj=0
        do ia=1,nsoord
        if(atmq_ps(ia).ne.0.d0)then
        n_ionajj=n_ionajj+1
        ionajj_list(n_ionajj)=ia
        end if
        end do
c.
c.define coordinates and charges of charged side group iirs
c.
       ix=iirs
       nsoordii=natm_polrs(ix)
c       write(*,*)'ssint_en: res ix=',ix,'nsoordii=',nsoordii
     
       n_ionaii=0
       do ia=1,nsoordii
       l=latm_polrs(ia,ix)
       atmq_ii(ia)=atmcha(l)
       if(atmq_ii(ia).ne.0.0d0)then
       n_ionaii=n_ionaii+1
c       ionaii_list(n_ionaii)=l
       ionaii_list(n_ionaii)=ia
       end if
       do k=1,3
       soordii(k,ia)=atmxyz(k,l)
       end do
       end do
       
       if(outdetl.gt.1)then
       write(*,*)'ssint_en:n_ionaii=',n_ionaii
       write(*,*)'ssint_en:PS+(ix),ix=',ix
       write(*,*)'nsoordii=',nsoordii
       write(*,*)'iat=,atmq=,atmrad=,xyz='
        do i=1,nsoordii
       write(*,'(i5,5f8.3)')i,atmq_ii(i),
     & (soordii(k,i),k=1,3)
        end do
        end if
c.
c.
        
        react_en=0.d0
        coul_en=0.d0

        do 200  jj=1,n_ionajj
c  atom number iatom
        jatom=ionajj_list(jj)
        senl=0.d0
        send=0.d0
        qinl=0.d0
        qind=0.d0

        do k=1,3
        xyz(k)=soord(k,jatom)
         end do
c..................................................................
c..direct coulombic energy
         do 300 ii=1,n_ionaii
         iatom=ionaii_list(ii)
c         write(*,*)'ssint_en:ii,iatom=',ii,iatom

         sd2=0.d0
         do k=1,3
         sd2=sd2+(soordii(k,iatom)-xyz(k))**2
         end do! k
         sd1=dsqrt(sd2)
300      coul_en=coul_en+atmq_ps(jatom)*atmq_ii(iatom)/sd1
c.................................................................
c.search for surface piece number

        do 400 ip=1,nsurfp_tm

        pd2=0.d0
        do k=1,3
         pd2=pd2+(xyz(k)-surfp_xyzm(k,ip))**2
         end do
c.......................................................
         if(pd2.le.rrlock2)then
c. piece ip included in local surface  which  is considered as collection
c. of small se
c.         write(*,*)'ssolv_en: loc surf'

         nsmal=nsurfp_smm(ip)
         ss=0.d0
         do ns=1,nsmal
c.nsg global number of small s.e.
         nsg=lsurfp_ismm(ns,ip)
         sd2=0.d0
         do k=1,3
         sd2=sd2+(xyz(k)-cxyzsmalse_tm(k,nsg))**2
         end do
         sd1=dsqrt(sd2)
         ss=ss+areasmalse_tm(nsg)
         qs=sigmasmt_tv(nsg,iirs)*areasmalse_tm(nsg)
         qinl=qinl+qs
         senl=senl+qs/sd1
         end do! ns

         if(dabs(ss-surfp_sm(ip)).gt.0.1d-9)then
        write(*,*)'ssint_en:ERROR7 in surf area '
        write(*,*)'ssm=',ss,'surfp_sm(ip)=',surfp_sm(ip),'ip=',ip 
         kprotfail=-154
         return
c        stop
         end if

c          write(*,*)'slv_en:ip,nsmal',ip,nsmal,'ssp',ss,'qinl',qinl       
        end if !loc
c...........................................................
         if(pd2.gt.rrlock2)then
c. distant surface
         ss=0.d0
         nlarg=nsurfp_lgm(ip)

         do ns=1,nlarg
c.nsg global number of large s.e.
         nsg=lsurfp_ilgm(ns,ip)
         sd2=0.d0
         do k=1,3
         sd2=sd2+(xyz(k)-cxyzlargse_tm(k,nsg))**2
         end do
         sd1=dsqrt(sd2)
         qs=sigmalgt_tv(nsg,iirs)*arealargse_tm(nsg)
         ss=ss+arealargse_tm(nsg)
c.. induced sigma on lg se taken = of that on surfpiece
         qind=qind+qs
         send=send+qs/sd1
         end do! ns

         if(dabs(ss-surfp_sm(ip)).gt.0.1d-8)then
        write(*,*)'ssint_en:ERROR8 in surf area'
        write(*,*)'ssl=',ss,'surfp_sm(ip)=',surfp_sm(ip),'ip=',ip
        kprotfail=-155
        return
c       stop
         end if

         end if ! dist
c...................................................................
400      continue
c...................................................................
         
         qat=atmq_ps(jatom)*coefel
         qqtot=qinl+qind

          if(outdetl.gt.1)then
         write(*,*)'ssint_en atom iii=',jatom,'induced qq=',qqtot
         write(*,*)' qind(loc)=',qinl,  ' qind(dis)=',qind
          end if

         senl=senl*qat
         send=send*qat
c         sent=senl+send
         react_en=react_en+ senl+send

c         write(*,*)'ssolv_en atom iii=',iatom,'solv_en(ii)',sent,
c     &   '/','solven(loc)',senl, 'solven(dis)=',send
c...........................................................
200      continue    ! next iii
c............................................................
c
        if(outdetl.gt.1)then
        index=1
        call timit(index)
        end if
c. final energies....................................................
         coul_en=coul_en*coefel/epsmol

         en_cl=coul_en   
         en_sl=react_en
         en_frt=coul_en+react_en
        
         if(outdetl.ge.1)then
         write(*,*)'ssint_en:final energies(kcal.mol):'
         write(*,*)'elecoul_en=',coul_en
         write(*,*)' reaction_en=',react_en  
         write(*,*)'tot free_en=', en_frt  
         end if 
c......................................................................
         
         return 
         end
