cag...Time sections of code. 
cag   index 0 call to initialize the timer (called once from start.f)
cag   index 1 call to print out time of last section plus total time
cag   index 2 as above but no output is generated. This is used if 
cag   an alternative output for the timing is required to that given by
cag   the format statement in this code.

      subroutine timit(index)
c      implicit none   ! is included in param.ibems
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      include 'param.ibems'
! DRR
!       real*8 time_zero,time_total,time_inc,time_last
        real time_zero,time_total,time_inc,time_last
	common/timecon/time_zero,time_total,time_inc,time_last
    
      logical lprint,timer

      integer index

! DRR
!     real*8 seconds
      real seconds

	timer=.true.
      if(.not. timer) return 

cag...For the timing routines to work on a given machine it is necessary 
cag   to provide a routine that returns elapsed time in seconds. Simply 
cag   modify the function call in the subroutine clock. If no such 
cag   function exists set timer to off in the control file, and comment 
cag   out the call to vmtime/tod in clock.f.      

      lprint = .false. 

      if(index .eq. 1) lprint = .true.

! DRR
      seconds = tcpu()
      if(index .eq. 0) then 
! DRR
!          call clock(seconds)
         time_zero = seconds
         time_last = time_zero
      else 
         if(index .gt. 0) then 
! DRR
!             call clock(seconds)
            time_inc  = seconds - time_last
            time_last = seconds
            time_total = seconds - time_zero 
            if(lprint) write(kanalp,1000) time_inc,time_total
         endif            
      endif               

1000  format(/5x,'Time for last section: ',f10.3,' s',
     &/5x,'Total time: ',11x,f10.3,' s')

      return
      end
