C $Date: 1997/05/09 17:14:13 $
C $Revision: 3.3 $
C
C
C
      subroutine do_vtf(fail)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif

#ifdef MP
      include 'PARAMET.MP'
      include 'COMMON.MP'
#endif
      include 'COMMON.CNTRL'
      include 'COMMON.EDMC'
      include 'COMMON.SETUP'
      include 'COMMON.BONDSX'
      include 'COMMON.CALC'
      include 'COMMON.INDXS'
      include 'COMMON.IOUNIT'
      include 'COMMON.TIME1'
      include 'COMMON.GEN100'
      include 'COMMON.TOR2'
      include 'COMMON.VTFEX'
      include 'COMMON.XBOUNDX'
      include 'COMMON.FILES'
      include 'COMMON.NNDRUK'
      include 'COMMON.MOVE'
      include 'COMMON.MYCONF'
      include 'COMMON.SAVEWEI'
      integer id
      dimension iv(LIV), urparm(1)
      dimension v(1:LV)
      external calcfpo,calcgpo,gradcax
      logical ovrtim,stopx,end_of_file,fail
      data izero /0/, ione /1/, ifour /4/, itrein /30/

C     write(*,*) 'NOW IN DO_VTF'
      if ( iflov.le.0 ) then
         write (*,'(//a27,f5.2,a1)' )
     &     ' Largest distance-allowed= ', biggest_vio,'A'
         write (*,'(a42,I5/)' )
     &     'VTF STEPS Before Aborting minimization ', maxviostp
      endif
! Restore original weight for  constraints.
      if (varwei) call restwei
      fail=.false.
      icntfail=0
      icntv=0
      inpv=1
      ten_ethresh= 10.0*ethresh
      icntf=0
      inpf=1
      min_noCons=50
C
      nf=0
      iv(1) = 0
      etors = 0.0
      id = 0
      irang = inumrs
      if (irangmx.gt.inumrs) irangmx=inumrs
C     call druang(jout,0)
      call geniter
C     write (jout, '(a,i10)') 'NUMVAR', numvar
C    Get Initial Energy  */
C     call calcfpo( numvar, x, nf, f, id, urparm, calcgpo )
C     write(jout,*) numvar, x, nf, f, id, ur
C  etot includes energy from distance constraints(4/8/94) DR
C     etot= f + epro
C     call eneprint
C      write (jout,1800) edis
C1800  format (4X,'   Edis = ', 1E13.4 )
      if (dihecnst) then
C if there are DIHEDRAL ANGLE CONSTRAINTS then, MINIMIZE them to 
C get starting dihedral angles without including DISTANCE CONSTRAINTS
C
         withcnst=.false.
C very important ! calculate indexes on gradcax.
         icx=1
         call minimize(numvar,x,calcfpo,calcgpo,iv,v,id,urparm,
     &                 gradcax,fail)
         if (fail) then
            write(jout,*) 'DO_VTF: minimization for dihedrals failed'
            fail=.false.
         endif
         withcnst=.true.
         nukco_OLD=nukco
         nukco=1
c        write(jout,*) 
c    &    'DO_VTF:Done Initial Minimization with DIHEDRAL CONSTRAINTS'
c        call const_dieh(n,x)
         nukco= nukco_OLD
         nf=0
         iv(1) = 0
         id = 0
      endif
C*  Define VTF Parameters
      npax1= ip (inumrs)
      npax2 = ip2(inumrs)
      if ( (npax1.eq.0).and.(npax2.eq.0) ) then
         write (jout,*) 'VTF Error; number of pairs is zero'
         fail=.true.
         return
      endif
       
      lrangmx=inumrs
      do i=1, inumrs-1
      npy1= npax1-ip (inumrs-i)
      npy2= npax2-ip2(inumrs-i)
      if ( (npy1.eq.0).and.(npy2.eq.0) ) lrangmx=lrangmx-1 
      enddo
      if (lrangmx.lt.irangmx) irangmx =lrangmx
c     write(*,*)'lrangmx=', lrangmx
      istp=0
      nmax  = max(npax1, npax2)
      is550 = nmax
      nmax1 = nmax
      iskipp = 1
      if ( iflov.eq.0 ) then
         is550 = 1
      else if ( iflov.lt.0 ) then
         is550 = 1
C Next two lines seem incorrect iflov increments rank iskipp distances DR SEP98.
         iskipp = -iflov
         nmax = nmax +iskipp+1
      else 
         write (*,'(/a/)')'DO_VTF: All distances incorporated at once'
      end if
C      write (jout,*) 'npax1 ',npax1, 'npax2 ',npax2, 'nmax ',nmax 
C
#ifdef PKSR
      call pthread_mutex_lock(imutex,istat)
#endif

C*  Carry out VTF Procedure
#ifdef PKSR
      call pthread_mutex_unlock(imutex,istat)
#endif
c     write(*,*)
c    &  'loop i550 ; is550= ',is550,' nmax ',nmax,' iskipp=',iskipp
      do 550 i550=is550,nmax, iskipp
! soften the constraints included until this point, giving better chances to 
! newer to be satisfied.
         if (varwei .and. i550.gt.is550 ) then
            call chngwei
c           write(*,*)' weights changed'
         endif
         istp= istp+1
         if ( ovrtim() ) then
C           write (jout,'(/80(1h*)/10X,a/80(1h*)/)')
C    &      'Time up. Finishing in do_vtf ... '
            fail=.true.
            goto 666
         end if
         if (stopx(dummy))  then
            fail=.true.
            goto 666
         end if
         idxkae1 = min(npax1,i550)
         idxkae2 = min(npax2,i550)
C         write(jout,*) 'idxkae1 ', idxkae1 , 'idxkae2 ', idxkae2 
         if(idxkae1.gt.0) then
            kae1 = kaes(idxkae1)
         else
            kae1 = 0
         endif
         if(idxkae2.gt.0) then
            kae2 = kaes2(idxkae2)
         else
            kae2 = 0
         endif
         irang_last=irang
         irang = max (kae1, kae2)
C Feng Ni, for the faster VTF or rabbit runs.
         if(ivtf.eq.1) irang=i550 
C**********************************************
         if (i550.ge.nmax1) irang = inumrs
         if ( irang.gt.inumrs ) irang = inumrs
         if ( irang.gt.irangmx ) goto 555
         npares1= min(i550, ip(inumrs))
         npares2 =min(i550, ip2(inumrs))
C Feng Ni, for rabbit runs                              NEW
         if(ivtf.eq.1) then
            numdis1=ip(irang)
            numdis2=ip2(irang)
            if(numdis1.gt.0) npares1=numdis1
            if(numdis2.gt.0) npares2=numdis2
            if (i550.gt.irangmx) goto 555
         end if
         Nold_npto=npto
         npto = npares1 + npares2
c        write(jout,1820) irang, npares1, npares2, npto
c        write(*,1820) irang, npares1, npares2, npto
c1820    format( 'irang= ', i5, ' npares1= ', i5 , ' npares2= ', i5, 
c    &      ' npto= ', i5 )
C  
C if no distance contrains are added increased i550
         if (Nold_npto.eq.npto) goto 550
C if the no. of distance contrains added is smaller than the minimum
C increased i550
         if ((npto-Nold_npto) .lt. min_noCons) goto 550
C Interaction array has to be reset because of irang

C Interaction array has to be reset because of irang
         call geniter
c         icx=1
         call minimize(numvar,x,calcfpo,calcgpo,iv,v,id,urparm,
     &                 gradcax,fail)
         if ( iv(1) .eq. 11 ) then
            if(ERR_X) then
C Abort minimization error in the X
               write(*,'(a)')'DO_VTF:Aborting minimization ERROR in Xs:'
               istop=0
               err_x=.false.
            else
               write(*,1409)
               write(jout,1409)
1409           format('STOPX termination.')
            endif
            fail=.true.
            goto 666
         endif
         nukco_OLD=nukco
         nukco=-1
         call disprt
         nukco= nukco_OLD
c        write(*,'(a10,l1)') 'Fail is: ',fail
         if (fail) then
            icntfail= icntfail+1
            if (icntfail.gt.5) then
               write(*,*) 'DO_VTF: minimization failed five times:'
C               write(jout,400) i550, npto
C 400            format(' DO_VTF: i550=',i4,' No. pairs= ',i4)
               goto 666
            endif 
            fail=.false.
         else
            icntfail=0
            if (viomax.gt.(1.1*biggest_vio) ) then
#ifdef MP
               write(*,'(i5,a20,i5,a20,f5.2,a20,i5)')taskid,
     &           ' VTF STEP: ',istp,' Viol exceeds limit ',
     &                          viomax,' Pairs considered=', npto
#else
               write(*,'(a20,i5,a20,f5.2,a20,i5)') 
     &           'VTF STEP: ',istp,' Viol exceeds limit ',
     &                          viomax,' Pairs considered=', npto
#endif
               if (npto.ne.inpv) then
                  icntv=icntv+1
                  inpv=npto
               endif
               if (icntv.gt.maxviostp) then
#ifdef MP
                  write (jout,'(/i5,a13,a30,f5.2,a10,f5.2,a6,i5,a6)') 
     &            taskid, ' Aborting VTF.',  
     &            ' Largest distance-violation (',viomax,') exceeds ',
     &              biggest_vio,'A for ',npto, ' pairs'
                  write (*,'(/i5,a13,a30,f5.2,a10,f5.2,a6,i5,a6)') 
     &            taskid, ' Aborting VTF.',  
     &            ' Largest distance-violation (',viomax,') exceeds ',
     &              biggest_vio,'A for ',npto, ' pairs'
#else
                  write (jout,'(/a13,a30,f5.2,a10,f5.2,a6,i5,a6)' )
     &            'Aborting VTF.',  
     &            ' Largest distance-violation (',viomax,') exceeds ',
     &              biggest_vio,'A for ',npto, ' pairs'
                  write (*,'(/a13,a30,f5.2,a10,f5.2,a6,i5,a6)' )
     &            'Aborting VTF.',  
     &            ' Largest distance-violation (',viomax,') exceeds ',
     &              biggest_vio,'A for ',npto, ' pairs'
#endif
                  fail=.true.
                  goto 666
               endif
            else
#ifdef MP
               write(*,'(i5,a20,i5,a20,f5.2,a20,i5)') taskid,
     &            ' VTF STEP ',istp,' Max violation = ',viomax 
     &            ,' Pairs considered=', npto
#else 
               write(*,'(a20,i5,a20,f5.2,a20,i5)') 
     &            'VTF STEP ',istp,' Max violation = ',viomax 
     &            ,' Pairs considered=', npto
#endif 
               icntv=0
               inpv=npto
            endif
c           write(*,'(a10,e12.5)') 'v(10) is= ',v(10)
            if ( v(10).gt.ten_ethresh) then
               if (npto.ne.inpf) then
                  icntf=icntf+1
                  inpf=npto
               endif
               if (icntf.gt.maxviostp) then
#ifdef MP
                  write (*,'(/i5,2a,e12.5)' ) taskid,
     &            ' Aborting VTF minimization for this conformation',
     &            ' Threshold energy exceeded ',ten_ethresh
#else
                  write (*,'(/2a,e12.5)' )
     &            'Aborting VTF minimization for this conformation',  
     &            ' Threshold energy exceeded ',ten_ethresh
#endif
                  fail=.true.
                  goto 666
               endif
            else
               icntf=0
               inpf=npto
            endif
         endif
 
C        write(jout,500) i550, npto, edis, v(10)
C500     format(' DO_VTF: i550=',i4,' No. pairs= ',i4,' EDIS= ',
C    &                          e12.5,' ETOT= ', e12.5)

550   continue


C ******** *************** *************
C Exit with irang > irangmx.
 555  continue
      if (viomax.gt.(1.1*biggest_vio) ) then
         fail=.true.
         goto 666
      endif
C Try to minimize with a "normal" (3.0kcal/mole) contact energy
C     irang=irang_last
      irang=irangmx
      write(*,5820)  'Final minimization with COEN= 3.0',
     &     irang, npares1, npares2, npto
5820  format(a/, 'irang= ',i5,' npares1= ',i5 ,' npares2= ',i5, 
     &      ' npto= ', i5 )

      if ( coen.gt.1.0) then
! Restore original weight for  constraints.
      if (varwei) call restwei
         coen_old= coen 
         coen= 1.0
         call mod_bd11
C very important ! calculate indexes on gradcax.
         nf=0
         iv(1) = 0
         id = 0
         write(jout,*)'DO_VTF: minimization with contact energy=',coen
         call minimize(numvar,x,calcfpo,calcgpo,iv,v,id,urparm,
     &                 gradcax,fail)
C reset  contact energy value and parameters for energy calculation.
         coen=coen_old
         call mod_bd11
         if (fail) then
            write(jout,*)'DO_VTF: minimization failed'
            fail=.false.
         endif
      endif

      if (viomax.gt.biggest_vio) then
         write (jout,'(a49,/a30,f5.2,a10,f5.2,a1)' )
     &        ' DO_VTF: rejected conformation.',  
     &        ' Largest distance-violation (',viomax,') exceeds ',
     &          biggest_vio,'A'
         fail=.true.
      endif
      if ( v(10).gt.ten_ethresh) then
          write (jout,'(/2a,e12.5)' )
     &        ' DO_VTF: rejected conformation.',  
     &        ' Threshold energy exceeded ',ten_ethresh
          fail=.true.
      endif


C ******** *************** *************
C Exit with STOPX or ABORTING MINIMIZATION 
 666  continue

      return
      end                                                               
      subroutine set_vtf
C driver routine for VTF calculation.     Written by    DR.   MAY94
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif

C
#ifdef PKSR
      INCLUDE 'COMMON.PARRAY'
#endif
C
      include 'COMMON.CNTRL'
      include 'COMMON.GEN100'
      include 'COMMON.EDMC'
      include 'COMMON.MYCONF'
      include 'COMMON.SETUP'
      include 'COMMON.BONDSX'
      include 'COMMON.CALC'
      include 'COMMON.TOR2'
      include 'COMMON.TORQUEX'
      include 'COMMON.TRACK'
      include 'COMMON.IOUNIT'
      include 'COMMON.NNDRUK'
      include 'COMMON.TIME1'
      include 'COMMON.XBOUNDX'
      include 'COMMON.VTFEX'
      include 'COMMON.SAVEWEI'
      logical end_of_file,ovrtim,fail
      dimension urparm(1)
      external calcgpo
      data izero /0/, ione /1/, ifour /4/, itrein /30/

c printing of max violation only, requires nukco >= 0 
c for additional printing of distance information nukco=1 
      icounts = 0

      ndone=0
      iamcon=0
      istop=0
      batime=tcpu()
      if (varwei) call savwei
C     
C     write(*,*) 'NOW IN SET_VTF'
      if ( (.not.readconfs).and.(istartrnd.ne.1) ) then
C  VTF for a single conformation provided in the main input file.
C
         if (.not.nominim) then
c        write(*,'(a)') 'SET_VFT: call to do_vtf'
            call do_vtf(fail)
            if (fail) then
              write(*,'(a,i5)')
     &       'VTF failed during Minimization of Conf. ',ndone+1
              write(jout,'(a,i5)')
     &       'VTF failed during Minimization of Conf. ',ndone+1
	      return
            endif
         endif
C  Calculate `energies' at final point and produce detailed output.
         call ene_eval
C
         ndone=ndone+1
         nukco_o=nukco
         nukco=1
         call disprt
         nukco=nukco_o
         call iter_ovtf

      else
C VTF for multiple conformations (read or generate randomly).
         prevtim=tcpu()

         if (restart) then
            call getold
            write (jout,'(/80(1h*)/10x,a,i4,/)')
     &      'Restarting the VTF procedure from iteration',ndone+1
            ndold=ndone
         else
            licz=0
            mst = 0
C
#ifdef PKSR
            call pthread_mutex_lock (imutex,istat)
#endif
            write (jout,110) ndone+1
            if (onscreen) write (*,110) ndone+1
C
#ifdef PKSR
            call pthread_mutex_unlock (imutex,istat)
#endif

         endif  
         not_done=.true.

#ifdef PKSR
************************************************************************
C Generate other threads.
         call edmc_pstart
C         write(6,'(A40)') 'FINISHED call to pstart'
#endif
C
         iseq=0
C
#ifdef PKSR
C
C  Check in to the barrier
         call pthread_barrier_checkin (barrier_id, iseq, istat)
         if (istat .ne. 0) call obituary 
     $       ('1 Couldn''t check in to the  barrier', iseq)
#endif
C
C  Execute the code
         call mintask(iseq,icounts)

C
#ifdef PKSR
C
C  Check out of the barrier
         call pthread_barrier_checkout(barrier_id, iseq, istat)
         if (istat .ne. 0) then
            call obituary ('2 Couldn''t check out of the barrier',
     $              iseq)
         endif
#endif

      endif

#ifdef PKSR
      continue
      evals = 0
      do 192 m=1, ncells
             evals= evals + counts(m)
192   continue
      eval_per_sec= evals/tcpu()
      Peval_per_sec= ( evals-eval0 )/(tcpu()-tcpu_zero)

      call pthread_mutex_lock (imutex,istat)

      write (jout,'(2(/a,e12.5/))')
     &    ' Total Number of Energy eval. = ', evals,
     &    'Energy Evals. per sec - whole run = ', eval_per_sec,
     &    'Energy Evals. per sec - parallel portion = ', Peval_per_sec

      call pthread_mutex_unlock (imutex,istat)
#else
      evals=  float(icounts)
      eval_per_sec= evals/tcpu()
      write (jout,'(2(a,e12.5/))')
     +' Total Number of Energy evals. = ',evals,
     +' Energy evals. per sec = ', eval_per_sec
#endif
      return
 110  format('***********************************************'/
     &       '        Beginning iteration #',I4/
     &       '***********************************************')

      end
C ********************************************************************
      SUBROUTINE RANGUX(IRESI)
c   generate `random' starting angles
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif

      PARAMETER (lvari = maxnum_dihe*maxnum_res )
      INCLUDE 'COMMON.REGG'
      INCLUDE 'COMMON.BONDSX'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.GEN002X'
      INCLUDE 'COMMON.GEN004'
      INCLUDE 'COMMON.PRAMX'
      INCLUDE 'COMMON.COSACO'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.CHECK'
      INCLUDE 'COMMON.TOR2'
      INCLUDE 'COMMON.TORQUEX'
      INCLUDE 'COMMON.SETUP'
      INCLUDE 'COMMON.VTFEX'
      INCLUDE 'COMMON.NNDRUK'
      INCLUDE 'COMMON.XBOUNDX'
      INCLUDE 'COMMON.BRIDGES'
      INCLUDE 'COMMON.EDMC'
      INCLUDE 'COMMON.THRLET'
      LOGICAL NATURAL_RES, PROUP
      COMMON/NUMRND/NUMR
      CHARACTER*8  SAMPTY
      DATA IZERO /0/, ZERO /0.00000000/

c     NUKCO=1  for debugging purposes. DR DEC94
      LISTI= LIST(IRESI)
      LT=ABS(LISTI)
      IF (IRESI.EQ.1.OR.IRESI.EQ.INUMRS) THEN
c  do not do much for end groups
         NT = IABS(LISTI)+NREG
         NBU = NBOND( IABS(LISTI) )
         IF (NBU.NE.0) THEN
            DO 20 J=1,NBU
               IF(NCHVAR(IRESI,J).EQ. 1) THEN
                  ANGULO(J,IRESI) = PI
                  IF (RNUNF(1).GT.0.7) THEN
                       ANGEL= 2*PI*RNUNF(1)
                       ANGULO(J,IRESI)= PINORM(ANGEL)
                  END IF
               END IF
20          CONTINUE
         END IF
         GOTO 250
      END IF
      
      IF (.NOT.NATURAL_RES(IRESI)) THEN
C        DO L=1,maxnum_dihe
         DO L=1,3+NCHI(LT)
            IF(NCHVAR(IRESI,L).EQ. 1) THEN
               ANGEL= 2*PI*RNUNF(1)
               ANGULO(L,IRESI)= PINORM(ANGEL)
            END IF
         ENDDO
         GOTO 200
      ENDIF
C CHECK FOR D-AMINO ACIDS.
      IF(LISTI.LT.IZERO) THEN
C        DO L=1,maxnum_dihe
         DO L=1,3+NCHI(LT)
            IF(NCHVAR(IRESI,L).EQ. 1) THEN
               ANGEL= 2*PI*RNUNF(1)
               ANGULO(L,IRESI)= PINORM(ANGEL)
            END IF
         ENDDO
         GOTO 200
      ENDIF
C IF WE ARE HERE, THEN THIS IS A NATURAL L-AMINO ACID!
      PROUP=.FALSE.
      II = IABS(KNDRES( LISTI ))
      IF (II.GT.20) THEN
         IF (II.EQ.21) II = 3
         IF (II.EQ.26) II = 7
         IF (II.EQ.27) II = 7
         IF (II.EQ.28) II = 9
         IF (II.EQ.29) II = 15
         IF (II.EQ.31) II = 2
         IF (II.EQ.32) II = 4
         IF (LISTI.EQ.33) THEN
            PROUP=.TRUE.
            II = 13
         END IF
      END IF

C      WRITE(JOUT,'(l1,2x,i4)')  REGSAMP, IZZ(2,IRESI)
      IF (.NOT.REGSAMP .OR.IZZ(2,IRESI).EQ.0 ) THEN
c if no Zimmerman or POPOV regions were specified, sample from
c ALL low-energy regions in phi-psi space (see Vasquez Scheraga,
c J. Biomol. Str. Dyn. 1988 papers )

         IF (II.NE.13.AND.II.NE.6) THEN
C    ALA-TYPE RESIDUE
            RN= RNUNF(1)
            RN2= RNUNF(1)
C            WRITE(JOUT,1004) I,rn,rn2
C1004        FORMAT( 'ALA ',i4,5x,' RN= ',f8.3,' RN= ',f8.3)
            IF (RN.GT.DEL(1,II)) THEN
C
C   SAMPLE UNIFORMLY OVER ALL SPACE
C    PHI : -180 to 180; PSI : -180 to 180
C
               IF(NCHVAR(IRESI,1).EQ. 1) ANGULO(1,IRESI)=
     &           ((2.0*(RN-DEL(1,II))*DEL(2,II)-1.)*EX(1))
               IF(NCHVAR(IRESI,2).EQ. 1) ANGULO(2,IRESI)= 
     &           (2.0*RN2-1.)*EX(1)
            ELSE IF (RN.GT.DEL(3,II)) THEN
C     LEFT HANDED ALPHA HELIX
C      PHI : 40 to 180;  PSI : 10 to 90
               IF(NCHVAR(IRESI,1).EQ. 1)ANGULO(1,IRESI)=
     &                   (EX(1)-(RN-DEL(3,II))*DEL(4,II)*EX(2))
               IF(NCHVAR(IRESI,2).EQ. 1) ANGULO(2,IRESI)= 
     &                   ( EX(3)-RN2*EX(4))
            ELSE IF(RN.GT.DEL(5,II)) THEN
C     RIGHT HANDED ALPHA HELIX REGION
C      PHI : -180 to -40; PSI : -90 to -10
               IF(NCHVAR(IRESI,1).EQ. 1)ANGULO(1,IRESI)= 
     &                   (-EX(1)+(RN-DEL(5,II))*DEL(6,II)*EX(2))
               IF(NCHVAR(IRESI,2).EQ. 1)ANGULO(2,IRESI)=
     &                   (-EX(3)+RN2*EX(4))
            ELSE
               RN=RN*DEL(7,II)
C   EXTENDED REGION
C    PHI : -180 to -40; PSI : 20 to 220 ( -140 )
               IF(NCHVAR(IRESI,1).EQ. 1) ANGULO(1,IRESI)=
     &                   (-EX(1)+RN*EX(2))
               XIP1=EX(5)+RN2*EX(6)
               IF(XIP1.GT.PI) XIP1 = XIP1 - 2*PI
               IF(NCHVAR(IRESI,2).EQ. 1) ANGULO(2,IRESI) = XIP1
            END IF
C      WRITE(JOUT,*) 'phi= ',ANGULO(1,IRESI),' psi= ', ANGULO(2,IRESI)
         ELSE IF (II.EQ.13) THEN
C     PROLINE
            RN= RNUNF(1)
            IF(RN.GT.DEL(4,II)) THEN
C     PSI IN 'FOLDED' REGION
               IF(NCHVAR(IRESI,2).EQ. 1)ANGULO(2,IRESI)=
     &               ( -EX(3)+(RN-DEL(4,II))*DEL(5,II)*EX(4))
               IF (PROUP .AND. (NCHVAR(IRESI,1).EQ. 1) ) THEN
                  ANGULO(1,IRESI) =  -53.040*RAD
               ELSE
                  ANGULO(1,IRESI) =  -68.780*RAD
               ENDIF
            ELSE
               RN=RN*DEL(6,II)*EX(6)
C    PSI IN 'EXTENDED' REGION
               IF(NCHVAR(IRESI,2).EQ. 1) ANGULO(2,IRESI)=(EX(5)+RN)
               IF (PROUP .AND. (NCHVAR(IRESI,1).EQ. 1) ) THEN
                  ANGULO(1,IRESI) =  -53.040*RAD
               ELSE
                  ANGULO(1,IRESI) =  -68.780*RAD
               ENDIF
            END IF
         ELSE
C    GLYCINE
            S=1.0
            RN= RNUNF(1)
            IK=INT(100.0*RN)
            IL=IK/2
            IL=2*IL
            IF(IK.EQ.IL) S=-1.0
            RX= RNUNF(1)
            IF(RX.GT.DEL(1,II)) THEN
C   UNIFORM
               IF(NCHVAR(IRESI,1).EQ.1) ANGULO(1,IRESI)=RN*2.0*EX(1)
               IF(NCHVAR(IRESI,2).EQ.1) ANGULO(2,IRESI)= 
     &                  (RX-DEL(1,II))*2.0*DEL(2,II)*EX(1)
            ELSE IF(RX.GT.DEL(3,II)) THEN
C    (LEFT OR RIGHT) ALPHA HELIX
               IF(NCHVAR(IRESI,1).EQ. 1) ANGULO(1,IRESI)=
     &                  ( S*EX(1)-S*RN*EX(2))
               IF(NCHVAR(IRESI,2).EQ. 1) ANGULO(2,IRESI)=
     &                  ( S*EX(3)-S*(RX-DEL(3,II))*DEL(4,II)*EX(4))
            ELSE
               RX=RX*DEL(5,II)*EX(6)
C    'EXTENDED' REGIONS
               IF(NCHVAR(IRESI,1).EQ. 1) ANGULO(1,IRESI)=
     &                  ( S*EX(1)-S*EX(2)*RN )
               IF(NCHVAR(IRESI,2).EQ. 1) ANGULO(2,IRESI)=
     &                  ( -S*EX(5)-RX )
            END IF
         END IF
      ELSE
         RNDNUM=RNUNF(1)
         IF (RNDNUM.LE.ZERO) THEN
           NUMR=NUMR+1
           IF (NUMR.GT.5) THEN
          write(jout,'(/a/a)')'ERROR random no. generator. Probability'
     &    ,'was consistently set to zero. Check initialization routine'
             stop
           ENDIF
         ELSE
            NUMR=0
         ENDIF
         IF (ITPRGSMP.EQ.2) THEN
            ISIZE=IZZ(2,IRESI)
            DO K=1, ISIZE+1
               PZK(K)=PZZ(K,IRESI)
            ENDDO
            CALL RNDNDX(ISIZE, PZK,IREGI) 
	    SAMPTY='NON-UNIF'
         ELSE
            IREGI=  INT( RNDNUM*IZZ(2,IRESI)) +1
	    SAMPTY='UNIFORM '
         ENDIF
         IF (NUKCO.NE.0) WRITE(JOUT,'(4A,I4)' ) SAMPTY, 
     &	 ' sampling of Region ',ZZ(IREGI,IRESI),' for residue ',IRESI
C        WRITE(JOUT,'(A,I4)' ) ' value of IREGI= ', IREGI

         ANGULO(1,IRESI)= RNUNF(1)
         ANGULO(2,IRESI)= RNUNF(1)
         CALL SAREG( ANGULO(1,IRESI), ZZ(IREGI,IRESI),IRESI)
         ANGI1=DEG*ANGULO(1,IRESI)
         ANGI2=DEG*ANGULO(2,IRESI)

         IF (NUKCO.NE.0) WRITE(JOUT,'(2(A,I4,A,F8.3))' ) 
     &    'Phi(',IRESI,')= ', ANGI1,'  Psi(',IRESI,')= ', ANGI2
      END IF
C     CHI'S
C      CHOOSE g- (-60 +/- 20)  WITH 40% CHANCE
C             t  (180 +/- 20)  WITH 30% CHANCE
C             g+ (+60 +/- 20)  WITH 30% CHANCE

      DO 60 J=4, NCHI(LT)
         RN= RNUNF(1)
         IF (RN.LE.0.4) THEN
            IF(NCHVAR(IRESI,J).EQ. 1) ANGULO(J,IRESI) = RAD*
     &                  ( -60.0 + (2.0*RN/0.4 -1.0) * 20.0)
         ELSE IF (RN.LE.0.7) THEN
            IF(NCHVAR(IRESI,J).EQ. 1) ANGULO(J,IRESI) = RAD*
     &                  (180.0 + (2.0*(RN-0.4)/0.3-1.0) * 20.0)
         ELSE
            IF(NCHVAR(IRESI,J).EQ. 1) ANGULO(J,IRESI) = RAD* 
     &                  (60.0 +(2.0*(RN-0.7)/0.3-1.0) * 20.0)
         END IF
  60  CONTINUE

 200  CONTINUE


C  OMEGA TO REFERENCE CONFORMATION (generally TRANS).
C     IF(NCHVAR(IRESI,3).EQ. 1) ANGULO(3,IRESI)=PI
C DR MAR/98
      IF(NCHVAR(IRESI,3).EQ. 1) ANGULO(3,IRESI)=RAD*OMREF(IRESI)

 250  CONTINUE
C If there is a dihedral angle constraints better to try values within
C those constraints.   DR FEB-10-98
      IF(DIHECNST) THEN
        if(numb_pdb) IIRSD=IRESI-1 
         IF (NUKCO.NE.0) WRITE(JOUT,'(A,I4,/A)')'IN RANGU for RESIDUE=',
     &                     IIRSD,'RESIDUE    DIHEDRAL    VALUE '
         DO J=1,NDIHCO
            IF (IDCN(1,J).EQ. IRESI) THEN
               DO L=1,maxnum_dihe
                  IF ((IDCN(2,J).EQ.L).AND.(NCHVAR(IRESI,L).EQ.1)) THEN
                    ANGEL= RAD*(DCN(1,J)-DCN(2,J) +
     &                                          2*DCN(2,J)*RNUNF(1))
                    IF (  (ABS(ANGEL).GT.1.0E+10) ) THEN 
                        WRITE (*,*)'ERROR RANGUX: ANGEL ',DEG*ANGEL
                    END IF
                    ANGULO(L,IRESI)= PINORM(ANGEL)
                    IF (NUKCO.NE.0) WRITE(JOUT,'(A3,A1,I5,A2,1X,I5,
     &             F8.3)') ARES(LT),'(',IIRSD,')=',L,DEG*ANGULO(L,IRESI)
                  END IF
               ENDDO
            END IF
         ENDDO
C Determine, if there is a need to adjust other (not changed) angles so as
C to satisfy the distance constraints in sampling.
         IF (IS.GT.0 .AND. IE.GT.0 .AND. IRESI.GT.IS .AND. IRESI.LT.IE)
     &      THEN
C Zero out the indices of "unmovable" angles.
            DO I=1,INUMRS
              IFFIX(I)=0
              IPFIX(I)=0
            ENDDO
            DO I=1,NLOOP
              NKAI1I=NKAI1(I)
              DO J=1,NKAI1I
                ICHFIX1(I,J)=0
                ICHFIX2(I,J)=0
              ENDDO
            ENDDO
C  Define "unmovable" angles.
            IFFIX(IRESI)=1
            IPFIX(IRESI)=1
            DO K=1,NCHI(LT)
              NDX = IRESI*maxnum_dihe+k+3
              DO I=1,NLOOP
                NKAI1I=NKAI1(I)
                DO J=1,NKAI1I
                  IF (NDX.EQ.ICHIND1(I,J)) THEN
                    ICHFIX1(I,J)=1
                  ELSEIF (NDX.EQ.ICHIND2(I,J)) THEN
                    ICHFIX2(I,J)=1
                  ENDIF
                ENDDO
              ENDDO
            ENDDO ! k
C Adjust the movable angles so as to satisfy the distance constraints.
            CALL DISTFORCE
         ENDIF
         IF (NUKCO.NE.0) WRITE(JOUT,'(/A)')'OUT OF RANGU'
      END IF

      RETURN
      END
C ********************************************************************
      SUBROUTINE BOUNDS_CALC
C This routine reads a PDB file and gets distance information between
C Heavy atoms. The output is written in a similar format to  the one used in
C DGEOM.  The output file (bound.*) can be used as input for other modules
C of this program like VTF or EDMC with  distance constraints.
C Written by Daniel Ripoll     APR94.
C
      LOGICAL END_OF_FILE
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif

      INCLUDE 'COMMON.CNTRL'
      INCLUDE 'COMMON.DEBUG'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.FILES'
      INCLUDE 'COMMON.CALC'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.ATOMSS'
      INCLUDE 'COMMON.BONDSX'
      INCLUDE 'COMMON.BOUNDAT'
C     INCLUDE 'COMMON.RMSFIT'
      INCLUDE 'COMMON.TYYY'
      INTEGER ICON(maxnum_atoms)
      DATA IZERO /0/,IONE /1/
      DATA UNDEFIN /-998.90/

      NATMOM=NPRE(INUMRS+1)
C   ############## READ REFERENCE CONFORMATION   #################

C     USE INPUT DATA FROM FILE "INPDB" (44)
C
      JKUNIT=INPDB
      WRITE(JOUT,'(/,a,i3/)') 
     &  'READING PDB file on UNIT ',INPDB
      IF (ITYPE_INP.EQ.1) THEN
         ITYPF=1
         WRITE(JOUT,'(2a)')'Input structure for reference in ',
     &           'ORIGINAL PDB format (no end groups)'
      ELSE IF (ITYPE_INP.EQ.2 ) THEN
         ITYPF=0
         WRITE(JOUT,'(2a)')'Input structure for reference in ',
     &           'ECEPP(or AMBER) PDB format (with end groups)'
      END IF

C  ###  READ FILE #####
C     OPEN(UNIT=JKUNIT)
      CALL SUBPDB (NATMOM,COORD,ICON,JKUNIT)
C   ############## END READING REFERENCE CONFORMATION #################
C     CLOSE(UNIT=JKUNIT)
      
C      DO 80 I=1, NATMOM
C        IF (ALPH(I)(1:1).EQ.'H') THEN
C           ICON(I) = 0
C        ELSE
C           ICON(I) = 1
C           WRITE(JOUT,1040) I,(COORD(J,I),J=1,3),ICON(I),ALPH(I)
C        ENDIF
C1040    FORMAT (i4,1X,3F9.3,I6,5X,A4)
C80    CONTINUE
C
C   ############## EXTRACTING UPPER AND LOWER BOUNDS FROM ##############
C   ##############         REFERENCE CONFORMATION         ##############
C      WRITE(JOUT,'(/,a/)')  'NOW CALL GET_BOUNDS'
      CALL GET_BOUNDS(NATMOM)
C
C     ************ DIHEDRAL ANGLES ***************
C     DETERMINE RESIDUES.
      ISTRES=1
      IFIRES=INUMRS
      NSUB=0
      IF (ITYPF.EQ.1) THEN
         ISTRES=ISTRES+1
         IFIRES=IFIRES-1
         NSUB=1
      ENDIF

C NOW CALCULATE STARTING DIHEDRAL ANGLES FROM PDB
      REWIND(JKUNIT)
      IFINR=IFIRES-NSUB
      WRITE(JOUT,'(/,a/)') 'NOW CALL DIHDRL '
C
      WRITE(JOUT,*) ' IFINR= ',IFINR,' ISTRES ', ISTRES,'IFIRES ',
     &                 IFIRES,'NSUB',NSUB
      CALL DIHDRL(IFINR)

      DO I=ISTRES,IFIRES
         ISUB=I-NSUB
         DO J=1,maxnum_dihe
            DIANG=ANGELA(J,ISUB)
            IF ( (J.LE.7).AND.(DIANG.GT.UNDEFIN ) ) THEN
                AGLO=   DIANG * RAD
                IF (  (ABS(AGLO).GT.1.0E+10) ) THEN
                   WRITE (*,*)'ERROR BOUNDS_CALC: AGLO= ',AGLO*DEG
                END IF

                ANGULO(J,I)=   PINORM( AGLO)
            ELSE
                RNDS=2*PI*RNUNF(1)
                IF (  (ABS(RNDS).GT.1.0E+10) ) THEN
                   WRITE (*,*)'ERROR BOUNDS_CALC: RNDS ',DEG*RNDS
                END IF

                ANGULO(J,I)= PINORM(RNDS)
            ENDIF
         ENDDO
      ENDDO
C print dihedral angles of  the reference conformation.
      CALL DRUANG(JANG,IZERO)
      RETURN 
      END
C ********************************************************************
      SUBROUTINE GET_BOUNDS(NATMOM)
C      Calculate upper and lower bound for atomic distances from a PDB file.
C    D. ripoll      APR94
      LOGICAL END_OF_FILE
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif

      INCLUDE 'COMMON.CNTRL'
      INCLUDE 'COMMON.DEBUG'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.FILES'
      INCLUDE 'COMMON.CALC'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.ATOMSS'
      INCLUDE 'COMMON.BONDSX'
      INCLUDE 'COMMON.BOUNDAT'
      INCLUDE 'COMMON.XBOUNDX'
      DIMENSION ICON(maxnum_atoms)
      DIMENSION CRD1(3),CRD2(3)
      DIMENSION RR(100000)
      CHARACTER*3 CHATOM2
      CHARACTER*3 CHARBND(2,maxnum_dist)
      COMMON/BOUND_ATOMS/CHARBND,NPARES,RWEI(maxnum_dist)
      CHARACTER*1 WILD
      DATA WILD /'*'/
      external ilen

C This routine calculates distance information between
C Heavy atoms. The output is written in a format suitable for the
C VTF program (or EDMC distance constraints file).

      NDIS=0
C     FIX VALUE ADDED TO AND SUBTRACTED FROM DISTANCE TO GENERATE
C     UPPER AND LOWER BOUNDS.
      IF(IDELTR.EQ.1) DELRR1=VALUE_DR

C     WRITE(JOUT,*)'NPARES= ', NPARES,' NATMOM= ',NATMOM
      DO K=1, NPARES
         WEIGHT=RWEI(K)
         LEN1= ILEN( CHARBND(1,K) )
         IF (CHARBND(1,K)(LEN1:LEN1).EQ. WILD)  THEN
            LEN1=LEN1-1
         ELSE
            LEN1=3
         ENDIF
         LEN2= ILEN( CHARBND(2,K) )
         IF (CHARBND(2,K)(LEN2:LEN2).EQ. WILD)  THEN
            LEN2=LEN2-1
         ELSE
            LEN2=3
         ENDIF
C        WRITE(JOUT,*)' CHARBND1= ',  CHARBND(1,K), ' K= ',K
C        WRITE(JOUT,*)' CHARBND2= ',  CHARBND(2,K), ' K= ',K
         DO 20 I=1, NATMOM
C CHECK IF ATOM1 IS ONE OF THE REQUESTED ATOMS
           IF (ALPH(I)(1:LEN1).EQ. CHARBND(1,K)(1:LEN1) ) THEN
                CHATOM2= CHARBND(2,K)(1:LEN2)
           ELSE IF (ALPH(I)(1:LEN2).EQ. CHARBND(2,K)(1:LEN2) ) THEN
                CHATOM2= CHARBND(1,K)(1:LEN1)
                LEN2=LEN1
            ELSE
               GOTO 20
            ENDIF
            IRES1=JON_RESIDUE(I)
C FOR MORE THAN ONE MOLECULE THE FOLLOWING FUNCTION SHOULD BE IMPLEMENTED. 
C            IMOL1=JON_MOLECULE(I)
             IMOL1=1
C           WRITE(JOUT,*)'1- ALPH(',I,')= ',ALPH(I),' RESID=',IRES1
C Store coord. of atom1 ind CRD1 array.
            DO L=1,3
               CRD1(L)=COORD(L,I)
            ENDDO
            DO 30 J=I+1, NATMOM
C                IF (ALPH(J)(1:3).EQ. CHATOM2 ) THEN
               IF (ALPH(J)(1:LEN2).EQ. CHATOM2 ) THEN
                  IRES2=JON_RESIDUE(J)
C                 IMOL2=JON_MOLECULE(I)
                  IMOL2=1
C                 WRITE(JOUT,*)'2- ALPH(',J,')= ',  ALPH(J),
C    &                                       ' RESID=',IRES1
C check if the separation of the residues is equal or greater
C than requested
                  IGAP=IRES2-IRES1
                  IF (IGAP.GE.IRSGAP) THEN
C Store coord. of atom2 ind CRD2 array.
                     DO L=1,3
                       CRD2(L)=COORD(L,J)
                     ENDDO
C  Calculate distance between atoms.
c
                     RR1=DISTA(CRD1,CRD2)
C ONLY THOSE DISTANCES SMALLER THAN RMAXDIST AND LARGER THAN  RMINDIST 
C WILL BE SAVED.
                     IF (RR1.LE.RMAXDIST.AND.RR1.GE.RMINDIST) THEN
                        NDIS=NDIS+1
                        WEI(NDIS)= WEIGHT
                        NMOLA(1,NDIS)=IMOL1
                        NRE(1,NDIS)=IRES1
                        ATOM(1,NDIS)=ALPH(I)
C
                        NMOLA(2,NDIS)=IMOL2
                        NRE(2,NDIS)=IRES2
                        ATOM(2,NDIS)=ALPH(J)
C                 WRITE(JBND,2000) IRES1,ALPH(I),IRES2,ALPH(J)
C A PERCENTAGE OF THE ACTUAL DISTANCE IS ADDED TO AND SUBTRACTED FROM 
C SUCH DISTANCE TO GENERATE UPPER AND LOWER BOUNDS.
                        IF(IDELTR.EQ.2) DELRR1=VALUE_DR*RR1
                        DISO(1,NDIS) = RR1-DELRR1
                        DISO(2,NDIS) = RR1+DELRR1
                     ENDIF
                  ENDIF
               ENDIF
30          CONTINUE
 1040       FORMAT (5X,A3,2x,A3,5x,F9.3)
20       CONTINUE
      ENDDO
      
      NNP1=0
      WRITE(JOUT,'(a,i4)')'NDIS= ', NDIS
      WRITE(JBND,'(a1,2I10,3X,F10.3)') '!', NNP1, NDIS, WEITB
      DO I=1,NDIS
         WRITE(JBND,2000) NMOLA(1,I), NRE(1,I),ATOM(1,I),
     &                    NMOLA(2,I),NRE(2,I),ATOM(2,I),
     &                     DISO(1,I), DISO(2,I), WEI(I)
 2000    FORMAT (8X,2(2I4,1X,A3,2X),3F8.3)
C
C         WRITE(JBND,3000) DISO(1,I), DISO(2,I)
 3000    FORMAT (2F10.3)
      ENDDO
      RETURN 

      END
C ********************************************************************
      SUBROUTINE DIHDRL(IFINR)
C ********************************************************************
C     THIS PROGRAM HAS BEEN ADAPTED. CURRENTLY, OUTPUTS HAVE BEEN
C     CANCELLED AND THE SET OF DIHEDRAL ANGLES ARE PASSED IN A COMMON
C     BLOCK (PDBDIH), BACK TO BOUNDS_CALC       DR  MAR 94.
C
C                             PROTEIN DATA BANK SOURCE CODE     DIHDRL
C                             AUTHOR. E.ABOLA
C                             ENTRY DATE.  3/80   SUPPORTED
C                             LAST REVISION.  3/80
C                             PURPOSE. COMPLETE TORSION ANGLES
C                             LANGUAGE. FORTRAN IV
C
C
C
C

C
C
C     WRITTEN BY -
C        ENRIQUE E. ABOLA
C        CHEMISTRY DEPARTMENT
C        BROOKHAVEN NATIONAL LABORATORY
C        UPTON,N.Y. 11973 U.S.A.
C
C     THE PROTEIN DATA BANK IS FUNDED BY THE NATIONAL SCIENCE FOUNDATION
C     UNDER GRANT PCM 77-16811.
C
C     THE USE OF A LIBRARY OF VECTOR MANIPULATION ROUTINES WRITTEN BY
C     LAWRENCE C. ANDREWS IS GRATEFULLY ACKNOWLEDGED.
C
C     THE PROCEDURE USED TO SET UP THE REQUIRED POINTERS FOLLOWS THAT
C     USED BY GEORGE REEKE IN HIS PROGRAM TORSIN.
C
C     PLEASE NOTIFY THE PROTEIN DATA BANK OF ANY DIFFICULTIES
C     ENCOUNTERED IN USING THIS PROGRAM.
C
C     PURPOSE -
C
C     DIHDRL(DIHEDRAL) CALCULATES THE FOLLOWING TORSION ANGLES ON
C     PROTEIN DATA BANK ENTRIES.
C
C        1.PSI     N(I)  -CA(I)-C(I)    -N(I+1)
C        2.PHI     C(I-1)-N(I) -CA(I)   -C(I)
C        3.OMEGA   CA(I) -C(I) -N(I+1)  -CA(I+1)
C        4.CHI1    N(I)  -CA(I)-CB(I)   -(CG,SG,OG1,CG1,OG)
C        5.CHI2    CA(I) -CB(I)-(CG,CG1)-(OD1,AD1,ND1,CD,CD1,SD)
C        6.CHI3    CB(I) -CG(I)-(CD,SD) -(OE1,AE1,CE,NE)
C        7.CHI4    CG(I) -CD(I)-(NE,CE) -(CZ,NZ)
C
C     ANGLES ARE NOT CALCULATED AND NOT PRINTED FOR THOSE SETS WHERE
C     ATOMS ARE MISSING OR THOSE FOR WHICH DISTANCES BETWEEN BONDED
C     ATOMS ARE LESS THAN 0.7 ANG. OR GREATER THAN 2.5 ANG.
C
C     I/O FILES
C
C     SYMBOLIC        LOGICAL     DESCRIPTION
C     DESIGNATION     UNIT
C
C     IPDB            TAPE1       PROTEIN DATA BANK ENTRIES
C     IOUT            TAPE2       FORMATTED FILE CONTAINING ANGLES
C     ISCR            TAPE3       SCRATCH FILE FOR ENCODE/DECODE
C     INPT            TAPE5       INPUT FILE FROM CARD READER
C     LPTR            TAPE6       OUTPUT FILE TO BE PRINTED
C
C     INPUT PARAMETERS ON FILE INPT
C
C     INPUT PARAMETER 1 FORMAT(3I5,A4)
C
C     COL. NO.     NAME           DESCRIPTION
C
C     1-5          ITOTFL         TOTAL NUMBER OF DATA PARTITIONS IN
C                                 IPDB TO BE PROCESSED (BLANK OR ZERO
C                                 DEFAULTS TO ONE)
C
C     6-10         NFILE          NUMBER OF PARTITIONS TO SKIP BEFORE
C                                 PROCESSING
C                         .LT. 0  POSITION THE FILE IPDB IN THE
C                                 PARTITION WITH THE HEADER NAME GIVEN
C                                 IN IFLNAM
C                         .EQ. 0  START PROCESSING FROM CURRENT FILE
C                                 POSITION
C                         .GT. 0  SKIP NFILE FILE MARKS BEFORE
C                                 PROCESSING
C
C     11-15        IOUT           = 0 NO TAPE OUTPUT
C                                 = 2 CREATE A FORMATTED OUTPUT FILE
C                                 EACH RECORD WILL CONTAIN THE
C                                 FOLLOWING.
C                                 LABL1,LABL2,NRES,NCHN,INSC,NALT1,
C                                 NALT2,NALT3,(ANGLE(I),I=1,7),IDSET
C                                 FORMAT(A4,A2,1X,A3,A1,I4,4A1,7(F7.2),
C                                 2X,A4)
C                                 AN ANGLE FOR WHICH A VALUE CANNOT BE
C                                 DEFINED IS GIVEN THE VALUE OF -999.
C
C     16-19        IFLNAM         FOUR CHARACTER CODE FOUND IN THE
C                                 HEADER RECORD OF THE PARTITION FROM
C                                 WHICH PROCESSING IS TO BEGIN
C
C     THE PROGRAM WILL STOP IF ITOTFL IS LESS THAN ZERO OR WHEN THERE
C     ARE NO MORE ENTRIES IN THE PROTEIN DATA BANK FILE IPDB.
C
C     OUTPUT
C
C     FOR EACH PROTEIN DATA BANK ENTRY PROCESSED THE IDENTIFYING INFOR-
C     MATION IS PRINTED AND IS FOLLWED BY A TABLE OF TORSION ANGLES FOR
C     EACH DISTINCT CHAIN FOUND IN THE ENTRY.
C     AN ALTERNATE LOCATION INDICATOR IS PRINTED FOR THOSE CASES IN
C     WHICH MORE THAN ONE LOCATION IS PROVIDED FOR THE SAME ATOM WITHIN
C     A RESIDUE.  THE FORM USED TO INDICATE MULTIPLE LOCATIONS IS
C        (A,B,C)
C     WHERE A REFERS TO ALTERNATE LOCATION A OF C(I-1)
C           B REFERS TO ALTERNATE LOCATION B OF RESIDUE I
C           C REFERS TO ALTERNATE LOCATION C OF CA(I+1) AND N(I+1)
C
C     A FORMATTED OUTPUT FILE IS CREATED WHEN IOUT IS SET TO 2.
C     THE OUTPUT FILE CONSISTS OF RECORDS CONTAINING THE FOLLOWING.
C        LABL1,LABL2,NRES,NCHN,NSEQ,INSC,NALT1,NALT2,NALT3,ANGLE,IDSET
C
C        LABL1 AND
C        LABL2     CONTAINS THE RECORD IDENTIFIER TORANG
C        NRES      RESIDUE NAME
C        NCHN      CHAIN NAME
C        NSEQ      SEQUENCE NUMBER
C        INSC      INSERT CODE
C        NALT1     ALTERNATE LOCATION CODE FOR (I-1) RESIDUE
C        NALT2     ALTERNATE LOCATION CODE FOR (I) RESIDUE
C        NALT3     ALTERNATE LOCATION CODE FOR (I+1) RESIDUE
C        ANGLE     TORSION ANGLES IN THE ORDER
C                       1. PHI
C                       2. PSI
C                       3. OMEGA
C                       4. CHI1
C                       5. CHI2
C                       6. CHI3
C                       7. CHI4
C        IDSET     ENTRY IDENTIFICATION CODE FOR THE PROTEIN
C
C     THIS IS WRITTEN USING THE FORMAT,
C        (A4,A2,1X,A3,A1,I4,4A1,7(F7.2),2X,A4)
C
C     AN ANGLE FOR WHICH A VALUE CANNOT BE DEFINED IS GIVEN THE VALUE
C     OF -999.
C
C     MACHINE DEPENDENCIES
C
C     THIS PROGRAM MUST HANDLE CHARACTERS STORED IN A WORD.  AN ATTEMPT
C     WAS MADE TO HAVE A LIMIT OF FOUR CHARACTERS PER WORD.  TYPICALLY A
C     RECORD IS READ IN 20A4 FORMAT AND IDENTIFIED.  SUBSEQUENTLY
C     IT IS ENCODED INTO A LINE IN 8A10 FORMAT THAT CAN BE DECODED USING
C     THE APPROPRIATE FORMAT.  THE ARRAY *LINE* IS ALWAYS USED FOR THIS
C     PURPOSE.
C     FOR COMPUTERS WITH ENCODE/DECODE CAPABILITY ONLY THE DIMENSION OF
C     *LINE* AND A FORMAT STATEMENT NEED BE CHANGED.  FOR THOSE WITHOUT
C     THIS CAPABILITY, THE LINE CAN BE WRITTEN ON A SCRATCH FILE AND
C     REREAD.
C     THE FOLLOWING SUBROUTINES USE THE ENCODE/DECODE FACILITY OF THE
C     CDC MACHINE
C        1. ANGOUT
C        2. NTRPRT
C        3. PRNTXT
C
C     EVERY READ STATEMENT IN THIS PROGRAM IS FOLLOWED BY THE TEST
C        IF ( EOF(IPDB)) S1, S2
C     THE PROGRAM JUMPS TO STATEMENT S1 IF AN END OF FILE HAS BEEN
C     ENCOUNTERED AFTER A READ ON FILE IPDB AND TO STATEMENT S2
C     OTHERWISE.
C     THE EOF TESTING PERFORMED IS UNIQUE FOR CDC MACHINES AND MAY NEED
C     REVISION TO THE MORE COMMON FORM OF
C        READ(INPT,1000,END=500) IBUF
C
C     THIS EOF TESTING IS USED IN THE FOLLOWING ROUTINES
C        1. MAIN PROGRAM
C        2. GETREC
C
C     ALL VARIABLES THAT ARE USED TO STORE CHARACTERS ARE DEFAULTED
C     TO BE OF INTEGER TYPE.  EACH ROUTINE WILL CONTAIN A LIST OF THESE
C     VARIABLES AS PART OF THE HEADER INFORMATION.
C
C     THE ARITHMETIC STATEMENT FUNCTION IDEN(I,J) IS USED TO COMPARE
C     ALPHANUMERIC VARIABLES.
C
C     ALGORITHM
C
C     THE PROCEDURE USED TO SET UP THE REQUIRED POINTERS FOLLOWS THAT
C     USED BY GEORGE REEKE IN HIS PROGRAM TORSIN.
C
C     ARRAYS USED
C
C     1. XYZ(I,J)       CONTAINS ATOMIC COORDINATES TO BE USED IN
C                       CALCULATING TORSION ANGLES
C     2. INLOC(J)       SET TO 0 WHEN AN ATOM IS MISSING
C                       SET TO 1 WHEN XYZ(I,J) CONTAINS THE COORDINATES
C                       OF AN ATOM
C     3. IATMNM         ARRAY OF ATOM NAMES OCCURRING IN PROTEINS
C                       ARRANGED IN A SPECIAL ORDER
C     4. INDIC(N)       FOR AN ATOM NAME FOUND IN THE NTH POSITION IN
C                       THE ARRAY IATMNM, INDIC(N) CONTAINS THE LOCATION
C                       IN THE ARRAY XYZ IN WHICH THE ATOM SHOULD BE
C                       STORED
C                       N.B.
C                          LOC(1) IS RESERVED FOR C(I-1)
C                          LOC(10) IS RESERVED FOR N(I+1)
C                          LOC(11) IS RESERVED FOR CA(I+1)
C
C     5. IPTR2(M)       NUMBER OF ANGLES TO BE CALCULATED FOR THE
C                       RESIDUE OF TYPE M, M IS RETURNED BY THE ROUTINE
C                       ISRSAA
C     6. IPTR1(M)       POINTS TO THE STARTING ADDRESS IN THE ARRAY
C                       IBONDS WHERE THE ANGLE CODE FOR THE RESIDUE OF
C                       TYPE M BEGINS
C     7. IBONDS         ARRAY CONTAINING THE ANGLE CODES TO BE USED FOR
C                       THE RESIDUES OCCURRING IN PROTEINS
C     8. KODE(I,L)      CONTAINS THE LOCATION IN THE ARRAY XYZ OF THE
C                       ATOMS TO BE USED FOR A SPECIFIC ANGLE.  THERE
C                       ARE SEVEN ANGLE TYPES CONSIDERED, GIVEN THE
C                       CODES 1-7 IN THE ORDER AS THEY ARE PRESENTED IN
C                       THE PURPOSE SECTION ABOVE.
C                       E.G.
C                       ANGLE PHI IS GIVEN L=1
C                       KODE WILL POINT TO LOCATIONS 1,2,3 AND 4 IN XYZ
C                       AS CONTAINING THE NECESSARY ATOMIC COORDINATES
C
C     THIS ROUTINE IS THE MAIN CONTROLLER FOR THE PROGRAM DIHDRL.
C     ITS MAIN PURPOSE IS TO COMMUNCIATE WITH THE USER VIA FILE INPT,
C     AND TO POSITION THE FILE IPDB PROPERLY.
C
C     VARIABLES USED TO STORE CHARACTERS
C     IFLNAM,IBUF,IDSET
C
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif

      DIMENSION IBUF(20)
      COMMON /HEADER/ IDSET
      INCLUDE 'COMMON.TYYY'
      DATA INPT/35/,LPTR/20/
C
      itotfl=0
      nfile=0
      iout=2
      CALL WRKTRS (IOUT,IER)
      ILASTQ=LASRES-IFRSTRS+1
      IF (ILASTQ.NE.IFINR) THEN
        WRITE (LPTR,'(2a,/,2i5)')'***ERROR IN DIHDRL ***',
     &  'LASRES, IFINR', LASRES, IFINR
      ELSE
        WRITE (LPTR,70)
      ENDIF
CD     STOP
      RETURN
C
   70 FORMAT ('----- END OF DIHEDRAL ANGLES CALCULATION -----')
   80 FORMAT (3I5,A4)
      END
      SUBROUTINE WRKTRS (IOUT,IER)
C
C     THIS SUBROUTINE CONTAINS THE MAIN WORK LOOP OF THE PROGRAM DIHDRL
C     IT IS CALLED BY THE MAIN CONTROLLER ONCE FOR EACH PROTEIN DATA
C     BANK ENTRY.
C
C     IOUT = 0 NO FORMATTED OUTPUT FILE IOUT
C          = 2 FILE IOUT IS TO BE GENERATED
C     IER IS AN ERROR FLAG WHICH IS SET TO A NON-ZERO VALUE FOR ERROR
C     CONDITIONS.
C
C     THE SUBROUTINE GETRES IS CALLED TO READ THE PROTEIN DATA BANK FILE
C     AND TO GATHER THE ATOMS INTO DISCRETE RESIDUE UNITS. THE COLLECTED
C     ATOMS ARE STORED IN THE COMMON AREA CURRES.  THE SUBROUTINE LOADRS
C     IS THEN CALLED TO CALCULATE AND PRINT THE TORSION ANGLES.
C     SUBROUTINE CLNUP IS CALLED TO INSURE THAT THERE ARE NO OUTSTANDING
C     RESIDUES FOR WHICH ANGLES HAVE NOT BEEN CALCULATED AFTER A TER,
C     END OR END OF DATA BASE RECORD TYPE.
C
C     THE FOLLOWING VARIABLES ARE USED TO STORE CHARACTERS
C     IBUF,IDSET,INCATM,IFIN,IBLANK
C     NRESCR,NCHNCR,INSCCR,NAMECR,NALTCR
C     NRES27,NCHN27,INSC27,NAME27,NALT27
C     NRES,NCHN,INSC,NALT1,NALT2,NALT3
C
      DIMENSION IBUF(20)
      DIMENSION INCATM(20)
      DIMENSION NSERCR(100), NAMECR(100), NALTCR(100)
      DIMENSION ATMXCR(100), ATMYCR(100), ATMZCR(100)
      DIMENSION XYZ(3,60), INLOC(60)
      DIMENSION NALT1(5), NALT2(5), NALT3(5)
C
      COMMON /ATOM/ NSER27,NAME27,NALT27,NRES27,NCHN27,NSEQ27,INSC27,ATM
     1X27,ATMY27,ATMZ27,OCPN27,TEMP27
C
      COMMON /CURRES/ NALLCR,NRESCR,NCHNCR,NSEQCR,INSCCR,NSERCR,NAMECR,N
     1ALTCR,ATMXCR,ATMYCR,ATMZCR
C
      COMMON /RES1/ XYZ,INLOC
      COMMON /RES2/ NRES,NCHN,NSEQ,INSC,IALT,ICAN,NALT1,NALT2,NALT3
      COMMON /HEADER/ IDSET
C
      DATA IBEGIN/0/,IHEAD/1/,ITER/28/,IENDD/31/,IENDB/-50/,IAUTHR/4/,ID
     1ONE/2/,JHET/1/,IFIN/'FINI'/
!    1ONE/2/,JHET/1/,IFIN/4HFINI/
!     DATA IBLANK/1H /
      DATA IBLANK/' '/
C
C     INITIALIZE PARAMETERS
C
      IALT=1
      ICAN=1
      ISTATE=IBEGIN
      IRC=IBEGIN
      INRES=1
      NINC=0
      IALRES=0
      DO 10 J=1,60
   10 INLOC(J)=0
      DO 20 J=1,5
      NALT1(J)=IBLANK
      NALT2(J)=IBLANK
   20 NALT3(J)=IBLANK
C
   30 CALL GETRES (ISTATE,NINC,INCATM,IBUF,JCODE,JHET)
C
C     SEE IF WE HAVE A RESIDUE
C
      IF (ISTATE.NE.IDONE) GO TO 40
C
C     WE HAVE A RESIDUE,CALCULATE ITS ANGLES
C
      CALL LOADRS (INRES,IALRES,IOUT)
      NSEROL=NSERCR(NALLCR)
      GO TO 110
C
   40 IF (JCODE.NE.IHEAD) GO TO 50
      CALL NTRPRT (IBUF,JCODE)
C
C     CHECK FOR END OF DATA BANK
C
      IF (IDSET.NE.IFIN) GO TO 50
      IER=1
      CALL CLNUP (IALRES,NSEROL,IOUT,INRES)
      IRC=1
      GO TO 110
C
C     SEE IF WE HAVE TO PRINT THE RECORD
C
   50 IF (IABS(JCODE).GT.IAUTHR) GO TO 60
      CALL PRNTXT (IBUF,JCODE)
      GO TO 110
C
C     CHECK FOR TER RECORDS
C
   60 IF (JCODE.NE.ITER) GO TO 90
      CALL CLNUP (IALRES,NSEROL,IOUT,INRES)
C
C     RESET PARAMETERS TO INITIAL VALUE
C
      ICAN=1
      ISTATE=IBEGIN
      IRC=IBEGIN
      INRES=1
      IALRES=0
      DO 70 J=1,60
   70 INLOC(J)=0
      DO 80 J=1,5
      NALT1(J)=IBLANK
      NALT2(J)=IBLANK
   80 NALT3(J)=IBLANK
      GO TO 110
C
C     CHECK FOR END OF PROTEIN DATA BANK ENTRY
C
   90 IF (JCODE.NE.IENDD) GO TO 100
      CALL CLNUP (IALRES,NSEROL,IOUT,INRES)
      IER=0
      IRC=1
      GO TO 110
C
C     CHECK FOR END OF DATA BANK
C
  100 IF (JCODE.NE.IENDB) GO TO 110
      CALL CLNUP (IALRES,NSEROL,IOUT,INRES)
      IER=1
      IRC=1
      GO TO 110
C
C
  110 IF (IRC.EQ.0) GO TO 30
C
C     WRITE AN EOF ON FILE TAPE2 IF IT HAD BEEN GENERATED
C
      IF (IOUT.EQ.2) END FILE IOUT
      RETURN
      END
      SUBROUTINE CLNUP (IALRES,NSEROL,IOUT,INRES)
C
C     THIS SUBROUTINE IS CALLED TO INSURE THAT ALL THE ANGLES HAVE BEEN
C     CALCULATED FOR THE CURRENT PROTEIN DATA BANK ENTRY.
C
C     THE FOLLOWING VARIABLES ARE USED TO STORE CHARACTERS
C     NRESCR,NCHNCR,INSCCR,NAMECR,NALTCR
C     NRES,NCHN,INSC,NALT1,NALT2,NALT3
C
      DIMENSION NSERCR(100), NAMECR(100), NALTCR(100)
      DIMENSION ATMXCR(100), ATMYCR(100), ATMZCR(100)
      DIMENSION XYZ(3,60), INLOC(60)
      DIMENSION NALT1(5), NALT2(5), NALT3(5)
      COMMON /CURRES/ NALLCR,NRESCR,NCHNCR,NSEQCR,INSCCR,NSERCR,NAMECR,N
     1ALTCR,ATMXCR,ATMYCR,ATMZCR
      COMMON /RES1/ XYZ,INLOC
      COMMON /RES2/ NRES,NCHN,NSEQ,INSC,IALT,ICAN,NALT1,NALT2,NALT3
C
      DATA ITIMES/1/
C
C     SEE IF WE HAVE ANY RESIDUES TO WORRY ABOUT
C
      IF (IALRES.EQ.0) GO TO 30
C
C     SEE IF THE CURRENT RESIDUE HAS ALREADY BEEN ANALYZED
C
      IF (NSEROL.EQ.NSERCR(NALLCR)) GO TO 10
      CALL LOADRS (INRES,IALRES,IOUT)
C
   10 CONTINUE
C
C     CALCULATE THE ANGLES FOR THE LAST RESIDUE IF NEEDED
C
      DO 20 I=1,IALT
      DO 20 J=1,ICAN
   20 CALL OMEGA (I,ITIMES,J,IOUT)
C
      GO TO 30
   30 RETURN
      END
      SUBROUTINE LOADRS (INRES,IALRES,IOUT)
C
C     THIS SUBROUTINE CALLS THE VARIOUS ROUTINES REQUIRED TO LOAD ATOMIC
C     COORDINATES INTO THE COMMON AREA RES1 AND RES2 (THE ARRAYS XYZ AND
C     INLOC) AND ALSO THE ROUTINES REQUIRED TO CALCULATE AND PRINT THE
C     ANGLES.
C        LDIPL1    LOADS N(I+1) AND CA(I+1) INTO XYZ
C        LDMNS1    LOADS C(I-1) AND ZEROS INLOC
C        LDCRR1    LOADS CURRES INTO XYZ
C        OMEGA     CALCULATES AND PRINTS THE ANGLES
C     THESE ROUTINES HANDLE THE CASE OF UP TO 5 DIFFERENT ALTERNATE
C     LOCATIONS IN THE (I-1),(I) AND (I+1) RESIDUE.
C
C     THE FOLLOWING VARIABLES ARE USED TO STORE CHARACTERS
C     NRESCR,NCHNCR,INSCCR,NAMECR,NALTCR
C     NRES,NCHN,INSC,NALT1,NALT2,NALT3
C     IDSET
C
      DIMENSION NSERCR(100), NAMECR(100), NALTCR(100)
      DIMENSION ATMXCR(100), ATMYCR(100), ATMZCR(100)
      DIMENSION XYZ(3,60), INLOC(60)
      DIMENSION NALT1(5), NALT2(5), NALT3(5)
C
      COMMON /CURRES/ NALLCR,NRESCR,NCHNCR,NSEQCR,INSCCR,NSERCR,NAMECR,N
     1ALTCR,ATMXCR,ATMYCR,ATMZCR
C
      COMMON /RES1/ XYZ,INLOC
      COMMON /RES2/ NRES,NCHN,NSEQ,INSC,IALT,ICAN,NALT1,NALT2,NALT3
      COMMON /HEADER/ IDSET
C
      COMMON /LDRLCL/ LINENO,IPAGE
C
C
      DATA MAXLIN/60/
      DATA LPTR/20/
C
C     MAKE SURE WE HAVE AN AMINO ACID
C
      CALL ISRSAA (NRESCR,IRES)
      IF (IRES.EQ.0) GO TO 50
      IF (INRES.NE.1) GO TO 10
C
C     FOR INITIAL ENTRY WE CANNOT CALCULATE PHI
C     FORCE A NEW PAGE AND WRITE OUT A HEADER
C
      IPAGE=0
      LINENO=MAXLIN+1
      CALL NEWLIN (IDSET,LINENO,IPAGE)
      WRITE (LPTR,60)
      INRES=2
      GO TO 40
C
C     LOAD C-ALPH(I+1) AND N (I+1)
C
   10 CALL LDIPL1 (ITIMES)
      IALRES=IALRES+1
C
C
C     IALT=NUMBER OF DIFFERENT ALTERNATE CODES IN RES(I)
C     ITIMES= NUMBER OF DIFFERENT ALTERNATE CODES IN RES(I+1)
C     ICAN= NUMBER OF DIFFERENT ALTERNATE CODES IN RES(I-1)
C
      DO 30 I=1,IALT
      DO 30 J=1,ITIMES
      DO 30 K=1,ICAN
C
C     MAKE SURE WE STILL HAVE ENOUGH LINES FOR A RESIDUE
C
      IF ((LINENO+2).LE.MAXLIN) GO TO 20
      LINENO=MAXLIN+1
      CALL NEWLIN (IDSET,LINENO,IPAGE)
      WRITE (LPTR,60)
      GO TO 20
C
   20 CONTINUE
C
C     CALCULATE AND PRINT ANGLES
C
      CALL OMEGA (I,J,K,IOUT)
      CALL NEWLIN (IDSET,LINENO,IPAGE)
      CALL NEWLIN (IDSET,LINENO,IPAGE)
      IF (LINENO.LE.6) WRITE (LPTR,60)
   30 CONTINUE
C
C     LOAD C(I-1) AND RESET INLOC
C
      CALL LDMNS1
C
C     LOAD CURRES INTO XYZ
C
   40 CALL LDCRR1
      GO TO 50
C
   50 RETURN
C
   60 FORMAT (1H0,22X,3HPHI,5X,3HPSI,3X,5HOMEGA,4X,4HCHI1,4X,4HCHI2,4X,4
     1HCHI3,4X,4HCHI4,/)
      END
      SUBROUTINE LDIPL1 (ILT)
C
C     THIS ROUTINE LOADS C-ALPHA (I+1) AND N (I+1) INTO RES1
C     N(I+1) IS LOADED INTO LOC(10) OF XYZ
C     C-ALPHA(I+1) IS LOADED INTO LOC(11) OF XYZ
C     ILT IS THE NUMBER OF ALTERNATE LOCATIONS WHICH OCCUR FOR THESE
C     TWO ATOMS
C     THE FOLLOWING VARIABLES ARE USED TO STORE CHARACTERS
C     NRESCR,NCHNCR,INSCCR,NAMECR,NALTCR
C     NRES,NCHN,INSC,NALT1,NALT2,NALT3
C     NRESTM,NCHNTM,INSCTM,NAMETM,NALTTM
C     ICALPH,NITR,IBLANK
C
      DIMENSION NSERCR(100), NAMECR(100), NALTCR(100)
      DIMENSION ATMXCR(100), ATMYCR(100), ATMZCR(100)
      DIMENSION NSERTM(100), NAMETM(100), NALTTM(100)
      DIMENSION ATMXTM(100), ATMYTM(100), ATMZTM(100)
      DIMENSION NALT1(5), NALT2(5), NALT3(5)
      DIMENSION XYZ(3,60), INLOC(60)
C
      COMMON /CURRES/ NALLCR,NRESCR,NCHNCR,NSEQCR,INSCCR,NSERCR,NAMECR,N
     1ALTCR,ATMXCR,ATMYCR,ATMZCR
C
      COMMON /RES1/ XYZ,INLOC
      COMMON /RES2/ NRES,NCHN,NSEQ,INSC,IALT,ICAN,NALT1,NALT2,NALT3
C
      COMMON /TMPRES/ NALLTM,NRESTM,NCHNTM,NSEQTM,INSCTM,NSERTM,NAMETM,N
     1ALTTM,ATMXTM,ATMYTM,ATMZTM
C
!     DATA INTOTM/1/,INTOCR/2/,ICALPH/4H CA /,NITR/4H N  /
      DATA INTOTM/1/,INTOCR/2/,ICALPH/' CA '/,NITR/' N  '/
!     DATA IBLANK/1H /
      DATA IBLANK/' '/
C
      IDEN(I,J)=I-J
C
C     LOAD CURRES INTO TMPRES SO THAT CURRES IS AVAILABLE FOR LOCAL TASK
C     THIS IS DONE TO BE ABLE TO COUNT ILT
C
      IDIR=INTOTM
      CALL PUSHRS (IDIR)
      NALLCR=0
C
C     LOAD CURRES WITH CALPHA AND N
C
      DO 10 J=1,NALLTM
      IF (.NOT.((IDEN(NAMETM(J),ICALPH).EQ.0).OR.(IDEN(NAMETM(J),NITR).E
     1Q.0))) GO TO 10
      NALLCR=NALLCR+1
      NAMECR(NALLCR)=NAMETM(J)
      NALTCR(NALLCR)=NALTTM(J)
      ATMXCR(NALLCR)=ATMXTM(J)
      ATMYCR(NALLCR)=ATMYTM(J)
      ATMZCR(NALLCR)=ATMZTM(J)
   10 CONTINUE
C
C     NOW COUNT HOW MANY ALTERNATE LOCATIONS EXIST
C
      CALL CNTALT (ILT,NALT3)
C
C     LOAD RES1 WITH ALL OCCURENCES OF C-ALPHA(I+1) AND N(I+1)
C
      DO 30 I=1,ILT
      DO 30 J=1,NALLCR
C
      IF (.NOT.(IDEN(NAMECR(J),ICALPH).EQ.0)) GO TO 20
      IF (.NOT.((IDEN(NALTCR(J),IBLANK).EQ.0).OR.(IDEN(NALTCR(J),NALT3(I
     1)).EQ.0))) GO TO 30
C
C     C-ALPHA(I+1) IS IN LOC(11)
C
      J1=(I-1)*11+11
      INLOC(J1)=1
      XYZ(1,J1)=ATMXCR(J)
      XYZ(2,J1)=ATMYCR(J)
      XYZ(3,J1)=ATMZCR(J)
      GO TO 30
C
   20 IF (.NOT.(IDEN(NAMECR(J),NITR).EQ.0)) GO TO 30
      IF (.NOT.((IDEN(NALTCR(J),IBLANK).EQ.0).OR.(IDEN(NALTCR(J),NALT3(I
     1)).EQ.0))) GO TO 30
C
C     N(I+1) IS IN LOC(10)
C
      J1=(I-1)*11+10
      INLOC(J1)=1
      XYZ(1,J1)=ATMXCR(J)
      XYZ(2,J1)=ATMYCR(J)
      XYZ(3,J1)=ATMZCR(J)
      GO TO 30
C
   30 CONTINUE
C
C     LOAD CURRES FROM TMPRES
C
      IDIR=INTOCR
      CALL PUSHRS (IDIR)
      RETURN
      END
      SUBROUTINE PUSHRS (IDIR)
C
C     THIS SUBROUTINE IS CALLED TO LOAD/UNLOAD BETWEEN CURRES AND TMPRES
C     THE FOLLOWING VARIABLES ARE USED TO STORE CHARACTERS
C     NRESCR,NCHNCR,INSCCR,NAMECR,NALTCR
C     NRESTM,NCHNTM,INSCTM,NAMETM,NALTTM
C
      DIMENSION NSERCR(100), NAMECR(100), NALTCR(100)
      DIMENSION ATMXCR(100), ATMYCR(100), ATMZCR(100)
      DIMENSION NSERTM(100), NAMETM(100), NALTTM(100)
      DIMENSION ATMXTM(100), ATMYTM(100), ATMZTM(100)
C
      COMMON /CURRES/ NALLCR,NRESCR,NCHNCR,NSEQCR,INSCCR,NSERCR,NAMECR,N
     1ALTCR,ATMXCR,ATMYCR,ATMZCR
      COMMON /TMPRES/ NALLTM,NRESTM,NCHNTM,NSEQTM,INSCTM,NSERTM,NAMETM,N
     1ALTTM,ATMXTM,ATMYTM,ATMZTM
C
      DATA INTOCR/2/,INTOTM/1/
C
      IF (IDIR.NE.INTOTM) GO TO 20
C
C     LOAD FROM TMPRES TO CURRES
C
      NALLTM=NALLCR
      NRESTM=NRESCR
      NCHNTM=NCHNCR
      NSEQTM=NSEQCR
      INSCTM=INSCCR
      DO 10 J=1,NALLCR
      NSERTM(J)=NSERCR(J)
      NAMETM(J)=NAMECR(J)
      NALTTM(J)=NALTCR(J)
      ATMXTM(J)=ATMXCR(J)
      ATMYTM(J)=ATMYCR(J)
      ATMZTM(J)=ATMZCR(J)
   10 CONTINUE
      GO TO 40
C
C     LOAD FROM CURRES TO TMPRES
C
   20 IF (IDIR.NE.INTOCR) GO TO 40
      NALLCR=NALLTM
      NRESCR=NRESTM
      NCHNCR=NCHNTM
      NSEQCR=NSEQTM
      INSCCR=INSCTM
      DO 30 J=1,NALLTM
      NSERTM(J)=NSERCR(J)
      NAMECR(J)=NAMETM(J)
      NALTCR(J)=NALTTM(J)
      ATMXCR(J)=ATMXTM(J)
      ATMYCR(J)=ATMYTM(J)
      ATMZCR(J)=ATMZTM(J)
   30 CONTINUE
      GO TO 40
C
   40 RETURN
      END
      SUBROUTINE LDMNS1
C
C     LOADS C(I-1) INTO RES1 AND ZEROES OUT INLOC
C     C(I-1) IS LOADED FROM CURRENT CONTENTS OF LOC(4) IN XYZ TO LOC(1)
C     ICAN IS THE NUMBER OF UNIQUE ALTERNATE LOCATIONS IN C(I-1)
C     THE FOLLOWING VARIABLES ARE USED TO STORE CHARACTERS
C     NRES,NCHN,INSC,NALT1,NALT2,NALT3
C     IBLANK
C
      DIMENSION NALT1(5), NALT2(5), NALT3(5)
      DIMENSION XYZ(3,60), INLOC(60)
C
C
      COMMON /RES1/ XYZ,INLOC
      COMMON /RES2/ NRES,NCHN,NSEQ,INSC,IALT,ICAN,NALT1,NALT2,NALT3
!     DATA IBLANK/1H /
      DATA IBLANK/' '/
C
      ICAN=1
C
C     ZERO OUT LOCATION INDICATOR FOR C(I-1)
C
      DO 10 I=1,5
      I1=(I-1)*11+1
   10 INLOC(I1)=0
C
C
C     LOOK FOR OCCURENCES OF C(I-1) AND LOAD IT INTO LOC(1)
C
      DO 20 I=1,IALT
      I1=(I-1)*11+4
      IF (INLOC(I1).NE.0) GO TO 30
   20 CONTINUE
C
C     THERE ARE NO C(I) SO NONE CAN BE LOADED
C
      GO TO 90
C
   30 CONTINUE
      XYZ(1,1)=XYZ(1,I1)
      XYZ(2,1)=XYZ(2,I1)
      XYZ(3,1)=XYZ(3,I1)
      INLOC(1)=1
      IST=2
      NALT1(1)=NALT2(I)
      IF (IST.GT.IALT) GO TO 90
C
C     NOW WE SEE IF THERE ARE ANY MORE UNIQUE C(I) TO LOAD
C
      DO 80 I=IST,IALT
      I2=(I-1)*11+4
      IF (INLOC(I2).EQ.0) GO TO 80
C
C     WE HAVE ANOTHER C(I) SEE IF WE ALREADY HAVE IT STORED
C
      DO 50 J=1,ICAN
      J2=(J-1)*11+1
      DO 40 K=1,3
      IF (ABS(XYZ(K,I2)-XYZ(K,J2)).GT.1.0E-5) GO TO 60
   40 CONTINUE
   50 CONTINUE
      GO TO 80
C
C     UPDATE NUMBER OF ALTERNATE CODES FOR C(I-1)
C
   60 ICAN=ICAN+1
      I1=(ICAN-1)*11+1
      DO 70 K=1,3
   70 XYZ(K,I1)=XYZ(K,I2)
      INLOC(I1)=1
      NALT1(ICAN)=NALT2(I)
      GO TO 80
C
   80 CONTINUE
C
C     RESET INLOC
C
   90 DO 100 K=2,11
      DO 100 I=1,5
      I1=(I-1)*11+K
      INLOC(I1)=0
  100 CONTINUE
C
C     FOR ONE ALTERNATE CODE, JUST USE A BLANK
C
      IF (ICAN.LE.1) NALT1(ICAN)=IBLANK
      RETURN
      END
      SUBROUTINE LDCRR1
C
C     LOADS RES1 AND RES2 FROM CURRES
C     IALT DEFINES THE NUMBER OF UNIQUE ALTERNATE LOCATIONS IN RES(I)
C     ATOMS ARE LOADED INTO LOCATIONS IN XYZ DEPENDING ON THE ATOM NAME
C
C     THE FOLLOWING VARIABLES ARE USED TO STORE CHARACTERS
C     NRESCR,NCHNCR,INSCCR,NAMECR,NALTCR
C     NRESTM,NCHNTM,INSCTM,NAMETM,NALTTM
C     NRES,NCHN,INSC,NALT1,NALT2,NALT3
C     IATMNM,NALTUQ,IBLANK
C
      DIMENSION NSERTM(100), NAMETM(100), NALTTM(100)
      DIMENSION ATMXTM(100), ATMYTM(100), ATMZTM(100)
      DIMENSION NSERCR(100), NAMECR(100), NALTCR(100)
      DIMENSION ATMXCR(100), ATMYCR(100), ATMZCR(100)
      DIMENSION XYZ(3,60), INLOC(60), INDIC(42)
      DIMENSION NALT1(5), NALT2(5), NALT3(5)
      DIMENSION IATMNM(42)
C
      COMMON /CURRES/ NALLCR,NRESCR,NCHNCR,NSEQCR,INSCCR,NSERCR,NAMECR,N
     1ALTCR,ATMXCR,ATMYCR,ATMZCR
      COMMON /TMPRES/ NALLTM,NRESTM,NCHNTM,NSEQTM,INSCTM,NSERTM,NAMETM,N
     1ALTTM,ATMXTM,ATMYTM,ATMZTM
      COMMON /RES1/ XYZ,INLOC
      COMMON /RES2/ NRES,NCHN,NSEQ,INSC,IALT,ICAN,NALT1,NALT2,NALT3
C
      DATA (INDIC(I),I=1,42)/2,3,4,5,5*6,6*7,5*8,2*9,20*0/
!     DATA (IATMNM(I),I=1,42)/4H N  ,4H CA ,4H C  ,4H CB ,4H CG ,4H CG1,
!    &4H OG ,4H OG1,4H SG ,4H CD ,4H CD1,4H ND1,4H OD1,4H AD1,4H SD ,
!    &4H CE ,4H CE1,4H NE ,4H OE1,4H AE1,4H CZ ,4H NZ ,4H O  ,4H CG2,
!    &4H CD2,4H ND2,4H OD2,4H AD2,4H CE2,4H CE3,4H NE1,4H NE2,4H OE2, 
!    &4H AE2,4H CZ2,4H CZ3,4H CH2,4H NH1,4H NH2,4H OH ,4H OXT,4H OE /
! Replace hollerick
      DATA (IATMNM(I),I=1,42)/' N  ',' CA ',' C  ',' CB ',' CG ',' CG1',
     &' OG ',' OG1',' SG ',' CD ',' CD1',' ND1',' OD1',' AD1',' SD ',
     &' CE ',' CE1',' NE ',' OE1',' AE1',' CZ ',' NZ ',' O  ',' CG2',
     &' CD2',' ND2',' OD2',' AD2',' CE2',' CE3',' NE1',' NE2',' OE2', 
     &' AE2',' CZ2',' CZ3',' CH2',' NH1',' NH2',' OH ',' OXT',' OE '/
      DATA INTOTM/1/
!     DATA IBLANK/1H /
      DATA IBLANK/' '/
C
      IDEN(I,J)=I-J
C
      IDIR=INTOTM
      CALL PUSHRS (IDIR)
      NALLCR=0
      DO 10 I=1,NALLTM
      DO 10 J=1,22
      IF (IDEN(NAMETM(I),IATMNM(J)).NE.0) GO TO 10
C
C     THIS IS AN ATOM THAT IS NEEDED FOR CALCULATION
C
      NALLCR=NALLCR+1
      NSERCR(NALLCR)=NSERTM(I)
      NAMECR(NALLCR)=NAMETM(I)
      NALTCR(NALLCR)=NALTTM(I)
      ATMXCR(NALLCR)=ATMXTM(I)
      ATMYCR(NALLCR)=ATMYTM(I)
      ATMZCR(NALLCR)=ATMZTM(I)
   10 CONTINUE
C
C     COUNT HOW MANY ALTERNATE LOCATIONS OCCUR IN CURRES
C
      CALL CNTALT (IALT,NALT2)
C
      DO 50 J=1,IALT
      DO 50 I=1,NALLCR
      K=1
   20 IF (IDEN(NAMECR(I),IATMNM(K)).EQ.0) GO TO 30
      K=K+1
C
C     ATOM IS NOT IN THE LIST ,DO NOT LOAD IT
C
      IF (K.LE.22) GO TO 20
      I1=0
      GO TO 40
C
C     CALCULATE FOR THE ATOMS POSITION IN RES1
C
   30 IF (.NOT.((IDEN(NALTCR(I),IBLANK).EQ.0).OR.(IDEN(NALTCR(I),NALT2(J
     1)).EQ.0))) GO TO 50
      I1=INDIC(K)
      I1=(J-1)*11+I1
      GO TO 40
C
   40 IF (I1.EQ.0) GO TO 50
      XYZ(1,I1)=ATMXCR(I)
      XYZ(2,I1)=ATMYCR(I)
      XYZ(3,I1)=ATMZCR(I)
      INLOC(I1)=1
      GO TO 50
C
   50 CONTINUE
C
C     PUSH CONTENTS INTO RES2
C
      NRES=NRESCR
      NCHN=NCHNCR
      NSEQ=NSEQCR
      INSC=INSCCR
      GO TO 60
C
   60 RETURN
      END
      SUBROUTINE OMEGA (IL,IN,IC,IOUT)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif

C
C     THIS ROUTINE DOES THE ACTUAL TORSION ANGLE CALCULATION
C
C     THE FOLLOWING VARIABLES ARE USED TO STORE CHARACTERS
C     NRES,NCHN,INSC,NALT1,NALT2,NALT3
C     LABL1,LABL2,IDSET
C
      DIMENSION NALT1(5), NALT2(5), NALT3(5)
      DIMENSION XYZ(3,60), INLOC(60)
      DIMENSION ANGLE(7)
      DIMENSION IPTR1(24), IPTR2(24), IBONDS(114)
      DIMENSION KODE(4,7)
C
      COMMON /RES1/ XYZ,INLOC
      COMMON /RES2/ NRES,NCHN,NSEQ,INSC,IALT,ICAN,NALT1,NALT2,NALT3
      COMMON /HEADER/ IDSET
C
      INCLUDE 'COMMON.TYYY'
C
!     DATA LABL1/4HTORA/,LABL2/2HNG/
      DATA LABL1/'TORA'/,LABL2/'NG'/
      DATA ((KODE(I,J),I=1,4),J=1,7)/1,2,3,4,2,3,4,10,3,4,10,11,2,3,5,6,
     13,5,6,7,5,6,7,8,6,7,8,9/
      DATA (IPTR1(I),I=1,24)/1,4,9,13,18,24,29,32,37,42,49,54,60,65,68,7
     14,81,85,89,93,98,103,109,112/
      DATA (IPTR2(I),I=1,24)/3,5,4,5,6,5,3,5,5,7,5,6,5,3,6,7,4,4,4,5,5,6
     1,3,3/
      DATA (IBONDS(I),I=1,114)/1,2,3,1,2,3,4,5,1,2,3,4,1,2,3,4,5,1,2,3,4
     1,5,6,1,2,3,4,5,1,2,3,1,2,3,4,5,1,2,3,4,5,1,2,3,4,5,6,7,1,2,3,4,5,1
     2,2,3,4,5,6,1,2,3,4,5,1,2,3,1,2,3,4,5,6,1,2,3,4,5,6,7,1,2,3,4,1,2,3
     3,4,1,2,3,4,1,2,3,4,5,1,2,3,4,5,1,2,3,4,5,6,1,2,3,1,2,3/
C
      DATA LPTR/20/
C
C     GET THE RESIDUE TYPE CODE
C
      CALL ISRSAA (NRES,IRES)
C
C     GET THE NUMBER OF BONDS IN  THIS RESIDUE AND ITS LOCATION IN BOND
C
      NB=IPTR2(IRES)
      IST=IPTR1(IRES)
C
      DO 10 L=1,7
   10 ANGLE(L)=-999.
C
C
      DO 80 L=1,NB
C
      IBTYPE=IBONDS(IST)
C
      I1=KODE(1,IBTYPE)
      I2=KODE(2,IBTYPE)
      I3=KODE(3,IBTYPE)
      I4=KODE(4,IBTYPE)
C
C     SEE IF IT IS A C(I-1)
C
      IF (I1.NE.1) GO TO 20
C
C     RETRIEVE IT IN RES1 DEPENDING ON THE ALTERNATE LOCATOR IC
C
      I1=(IC-1)*11+I1
      GO TO 30
C
C     RETRIEVE IT IN RES1 DEPENDING ON THE ALTERNATE LOCATOR IL
C
   20 I1=(IL-1)*11+I1
      GO TO 30
C
C     SEE IF IT IS A N(I+1)
C
   30 IF (I3.NE.10) GO TO 40
C
C     RETRIEVE IT IN RES1 DEPENDING ON THE ALTERNATE LOCATOR IN
C
      I3=(IN-1)*11+I3
      GO TO 50
C
C     RETRIEVE IT IN RES1 DEPENDING ON THE ALTERNATE LOCATOR IL
C
   40 I3=(IL-1)*11+I3
      GO TO 50
C
   50 IF (.NOT.((I4.EQ.10).OR.(I4.EQ.11))) GO TO 60
C
C     RETRIEVE IT IN RES1 DEPENDING ON THE ALTERNATE LOCATOR IN
C
      I4=(IN-1)*11+I4
      GO TO 70
C
C     RETRIEVE IT IN RES1 DEPENDING ON THE ALTERNATE LOCATOR IL
C
   60 I4=(IL-1)*11+I4
      GO TO 70
C
   70 I2=(IL-1)*11+I2
C
C     CHECK TO SEE IF THERE ARE ANY MISSING ATOMS
C
      ITMP=INLOC(I1)+INLOC(I2)+INLOC(I3)+INLOC(I4)
      IF (ITMP.NE.4) GO TO 80
C
      ANGLE(IBTYPE)=TORCHK(XYZ(1,I1),XYZ(1,I2),XYZ(1,I3),XYZ(1,I4))
      GO TO 80
   80 IST=IST+1
C
C     PRINT THE ANGLES
C
      IF (IOUT.NE.2) GO TO 90
C     WRITE (IOUT,100) LABL1,LABL2,NRES,NCHN,NSEQ,INSC,NALT1(IC),NALT2(I
C    1L),NALT3(IN),(ANGLE(I),I=1,7),IDSET
C     write (   4,101) nseq, (angle(i),i=1,7)
  101 format ( i4,6x,8f8.2)
C   STORE ANGLES                                        DR  MAR94
      WRITE (LPTR,101) nseq, (angle(i),i=1,7)
      iaddrs=nseq-ifrstrs+1
      do i=1,7
        angela(i,iaddrs)=angle(i)
      enddo
      lasres=nseq
   90 CONTINUE
      CALL ANGOUT (IL,IN,IC,ANGLE)
      RETURN
C
  100 FORMAT (A4,A2,1X,A3,A1,I4,4A1,7(F7.2),2X,A4)
      END
      SUBROUTINE ANGOUT (IL,IN,IC,ANGLE)
C
C     THIS SUBROUTINE PRINTS THE ANGLES IN ALPHANUMERIC FORM
C     THE FOLLOWING VARIABLES ARE USED TO STORE CHARACTERS
C     NRES,NCHN,INSC,NALT1,NALT2,NALT3
C     IBLANK,IDSET,LINE
C     I1
C
      DIMENSION NALT1(5), NALT2(5), NALT3(5)
      DIMENSION ANGLE(7), LINE(14)
C
      COMMON /HEADER/ IDSET
      COMMON /RES2/ NRES,NCHN,NSEQ,INSC,IALT,ICAN,NALT1,NALT2,NALT3
!     DATA IBLANK/4H    /,LPTR/20/
      DATA IBLANK/'    '/,LPTR/20/
C
C     THIS DATA STATEMENT IS NEEDED WHEN ENCODE/DECODE IS DONE VIA
C     FILE TAPE3
C
      DATA ISCR/3/
C
      IDEN(I,J)=I-J
C
C     CONVERT THE ANGLES TO ALPHANUMERIC
C
      DO 20 I=1,7
      I1=7+I
      IF (ANGLE(I).GT.-999.) GO TO 10
      LINE(I1)=IBLANK
      GO TO 20
C
   10 CONTINUE
      I2=IFIX(ANGLE(I)+(SIGN(0.5,ANGLE(I))))
C
C     THIS CODE IS USED TO SIMULATE AN ENCODE/DECODE SEQUENCE
C
      REWIND ISCR
      WRITE(ISCR,50) I2
 1010 FORMAT(A4)
      REWIND ISCR
      READ (ISCR,1010) LINE(I1)
C
clg   ENCODE (4,50,LINE(I1) )I2
C
   20 CONTINUE
      I1=LINE(10)
      LINE(10)=IBLANK
C
      LINE(1)=NRES
      LINE(2)=NCHN
      LINE(4)=INSC
C
C     THIS CODE IS USED TO SIMULATE AN ENCODE/DECODE SEQUENCE
C
      REWIND ISCR
      WRITE(ISCR,50) NSEQ
      REWIND ISCR
      READ(ISCR,1010) LINE(3)
clg   ENCODE (4,50,LINE(3) )NSEQ
C
      IF (.NOT.((IDEN(NALT1(IC),IBLANK).EQ.0).AND.(IDEN(NALT2(IL),IBLANK
     1).EQ.0).AND.(IDEN(NALT3(IN),IBLANK).EQ.0))) GO TO 30
      LINE(5)=IBLANK
      LINE(6)=IBLANK
      LINE(7)=IBLANK
      WRITE (LPTR,60) LINE
      WRITE (LPTR,70) I1
      GO TO 40
C
   30 LINE(5)=NALT1(IC)
      LINE(6)=NALT2(IL)
      LINE(7)=NALT3(IN)
      WRITE (LPTR,80) LINE
      WRITE (LPTR,70) I1
   40 RETURN
C
   50 FORMAT (I4)
   60 FORMAT (1X,A3,1X,A1,1X,A4,A1,1X,3A1,5X,A4,6(4X,A4))
   70 FORMAT (37X,A4)
   80 FORMAT (1X,A3,1X,A1,1X,A4,A1,1X,1H(,A1,1H,,A1,1H,,A1,1H),1X,A4,6(4
     1X,A4))
      END
      SUBROUTINE POSNAM (IFLNAM,IER,IBUF,JCODE)
C
C     THIS ROUTINE IS USED TO POSITION FILE IPDB BY NAME.
C
C     THE FOLLOWING VARIABLES ARE USED TO STORE CHARACTERS
C     IBUF,IFLNAM,IFINI,IDSET
C
C     PARAMETERS PASSED TO/FROM CALLING PROGRAM
C        IFLNAM    FOUR CHARACTER PROTEIN DATA BANK ENTRY NAME
C        IER       ERROR CODE, ZERO FOR NO ERROR, NON-ZERO OTHERWISE
C        IBUF      CONTENTS OF A RECORD FROM IPDB
C        JCODE     INTEGER GIVING THE RECORD TYPE
C
      DIMENSION IBUF(20)
C
      COMMON /HEADER/ IDSET
C
!      DATA IFINI/4HFINI/,ITERM/-50/,IHEAD/1/
      DATA IFINI/'FINI'/,ITERM/-50/,IHEAD/1/
      DATA LPTR/20/
C
      IDEN(I,J)=I-J
C
      IER=0
C
   10 CALL GETREC (IBUF,JCODE)
C
C     TEST FOR END OF DATA BASE
C
      IF (JCODE.NE.ITERM) GO TO 20
      GO TO 30
C
C
   20 IF (JCODE.NE.IHEAD) GO TO 10
      CALL NTRPRT (IBUF,JCODE)
      IF (IDEN(IDSET,IFINI).EQ.0) GO TO 30
      IF (IDEN(IDSET,IFLNAM).EQ.0) GO TO 40
      GO TO 10
C
C     ERROR SINKS
C
   30 IER=3
      WRITE (LPTR,50)
      GO TO 40
C
C
   40 RETURN
C
   50 FORMAT (53H0ERROR IN POSNAM--- END OF DATA BASE HAS BEEN REACHED)
      END
      SUBROUTINE PRNTXT (IBUF,JCODE)
C
C     THIS ROUTINE HANDLES TEXT PRINTOUT
C     THE PROGRAM HANDLES THE FOLLOWING RECORD TYPES DIFFERENTLY
C        A) HEADER      PRINTS ONLY DATE AND ENTRY CODE
C     FOR THE FOLLOWING RECORD TYPES, AN APPROPRIATE HEADER AND THE
C     CONTENTS OF THE BUFFER FROM COLUMN 11 IS PRINTED.
C        COMPND
C        SOURCE
C        AUTHOR
C
C     FOR OTHER RECORD TYPES THE WHOLE BUFFER IS PRINTED, SHIFTED BY 1
C     COLUMN SPACE.
C
C     THE FOLLOWING VARIABLES ARE USED TO STORE CHARACTERS
C     IBUF,IDATE,LINE,INTRY
C
C     PARAMETERS PASSED TO/FROM CALLING PROGRAM
C        IBUF      CONTENTS OF AN IPDB RECORD TO BE PRINTED
C        JCODE     INTEGER GIVING THE RECORD TYPE
C
C
      DIMENSION IBUF(20)
      DIMENSION IDATE(3)
      DIMENSION LINE(8)
C
      COMMON /TXTCNT/ NCMPD,NSRCE,NAUTHR
C
C
C     THIS DATA STATEMENT IS NEEDED WHEN USING FILE ISCR FOR ENCODE
C
      DATA ISCR/3/
C
      DATA IBEGIN/1/
      DATA IHEAD/1/
      DATA IJRNL/5/
      DATA LPTR/20/
      DATA ICMPD/2/,ISRCE/3/,IAUTH/4/
C
C
      IF (JCODE.GT.IJRNL) GO TO 50
      IF (JCODE.NE.IHEAD) GO TO 10
C
C     HEADER TYPE OF RECORD
C
C
C     THE FOLLOWING STATEMENTS SIMULATE AN ENCODE/DECODE SEQUENCE
C
      REWIND ISCR
      WRITE(ISCR,100 ) (IBUF(I),I=1,20)
      REWIND ISCR
      READ(ISCR,110 ) IDATE,INTRY
C
clg   ENCODE (80,100,LINE(1) )(IBUF(I),I=1,20)
clg   DECODE (80,110,LINE(1) )IDATE,INTRY
      WRITE (LPTR,120) INTRY,IDATE
C
C     INITIALIZE RECORD TYPE COUNTS
C
      NCMPD=IBEGIN
      NSRCE=IBEGIN
      NAUTHR=IBEGIN
      GO TO 60
C
C     SHIFT THE OUTPUT SO AS NOT TO WRITE THE RECORD TYPE
C
C
C     THE FOLLOWING STATEMENTS SIMULATE AN ENCODE/DECODE SEQUENCE
C
   10 REWIND ISCR
      WRITE(ISCR,100 ) (IBUF(I),I=1,20)
      REWIND ISCR
      READ(ISCR,130 ) (IBUF(I),I=1,15)
C
clg10 ENCODE (80,100,LINE(1) )(IBUF(I),I=1,20)
clg   DECODE (80,130,LINE(1) )(IBUF(I),I=1,15)
      IF (JCODE.NE.ICMPD) GO TO 20
      IF (NCMPD.GT.1) GO TO 40
      NCMPD=2
      WRITE (LPTR,70)
      GO TO 40
   20 IF (JCODE.NE.ISRCE) GO TO 30
      IF (NSRCE.GT.1) GO TO 40
      NSRCE=2
      WRITE (LPTR,80)
      GO TO 40
   30 IF (JCODE.NE.IAUTH) GO TO 40
      IF (NAUTHR.GT.1) GO TO 40
      NAUTHR=2
      WRITE (LPTR,90)
      GO TO 40
   40 CONTINUE
      WRITE (LPTR,140) (IBUF(I),I=1,15)
      GO TO 60
C
C     ALL OTHER RECORD TYPES,JUST PRINT THE ENTIRE BUFFER
C
   50 WRITE (LPTR,150) (IBUF(I),I=1,20)
      GO TO 60
C
C
   60 RETURN
C
C
   70 FORMAT (5H0FOR-)
   80 FORMAT (8H0SOURCE-)
   90 FORMAT (14H0DEPOSITED BY-)
  100 FORMAT (20A4)
  110 FORMAT (50X,2A4,A2,2X,A4)
  120 FORMAT (25H1PROTEIN DATA BANK ENTRY ,A4,9H  DATED  ,2A4,A2)
  130 FORMAT (10X,15A4)
  140 FORMAT (1X,15A4)
  150 FORMAT (1X,20A4)
      END
      SUBROUTINE SKIPFL (NFILE,IER)
C
C     THIS ROUTINE POSITIONS THE INPUT FILE IPDB BY SKIPPING NFILE
C     TAPE MARKS.
C     ROUTINE CHECKS FOR END OF DATA BASE TWO WAYS, EITHER BY A
C     JCODE=-50 FOR DOUBLE END OF FILE OR BY A HEADER CARD WITH A FOUR
C     LETTER CODE FINI.
C     THIS ROUTINE COMMUNICATES WITH NTRPRT AND THUS REQUIRES THE COMMON
C     BLOCK HEADER
C
C     THE FOLLOWING VARIABLES ARE USED TO STORE CHARACTERS
C     IBUF,IDSET,IFINI
C
      DIMENSION IBUF(20)
      COMMON /HEADER/ IDSET
C
C
      DATA ITERM/-50/,IHEAD/1/,IEND/31/,IENDFL/-100/
!      DATA IFINI/4HFINI/,IATOM/27/,LPTR/20/
      DATA IFINI/'FINI'/,IATOM/27/,LPTR/20/
C
      IDEN(I,J)=I-J
C
      IER=0
      IEOF=0
      I=1
C
   10 CALL GETREC (IBUF,JCODE)
C
      IF (JCODE.EQ.IATOM) GO TO 60
C
      IF (JCODE.NE.IHEAD) GO TO 20
      CALL NTRPRT (IBUF,JCODE)
      IF (IDEN(IDSET,IFINI).EQ.0) GO TO 70
      GO TO 60
C
   20 IF (JCODE.NE.IEND) GO TO 30
      IEOF=1
      GO TO 40
C
   30 IF (JCODE.NE.IENDFL) GO TO 50
      IF (IEOF.EQ.0) GO TO 40
      IEOF=0
      GO TO 60
C
   40 I=I+1
      IF (I.GT.NFILE) GO TO 80
      GO TO 60
C
   50 IF (JCODE.NE.ITERM) GO TO 60
      GO TO 70
C
   60 GO TO 10
C
C
   70 IER=3
      WRITE (LPTR,90)
C
   80 RETURN
C
   90 FORMAT (43H0END OF DATA BASE HAS BEEN REACHED---SKIPFL)
      END
      SUBROUTINE GETRES (IRC,NINC,INCATM,IBUF,JCODE,JHET)
C
C     THIS ROUTINE COLLECTS ATOMS AND FORMS A COMPLETE RESIDUE
C     A COMPLETE RESIDUE IS DEFINED AS HAVING IDENTICAL CODES IN THE
C     FOLLOWING FIELDS
C        1) RESIDUE NAME
C        2) RESIDUE SEQUENCE NUMBER
C        3) CHAIN NAME
C        4) INSERT CODE
C
C
C     IRC IS THE RETURN CODE
C     IRC = 0 FOR INITIAL ENTRY TO ROUTINE,MUST BE SET BY CALLING PGM.
C     IRC = 1 IBUF CONTAINS A NON-ATOM RECORD TYPE,JCODE HAS THE REC TYP
C     IRC = 2 COMPLETED A RESIDUE IT IS IN CURRES
C
C        NINC      NUMBER OF ATOM NAMES FOUND IN INCATM THAT ARE TO
C                  BE INCLUDED IN ACCUMULATING THE RESIDUE, ALL OTHERS
C                  ARE IGNORED. WHEN THIS IS SET TO ZERO, GETRES WILL
C                  INCLUDE ALL THE ATOMS IN A RESIDUE.
C        INCATM    ARRAY CONTAINING ATOM NAMES, GETRES WILL ACCUMULATE
C                  ONLY THESE ATOMS.
C        IBUF      CONTENTS OF A RECORD FROM IPDB
C        JCODE     INTEGER GIVING THE RECORD TYPE
C        JHET      FLAG TO INDICATE WHETHER HETATMS ARE TO BE PROCESSED
C                  OR NOT.
C                  JHET = 0  PROCESS HETATM
C                  JHET = 1  DO NOT PROCESS HETATM
C
C     THE FOLLOWING VARIABLES ARE USED TO STORE CHARACTERS
C     IBUF,INCATM
C     NAME27,NALT27,NRES27,NCHN27,INSC27
C     NAMECR,NALTCR,NRESCR,NCHNCR,INSCCR
C     NAMEOL,NALTOL,NRESOL,NCHNOL,INSCOL
C
C
C     NEW ATOM CARDS ARE ASSUMED TO HAVE BEEN DEPOSITED IN COMMON AREA
C     NAMED ATOM BY THE ROUTINE NTRPRT
C
      DIMENSION IBUF(20)
      DIMENSION INCATM(20)
      DIMENSION NSERCR(100), NAMECR(100), NALTCR(100)
      DIMENSION ATMXCR(100), ATMYCR(100), ATMZCR(100)
C
      COMMON /ATOM/ NSER27,NAME27,NALT27,NRES27,NCHN27,NSEQ27,INSC27,ATM
     1X27,ATMY27,ATMZ27,OCPN27,TEMP27
C
      COMMON /CURRES/ NALLCR,NRESCR,NCHNCR,NSEQCR,INSCCR,NSERCR,NAMECR,N
     1ALTCR,ATMXCR,ATMYCR,ATMZCR
C
      COMMON /OLDRES/ NSEROL,NAMEOL,NALTOL,NRESOL,NCHNOL,NSEQOL,INSCOL,A
     1TMXOL,ATMYOL,ATMZOL
C
      COMMON /RESLCL/ INOL
C
      DATA IATOM/27/
      DATA IYES/0/,IHET/36/
C
      IDEN(I,J)=I-J
C
      IF (IRC.NE.0) GO TO 10
      INOL=0
      NALLCR=0
      GO TO 20
C
   10 IF (INOL.NE.1) GO TO 20
      INOL=0
      NALLCR=1
      CALL PUSHCR (NRESOL,NCHNOL,NSEQOL,INSCOL,NSEROL,NAMEOL,NALTOL,ATMX
     1OL,ATMYOL,ATMZOL)
      GO TO 20
C
   20 CALL GETREC (IBUF,JCODE)
C
      IF ((JCODE.EQ.IATOM).OR.(JCODE.EQ.IHET.AND.JHET.EQ.IYES)) GO TO 30
C
      IRC=1
      GO TO 90
C
   30 JCODE=27
      CALL NTRPRT (IBUF,JCODE)
C
C     CHECK WHETHER WE WANT THIS ATOM
C
      IF (NINC.EQ.0) GO TO 50
C
      DO 40 J=1,NINC
      IF (IDEN(NAME27,INCATM(J)).EQ.0) GO TO 50
   40 CONTINUE
      GO TO 80
C
   50 IF (NALLCR.LE.0) GO TO 70
      IF (IDEN(NRES27,NRESCR).NE.0) GO TO 60
      IF (IDEN(NSEQ27,NSEQCR).NE.0) GO TO 60
      IF (IDEN(NCHN27,NCHNCR).NE.0) GO TO 60
      IF (IDEN(INSC27,INSCCR).NE.0) GO TO 60
      GO TO 70
C
   60 IRC=2
      INOL=1
      CALL PUSHOL (NSER27,NAME27,NALT27,NRES27,NCHN27,NSEQ27,INSC27,ATMX
     127,ATMY27,ATMZ27)
      GO TO 90
C
   70 NALLCR=NALLCR+1
      CALL PUSHCR (NRES27,NCHN27,NSEQ27,INSC27,NSER27,NAME27,NALT27,ATMX
     127,ATMY27,ATMZ27)
      GO TO 80
C
   80 GO TO 20
C
   90 RETURN
      END
      SUBROUTINE PUSHCR (NRES,NCHN,NSEQ,INSC,NSER,NAME,NALT,ATMX,ATMY,AT
     1MZ)
C
C     THIS ROUTINE DEPOSITS VALUES FOR THE VARIABLES IN THE COMMON
C     AREA CURRES.
C
C     THE FOLLOWING VARIABLES ARE USED TO STORE CHARACTERS
C     NRES,NCHN,INSC,NAME,NALT
C     NRESCR,NCHNCR,INSCCR,NAMECR,NALTCR
C
      DIMENSION NSERCR(100), NAMECR(100), NALTCR(100)
      DIMENSION ATMXCR(100), ATMYCR(100), ATMZCR(100)
C
      COMMON /CURRES/ NALLCR,NRESCR,NCHNCR,NSEQCR,INSCCR,NSERCR,NAMECR,N
     1ALTCR,ATMXCR,ATMYCR,ATMZCR
C
C
      NRESCR=NRES
      NCHNCR=NCHN
      NSEQCR=NSEQ
      INSCCR=INSC
      NSERCR(NALLCR)=NSER
      NAMECR(NALLCR)=NAME
      NALTCR(NALLCR)=NALT
      ATMXCR(NALLCR)=ATMX
      ATMYCR(NALLCR)=ATMY
      ATMZCR(NALLCR)=ATMZ
      RETURN
      END
      SUBROUTINE PUSHOL (NSER,NAME,NALT,NRES,NCHN,NSEQ,INSC,ATMX,ATMY,AT
     1MZ)
C
C     THIS ROUTINE DEPOSITS VALUES FOR THE VARIABLES IN THE COMMON
C     AREA OLDRES
C
C     THE FOLLOWING VARIABLES ARE USED TO STORE CHARACTERS
C     NAME,NALT,NRES,NCHN,INSC
C     NAMEOL,NALTOL,NRESOL,NCHNOL,INSCOL
C
C
      COMMON /OLDRES/ NSEROL,NAMEOL,NALTOL,NRESOL,NCHNOL,NSEQOL,INSCOL,A
     1TMXOL,ATMYOL,ATMZOL
C
      NSEROL=NSER
      NAMEOL=NAME
      NALTOL=NALT
      NRESOL=NRES
      NCHNOL=NCHN
      NSEQOL=NSEQ
      INSCOL=INSC
      ATMXOL=ATMX
      ATMYOL=ATMY
      ATMZOL=ATMZ
C
      RETURN
      END
      SUBROUTINE NTRPRT (IBUF,JCODE)
C
C     THIS ROUTINE DECODES A RECORD TYPE AND STORES THE PERTINENT
C     VARIABLES IN A NAMED COMMON AREA
C     EACH RECORD TYPE WILL BE GIVEN A NAMED COMMON AREA
C
C     REC. NO.                TYPE               JCODE
C        1       HEADER                            1
C        2       COMPND                            2
C        3       SOURCE                            3
C        4       AUTHOR                            4
C        5       JRNL                              5
C        6       REMARK                            6
C        7       FTNOTE                            7
C        8       HET                               8
C        9       HELIX                             9
C        10      SHEET                             10
C        11      TURN                              11
C        12      SITE                              12
C        13      CRYST,CRYST1                      13
C        14      ORIGX,ORIGX1,ORIGX2,ORIGX3        15
C        15      SCALE,SCALE1,SCALE2,SCALE3        19
C        16      MTRIX,MTRIX1,MTRIX2,MTRIX3        23
C        17      ATOM                              27
C        18      TER                               28
C        19      CONECT                            29
C        20      MASTER                            30
C        21      END                               31
C        22      SEQRES                            32
C        23      SSBOND                            33
C        24      FORMUL                            34
C        25      TVECT                             35
C        26      HETATM                            36
C        27      SIGATM                            37
C
C
C     NAMING CONVENTION USED
C        VARIABLE NAMES
C          DEFAULT VARIABLE TYPE IS USED
C          FIRST FOUR LETTERS ARE USER MNEMONICS
C          LAST TWO INDICATE RECORD TYPE
C          FOUR CHARACTERS STORED PER VARIABLE
C
C
C     THIS ROUTINE WILL EXPAND IN THE FUTURE TO HANDLE OTHER RECORD
C     TYPES
C
C     MNEMONICS USED
C        SERIAL NUMBER       -   NSER
C        ATOM NAME           -   NAME
C        ALTERNATE LOCATOR   -   NALT
C        RESIDUE NAME        -   NRES
C        CHAIN ID            -   NCHN
C        RESIDUE SEQ.        -   NSEQ
C        INSERTION CODE      -   INSC
C
C     THE FOLLOWING VARIABLES ARE USED TO STORE CHARACTERS
C     IBUF,LINE,IDSET
C     NAME27,NALT27,NRES27,NCHN27,INSC27
C
C
      DIMENSION IBUF(20)
      DIMENSION LINE(8)
C
      COMMON /ATOM/ NSER27,NAME27,NALT27,NRES27,NCHN27,NSEQ27,INSC27,ATM
     1X27,ATMY27,ATMZ27,OCPN27,TEMP27
C
      COMMON /HEADER/ IDSET
C
      DATA IHEAD/1/,IATOM/27/
C
C     THIS DATA STATEMENT IS NEEDED WHEN FILE ISCR IS USED FOR ENCODE
C
      DATA ISCR/3/
      DATA LPTR/20/
C
C
      NTYPS=37
C
      IF (JCODE.GT.NTYPS) GO TO 40
C
C     JCODE = 27 ATOM RECORD TYPE
C
      IF (JCODE.NE.IATOM) GO TO 10
C
C
C     THE FOLLOWING STATEMENTS SIMULATE AN ENCODE/DECODE SEQUENCE
C
      REWIND ISCR
      WRITE(ISCR,80)  (IBUF(I),I=1,20)
      REWIND ISCR
      READ(ISCR,50) NSER27,NAME27,NALT27,NRES27,NCHN27,
     1              NSEQ27,INSC27,ATMX27,ATMY27,ATMZ27,
     2              OCPN27,TEMP27
C
clg   ENCODE (80,80,LINE(1) )(IBUF(I),I=1,20)
clg   DECODE (80,50,LINE(1) )NSER27,NAME27,NALT27,NRES27,NCHN27,NSEQ27,I
clg  1NSC27,ATMX27,ATMY27,ATMZ27,OCPN27,TEMP27
      GO TO 30
C
C     JCODE = 1  HEADER TYPE OF RECORD
C
   10 IF (JCODE.NE.IHEAD) GO TO 20
C
C
C     THE FOLLOWING STATEMENTS SIMULATE AN ENCODE/DECODE SEQUENCE
C
      REWIND ISCR
      WRITE(ISCR,80)  (IBUF(I),I=1,20)
      REWIND ISCR
      READ(ISCR, 60) IDSET
C
clg   ENCODE (80,80,LINE(1) )(IBUF(I),I=1,20)
clg   DECODE (80,60,LINE(1) )IDSET
      GO TO 30
C
C
   20 GO TO 30
C
C
   30 RETURN
C
C
   40 WRITE (LPTR,70)
      RETURN
C
C
   50 FORMAT (6X,I5,1X,A4,A1,A3,1X,A1,I4,A1,3X,3F8.3,2F6.2,1X,I3)
   60 FORMAT (62X,A4)
   70 FORMAT (27H ERROR IN NTRPRT,.GT. NTYPS)
   80 FORMAT (20A4)
      END
      SUBROUTINE NEWLIN (ITITLE,LINENO,IPAGE)
C
C     THIS ROUTINE IS USED TO CONTROL PAGINATION.
C     THIS ROUTINE SHOULD BE CALLED ONCE FOR EVERY OUTPUT TO LPTR.
C
C     THE FOLLOWING VARIABLES ARE USED TO STORE CHARACTERS
C     ITITLE
C
      DATA MAXLIN/60/
C
C
      LINENO=LINENO+1
      IF (LINENO.LT.MAXLIN) GO TO 10
      IPAGE=IPAGE+1
      CALL NEWPAG (ITITLE,IPAGE)
      LINENO=6
      GO TO 10
C
C
   10 RETURN
      END
      SUBROUTINE NEWPAG (ITITLE,IPAGE)
C
C     THIS ROUTINE IS CALLED TO WRITE OUT A NEW PAGE
C
C     THE FOLLOWING VARIABLES ARE USED TO STORE CHARACTERS
C     ITITLE,IBLANK
C
!     DATA LPTR/20/,IBLANK/1H /
      DATA LPTR/20/,IBLANK/' '/
C
C
      WRITE (LPTR,10) ITITLE,IPAGE
C
C     SKIP TWO LINES
C
      WRITE (LPTR,20) IBLANK
C
      RETURN
C
   10 FORMAT (1H1,26HPROTEIN DATA BANK ENTRY   ,A4,38X,4HPAGE,I5)
   20 FORMAT (1H0,A1)
      END
      SUBROUTINE CNTALT (IALT,NALTUQ)
C
C     THIS ROUTINE COUNTS THE NUMBER OF ALTERNATE LOCATIONS THAT
C     OCCUR.
C
C     IALT IS THE NUMBER OF ALTERNATE LOCATIONS FOUND
C     NALTUQ IS THE ARRAY CONTAINING THE ALTERNATE LOCATION INDICATOR.
C
C     THE FOLLOWING VARIABLES ARE USED TO STORE CHARACTERS
C     NALTUQ,IBLANK
C     NRESCR,NCHNCR,INSCCR,NAMECR,NALTCR
C
      DIMENSION NALTUQ(5)
      DIMENSION NSERCR(100), NAMECR(100), NALTCR(100)
      DIMENSION ATMXCR(100), ATMYCR(100), ATMZCR(100)
      COMMON /CURRES/ NALLCR,NRESCR,NCHNCR,NSEQCR,INSCCR,NSERCR,NAMECR,N
     1ALTCR,ATMXCR,ATMYCR,ATMZCR
!     DATA IBLANK/1H /
      DATA IBLANK/' '/
      IDEN(I,J)=I-J
      IALT=1
      NALTUQ(1)=NALTCR(1)
C
      DO 20 I=1,NALLCR
      DO 10 J=1,IALT
      IF (IDEN(NALTCR(I),NALTUQ(J)).EQ.0) GO TO 20
C
   10 CONTINUE
C
C     WE HAVE A NEW ALTERNATE LOCATION
C
      IALT=IALT+1
      NALTUQ(IALT)=NALTCR(I)
C
   20 CONTINUE
      IF (IALT.EQ.1) GO TO 60
C
C     IF BLANK HAD BEEN PICKED UP AS ONE OF THE ALTERNATE CODE,REMOVE IT
C
      DO 30 J=1,IALT
      IF ((IDEN(NALTUQ(J),IBLANK)).EQ.0) GO TO 40
   30 CONTINUE
      GO TO 60
   40 IF (J.EQ.IALT) GO TO 50
      K=J+1
      NALTUQ(J)=NALTUQ(K)
      J=J+1
      GO TO 40
   50 IALT=IALT-1
      GO TO 60
C
   60 RETURN
      END
      SUBROUTINE GETREC (IBUF,JCODE)
C
C        MODIFIED BY                          DR. MAR94
C     IPDB REPLACED BY JKUNIT, WHICH IS PASSED VIA A COMMON BLOCK.
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif

C 
C     ROUTINE NAME GETREC
C     THIS ROUTINE READS A RECORD FROM THE INPUT FILE IPDB.
C     AND ASSIGNS AN INTEGER CODE TO JCODE DEPENDING ON RECORD TYPE
C
C
C     PRESENT CODE RECOGNIZES 27 RECORD TYPES
C     JCODE IS SET TO -999 FOR UNRECOGNIZED RECORD TYPES
C                     -100 FOR END-OF-FILE
C                      -50 FOR DOUBLE END-OF-FILE
C
C     THE FOLLOWING VARIABLES ARE USED TO STORE CHARACTERS
C     IBUF,ITYP,IATOM,IHET,IREMA
C
C
      DIMENSION IBUF(20)
      DIMENSION ITYP(27)
      DIMENSION NTYP(27)
C
      COMMON /GTRLCL/ IEOF
C
      INCLUDE 'COMMON.TYYY'
C
!     DATA ITYP/4HHEAD,4HCOMP,4HSOUR,4HAUTH,4HJRNL,4HREMA,4HFTNO,4HHET ,
!    14HHELI,4HSHEE,4HTURN,4HSITE,4HCRYS,4HORIG,4HSCAL,4HMTRI,4HATOM,4HT
!    2ER ,4HCONE,4HMAST,4HEND ,4HSEQR,4HSSBO,4HFORM,4HTVEC,4HHETA,4HSIGA
!    3/
C
      DATA ITYP/'HEAD','COMP','SOUR','AUTH','JRNL','REMA','FTNO',
     &'HET ','HELI','SHEE','TURN','SITE','CRYS','ORIG','SCAL','MTRI',
     &'ATOM','TER ','CONE','MAST','END ','SEQR','SSBO','FORM','TVEC',
     &'HETA','SIGA'/
C
      DATA NUNIQT/27/
      DATA NTYP/1,2,3,4,5,6,7,8,9,10,11,12,13,15,19,23,27,28,29,30,31,32
     1,33,34,35,36,37/
C
C     DATA IPDB/1/,ISTART/0/
      DATA ISTART/0/
C
!     DATA IATOM/4HATOM/,IHET/4HHETA/,IREMA/4HREMA/
      DATA IATOM/'ATOM'/,IHET/'HETA'/,IREMA/'REMA'/
C
      IDEN(I,J)=I-J
C
      IF (ISTART.NE.0) GO TO 10
      IEOF=0
      ISTART=1
      GO TO 10
C
   10 JCODE=-999
C
C
CD      READ (IPDB,110,end=80) IBUF
C     READ FROM PDB FILE
C     WRITE (20,*) 'NOW READING PDB FILE IN UNIT =', JKUNIT
      READ (JKUNIT,110,err=80,end=80) IBUF
C WRITE TO MAIN OUTPUT
C     WRITE (20,110) IBUF

clg   IF (EOF(IPDB)) 80,20
C
C     THESE IF STATEMENTS ARE FOR SPEED UP PURPOSES
C     SINCE THE MAJORITY OF RECORDS WILL BE ONE OF THESE
C
   20 IEOF=0
C
C     CHECK FOR ATOM TYPE
C
      IF (IDEN(IBUF(1),IATOM).NE.0) GO TO 30
      JCODE=NTYP(17)
      GO TO 100
C
C     CHECK FOR REMARK
C
   30 IF (IDEN(IBUF(1),IREMA).NE.0) GO TO 40
      JCODE=NTYP(6)
      GO TO 100
C
C     CHECK FOR HET TYPE
C
   40 IF (IDEN(IBUF(1),IHET).NE.0) GO TO 50
      JCODE=NTYP(26)
      GO TO 100
C
   50 DO 60 I=1,NUNIQT
      IF (IDEN(IBUF(1),ITYP(I)).EQ.0) GO TO 70
   60 CONTINUE
C
C     COULD NOT FIND RECORD TYPE
      GO TO 100
C
   70 JCODE=NTYP(I)
      GO TO 100
C
C
   80 IEOF=IEOF+1
      IF (IEOF.LT.2) GO TO 90
      JCODE=-50
      GO TO 100
C
C
   90 JCODE=-100
      GO TO 100
C
C
  100 RETURN
C
C
C
  110 FORMAT (20A4)
      END
      SUBROUTINE ISRSAA (NRES,INUM)
C
C
C     THE FOLLOWING VARIABLES ARE USED TO STORE CHARACTERS
C     NRES,NAMESR
C
C     THIS ROUTINE CHECKS WHETHER A RESUDUE IS AN AMINO ACID
      DIMENSION NAMESR(25)
!     DATA NAMESR/3HALA,3HASX,3HCYS,3HASP,3HGLU,3HPHE,3HGLY,3HHIS,3HILE,
!    13HLYS,3HLEU,3HMET,3HASN,3HPRO,3HGLN,3HARG,3HSER,3HTHR,3HVAL,3HTRP,
!    23HTYR,3HGLX,3HHYP,3HPCA,3HUNK/
      DATA NAMESR/'ALA','ASX','CYS','ASP','GLU','PHE','GLY','HIS','ILE',
     1'LYS','LEU','MET','ASN','PRO','GLN','ARG','SER','THR','VAL','TRP',
     2'TYR','GLX','HYP','PCA','UNK'/

      IDEN(I,J)=I-J
C
      INUM=0
      DO 10 I=1,25
      IF (IDEN(NAMESR(I),NRES).EQ.0) GO TO 20
   10 CONTINUE
C
C     NOT IN THE TABLE
      GO TO 30
C
   20 INUM=I
      GO TO 30
C
   30 RETURN
      END
      FUNCTION TORCHK (A,B,C,D)
C
C     CALCULATE THE TORSION ANGLE FOR FOUR ATOMS
C
C     THE FOUR  THREE-ELEMENT VECTORS A,B,C,D ARE THE COORDINATES (IN A
C     CARTESIAN REFERENCE FRAME) OF THE FOUR ATOMS.
C
      COMMON /VECCOM/ X(12)
      DIMENSION Y(3), P(3), Q(3)
      EQUIVALENCE (X(4),Y(1)), (X(7),P(1)), (X(10),Q(1))
      DIMENSION A(3), B(3), C(3), D(3)
      DIMENSION ZERO(3)
      DATA (ZERO(I),I=1,3)/0.0,0.0,0.0/
      CALL VECDIF (A,B,P)
      CALL DISCHK (P,ICHK)
      IF (ICHK.GT.0) GO TO 10
      CALL VECDIF (C,B,Q)
      CALL DISCHK (Q,ICHK)
      IF (ICHK.GT.0) GO TO 10
      CALL CROSDH (P,Q,X)
      CALL VECDIF (B,C,P)
      CALL VECDIF (D,C,Q)
      CALL DISCHK (Q,ICHK)
      IF (ICHK.GT.0) GO TO 10
      CALL CROSDH (P,Q,Y)
      TORCHK=ANGLEX(X,ZERO,Y)
      CALL CROSDH (X,Y,Q)
      X(1)=DOT_VTF(P,Q)
      IF (X(1).GT.0.0) TORCHK=-TORCHK
      RETURN
   10 TORCHK=-999.0
      RETURN
      END
      SUBROUTINE DISCHK (X,ICHK)
C
C     CHECK TO SEE IF ATOMS ARE WITHIN REASONABLE DISTANCES BEFORE
C     CALCULATING TORSION ANGLES.
C
      DIMENSION X(3)
      ICHK=0
      DSSQ=DOT_VTF(X,X)
      IF ((DSSQ.LT.0.5).OR.(DSSQ.GT.9.00)) ICHK=1
      RETURN
      END
      SUBROUTINE VECDIF (X,Y,Z)
C----SUBTRACT TWO VECTORS AND RETURN THE RESULT IN Z
      DIMENSION X(3), Y(3), Z(3)
      DO 1000 I=1,3
      Z(I) = X(I) - Y(I)
 1000 CONTINUE
      RETURN
      END
      SUBROUTINE CROSDH (X,Y,Z)
C----COMPUTE Z = X CROSS Y
      DIMENSION X(3),Y(3),Z(3)
      Z(1) = X(2)*Y(3) - Y(2)*X(3)
      Z(2) =-X(1)*Y(3) + Y(1)*X(3)
      Z(3) = X(1)*Y(2) - Y(1)*X(2)
      RETURN
      END
      FUNCTION ANGLEX(A,B,C)
C----GET THE ANGLE BETWEEN TWO VECTORS DEFINED BY THE ENDS
C     OF THREE VECTORS
      COMMON /VECCOM/ X(12)
      DIMENSION Y(3)
      EQUIVALENCE (X(4),Y(1))
      DIMENSION A(3),B(3),C(3)
      CALL VECDIF (A,B,X)
      CALL VECDIF (C,B,Y)
      Q = AMAG(X) * AMAG(Y)
      IF (Q .LT. 1.0E-7) Q = 1.0E-7
      ANGLEX = DOT_VTF (X,Y) / Q
      IF(ABS(ANGLEX).GT.1.0) ANGLEX=ANGLEX/ABS(ANGLEX)
      ANGLEX = 57.296 * ACOS (ANGLEX)
      RETURN
      END
      FUNCTION DOT_VTF (X,Y)
C----COMPUTE AND RETURN THE DOT PRODUCT OF X AND Y
      DIMENSION X(3),Y(3)
      DOT = 0.0
      DO 1000 I=1,3
      DOT = DOT + X(I) * Y(I)
 1000 CONTINUE
      DOT_VTF=DOT 
      RETURN
      END
      FUNCTION AMAG (X)
C----GET AND RETURN THE MAGNITUDE OF A VECTOR X
      DIMENSION X(3)
      AMAG = DOT_VTF(X,X)
      AMAG = SQRT(AMAG)
      RETURN
      END
