      SUBROUTINE AMBWRT (R,N,I2)
C THIS SUBROUTINE PRINTS THE GENERATED COORDINATES FOR EACH ATOM
C IN AMBER HISTORY FILE FORMAT (10F8.3)
C
      DIMENSION R(N)
      WRITE (I2,360) R
      RETURN
  360 FORMAT(10F8.3)
      END
      SUBROUTINE DRUANG(NPRIN,IAMCON)
C THIS SUBROUTINE PRINTS DIHEDRAL ANGLES
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      REAL ANGU(maxnum_dihe,maxnum_res)
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.BONDSX'
      INCLUDE 'COMMON.GEN004'
      INCLUDE 'COMMON.GEN002X'
      INCLUDE 'COMMON.GEN000'
      INCLUDE 'COMMON.PRAMX'
      INCLUDE 'COMMON.EDMC'
      INCLUDE 'COMMON.FILES'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.CALC'
      INCLUDE 'COMMON.TRACK'

      LX=  nreg
c            WRITE(6,*)  LX
      IF (NPRIN .EQ. JANG) THEN
C  GENERATING MAX'S ESUMI3 INPUT FILE.
****************************************************************
C Next statements for machines that support the APPEND 
C status in the OPEN statement (e.g. SUN, STARDENT).
C        OPEN (NPRIN,FILE=ANGFILE,STATUS='OLD',ACCESS='APPEND')
#ifdef AIX
         OPEN (NPRIN,FILE=ANGFILE,STATUS='UNKNOWN',POSITION='APPEND')
#else
         OPEN (NPRIN,FILE=ANGFILE,STATUS='UNKNOWN',ACCESS='APPEND')
#endif
         WRITE (NPRIN,'(I10,4E15.6)') IAMCON,ETOT,EES,ENB,EHYDA
C The following WRITE will be activated only after the new standard of
C EDMC is fully introduced, because it changes the form of the *.ang files.
         WRITE (NPRIN,'(20I4)') (LIST(I),I=1,INUMRS)
         XX1=0.0
         NT = IABS(LIST(1))+LX
         NBU = NBOND( IABS( LIST(1) ) )
         IF ( NBU .NE. 0 ) THEN
              DO 390 I=1,NBU
              ANGULO(I,1)=PINORM(ANGULO(I,1))
              ANGU(I,1)=ANGULO(I,1)*DEG
390           CONTINUE
              WRITE(NPRIN,750)  (ANGU(I,1),I=1,NBU )
         ELSE
              WRITE(NPRIN,750) XX1,XX1
         END IF
         DO 850 I=2,INUMRS-1
         NT=IABS(LIST(I))
         DO 851 J=1,NCHI(NT)+3
         ANGULO(J,I)=PINORM(ANGULO(J,I))
         ANGU(J,I)=ANGULO(J,I)*DEG
851      CONTINUE
         WRITE(NPRIN,750) (ANGU(J,I), J=1,NCHI(NT)+3)

850      CONTINUE
         NT = IABS(LIST(INUMRS))+LX
         NBO = NBOND( IABS( LIST(INUMRS) ) )-1
         IF ( NBO .GT. 0 ) THEN
              DO 490 I=1,NBO
              ANGULO(I,INUMRS)=PINORM(ANGULO(I,INUMRS))
              ANGU(I,INUMRS)=ANGULO(I,INUMRS)*DEG
490           CONTINUE
              WRITE(NPRIN,750)  (ANGU(I,INUMRS),I=1,NBO )
         ELSE
              WRITE(NPRIN,750) XX1,XX1
         END IF
C Next statement for machines that support the APPEND access.
C         Next statement for machines that support the APPEND access.
         CLOSE (NPRIN)
      ELSE IF (NPRIN .EQ. JCLSTR) THEN
         OPEN (NPRIN,FILE=CLSTRFILE,STATUS='UNKNOWN')
         JJ = 0
         do J=1, NCON
            IF (LACCEPT(J)) THEN
              JJ=JJ+1

              WRITE(NPRIN, '(I10,4E15.6)' ) niterat(j), enemin(j)
              WRITE(NPRIN, '(20I4)' ) (listmin(k,j), k=1,inumrs)
              XX1=0.0
              NT = IABS(LISTMIN(1,J))+LX
              NBU = NBOND( IABS( LISTMIN(1,J) ) )
              IF ( NBU .NE. 0 ) THEN
                 DO I=1,NBU
                   ANGULO(I,1)=PINORM(ANGMIN(I,1,J))
                   ANGU(I,1)=ANGULO(I,1)*DEG
                   ENDDO
                 WRITE(NPRIN,750)  (ANGU(I,1),I=1,NBU )
              ELSE
                   WRITE(NPRIN,750) XX1,XX1
              END IF
              DO I=2,INUMRS-1
                 NT=IABS(LISTMIN(I,J))
                 DO K=1,NCHI(NT)+3
                   ANGULO(K,I)=PINORM(ANGMIN(K,I,J))
                   ANGU(K,I)=ANGULO(K,I)*DEG
                 ENDDO
                 WRITE(NPRIN,750) (ANGU(K,I), K=1,NCHI(NT)+3)

              ENDDO
              NT = IABS(LISTMIN(INUMRS,J))+LX
              NBO = NBOND( IABS( LISTMIN(INUMRS,J) ) )-1
              IF ( NBO .GT. 0 ) THEN
                 DO I=1,NBO
                   ANGULO(I,INUMRS)=PINORM(ANGMIN(I,INUMRS,J))
                   ANGU(I,INUMRS)=ANGULO(I,INUMRS)*DEG
                 ENDDO
                 WRITE(NPRIN,750)  (ANGU(I,INUMRS),I=1,NBO )
              ELSE
                 WRITE(NPRIN,750) XX1,XX1
              END IF
            ENDIF
         ENDDO
 
         CLOSE (NPRIN)

      ELSE
         WRITE(NPRIN,1003)
         NT = IABS(LIST(1))+LX
         NBU = NBOND( IABS( LIST(1) ) )
         IF ( NBU .NE. 0 ) THEN
            DO 3090 I=1,NBU
            ANGULO(I,1)=PINORM(ANGULO(I,1))
            ANGU(I,1)=ANGULO(I,1)*DEG
3090        CONTINUE
            WRITE(NPRIN,780)1,LIST(1),(TITL(K,NT),K=1,4),
     &      (ANGU(I,1),I=1,NBU)
         ELSE
            WRITE(NPRIN,790)1,LIST(1),(TITL(K,NT),K=1,4)
         END IF
         DO 3800 I=2,INUMRS-1
         NT=IABS(LIST(I))
         DO 3831 J=1,NCHI(NT)+3
         ANGULO(J,I)=PINORM(ANGULO(J,I))
         ANGU(J,I)=ANGULO(J,I)*DEG
3831      CONTINUE
         WRITE(NPRIN,780)I,LIST(I),(TITL(K,NT),K=1,4),
     &   (ANGU(J,I), J=1,NCHI(NT)+3)
3800      CONTINUE
         NT = IABS(LIST(INUMRS))+LX
         NBO = NBOND( IABS( LIST(INUMRS) ) )-1
         IF ( NBO .GT. 0 ) THEN
            DO 3190 I=1,NBO
            ANGULO(I,INUMRS)=PINORM(ANGULO(I,INUMRS))
            ANGU(I,INUMRS)=ANGULO(I,INUMRS)*DEG
3190        CONTINUE
            WRITE(NPRIN,780)INUMRS,LIST(INUMRS),(TITL(K,NT),K=1,4),
     &      (ANGU(I,INUMRS),I=1,NBO )
         ELSE
            WRITE(NPRIN,790)INUMRS,LIST(INUMRS),(TITL(K,NT),K=1,4)
         END IF
      END IF
      RETURN
780      FORMAT(I3,1X,I3,1X,4A4,1X,12(F8.3))
790      FORMAT(I3,1X,I3,1X,4A4)
1003     FORMAT('  ')

750      FORMAT(15F8.3)

      END
      SUBROUTINE ENEPRINT
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.CALC'
      INCLUDE 'COMMON.TOR'
      INCLUDE 'COMMON.CNTRL'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.THRLET'
      INCLUDE 'COMMON.EXTPH'
      INCLUDE 'COMMON.GEN100'
#ifdef PHCALC

      include 'param.ibems'
      include 'comm.ibems'
C Interface to IBEMS program
      INCLUDE 'ecepp_ibems_intrf.h'
      dimension pK_intr(maxnum_res)
#endif

      IF(ICOMP(4).EQ.5) THEN
         WRITE(JOUT,1002) EES, ENB, ETOR, EPRO, ETORBR, ELOOP,
     1    EHYDA, EVIB, EDIS, EDIHC, ETOT
C     WRITE(JOUT,'(a,e12.5)') 'ETORS= ', etors
         IF (ONSCREEN) THEN
            WRITE(*,1002) EES, ENB, ETOR, EPRO, ETORBR, ELOOP,
     1    EHYDA, EVIB, EDIS, EDIHC, ETOT
         ENDIF
#ifdef PHCALC
      ELSE IF(pHs.GT.0.0) THEN
         WRITE(JOUT,1011) EES, ENB, ETOR, EPRO, ETORBR, ELOOP, EHYDA,
     1      DELPHI, EPROT, EVIB, EDIS, ETOT
C        WRITE(JOUT,'(a,e12.5)') 'ETORS= ', etors
         if ((phs.gt.0).and.(npolres_tei.gt.0)) then
            write (jout,*)
            write (jout,*) 'number of ionizable groups', npolres_tei
            write (jout,1012) phs
            do i=1,npolres_tei
              pK_intr(i)=pHs+qqq_res(i)*
     &       alog10(opt_ionz_ei(i)/(1.0-opt_ionz_ei(i)))
            enddo
            do i=1,npolres_tei
              listi=iabs(list(ionresgl_ei(i)))
              if (ionresgl_ei(i).eq.1 .or. ionresgl_ei(i).eq.inumrs)
     &        listi=listi+num_restypes
              write (jout,1013) ares(listi),
     &        ionresgl_ei(i),pK0_res(i),pK_intr(i),
     &        pK_intr(i)-pK0_res(i), opt_ionz_ei(i)
            enddo
         endif
         IF (ONSCREEN) THEN
            WRITE(*,1011) EES, ENB, ETOR, EPRO, ETORBR, ELOOP, EHYDA,
     1         DELPHI, EPROT, EVIB, EDIS, ETOT
           if ((phs.gt.0).and.(npolres_tei.gt.0)) then
              write (jout,*)
              write (*,1012) phs
              do i=1,npolres_tei
                listi=iabs(list(ionresgl_ei(i)))
                if (ionresgl_ei(i).eq.1 .or. ionresgl_ei(i).eq.inumrs)
     &          listi=listi+num_restypes
                write (*,1013) ares(listi),ionresgl_ei(i),
     &          pK0_res(i),pK_intr(i),pK_intr(i)-pK0_res(i),
     &          opt_ionz_ei(i)
               enddo
            endif
         ENDIF
#endif
      ELSE
         WRITE(JOUT,1001) EES, ENB, ETOR, EPRO, ETORBR, ELOOP, 
     1       EHYDA, EVIB, EDIS, EDIHC, ETOT
C     WRITE(JOUT,'(a,e12.5)') 'ETORS= ', etors
         IF (ONSCREEN) THEN
            WRITE(*,1001) EES, ENB, ETOR, EPRO, ETORBR, ELOOP,
     1       EHYDA, EVIB, EDIS, EDIHC, ETOT
         ENDIF
      ENDIF
1001  FORMAT (/'Conformational energies (kcal/mole)'
     & /5X,3HEES,5X,E12.5,3X,   '(electrostatic)'
     & /5X,3HENB,5X,E12.5,3X,   '(nonbonded)'
     & /5X,4HETOR,4X,E12.5,3X,  '(torsional)'
     & /5X,4HEPRO,4X,E12.5,3X,  '(fixed Pro and Hypro)'
     & /5X,6HETORBR,2X,E12.5,3X,'(loop torsional)'
     & /5X,5HELOOP,3X,E12.5,3X, '(loop closing)'
     & /5X,5HEHYDA,3X,E12.5,3X, '(surface hydration)'
     & /5X,'EVIB',4X,E12.5,3X,  '(conformational entropy)' 
     & /5X,4HEDIS,4X,E12.5,3X,  '(distance constraints)'
     & /5X,5HEDIHC,3X,E12.5,3X,  '(dihedral angle constraints)'
     & /5X,4HETOT,4X,E12.5,3X,  '(total)')
1002  FORMAT (/'Conformational energies (kcal/mole)'
     & /5X,'EES',5X,E12.5,3X,   '(electrostatic)'
     & /5X,'ENB',5X,E12.5,3X,   '(nonbonded)'
     & /5X,'ETOR',4X,E12.5,3X,  '(torsional)'
     & /5X,'EPRO',4X,E12.5,3X,  '(fixed Pro and Hypro)'
     & /5X,'ETORBR',2X,E12.5,3X,'(loop torsional)'
     & /5X,'ELOOP',3X,E12.5,3X, '(loop closing)'
     & /5X,'EHYDA',3X,E12.5,3X, '(volume hydration)'
     & /5X,'EVIB',4X,E12.5,3X,  '(conformational entropy)' 
     & /5X,'EDIS',4X,E12.5,3X,  '(distance constraints)'
     & /5X,'EDIHC',3X,E12.5,3X,  '(dihedral angle constraints)'
     & /5X,'ETOT',4X,E12.5,3X,  '(total)')
1011  FORMAT (/'Conformational energies (kcal/mole)'
     & /5X,'EES',5X,E12.5,3X,   '(electrostatic)'
     & /5X,'ENB',5X,E12.5,3X,   '(nonbonded)'
     & /5X,'ETOR',4X,E12.5,3X,  '(torsional)'
     & /5X,'EPRO',4X,E12.5,3X,  '(fixed Pro and Hypro)'
     & /5X,'ETORBR',2X,E12.5,3X,'(loop torsional)'
     & /5X,'ELOOP',3X,E12.5,3X, '(loop closing)'
     & /5X,'EHYDA',3X,E12.5,3X, '(surface hydration)'
     & /5X,'DELPHI',2X,E12.5,3X,'(electrostatic hydration)'
     & /5x,'EPROT',3X,E12.5,3X, '(ionization)'
     & /5X,'EVIB',4X,E12.5,3X,  '(conformational entropy)' 
     & /5X,'EDIS',4X,E12.5,3X,  '(distance constraints)' 
     & /5X,'ETOT',4X,E12.5,3X,  '(total)')
 1012 FORMAT(/'Intrinsic pKas, pKa shifts and average degrees of',
     & ' ionization of ionizable residues',
     & ' at pH ',f6.3/'Residue',5x,'pKa0',4x,'pKai',4x,'DpKa',4x,'deg.')
 1013 FORMAT(a3,1h(,i3,1h),4f8.3)

      RETURN
      END
***********************************************************************
      subroutine errout(jout,nkwd,ikey,keywd,line,narg,keywdset,icall)
      character*16 keywd,keywdset(1:nkwd,0:nkwd)
      dimension narg(0:nkwd)
      character*80 line
      goto (1,2,3,4,5,6,7) icall
    1 write (jout,'(2a)') 'Error when reading the keyword: ',keywd
      goto 8
    2 write (jout,'(2a)') 'Error when reading the argument: ',keywd
      write (jout,'(2a)') 'to the keyword: ',keywdset(ikey,0)
      goto 8
    3 write (jout,'(4a)') 'Error when reading the numeric argument ',
     &   keywd,' to keyword: ',keywdset(ikey,0)
      goto 8
    4 write (jout,'(2a)') 'Argument expected to the keyword: ',keywd
      write (jout,'(a)') 'but not received.'
      goto 8
    5 write (jout,'(4a)') 'Argument ',keywd,
     & '  received to the keyword: ',keywdset(ikey,0)
      write (jout,'(a)') 'but not expected.'
      goto 8
    6 write (jout,'(4a)') 'Unrecognized argument: ',keywd,
     & ' to keyword: ',keywdset(ikey,0)
      write (jout,'(a)') 'The allowed arguments are:'
      write (jout,'(10(5a16/))') (keywdset(i,ikey),i=1,narg(ikey))
      goto 8
    7 write (jout,'(2a)') 'Unrecognized keyword: ',keywd
      write (jout,'(a)') 'The allowed keywords for this data group are:'
      write (jout,'(10(5a16/))') (keywdset(i,0),i=1,narg(0))
    8 write (jout,'(2a)') 'This error occurred in the following data',
     &  ' line:' 
      write (jout,'(a)') line
      return
      end
      SUBROUTINE ITER_OUT
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.TIME1'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.MYCONF'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.CNTRL'
      INCLUDE 'COMMON.EDMC'
      INCLUDE 'COMMON.FILES'
      INCLUDE 'COMMON.CALC'
      INCLUDE 'COMMON.TRACK'
      CHARACTER*3 NUMM
      CHARACTER*64 CFF,OLD_PREFIX
      DATA IZERO /0/, ITREIN /30/
C
      ITOTG=ITOTC(1)+ITOTC(2)+ITOTC(3)
      ITOTACC=IACC(1)+IACC(2)+IACC(3)
      CALL DRUANG(JANG,ndone)
      IF (PRINT) THEN
c       CALL NUMSTR(ndone,NUMM)
        CALL NUMSTR(ncon,NUMM)
        CALL CONCAT(COORPREF,NUMM,CFF)
        OLD_PREFIX=COORPREF
        COORPREF=CFF
        CALL OUTNW(IZERO,ITREIN,ndone)
        COORPREF=OLD_PREFIX
      ENDIF
      WRITE (JOUT,'(/A)') 'ZIMMERMAN CODE of Accepted Conformation is:'
      WRITE (JOUT,80) (ZIMMK(J), J=2, INUMRS-1)
      CALL ENEPRINT
      CURTIM=TCPU()
      WRITE (JOUT,90) ITOTC(1),ITOTC(2),ITOTC(3),ITOTG,
     &  IACC(1),IACC(2),IACC(3),ITOTACC,(ITOTACC+0.0)/(ITOTG+0.0)  
      WRITE (JOUT,100) CURTIM,TIMLIM,ndone,CURTIM-BATIME
      IF (ONSCREEN) THEN
        WRITE (*,90) ITOTC(1),ITOTC(2),ITOTC(3),ITOTG,
     &  IACC(1),IACC(2),IACC(3),ITOTACC,(ITOTACC+0.0)/(ITOTG+0.0)  
        WRITE (*,100) CURTIM,TIMLIM,ndone,CURTIM-BATIME
      ENDIF
      BATIME=CURTIM
  80  FORMAT(20(A2,1X))
  90  FORMAT(/'Confs. generated:',I6,' electrostatic,',I6,
     & ' random,',I6,' thermal,',i6,' total.'/
     &       'Confs. accepted: ',I6,' electrostatic,',I6,
     & ' random,',I6,' thermal,',i6,' total.'/
     & 'Fraction of accepted conformations: ',F8.3)
 100  FORMAT(/'*** Elapsed time so far:',E15.4,' seconds of ',E15.4,
     &          ' seconds ***'/
     &        '****** Time for iteration',I4,' was ',F11.2,
     &          ' seconds ******'/)
      RETURN
      END
      SUBROUTINE ITER_OVTF
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.TIME1'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.CNTRL'
      INCLUDE 'COMMON.EDMC'
      INCLUDE 'COMMON.FILES'
      INCLUDE 'COMMON.CALC'
      CHARACTER*3 NUMM
      CHARACTER*64 CFF,OLD_PREFIX
      DATA IZERO /0/, ITREIN /30/
C
      CALL DRUANG(JANG,ndone)
      IF (PRINT) THEN
        CALL NUMSTR(ndone,NUMM)
        CALL CONCAT(COORPREF,NUMM,CFF)
        OLD_PREFIX=COORPREF
        COORPREF=CFF
        CALL OUTNW(IZERO,ITREIN,ndone)
        COORPREF=OLD_PREFIX
      ENDIF
      CALL ENEPRINT
      CURTIM=TCPU()
      WRITE (JOUT,100) CURTIM,TIMLIM,ndone,CURTIM-BATIME
      IF (ONSCREEN) THEN
        WRITE (*,100) CURTIM,TIMLIM,ndone,CURTIM-BATIME
      ENDIF
      BATIME=CURTIM
 100  FORMAT(/'*** Elapsed time so far:',E15.4,' seconds of ',E15.4,
     &          ' seconds ***'/
     &        '****** Time for iteration',I4,' was ',F11.2,
     &          ' seconds ******'/)
      RETURN
      END
      SUBROUTINE OUTNW(I1,I2,IAMCON)
C
C THIS SUBROUTINE PRINTS OR PUNCHES THE VALUES OF ALL DIHEDRAL ANGLES
C IN THE USER'S POLYPEPTIDE, AND THE FOLLOWING INFORMATION FOR EACH
C ATOM: GENERATED COORDINATES, CHEMICAL TYPE, ATOM TYPE FOR NONBONDED
C INTERACTIONS, AND PARTIAL CHARGE.  I1 AND I2 ARE LOGICAL UNIT NUMBERS
C FOR THE DIHEDRAL ANGLE AND COORDINATE SECTIONS OF THE OUTPUT,
C RESPECTIVELY.
C
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.CNTRL'
      INCLUDE 'COMMON.FILES'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.GEN002X'
      INCLUDE 'COMMON.GEN004'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.ATOMSS'
      INCLUDE 'COMMON.BONDSX'
      INCLUDE 'COMMON.CHECK'
      INCLUDE 'COMMON.GEN000'
      INCLUDE 'COMMON.PRAMX'
      INCLUDE 'COMMON.PUT14'
      INCLUDE 'COMMON.PUT15'
      INCLUDE 'COMMON.THRLET'
      INCLUDE 'COMMON.CALC'
      INCLUDE 'COMMON.SOLVAT'
      INCLUDE 'COMMON.RMSPDB'
      INTEGER ISELAT(MAXNUM_ATOMS), NSELAT
      COMMON/SELATM/ISELAT, NSELAT
      CHARACTER*4 FILE_EXTN(6) /'.ecp','.pdb','.his','.cnd','.pdb',
     &   '.pdb'/
      CHARACTER*64 PDBFILE
      DIMENSION A(maxnum_dihe)
      CHARACTER*3 RESIN, RESCA
      CHARACTER *3 CALFA
      CHARACTER *1 HYDRG
      DIMENSION IATCNM(28)
      DATA IATCNM /5*1,7*6,3*7,0,3*8,2*16,7*0/
      DATA CALFA /'CA '/, RESCA /'ALA'/
      DATA HYDRG /'H'/
      DATA IONE /1/
C
C     write(jout,'(a,i3)') 'Writing Cartesian coordinates : ', IFORM
      IF (IFORM.EQ.3) THEN
C AMBER HISTORY FILE
         NATMM=NPRE(INUMRS+1)
         NATM3 = 3*NATMM
         CALL AMBWRT(COORD,NATM3,I2)
         RETURN
      ENDIF
      IF (IFORM.EQ.6) THEN
C WRITING COORDINATES OF SELECTED ATOMS
         GOTO 55
      ENDIF
      CALL CONCAT(COORPREF,FILE_EXTN(IFORM),PDBFILE)
      WRITE(jout, '(2a)') 'Writing Cartesians to file: ', PDBFILE
      OPEN (I2,FILE=PDBFILE,STATUS='UNKNOWN')
      IF (IFORM.EQ.1) THEN
C ORIGINAL ECEPP OUTPUT FORMAT
         WRITE(I2,'(A,I5,A,E12.5,A)') 'CONFORMATION',IAMCON,
     &                                 ' ENERGY',ETOT,' KCAL/MOLE'
      ELSEIF (IFORM.EQ.2) THEN
C PDB FILE 
         WRITE(I2,'(A,I5,A,E12.5,A)') 'REMARK CONFORMATION',IAMCON,
     &                                 ' ENERGY',ETOT,' KCAL/MOLE'
      ELSEIF (IFORM.EQ.4) THEN
C CNDO FILE
         WRITE(I2,'(A,I5,A,E12.5,A)') 'CONFORMATION',IAMCON,
     &                                 ' ENERGY',ETOT,' KCAL/MOLE'
      ELSEIF (IFORM.EQ.5) THEN
C C-ALPHA COORDINATES TO PDB FILE 
         WRITE(I2,'(A,I5,A,E12.5,A)') 'REMARK CONFORMATION',IAMCON,
     &                                 ' ENERGY',ETOT,' KCAL/MOLE'
         JCA=0
      ENDIF
55    CONTINUE
      ECUT =0.0
      SURFEX =0.0
      IF (I1 .EQ. 0) GO TO 220
      IF (I1.EQ.JPRINT) WRITE(I1,310) (I,I=1,10)
      DO 210 I=1,INUMRS
      LISTI=LIST(I)
      LISTI = IABS(LISTI)
      IF (I.EQ.1.OR.I.EQ.INUMRS) GO TO 120
      NS=NCHI(LISTI) + 3
  120 K = NPRE(I)+1
      NT = LISTI
      IF (I .NE. 1 .AND. I .NE. INUMRS) GO TO 140
      NT=NT+NREG
      NS = NBOND(LISTI)
      IF(I.EQ.INUMRS) NS=NS-1
  140 IF(NS.LE.0) GO TO 190
      DO 150 J = 1,NS
      A(J) = ANGULO(J,I) * 57.29578
      IF (A(J).GT.180.0) A(J) = A(J) - 360.0
      IF (A(J).LT.(-180.0)) A(J) = A(J) + 360.0
  150 CONTINUE
      IF (I1.NE.JPUNCH) GO TO 155
      WRITE (I1,340) (A(J),J=1,NS)
      GO TO 210
  155 IF (LIST(I).LT.0) GO TO 160
      WRITE (I1,320) I,LIST(I),(TITL(L,NT),L=1,4),(A(J),J=1,NS)
      GO TO 210
  160 WRITE (I1,330) I,LIST(I),(TITL(L,NT),L=1,4),(A(J),J=1,NS)
      GO TO 210
  190 IF (I1.NE.JPUNCH) GO TO 200
      WRITE (I1,390)
      GO TO 210
  200 WRITE (I1,320) I,LIST(I),(TITL(L,NT),L=1,4)
  210 CONTINUE
  220 IF (I2 .EQ. 0) RETURN
      IF (IFORM.EQ.1) WRITE(I2,350)
      DO 300 I=1,INUMRS
      LISTI=LIST(I)
      LISTI=IABS(LISTI)
      NS=NPRE(I)+1
      NS1=NPRE(I+1)
      NSDEL=NS1-NS-1
      IF(NS.EQ.0) NS=1
      IF(NS1.LT.NS) GO TO 300
c *********************************************************************
c DR -  APR 1991
      IF (I.EQ.1.OR.I.EQ.INUMRS) THEN
         LISTI=LISTI+num_restypes
      END IF
      RESIN=ARES(LISTI)
      IF (IFORM.GE.2) GO TO 290
c*******************************************
      IF (I2.EQ.JPUNCH) GO TO 290
      IF (LIST(I).LT.0) GO TO 280
      if (i.eq.1 .or. i.eq.inumrs) listi=listi+num_restypes
      WRITE(I2,370) I,(TITL(J,LISTI),J=1,4)
      GO TO 290
  280 WRITE(I2,380) I,(TITL(J,LISTI),J=1,4)
  290    CONTINUE
         DO 295 J = NS,NS1
         ECUS = CHARGE(J)*0.077615
         ECUT = ECUT + ECUS
         IF (IFORM.EQ.1) THEN
C WRITE COORDINATES USING ORIGINAL ECEPP OUTPUT FORMAT
           WRITE (I2,360) 
     &             (COORD(NN,J),NN=1,3),ALPH(J),NBTYPE(J),ECUS,J
         ELSEIF (IFORM.EQ.2) THEN
C WRITE COORDINATES TO PDB FILE 
           IF (ISFOUT.EQ.1) THEN
              IF (ICTSOL(J).EQ.0) THEN
                AREAAT=0.0
                RADIAT=0.0
              ELSE
                AREAAT=AARS(ICTSOL(J),1)
                RADIAT=RADII(ICTSOL(J))
              ENDIF
              WRITE (I2,364) J,ALPH(J),RESIN,I,(COORD(NN,J),NN=1,3),
     &         CHARGE(J),  RADIAT, AREAAT
           ELSE
!              write (*,*)'NO_HYDRG ', NO_HYDRG
              IF (NO_HYDRG) THEN
                 IF ( ALPH(J)(1:1) .NE. 'H') 
     &           WRITE (I2,365) J,ALPH(J),RESIN,I,(COORD(NN,J),NN=1,3),
     &           CHARGE(J), ECUS
              ELSE
              WRITE (I2,365) J,ALPH(J),RESIN,I,(COORD(NN,J),NN=1,3),
     &         CHARGE(J), ECUS
              ENDIF
           ENDIF
C          WRITE (32,465) ALPH(J),RESIN,ECUS
         ELSEIF (IFORM.EQ.4) THEN
C WRITE CNDO INPUT FILE
           ITOMIC= IATCNM(NBTYPE(J))
           WRITE (I2,366) ITOMIC,(COORD(NN,J),NN=1,3)
  366      FORMAT(I4,1X,3(F12.4,3X))
         ELSEIF (IFORM.EQ.5) THEN
C WRITE C-ALPHA COORDINATES TO PDB FILE 
           IF ( ALPH(J) .EQ. CALFA) THEN
             JCA=JCA+1
             WRITE (I2,365) JCA,CALFA,RESCA,IONE,(COORD(NN,J),NN=1,3)
           END IF
         ELSEIF (IFORM.EQ.6) THEN
C WRITE C-ALPHA COORDINATES TO PDB FILE 
           IF ( NSELAT.EQ. 0 ) 
     &       WRITE(JOUT, *)' ERROR IN OUTNW: NSELAT IS ZERO'
           DO NK=1, NSELAT
              IF ( J .EQ. ISELAT(NK) ) THEN
                 IF (ISFOUT.EQ.1) THEN
                    IF (ICTSOL(J).EQ.0) THEN
                      AREAAT=0.0
                      RADIAT=0.0
                    ELSE
                      AREAAT=AARS(ICTSOL(J),1)
                      RADIAT=RADII(ICTSOL(J))
                      SURFEX= SURFEX+AREAAT
                    ENDIF
                    WRITE (I2,364) J,ALPH(J),RESIN,I,
     &               (COORD(NN,J),NN=1,3),CHARGE(J),  RADIAT, AREAAT
                 ELSE
                      WRITE (I2,365) J,ALPH(J),RESIN,I,
     &                 (COORD(NN,J),NN=1,3), CHARGE(J), ECUS
              ENDIF
              ENDIF
            ENDDO
         ENDIF
           
  295 CONTINUE
  300 CONTINUE
      IF (IFORM.EQ.6) 
     &  WRITE(I2,'(A19,I5,A8,E12.5,A22,F10.3)') 'REMARK CONFORMATION',
     &    IAMCON,' ENERGY ',ETOT,' KCAL/MOLE;  SURFACE =', SURFEX
      IF (IFORM.EQ.6) 
     &  WRITE(jete,'(A19,I5,A8,E12.5,A22,F10.3)') 'REMARK CONFORMATION',
     &    IAMCON,' ENERGY ',ETOT,' KCAL/MOLE;  SURFACE =', SURFEX

C     WRITE (32,*) 'TOTAL MOLECULAR CHARGE =', ECUT
      IF (IFORM.NE.6) CLOSE(I2)
      RETURN
C
 310  FORMAT(//1X,46HNO.IN LIST  RESIDUE NAME       DIHEDRAL ANGULO/
     1 1X,10HCHAIN  NO.,16X,12I9)
  320 FORMAT(I3,1X,I3,1X,4A4,1X,12(F8.3))
  330 FORMAT(I3,1X,I3,1X,2HD-,4A4,1X,12(F8.3))
  340 FORMAT(12F8.3)
  350 FORMAT(//12X,18HATOMIC COORDINATES,24X,6HCHARGE/11X,1HX,9X,
     1   1HY,9X,1HZ,7X,4HATOM,4X,4HTYPE,2X,8H(E.C.U.),3X,8HATOM NO.)
  360 FORMAT(5X,3F10.4,5X,A3,5X,I2,F10.3,5X,I5)
  364 FORMAT('ATOM',I7,2X,A3,1X,A3,I6,4X,3F8.3,1X,F5.2,2(1X,F8.3))
  365 FORMAT('ATOM',I7,2X,A3,1X,A3,I6,4X,3F8.3,2(1X,F5.2))
c  365 FORMAT('ATOM',I7,2X,A3,1X,A3,I6,4X,3F8.3)
  370 FORMAT (/1X,I5,1X,4A4/)
  380 FORMAT (/1X,I5,1X,2HD-,4A4/)
  390 FORMAT (1H )
  465 FORMAT(A3,3X,A3,6X,F7.3)
      END
      SUBROUTINE PRINT_DATA
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      INCLUDE 'COMMON.CNTRL'
      INCLUDE 'COMMON.DATA_READ'
      INCLUDE 'COMMON.OMTOR'
      INCLUDE 'COMMON.MINPAR'
      INCLUDE 'COMMON.SOLVAT'
      INCLUDE 'COMMON.EXTPH'
      INTEGER LISTP(maxnum_res)
      INCLUDE 'COMMON.CALC'
      INCLUDE 'COMMON.EDMC'
      INCLUDE 'COMMON.TOR'
      INCLUDE 'COMMON.SETUP'
      INCLUDE 'COMMON.BRIDGES'
      INCLUDE 'COMMON.XBOUNDX'
      INCLUDE 'COMMON.VTFEX'
      INCLUDE 'COMMON.GEN002X'
      INCLUDE 'COMMON.TIME1'
      INCLUDE 'COMMON.BONDSX'
      INCLUDE 'COMMON.TORPX'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.FILES'
      INCLUDE 'COMMON.BLOKA'
      INCLUDE 'COMMON.GEN000'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.GEN004'
      INCLUDE 'COMMON.PRAMX'
      INCLUDE 'COMMON.TOR2'
      INCLUDE 'COMMON.TORQUEX'
      INCLUDE 'COMMON.MOVE'
      INCLUDE 'COMMON.BRAIN'
      INCLUDE 'COMMON.PICK'
      INCLUDE 'COMMON.BIAS'
      INCLUDE 'COMMON.THRLET'
      INCLUDE 'COMMON.RMSFIT'
      CHARACTER*16 FORCE_FIELD(6)/'ECEPP/3','SOFT_SPHERE','AMBER',
     &  'DISCOVER','CHARMM','MM3'/
      CHARACTER*64 NAME_JUNK
      CHARACTER*25 FORMA(6)/'ECEPP','PDB','AMBER','CNDO'
     &  ,'PDB (C-ALPHA)' ,'PDB (SELECTED ATOMS)'/
      CHARACTER*16 EXTEN_JUNK(6) /'xxx.ecp','xxx.pdb','.amb',
     &                       'xxx.cnd','xxx.pdb','xxx.pdb'/
      CHARACTER*4 MODE_MC(0:1) /'EDMC','MCM'/
      CHARACTER*8 EXTEN_REST /'.info'/,EXTEN_RAND /'.random'/
      CHARACTER*10 MOV(3) /'Piela','crankshaft','lambda'/
      CHARACTER*20 CUTIN(3) /'NO','BLOCK','CA_CA Distance'/
      CHARACTER*64 FNAME 
      character*5 cistrans(2) /'CIS','TRANS'/
      EXTERNAL ILEN
C
      WRITE(JOUT,'(A,1X, A)')' Data taken fron Input file: ',INFILE
C
      GOTO (10,20,30,40,50,60,70,80) IRUNTYP
   10 WRITE (JOUT,'(//A/)') 
     & 'Only initial energy will be evaluated.'
      IF (READCONFS) THEN
        FNAME=SAVEFILE
        III=JSAVE
        WRITE(JOUT,'(A,I2,1X, A)')' opening unit ',III, FNAME
#ifdef WINNT
        OPEN (JSAVE,FILE=FNAME,STATUS='UNKNOWN',ACTION='READ',ERR=5555)       
#else
        OPEN (JSAVE,FILE=FNAME,STATUS='UNKNOWN',ERR=5555)
#endif
      ENDIF

      GOTO 500
   20 WRITE (JOUT,'(//A/)') 
     & 'Analytical and numerical gradients will be compared.'
      GOTO 500
   30 WRITE (JOUT,'(//A/)') 'Energy will be minimized.'
      IF (READCONFS) THEN
        FNAME=SAVEFILE
        III=JSAVE
        WRITE(JOUT,'(A,I2,1X, A)')' opening unit ',III, FNAME
#ifdef WINNT
        OPEN (JSAVE,FILE=FNAME,STATUS='UNKNOWN',ACTION='READ',ERR=5555)       
#else
        OPEN (JSAVE,FILE=FNAME,STATUS='UNKNOWN',ERR=5555)
#endif
      ENDIF

      GOTO 500
   40 CONTINUE
      WRITE (JOUT,'(//A/)') 'EDMC/MCM simulations ...'
      GOTO 500
   50  CONTINUE
      IF (.NOT.PRESENT(12)) THEN 
        WRITE (JOUT,'(//A/)') 'Keyword $RMSFIT is missing.'
        STOP
      ELSE
        WRITE (JOUT,'(//A/)') 'RMS FITTING will be performed.'
      ENDIF
      IF (GENERATE_REF) THEN
         IF (ITYPE_REF.NE.3) THEN
          FNAME=INREFFILE
          III=JINREF
          OPEN (III,FILE=FNAME,STATUS='UNKNOWN',ERR=5555)
         ENDIF
         FNAME=REFXYFILE
         III=JOUREF
         OPEN (III,FILE=FNAME,STATUS='UNKNOWN',ERR=5555)
      ELSE
         FNAME=REFXYFILE
         III=JREFXY
         OPEN (III,FILE=FNAME,STATUS='UNKNOWN',ERR=5555)
      ENDIF
      IF (ITYPE_INP.EQ.3) THEN
        FNAME=SAVEFILE
        III=JSAVE
        WRITE(JOUT,'(A,I2,1X, A)')' opening unit ',III, FNAME
        OPEN (JSAVE,FILE=FNAME,STATUS='OLD',ERR=5555)
      ELSE
        FNAME=INPDBFILE
        III=INPDB
        OPEN (III,FILE=FNAME,STATUS='OLD',ERR=5555)
      ENDIF
      GOTO 500

   60   CONTINUE
      IF (.NOT.PRESENT(14)) THEN 
        WRITE (JOUT,'(//A/)') 'Keyword $BOUND_DEF is missing.'
        STOP
      ENDIF
      IF (.NOT.PRESENT(15)) THEN 
        WRITE (JOUT,'(//A/)') 'Keyword $BOUNDS is missing.'
        STOP 
      ENDIF
      WRITE (JOUT,'(//A/)') 
     & 'UPPER AND LOWER BOUNDS from a PDB File wil be obtained.'
C
C OPEN INPUT  PDB FILE FOR GENERATING DISTANCE CONSTRAINTS 
      FNAME=INPDBFILE
      III = INPDB
      OPEN (INPDB,FILE=INPDBFILE,STATUS='UNKNOWN',ERR=5555)

C OPEN  DISTANCE CONSTRAINTS FILE  (FOR OUTPUT)
      III=JBND
      FNAME =DISTFILE
      OPEN (JBND,FILE=DISTFILE,STATUS='UNKNOWN',ERR=5555)
      GOTO 500

   70 CONTINUE
      WRITE (JOUT,'(//A/)') 'VTF Procedure ...'
      IF (.NOT.PRESENT(16)) THEN 
        WRITE (JOUT,'(//A/)') 'Keyword $VTF is missing.'
        STOP 
      ENDIF
      IF (ECEPPCF.AND.(NPAIR1+NPAIR2).EQ.0) THEN
        WRITE (JOUT,'(//A)') 'Procedure VTF: the Number of distance '
        WRITE (JOUT,'(A/)') 'constraints provided is  ZERO.'
        STOP 
      ENDIF
      IF (READCONFS) THEN
        FNAME=SAVEFILE
        III=JSAVE
        WRITE(JOUT,'(A,I2,1X, A)')' opening unit ',III, FNAME
#ifdef WINNT
        OPEN (JSAVE,FILE=FNAME,STATUS='UNKNOWN',ACTION='READ',ERR=5555)       
#else
        OPEN (JSAVE,FILE=FNAME,STATUS='UNKNOWN',ERR=5555)
#endif
      ENDIF
      GOTO 500

   80 CONTINUE
      IF (.NOT.PRESENT(23)) THEN 
        WRITE (JOUT,'(//A/)') 'Keyword $ECEPPIZE is missing.'
        STOP
      ELSE
        WRITE (JOUT,'(//A/)') 'ECEPPIZATION will be performed.'
      ENDIF
      IF (GENERATE_REF) THEN
         IF (ITYPE_REF.NE.3) THEN
            FNAME=INREFFILE
            III=JINREF
            OPEN (III,FILE=FNAME,STATUS='UNKNOWN',ERR=5555)
         ENDIF
         FNAME=REFXYFILE
         III=JOUREF
         OPEN (III,FILE=FNAME,STATUS='UNKNOWN',ERR=5555)
      ELSE
         FNAME=REFXYFILE
         III=JREFXY
         OPEN (III,FILE=FNAME,STATUS='UNKNOWN',ERR=5555)
      ENDIF
!     IF (ITYPE_INP.EQ.3) THEN
        FNAME=SAVEFILE
        III=JSAVE
        WRITE(JOUT,'(A,I2,1X, A)')' opening unit ',III, FNAME
        OPEN (JSAVE,FILE=FNAME,STATUS='OLD',ERR=5555)
!     ELSE
!       FNAME=INPDBFILE
!       III=INPDB
!       OPEN (III,FILE=FNAME,STATUS='OLD',ERR=5555)
!     ENDIF
!     GOTO 500
C
  500 CONTINUE
C
      IF (WITHCNST ) THEN
        IF (.NOT.PRESENT(17)  ) THEN
           WRITE (JOUT,'(//A/)') 'Keyword $DIST_CONST is missing.'
           STOP
        ENDIF
        WRITE (JOUT,'(/2A/)') ' DISTANCE CONSTRAINTS will be added',
     & ' to the potential.'
      ENDIF
      WRITE(JOUT,'(A,I4)')
     & 'Number of full residues in the polypeptide chain: ',NRES
C 
C ICOMP(1) determines the force field:
C 0 - no force field to be used; only solvation energy will be computed;
C 1 - ECEPP/3;
C 2 - AMBER;
C 3 - DISCOVER;
C 4 - CHARMM;
C 5 - MM3.
C 
      IF (ICOMP(1).GT.0) THEN
        WRITE (JOUT,'(/3A/)') 'The ',FORCE_FIELD(ICOMP(1)),
     &    'force field is used.'
      ELSE
        WRITE (JOUT,'(/A/)') 'Only solvation energy will be calculated.'
      ENDIF

      IF (IPRINT(1).GT.0.0) THEN
        IL=ILEN(SUMSLFILE)
        FNAME=SUMSLFILE(:IL)
        III=JSUMSL
C       WRITE(JOUT,'(A,I2,1X, A)')' opening unit ',III, FNAME
        OPEN (III,FILE=FNAME,STATUS='UNKNOWN',ERR=5555)
      ENDIF

      IL=ILEN(READFILE)
      WRITE (JOUT,'(3A/)') 'Residue database: ',readfile(1:il),'.'

C
#ifdef PHCALC

      IF (pHs.GT.0.0) THEN
        print *,'pH=',pHs
      ENDIF
#endif

      IL=ILEN(CUTIN(ICUTOFF))
      WRITE (JOUT,1055) CUTIN(ICUTOFF)(1:IL)
 1055 FORMAT('*',1x,A,' Cutoff will be used.',T80,'*'/
     & '*',T80,'*')
      IF (ICUTOFF.EQ.3) THEN
         IL2=ILEN(CUTIN(ICUTOFF))
         WRITE (JOUT,1056) CUTIN(ICUTOFF)(1:IL),CUTIN(2)(1:IL2)
 1056    FORMAT('*',1x,'Since',A,'Cutoff is not implemented yet, ',
     &    /,'cutoff criterium was changed to:',A10,T80,'*'/
     &    '*',T80,'*')
          ICUTOFF=2
      ENDIF
c
c ICOMP(4)=4 SURFACE HYDRATION; ICOMP(4)=5 VOLUME HYDRATION.
c If ICOMP(4)=4 or 5 then, it is also possible to include the 
c Hydration term during minimization using the SURDER option, below.
c
      IF (ICOMP(4).EQ.4. OR. ICOMP(4).EQ.5 ) THEN
        IL=ILEN(SOLVFILE)
        FNAME=SOLVFILE(:IL)
        III=JSOLV
        WRITE(*,'(A,I2,1X, A)')' opening unit ',III, FNAME
#ifdef WINNT
        OPEN (III,FILE=FNAME,STATUS='OLD',ACTION='READ',ERR=5555)
#else
        OPEN (III,FILE=FNAME,STATUS='OLD',ERR=5555)
#endif
        if(icomp(4).eq.4) then
        WRITE (JOUT,'(2A/2A/)') 'Surface-hydration energy will be ',
     &    'evaluated, using parameters from file ',solvfile(1:il),'.'
        elseif(icomp(4).eq.5) then
C read pre-computed fixed volumes for the atoms.
C          call read_fxvol
           lenpre=ILEN(FXVOLFILE)
           WRITE (JOUT,'(2A/A/2A/)')'Volume-hydration energy will be ',
     &     'evaluated, using parameters from files ',SOLVFILE(1:IL),
     &     ' and ', FXVOLFILE(1:lenpre)
        endif
c
c Surface derivative is now an option, SURDER, (the logical option in in
c data means: (F) only ECEPP/3 energy will be minimized and hydration wi
c added after minimization is completed. (T) Minimization will involve
c both components ECEPP/3 and Hydration (remember: when SOLPRM.NMR
c parameter are choosed only option (F) SHOULD be used!.
c
        IF (SURDER) THEN
          if(icomp(4).eq.4) then
          WRITE (JOUT,'(2A/)') 'Surface solvation will be included',
     &    ' in minimization.' 
          elseif(icomp(4).eq.5) then
             WRITE (JOUT,'(2A/)') 'Volume solvation will be included',
     &       ' in minimization.' 
          endif
        ELSE
          if(icomp(4).eq.4) then
          WRITE (JOUT,'(2A/)') 'Vacuum energy will be minimized and ',
     &   'surface-solvation added after minimization.' 
          elseif(icomp(4).eq.5) then
            WRITE (JOUT,'(2A/)') 'Vacuum energy will be minimized and ',
     &      'volume-solvation added after minimization.' 
        ENDIF  
      ENDIF
         ENDIF
      IF (ISFOUT.EQ.1 .AND. ICOMP(4).NE.4) THEN
         WRITE (JOUT,'(2A/)') 
     &     'WARNING: If printing of surface areas is requested, ',
     &    ' the keyword "SOLVATION=SURFACE" must be added in $FFIELD.'
      ENDIF

c
c ICOMP(3): ELECTROSTATIC SOLVATION.
c Electrostatic contributions due to the polarization of the solvent
c (DELPHI) can be included also as with this option.
c ICOMP(3)= 0, means don't perform the calculation, 1, means do it.
c
      IF (ICOMP(3).EQ.2) THEN
        WRITE (JOUT,'(/A/)') 'DELPHI not supported yet.'
        ICOMP(3)=0
      ELSE IF (ICOMP(3).EQ.1) THEN
#ifdef PHCALC
        WRITE (JOUT,'(/2A/)') 'The IBEM method of Y. Vorobjev will',
     &       ' be used to evaluate electrostatic-solvation energy'
      ENDIF
      IF (PHS.GT.0) THEN
        WRITE (JOUT,'(/A,F5.2,A/2A/A/A/A/)') 
     & 'Calculations will be carried out assuming pH value of ',PHS,
     & '.','The actual degree of ionization and pKa shifts will be',
     & ' estimated',
     & 'using the IBEM-based method developed by Y. Vorobjev.',
     & 'Previously calculated solvation energy will be overriden',
     & 'and replaced with IBEM-based value.' 
#else
        WRITE (JOUT,'(/2A/)') 'For pH calculations,',
     &        ' compile the program with the correct "make" file.'
        ICOMP(3)=0
#endif
      ENDIF
      IF (INTOR.EQ.0) WRITE(JOUT,'(a)')
     & 'All torsional constants will be zeroed out.'
c
C the flag IREP controls whether area constraints are applied.
C IREP=1 means apply constraints.
C IREP has been set at zero in the current version.
C*********************************************************************
C IFORM = 0 don't write coordinates.
C IFORM = 1 write coordinates in ECEPP FORMAT.
C IFORM = 2 write coordinates in PDB FORMAT.
C IFORM = 3 write  coordinates in AMBER FORMAT (history file).
C IFORM = 4 write coordinates for input of CNDO CALCULATION.
C IFORM = 5 write CA coordinates in PDB FORMAT.
C IFORM = 6 write selected atomic coordinates in PDB FORMAT.
      IF (PRINT. AND. (IFORM.GT.0) ) THEN
        CALL CONCAT(COORPREF,EXTEN_JUNK(IFORM),NAME_JUNK)
        il=ilen(forma(iform))
        jl=ilen(name_junk)
        WRITE (JOUT,'(/4A/3A)') 'Cartesian coordinates of the',
     & ' polypeptide will be written in ',FORMA(IFORM)(1:il),' format',
     & 'on files(s) ',NAME_JUNK(1:jl),'.' 
        IF(IFORM.EQ.3) THEN
           FNAME=NAME_JUNK(1:JL)
C AMBER HISTORY FILE
           III=IOUTPDB
C          WRITE(JOUT,'(A,I2,1X, A)')' opening unit ',III, FNAME
           OPEN (III,FILE=FNAME,STATUS='UNKNOWN',ERR=5555)
           WRITE(III,'(A)') COORPREF
        ELSE IF (IFORM.EQ.6)  THEN
C PDB FILE FOR SELECTED ATOMS
         WRITE(JOUT,'(A)') 'PDB file will contain selected atoms, only.'
      ENDIF 
      ENDIF 
      IF (CHISCAN) WRITE (JOUT,'(/A/)') 
     & 'Some dihedral angles will be scanned over for a lower energy.'
      IF (IRUNTYP.EQ.4) THEN
        IMODE=AINT(ARBT)
        HRTIME=TIMLIM/3600
        WRITE(JOUT,1100) MODE_MC(IMODE),HRTIME,EFINAL,LICZM,NREPMM
        IF (IMODE.LT.1) WRITE (JOUT,1101) MAXEL
        WRITE (JOUT,1102) NRANM
        IF (NSTEPC.GT.0 .AND. NSTEPH.GT.0) WRITE(JOUT,1105) NTERMM
 1100 FORMAT(/80(1h*)/'*',10x,'Control parameters for EDMC/MCM',T80,'*'/
     &                '*',T80,'*'/
     & '*',1x,'Monte Carlo procedure: ',A4,T80,'*'/
     & '*',1x,'Time limit:',E14.5,' hours',T80,'*'/
     & '*',1x,'Lower boundary of energy:',E14.5,' kcal/mole ',T80,'*'/
     & '*',T80,'*'/
     & '*',1x,'Number of iterations:',I4,T80,'*'/
     & '*',1x,'Max. number of repetitions of the same minimum:',I4,
     & T80,'*')
 1101 FORMAT('*',1x,'Max. number of electrostatically-predicted ',
     & 'conformations  per iteration:',I4,T80,'*')
 1102 FORMAT('*',1x,'Max. number of random-generated conformations ',
     & ' per iteration:',I4,T80,'*')
 1105 FORMAT('*',1x,'Max. number of steps at one increased temperature:'
     & ,I4,T80,'*'/'*',T80,'*')
        IF (IMODE.LT.1) WRITE (JOUT,1110) ARBT,NPRINT_ELEC
 1110 FORMAT('*',1x,'Fraction of random/electr.-predicted',
     & ' conformations:',F6.2,T80,'*'/
     & '*',1x,'Electrostatic-prediction results printed every',I3,
     & ' iterations',T80,'*'/'*',T80,'*')
      WRITE (JOUT,1115) OMPROB
 1115 FORMAT('*',1x,'Preference to changing omega angles from cis',
     & ' to trans conformation',F7.1,T80,'*')
      IF (PRESENT(17)) THEN 
        WRITE (JOUT,'(/A/)') 
     &    'SAMPLING REGIONS for residues will be used.'
        REGSAMP=.TRUE.
      ENDIF
        IF (TLOW.EQ.TUP) THEN
          WRITE (JOUT,1120) TLOW
 1120 FORMAT('*',T80,'*'/
     &   '*',1x,'Constant-temperature mode is used with T=',F10.1,
     & ' K',T80,'*'/'*',T80,'*')
        ELSE IF (NSTEPC.EQ.1 .AND. NSTEPH.EQ.1) THEN
          WRITE (JOUT,1130) TLOW,TUP
 1130 FORMAT('*',T80,'*'/
     & '*',1x,'Heat-shock procedure is used: T(low)=',F10.1,' K',
     & ' T(up)=',F10.1,' K',T80,'*'/'*',T80,'*')
        ELSE
          WRITE (JOUT,1140) TLOW,TUP,NSTEPH,NSTEPC
 1140 FORMAT('*',T80,'*'/
     & '*',1x,'Adaptive-temperature scheme is used: ',T80,'*'/
     & '*',1x,'T(low)=',F10.1,' K',' T(up)=',F10.1,'K, Nsteph=',I2,
     & ' Nstepc=',I2,T80,'*'/'*',T80,'*')
        ENDIF
        IF (EXCPRH.GE.1.0) THEN
          WRITE (JOUT,1147) 
        ELSE 
          WRITE (JOUT,1148) 1.0-EXCPRH
        ENDIF
 1147 FORMAT('*',1x,'Histidine/Proline configuration will not be',
     & ' changed during simulations.',T80,'*')
 1148 FORMAT('*',1x,'Probability of changing His/Pro configuration is',
     & F10.5,T80,'*')
        WRITE (JOUT,1145) MOV(MOVANG)
 1145 FORMAT('*',1x,'Type of backbone motion is ',A10,'.',T80,'*'/
     & '*',T80,'*')
        IF (WITHCNST) WRITE (JOUT,1146) 
 1146 FORMAT('*',1x,'Distance constraints will be considered in ',
     & 'sampling.',T80,'*'/'*',T80,'*')
        IF (NWIND.GT.0) THEN
          WRITE (JOUT,2016) NWIND
          DO I=1,NWIND
            IW1=IWIND(I,1)
            IR1=IABS(LIST(IW1))
            IF (IW1.EQ.1 .OR. IW1.EQ.INUMRS) IR1=IR1+num_restypes
            IW2=IWIND(I,2)
            IR2=IABS(LIST(IW2))
            IF (IW2.EQ.1 .OR. IW2.EQ.INUMRS) IR2=IR2+num_restypes
            WRITE (JOUT,2017) ARES(IR1),IW1,ARES(IR2),IW2
          ENDDO
          WRITE (JOUT,'(A,T80,A)') '*','*'
        endif
 2016 FORMAT('*',1x,'Sampling will be restricted to the following',
     & ' residues:',T80,'*')
 2017 FORMAT('*',1x,'from ',a3,'(',i3,') to ',a3,'(',i3,')',T80,'*')
        WRITE (JOUT,'(/2A,T80,A)')
     &     '* The following reference configurations',
     &     ' of the peptide groups are assumed:','*'
        DO LINIA=1,NRES+1,8
          I1=LINIA
          I2=MIN0(LINIA+7,NRES+1)
          WRITE (JOUT,'(8(A4,I3,3X))') (ARES(IABS(LLIST(I+1))),
     &       I,I=I1,I2)
          WRITE (JOUT,'(30(A6,7A10/))')(CISTRANS(OMREF(I+1)/179.9999+1),
     &       I=I1,I2)
        ENDDO
        il=ilen(restfile)
        jl=ilen(randfile)
        WRITE (JOUT,1150) RESTFILE(1:il),RANDFILE(1:jl),BACKUP
 1150 FORMAT('*',1x,'Main restart file: ',a,T80,'*'/ 
     &       '*',1x,'Random-number restart file: ',a,T80,'*'/
     &       '*',1x,'Restart will be written every',F8.1,' seconds.',
     &           T80,'*') 
        IF (RESTART) THEN
          WRITE (JOUT,1160) 
 1160 FORMAT('*',T80,'*'/
     & '*',10x,'Calculation restarted',T80,'*'/'*',T80,'*')
        ELSE IF (ICHCNF.EQ.0) THEN
          WRITE (JOUT,1170) 
 1170 FORMAT('*',T80,'*'/
     &'*',1x,'Starting conformation as read from the data.',
     & T80,'*')
        ELSE
          WRITE (JOUT,1180)
 1180 FORMAT('*',1x,'Simulation will be started from a random-',
     &'generated conformation.',T80,'*')
        ENDIF
        WRITE (JOUT,'(80(1h*))')
      ENDIF
      CALL CLOSE_APP(JOUT,OUTFILE)
      RETURN
 5555 WRITE (*,'(a,i4,/2a)') 'ERR% PRINT_DATA: can"t open logical unit',
     &      III, ' file= ', FNAME
      STOP 
      END
c--------------------------------------------------------------------------------
      integer function llist(i)
#ifdef PHCALC
      INCLUDE 'PARAMET.ECEPPH'
#else
      INCLUDE 'PARAMET.ECEPP'
#endif
      include 'COMMON.SETUP'
      include 'COMMON.GEN100'
      if (i.eq.1 .or. i.eq.nres+2) then
        llist=list(i)+num_restypes
      else
        llist=list(i)
      endif
      return
      end
